/*
 * Copyright 1993-2007 NVIDIA Corporation.  All rights reserved.
 *
 * NOTICE TO USER:   
 *
 * This source code is subject to NVIDIA ownership rights under U.S. and 
 * international Copyright laws.  Users and possessors of this source code 
 * are hereby granted a nonexclusive, royalty-free license to use this code 
 * in individual and commercial software.
 *
 * NVIDIA MAKES NO REPRESENTATION ABOUT THE SUITABILITY OF THIS SOURCE 
 * CODE FOR ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR 
 * IMPLIED WARRANTY OF ANY KIND.  NVIDIA DISCLAIMS ALL WARRANTIES WITH 
 * REGARD TO THIS SOURCE CODE, INCLUDING ALL IMPLIED WARRANTIES OF 
 * MERCHANTABILITY, NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE.
 * IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL, 
 * OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS 
 * OF USE, DATA OR PROFITS,  WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE 
 * OR OTHER TORTIOUS ACTION,  ARISING OUT OF OR IN CONNECTION WITH THE USE 
 * OR PERFORMANCE OF THIS SOURCE CODE.  
 *
 * U.S. Government End Users.   This source code is a "commercial item" as 
 * that term is defined at  48 C.F.R. 2.101 (OCT 1995), consisting  of 
 * "commercial computer  software"  and "commercial computer software 
 * documentation" as such terms are  used in 48 C.F.R. 12.212 (SEPT 1995) 
 * and is provided to the U.S. Government only as a commercial end item.  
 * Consistent with 48 C.F.R.12.212 and 48 C.F.R. 227.7202-1 through 
 * 227.7202-4 (JUNE 1995), all U.S. Government End Users acquire the 
 * source code with only those rights set forth herein. 
 *
 * Any use of this source code in individual and commercial software must 
 * include, in the user documentation and internal comments to the code,
 * the above Disclaimer and U.S. Government End Users Notice.
 */

#if !defined(__DONT_INCLUDE_NON_CUDART_HEADERS__)

#define __DONT_INCLUDE_NON_CUDART_HEADERS__ \
        1

#endif /* !__DONT_INCLUDE_NON_CUDART_HEADERS__ */

#include "../host_defines.h"
#include "storage_class.h"

#define __texture__(type, pref, dim) \
        __##pref##dim##texture
#define __unsized_array_size \
        []
#define __no_sc__

/*TEXTURE_TYPE*/
typedef const void* __i1texture;
/*TEXTURE_TYPE*/
typedef const void* __i2texture;
/*TEXTURE_TYPE*/
typedef const void* __i3texture;
/*TEXTURE_TYPE*/
typedef const void* __u1texture;
/*TEXTURE_TYPE*/
typedef const void* __u2texture;
/*TEXTURE_TYPE*/
typedef const void* __u3texture;
/*TEXTURE_TYPE*/
typedef const void* __f1texture;
/*TEXTURE_TYPE*/
typedef const void* __f2texture;
/*TEXTURE_TYPE*/
typedef const void* __f3texture;

#if defined(__cplusplus)

#define __cuda_name(m, um) \
        um

#else /* __cplusplus */

#define __cuda_name(m, um) \
        m

#endif /* __cplusplus */

#if defined(__CUDABE__) /* cudabe compiler */

#define __loc_sc__(loc, sc) \
        __storage##_##sc##loc loc
#define __text__ \
        __attribute__((__texture__))
#define ___device__(sc) \
        static
#define __in__(cdecl, decl) \
        __shared__ cdecl
#define __in_type__(cdecl, decl) \
        cdecl
#define __texture_var(name) \
        name
#define __val_param(name) \
        __val_param##name
#define __copy_param(local_decl, param) \
        local_decl = param
#define __shared_unsized_array(type_pre, name, type_post) \
        type_pre name type_post

#undef __cdecl
#define __cdecl
#undef __w64
#define __w64

#elif defined(__CUDACC__) /* cudafe compiler */

typedef char bool;

#define __loc_sc__(loc, sc) \
        sc loc
#define __text__
#define ___device__(sc) \
        sc __device__
#define __in__(cdecl, decl) \
        decl
#define __in_type__(cdecl, decl) \
        decl
#define __texture_var(name) \
        name
#define __val_param(name) \
        name
#define __copy_param(local_decl, param)
#define __shared_unsized_array(type_pre, name, type_post) \
        type_pre name type_post

#else /* host compiler (cl, gcc, ...) */

#define ___device__(sc) \
        static __device__
#define __in__(cdecl, decl) \
        decl
#define __in_type__(cdecl, decl) \
        decl
#define __texture_var(name) \
        __texture_##name
#define __val_param(name) \
        name
#define __copy_param(local_decl, param)
#define __shared__unsized_array_size
#define __shared_unsized_array(type_pre, name, type_post) \
        type_pre (*name)__shared##type_post

#if defined(__GNUC__)

#define __STORAGE__ \
        __attribute__((common))

#elif defined(__cplusplus)

#define __STORAGE__ \
        __declspec(selectany)

#pragma warning(disable: 4099)

#else /* __cplusplus */

#define __STORAGE__

#endif /* __GNUC__ */

/* this is compiled with a host compiler for device emulation */
#define __device_emulation

#endif /* __CUDABE__ */

#include "../builtin_types.h"
#include "../device_launch_parameters.h"
