#ifndef MainWindowH
#define MainWindowH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "MenuWidget.h"
#include "MainWindowWidget_ui.h"
#include "UnitTests.h"
#include <QtCore/QTimer>
//---------------------------------------------------------------------------

class QPushButton;

namespace geoxl
{
	using namespace std;
	
class Object;
class ClassEditor;
class ObjectDictionary;
class ObjectDictionaryEditorWidget;

class MainWindow : public QMainWindow
{

	Q_OBJECT


 private:
	Ui_MainWindowWidget ui;
	struct UnitTestEntry {
	   UnitTest test;
	   QAction *action;
	};
	vector<UnitTestEntry> unitTestEntries;

	ObjectDictionary		*	m_MainObject;
	ClassEditor				*	m_MainEditor;
	ObjectDictionaryEditorWidget * m_ObjectDictEditor;

	ClassEditor				*	m_ConfigurationEditor;
	QWidget					*	m_ConfigurationWidget;

	void cleanupAllocs();
 protected:
	void closeEvent(QCloseEvent *event);

 public:
	MainWindow(QWidget * parent=NULL, Qt::WFlags f=0);
	~MainWindow(void);

 private slots:
	void on_newButton_clicked();
	void on_exitButton_clicked();
	void on_openButton_clicked();
	void on_saveButton_clicked();
	void on_menubar_triggered(QAction* action);

/*	void sltShortCut_new();
	void sltShortCut_open();
	void sltShortCut_save();
	void sltShortCut_exit();
	void sltShortCut_debugWindow();
	void sltShortCut_online();*/
	void on_actionCreate_New_Object_triggered();
	void on_action_Open_Object_triggered();
	void on_actionSave_Object_As_triggered();
	void on_actionConfiguration_triggered();
	void on_actionE_xit_triggered();
	void on_actionShow_Debug_Window_triggered();
	void on_action_Online_Help_triggered();
	void on_action_Index_triggered();
	void on_action_Info_triggered();
	void startBatch();

 protected:
	 string inputFile;
	 string outputFile;
	 string scriptFile;

public:
	void setBatchMode(string inputFile, string outputFile, string scriptFile);


};
}

#endif