#ifndef PCIFeatureTestEditorWidgetH 
#define PCIFeatureTestEditorWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PCIFeatureTestEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace geoxl
{
	using namespace std;

class PCIFeatureTest;

class ANIMATIONRECONSTRUCTION_API PCIFeatureTestEditorWidget : public QWidget
{
	Q_OBJECT

private:

	PCIFeatureTest	*	m_Object;

	///used to access buttons, etc. from QtDesigner
	Ui_PCIFeatureTestEditorForm ui;

public:
	PCIFeatureTestEditorWidget(QWidget * parent = NULL, Qt::WFlags f=0);
	~PCIFeatureTestEditorWidget(void);

	void setup( PCIFeatureTest * obj );

	/// update editor content with object data
	void updateEditor();

public slots:

	void on_cbDistortionMode_currentIndexChanged(int);
	void on_dDistortionStrength_valueChanged(double);
	void on_pbDistort_clicked();
	void on_iNumGravityBalls_valueChanged(int);
	void on_iRandomSeed_valueChanged(int);
	void on_pbTestDetector_clicked();
	void on_pbTestDescriptor_clicked();
	void on_pbTestRegistration_clicked();
	void on_bHideInitialPairs_clicked();
	void on_dShowPairsPercentage_valueChanged(double);
	void on_bDrawGradients_clicked();
	void on_dGradientLength_valueChanged(double);
	void on_dRelativeFeatureSize_valueChanged(double);
	void on_bDrawFeatureScale_clicked();
	void on_pbCalcFeatures_clicked();
	void on_pbValidatePairs_clicked();
	void on_pbPruning_clicked();
	void on_pbTestGeodeticDistances_clicked();
	void on_pbRecalcDesc_clicked();

	void on_dSpectralSigma_valueChanged(double);
	void on_dSpectralAddDiff_valueChanged(double);
	void on_dSpectralScaleDiff_valueChanged(double);

	void on_pbDebugMultiScale_clicked();
	void on_dDescClusterRadius_valueChanged(double);
	void on_pbCalculateCurvature_clicked();
	void on_pbTestDetectorStability_clicked();
	void on_pbTestDescriptorStability_clicked();
	
	void on_pbGlobalRegFeatures_clicked();
	void on_pbGlobalRegTransform_clicked();
	void on_pbTestValidation_clicked();

	void on_pbCopyTrans_clicked();
	void on_pbPasteTrans_clicked();

};

MAKE_CLASS_EDITOR( ANIMATIONRECONSTRUCTION_API , PCIFeatureTest )


}

#endif