#ifndef PatchGraphMergeCandidateSelectEditorWidgedH 
#define PatchGraphMergeCandidateSelectEditorWidgedH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
#include "ClassEditor.h"
#include "PatchGraphMergeCandidateSelectEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace geoxl
{

class PatchGraphMergeCandidateSelect;

class ANIMATIONRECONSTRUCTION_API PatchGraphMergeCandidateSelectEditorWidget : public QWidget
{
	Q_OBJECT

	private:
		/// Object
		PatchGraphMergeCandidateSelect*	obj;
		///used to access buttons, etc. from QtDesigner
		Ui_PatchGraphMergeCandidateSelectEditorForm ui;

		/// Init manual selection fields based on current patch graph container
		void initFields();
		/// Init manual selection merge candidate list based on current patch graph container and crossing selection
		void initMergeCandidates();

	public:
		/// Constructor
		PatchGraphMergeCandidateSelectEditorWidget(QWidget * parent = NULL, Qt::WFlags f=0);
		/// Destructor
		~PatchGraphMergeCandidateSelectEditorWidget(void);

		/// Setup call
		void setup( PatchGraphMergeCandidateSelect* obj );

		/// update editor content with object data
		void updateEditor();

	public slots:
		void on_CB_mergeCrossing_currentIndexChanged( const QString& text );
		void on_CB_cand1_currentIndexChanged( const QString& text );
		void on_CB_cand2_currentIndexChanged( const QString& text );
		void sltPGContainerChanged();
		void on_PB_selectAutomatical_clicked();
};

MAKE_CLASS_EDITOR( ANIMATIONRECONSTRUCTION_API, PatchGraphMergeCandidateSelect )

}

#endif