//---------------------------------------------------------------------------
#ifndef ComputeSampleSpacingH
#define ComputeSampleSpacingH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace geoxl {

class PatchGraph;
class PointCloudAnimationSequence;

/**
	compute sample spacing for patches
*/
class ANIMATIONRECONSTRUCTION_API ComputeSampleSpacing : public Persistent {
	GEOXL_CLASS( ComputeSampleSpacing )

 public:
	static const card32 TECHNIQUE_MAX_NEIGHBOR_DIST = 0;
	static const card32 TECHNIQUE_AVERAGE_NEIGHBOR_DIST = 1;
	static const card32 TECHNIQUE_KTH_SMALLEST = 2;
	static const card32 TECHNIQUE_KNN_AREA = 3;
	
 private:
	card32 technique;
	card32 kthSmallestIndex;
	card32 numKNN;
	/// set this value to values other than one to fine tune the results
	float32 corrrectionFactor;

 public:
	ComputeSampleSpacing();
	
	void setup(card32 technique);
   
   void assign(const Object* obj, CopyContext *context = NULL);
   
   virtual void estimatePatchSamplingDistance(PatchGraph *pg);
   
	virtual ~ComputeSampleSpacing();

};

}

#endif