//---------------------------------------------------------------------------
#ifndef LocalTopologyResamplingH
#define LocalTopologyResamplingH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "AbstractMergeExtrapolator.h"
//---------------------------------------------------------------------------

namespace geoxl {

/**
	recompute local topology:
	- first, search all for all nodes reachable in a certain geodesic distance
	- second, connect all nodes topologically which are within a certain (smaller) geodesic distance
*/
class ANIMATIONRECONSTRUCTION_API LocalTopologyResampling {
 public:
	static void resampleTopology( 
		AnimationBSRContext* context,
		PatchGraph *pg,
		const card32 stichFrame,
		DebugRenderer *debugRenderer,  
		const bool verbose = false );

	static void resampleTopology_Modified( 
		AnimationBSRContext* context,
		PatchGraph *pg,
		const card32 stichFrame,
		DebugRenderer *debugRenderer,  
		const bool verbose = false );
};

}

#endif