//---------------------------------------------------------------------------
#ifndef NearestNeighborTopologyMergingH
#define NearestNeighborTopologyMergingH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "AbstractMergeExtrapolator.h"
//---------------------------------------------------------------------------
#include <set>
//---------------------------------------------------------------------------

namespace geoxl {
	using namespace std;

/**
	stich two topologies together by nearest neighbor queries
*/
class ANIMATIONRECONSTRUCTION_API NearestNeighborTopologyMerging {
 private:
	static void stich(
		const PointSet* source, 
		const PointSet* target, 
		const float32 pruneDist,
		const card32 sourcePatchIndexOffset,
		const card32 targetPatchIndexOffset,
		AttachedIndexedOctree *targetOctree,
		set< pair<card32, card32> > &result
	);

	static void stich_Modified(
		const PointSet* source, 
		const PointSet* target, 
		const float32 pruneDist,
		const card32 sourcePatchIndexOffset,
		const card32 targetPatchIndexOffset,
		AttachedIndexedOctree *targetOctree,
		set< pair<card32, card32> > &result
		);
	
 public:
	static void connectNeighbors( 
		AnimationBSRContext* context,
		const PointSet* interpolatedFrame, const PointSet* targetFrame, 
		PatchGraph* combinedPG,
		const card32 sourcePatchIndexOffset,
		const card32 targetPatchIndexOffset,
		DebugRenderer *debugRenderer,  
		const bool verbose = false
	);

	/// the following method is used by peter
	/// the change is only about a pointer
	static void connectNeighbors_Modified( 
		AnimationBSRContext* context,
		const PointSet* interpolatedFrame, const PointSet* targetFrame, 
		InCorePCTopologyGraph	*topology,
		const card32 sourcePatchIndexOffset,
		const card32 targetPatchIndexOffset,
		DebugRenderer *debugRenderer,  
		const bool verbose = false
		);

	static void connectNeighbors_Final( 
		AnimationBSRContext* context,
		const PointSet* interpolatedFrame, 
		const PointSet* targetFrame,
		const PatchGraph* interpolatedPatchGraph,
		const PatchGraph* targetPatchGraph,
		InCorePCTopologyGraph	*topology,
		const card32 sourcePatchIndexOffset,
		const card32 targetPatchIndexOffset,
		DebugRenderer *debugRenderer,  
		const bool verbose = false
		);
};

}

#endif