//---------------------------------------------------------------------------
#ifndef NoiseLevelEstimatorH
#define NoiseLevelEstimatorH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace geoxl {

/// Estimate the noise level in a point cloud
class ANIMATIONRECONSTRUCTION_API NoiseLevelEstimator : public Persistent {
	GEOXL_CLASS( NoiseLevelEstimator )

	private:
	
	public:
		/// Constructor
		NoiseLevelEstimator();   
		/// Destructor
		virtual ~NoiseLevelEstimator();

		/// Estimate average noise level in point cloud
		float32 estimateNoiseLevel( PointCloud* pc );
   
		/// Object assignment
		void assign(const Object* obj, CopyContext *context = NULL);

};

}

#endif