//---------------------------------------------------------------------------
#ifndef PGOperationsDebuggingH
#define PGOperationsDebuggingH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
#include "PatchGraphContainer.h"
//---------------------------------------------------------------------------

namespace geoxl {

/// derive from this class and implement the render method to show a certain
/// step of the algorithm in 3d
class DebugRenderFunction {     // INTERFACE CLASS
 public:
   virtual void debugDraw() const = 0;
};


/// this object represents an interface to the object that owns the GL context,
/// beeing able to initiate a repaint
class DebugRenderer {           // INTERFACE CLASS
 public:
   /// call this function to show a debug drawing
   virtual void performRedraw(const DebugRenderFunction *painter) = 0;
};

}

#endif