//---------------------------------------------------------------------------
#ifndef PatchGraphMergeCandidateSelectH
#define PatchGraphMergeCandidateSelectH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
#include "AnimationBSRContext.h"
//---------------------------------------------------------------------------

namespace geoxl {

/// Merge patch graphs
class ANIMATIONRECONSTRUCTION_API PatchGraphMergeCandidateSelect : public Persistent {
	GEOXL_CLASS( PatchGraphMergeCandidateSelect )

	private:
		/// Currently selected merge candidates
		int32 cand1, cand2;
		/// Context
		AnimationBSRContext* context;
		/// Weights
		float32 omegaDistance, omegaNumPatches, omegaNumFrames, omegaSize;

		/// Find next best merge candidates
		void findNextMergeCandidates();
		/// Estimate the score of a merge operation
		float32 estimateMergeScore( PatchGraph* pg1, PatchGraph* pg2, PatchGraphContainer* pgContainer );
		
	public:
		/*** CLASS MANAGEMENT ***/
		/// Constructor
		PatchGraphMergeCandidateSelect();   
		/// Destructor
		~PatchGraphMergeCandidateSelect();

		/// Find next candidates
		void select();

		/*
		/// Container descriptor
		void setNumfilterss( card32 size ) { filters.resize(size);}
		void deletefilters( card32 index ){ pAssert( index < filters.size()); filters.erase( filters.begin()+index );}
		char* getfilters( card32 index ){pAssert( index < filters.size()); return (char*)&filters[index];}
		card32 getNumfilterss(){return filters.size();}
		string getfiltersName(card32 index ){ 
			pAssert( index < filters.size()); 
			return filters[index]->getName().toStdString();
		}
		*/

		/*** MEMBER ACCESS ***/
		inline int32 getCand1() const { return cand1; }
		inline int32 getCand2() const { return cand2; }
		inline void setContext( AnimationBSRContext* context ){ this->context = context; }
		inline AnimationBSRContext* getContext() const { return context; }
		inline void setCand1( const int32 c ){ cand1 = c; }
		inline void setCand2( const int32 c ){ cand2 = c; }
		//inline void addFilter( MergeFilter* filter ){ filters.push_back( filter ); }
};
}

#endif