//---------------------------------------------------------------------------
#ifndef PatchGraphResampleH
#define PatchGraphResampleH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
#include "PatchGraphContainer.h"
#include "TensorVoting.h"
#include "UniformPointCloudResampling.h"
#include "InCorePCTopologyGraph.h"
#include "AnimationBSRContext.h"
//---------------------------------------------------------------------------

namespace geoxl {

/// Resamples a patch graph: 
/// ATTENTION: does not consider data points; needs to be done by 'DataPointAssignment'-class
class ANIMATIONRECONSTRUCTION_API PatchGraphResample : public Persistent {
	GEOXL_CLASS( PatchGraphResample )

	private:
		/// Context
		AnimationBSRContext* context;
		
	public:
		/*** CLASS MANAGEMENT ***/
		/// Constructor
		PatchGraphResample();   
		/// Destructor
		~PatchGraphResample();
		/// Object assignment
		void assign(const Object* obj, CopyContext *context = NULL);

		/*** OPERATIONS ***/
		/// Merge two patch graphs; return true on success
		bool resample( PatchGraph* pg );

		/*** MEMBER ACCESS ***/
		inline void setContext( AnimationBSRContext* context ){ this->context = context; }

};

}

#endif