//---------------------------------------------------------------------------
#ifndef PatchGraphRoutinesH
#define PatchGraphRoutinesH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
#include "LinearAlgebra.h"
//---------------------------------------------------------------------------

namespace geoxl {

struct ReferenceFramePatch;
struct CoefficientSet;

void ANIMATIONRECONSTRUCTION_API computeClosestPointQuadPatch(
	const Vector3f &patchOrigin, 
	const ReferenceFramePatch &ref, 
	const CoefficientSet &quadraticCoefficients, 
	const Vector3f &targetPoint, 
	const float32 searchDistance,
	Vector2f &minUV,
	float32 &minDist,
	const card32 startGrid = 5,
	const card32 numNewton = 3);

}

#endif