//---------------------------------------------------------------------------
#ifndef RefFrameEst3DH
#define RefFrameEst3DH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace geoxl {

class PatchGraph;
class PointCloudAnimationSequence;

/**
	estimates inital reference frames for patch graphs 
	3d only, ignores anim in the sense that each frame is handled separately
	no regularization of coordinate frame orientations (basically, this is just local PCAs)
	no prerequisites other than valid position and topology
	all target channels must exist
*/
class ANIMATIONRECONSTRUCTION_API RefFrameEst3D : public Persistent {
	GEOXL_CLASS( RefFrameEst3D )

 private:

 public:
	RefFrameEst3D();
   
   void assign(const Object* obj, CopyContext *context = NULL);
   
   virtual void estimateReferenceFrameFromNeighbors(PatchGraph *pg);
   virtual void estimateReferenceFrameFromDataPoints(PatchGraph *pg, PointCloudAnimationSequence *dataPoints);
   
	virtual ~RefFrameEst3D();

};

}

#endif