//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "SmallDeformationAlignment.h"
//---------------------------------------------------------------------------
#include "BSROptContext.h"
#include "PatchGraphBSROpt.h"
#include "VariableArrayClassProperty.h"
#include "ClassTypeClassProperty.h"
#include "ObjectClassProperty.h"
#include "CorrespondenceExtrapolation.h"
#include "PatchGraphRenderer.h"
#include "NearestNeighborTopologyMerging.h"
#include "LocalTopologyResampling.h"
#include "BSROptConfig.h"
#include "PatchTypes.h"
#include "PGNeighborhoodExtrapolator4D.h"
#include "FeatureRegistration.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



//IMPLEMENT_GEOXL_CLASS(SmallDeformationAlignment, 0)
//{
//	BEGIN_CLASS_INIT(SmallDeformationAlignment);
//	ADD_OBJECT_PROP(corrInterpConfig, 0, BSROptConfig::getClass(), true);
//	ADD_OBJECT_PROP(extrapolateConfig, 0, BSROptConfig::getClass(), true);
//}
//
//
//// ----
//
//
//SmallDeformationAlignment::SmallDeformationAlignment() {
//	optimizer = new PatchGraphBSROpt();
//
//	corrInterpConfig = new BSROptConfig();
//	
//	corrInterpConfig->setOptMode(BSROptConfig::MODE_OLD_OPT);
//	
//	corrInterpConfig->setCCGaussianPrjLikelihood(true);
//	corrInterpConfig->setCCSimpleICPLikelihood(true);
//	corrInterpConfig->setCCSpringBasedRigidity(true);
//	
//	BSROptContext *corrInterpParams = corrInterpConfig->getParameters();
//		
//	corrInterpParams->optMode				= BSROptContext::MODE_MOVE_POINTS;
//	corrInterpParams->solver				= BSROptContext::SOLVER_NEWTON_CG;
//	corrInterpParams->stoppingCriterion	= BSROptContext::STOP_CONV_GRAD_INFNORM;
//	corrInterpParams->numIterations		= 5;	  
//	corrInterpParams->convergenceEps		= 0.0025f;
//	corrInterpParams->coeffsUpdateFreq	= 1;
//	corrInterpParams->coordsUpdateFreq	= 1;
//	corrInterpParams->newtonRegularization = 1.0f;
//
//	corrInterpParams->weightLikelihood        = 1;
//	corrInterpParams->weightICPLikelihood     = 1;
//	corrInterpParams->weightSmooth            = 1;
//	corrInterpParams->weightSmoothCurvature   = 1;
//	corrInterpParams->weightSTSmoothness      = 1;
//	corrInterpParams->weightSTAngleSmoothness = 0;
//	corrInterpParams->weightCorrSmooth        = 1;
//	corrInterpParams->weightDensity           = 0;
//
//	corrInterpParams->simpleLikelihood				 = true;
//	corrInterpParams->hardLikelihoodConstraint	 = false;
//	corrInterpParams->simpleSmoothness            = false;
//	corrInterpParams->stSmoothnessForward         = true;
//	corrInterpParams->stSmoothnessBackward        = false;
//	corrInterpParams->stSmoothnessUrshapeToFrames = false;
//	corrInterpParams->stSmoothnessFramesToUrshape = false;
//	corrInterpParams->stCorrLinPrjSmoothing       = false;
//	corrInterpParams->stPreserveAngles            = false;
//	corrInterpParams->smoothPatchGraph            = true;
//	corrInterpParams->smoothUrshape               = false;
//
//	corrInterpParams->cgStopRes = 0.001f;
//	corrInterpParams->cgMaxNumIterations = 100;
//	
//	extrapolateConfig = new BSROptConfig();
//	
//	extrapolateConfig->setOptMode(BSROptConfig::MODE_OLD_OPT);
//	
//	extrapolateConfig->setCCSimpleICPLikelihood(true);
//	extrapolateConfig->setCCPrjSmoothness(true);
//	extrapolateConfig->setCCSpringBasedRigidity(true);
//	
//	BSROptContext *extrapolateParams = extrapolateConfig->getParameters();
//
//	extrapolateParams->optMode				 = BSROptContext::MODE_MOVE_POINTS;
//	extrapolateParams->solver				 = BSROptContext::SOLVER_NEWTON_CG;
//	extrapolateParams->stoppingCriterion = BSROptContext::STOP_CONV_GRAD_INFNORM;
//	extrapolateParams->numIterations		 = 5;
//	extrapolateParams->convergenceEps	 = 0.0025f;
//	extrapolateParams->coeffsUpdateFreq	 = 1;
//	extrapolateParams->coordsUpdateFreq	 = 1;
//	extrapolateParams->newtonRegularization = 1.0f;
//
//	extrapolateParams->weightLikelihood        = 1;
//	extrapolateParams->weightICPLikelihood     = 1;
//	extrapolateParams->weightSmooth            = 1;
//	extrapolateParams->weightSmoothCurvature   = 1;
//	extrapolateParams->weightSTSmoothness      = 1;
//	extrapolateParams->weightSTAngleSmoothness = 0;
//	extrapolateParams->weightCorrSmooth        = 1;
//	extrapolateParams->weightDensity           = 0;
//
//	extrapolateParams->simpleLikelihood				  = false;
//	extrapolateParams->hardLikelihoodConstraint	  = false;
//	extrapolateParams->simpleSmoothness            = true;
//	extrapolateParams->stSmoothnessForward         = true;
//	extrapolateParams->stSmoothnessBackward        = true;
//	extrapolateParams->stSmoothnessUrshapeToFrames = false;
//	extrapolateParams->stSmoothnessFramesToUrshape = false;
//	extrapolateParams->stCorrLinPrjSmoothing       = false;
//	extrapolateParams->stPreserveAngles            = false;
//	extrapolateParams->smoothPatchGraph            = true;
//	extrapolateParams->smoothUrshape               = false;
//
//	extrapolateParams->cgStopRes = 0.001f;
//	extrapolateParams->cgMaxNumIterations = 500;
//
//
//	visualization = new StandardPatchGraphRenderer();
//	visualization->setUseDL(false);
//	visualization->setShowTopology(true);
//	visualization->setShowCoords(false);
//	visualization->setShowDataPoints(true);
//	visualization->setShowPoints(true);
//	visualization->setShowLocalPatches(false);
//	visualization->setShowAllFrames(true);
//	
//	tmpDebugRenderer = NULL;
//	tmpPG				  = NULL;
//	tmpData			  = NULL;
//}
//
//SmallDeformationAlignment::~SmallDeformationAlignment() {
//	delete optimizer;
//	delete corrInterpConfig;
//	delete extrapolateConfig;	
//	delete visualization;
//}
//
//
//void SmallDeformationAlignment::alignAndConnectParts
//  (AnimationBSRContext* context,
//	const PatchGraph *part1,
//	const PatchGraph *part2, 
//	card32 part1FrameIndex, 
//	card32 part2FrameIndex,
//	card32 nextAfterPart1DataIndex,
//	card32 destFrameIndex,
//	card32 extrapolatedPointsCopyIndex,
//	card32 part1StartPatch,
//	card32 part2StartPatch,
//	PatchGraph *combinedPG,
//	const vector<CorrespondenceExtrapolation::PatchCorrespondence> &knownCorrespondences,
//	DebugRenderer *debugRenderer, 
//	const bool verbose)
//{
//	
//	PatchGraph *mergePG;
//	PointCloudAnimationSequence *mergeDataPts;
//	CorrespondenceExtrapolation::buildCorrExtrapolationPatchGraph(
//		part1, context->getPGContainer()->getAnimSeq(), 
//		part1FrameIndex, nextAfterPart1DataIndex, knownCorrespondences, 
//		mergePG, mergeDataPts
//	);
//
//	corrInterpConfig->configure(optimizer);
//	
//	PriorsBasedCorrExtrapolation ce(context, mergePG, mergeDataPts, debugRenderer, visualization);
//	ce.doOptimization(optimizer);
//	
//	{
//		/// copy data to combinedPG
//		const card32 numMergePGPoints = mergePG->getTrajectorySet()->getNumPatches();
//		PointSet *ps_dest = combinedPG->getTrajectorySet()->getTrajectories();
//		PointSet *ps_source = mergePG->getTrajectorySet()->getTrajectories();
//		const AAT AAT_DEST_FLAGS = ps_dest->getAAT("flags");
//		for (card32 i=0; i<numMergePGPoints; i++) {
//			ps_dest->setVertex(destFrameIndex, i+extrapolatedPointsCopyIndex, ps_source->getDataPointer(1, i));
//			ps_dest->set<int>(destFrameIndex, i+extrapolatedPointsCopyIndex, AAT_DEST_FLAGS, FLAG_PATCH_INITIALIZED);
//		}
//	}
//
//	PointSet *interpolated = mergePG->getTrajectorySet()->copySingleFrame(1);
//	PointSet *target = part2->getTrajectorySet()->copySingleFrame(part2FrameIndex);
//	
//
//	NearestNeighborTopologyMerging::connectNeighbors(
//		context, 
//		interpolated, target, combinedPG, 
//		part1StartPatch,
//		part2StartPatch,
//		debugRenderer, verbose
//	);
//	
//	delete interpolated;
//	delete target;
//	  
//	delete mergePG;
//	delete mergeDataPts;
//}
//
//void SmallDeformationAlignment::computeFeatureMatch
//  (FeatureRegistration *featureMatcher,
//   vector< pair<Vector3f, Vector3f> > &matchingPoints, 
//	FeatureList *feat1,
//	FeatureList *feat2)
//{
//	//vector<FeaturePair> pairs = featureMatcher->buildFeaturePairs(feat1, feat2, context->maxFeatureDistance);
//	
//}
//
//
//void SmallDeformationAlignment::compute( 
//	AnimationBSRContext* context,
//	FeatureRegistration *featureMatcher,
//	const PatchGraph* pg1, const PatchGraph* pg2, 
//	PatchGraph* combinedPG,
//	DebugRenderer *debugRenderer, const bool verbose)
//{
//	int32 lastPG1Frame = pg1->getTrajectorySet()->getNumFrames()-1;
//	
//	//vector< pair<Vector3f, Vector3f> > matchingPoints;
//	//computeFeatureMatch(matchingPoints, pg1->getFeatureList(lastPG1Frame), pg2->getFeatureList(0));
//	
//	vector<CorrespondenceExtrapolation::PatchCorrespondence> knownPg1Pg2Corr, knownPg2Pg1Corr;	
//	
//	alignAndConnectParts(
//		context, pg1, pg2, 
//		lastPG1Frame,										 // part1FrameIndex,
//		0,														 // part2FrameIndex
//		lastPG1Frame+1+pg1->getStartFrameIndex(),	 // nextAfterPart1DataIndex
//		lastPG1Frame+1,									 // destFrameIndex
//		0,														 // extrapolatedPointsCopyIndex
//		0,                                         // part1StartPatch 
//		pg1->getTrajectorySet()->getNumPatches(),  // part2StartPatch 
//		combinedPG, 
//		knownPg1Pg2Corr,
//		debugRenderer, verbose
//	);
//	alignAndConnectParts(
//		context, pg2, pg1, 
//		0,																			 // part1FrameIndex,
//		lastPG1Frame,															 // part2FrameIndex
//		pg2->getStartFrameIndex()-1,										 // nextAfterPart1DataIndex
//		lastPG1Frame,															 // destFrameIndex
//		pg1->getTrajectorySet()->getTrajectories()->getHeight(),	 // extrapolatedPointsCopyIndex
//		pg1->getTrajectorySet()->getNumPatches(),						 // part1StartPatch 
//		0,																			 // part1StartPatch 
//		combinedPG, 
//		knownPg2Pg1Corr,
//		debugRenderer, verbose
//	);
//		
//	LocalTopologyResampling::resampleTopology( 
//		context,
//		combinedPG,
//		lastPG1Frame+1,
//		debugRenderer, verbose
//	);
//
//
//	this->tmpDebugRenderer = debugRenderer;
//	this->tmpPG				  = combinedPG;
//	this->tmpData			  = context->getPGContainer()->getAnimSeq();
//
//	card32 numChanged;
//	do {
//		numChanged = PGNeighborhoodExtrapolator4D::extrapolateNeighbors(
//			context,
//			combinedPG
//		);	
//		if (numChanged > 0) {
//			extrapolateConfig->setCCSpringBasedRigidity(false);
//			extrapolateConfig->configure(optimizer);
//			PGNeighborhoodExtrapolator4D::partialOptimization(
//				context,
//				combinedPG, context->getPGContainer()->getAnimSeq(),
//				optimizer,
//				debugRedraw, this
//			);
//		   
//			extrapolateConfig->setCCSpringBasedRigidity(true);
//			extrapolateConfig->configure(optimizer);
//			PGNeighborhoodExtrapolator4D::partialOptimization(
//				context,
//				combinedPG, context->getPGContainer()->getAnimSeq(),
//				optimizer,
//				debugRedraw, this
//			);
//		}
//	} while (numChanged > 0);
//		
//	this->tmpDebugRenderer = NULL;
//	this->tmpPG				  = NULL;
//	this->tmpData			  = NULL;
//}
//
//void SmallDeformationAlignment::debugRedraw(void *context) {
//	SmallDeformationAlignment* cthis = ((SmallDeformationAlignment*)context);
//	DebugRenderer *debugRenderer = cthis->tmpDebugRenderer;
//	if (debugRenderer != NULL) {
//		debugRenderer->performRedraw(cthis);
//	}
//}
//
//void SmallDeformationAlignment::debugDraw() const {
//	visualization->renderGL(tmpPG, tmpData, 0);	
//}
