//---------------------------------------------------------------------------
#ifndef TopologyBreakerH
#define TopologyBreakerH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
#include "Persistent.h"
#include "AnimationBSRContext.h"
//---------------------------------------------------------------------------

namespace geoxl {

/// Break up topological connections if the length of a connection grows non-normally
class ANIMATIONRECONSTRUCTION_API TopologyBreaker : public Persistent {
	GEOXL_CLASS( TopologyBreaker )

	private:
		/// Context
		AnimationBSRContext* context;
		/// Threshold value for invalid edges
		float32 lengthScaleThreshold;
		
	public:
		/// Constructor
		TopologyBreaker();
		/// Destructor
		~TopologyBreaker();

		/// Check for invalid connections; break ir required
		void checkAndApply( PatchGraph* pg );

		/*** MEMBER ACCESS ***/
		inline void setContext( AnimationBSRContext* context ){ this->context = context; }

};
}

#endif