//---------------------------------------------------------------------------
#ifndef UnifyNormalsH
#define UnifyNormalsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
#include "BSROptPotential.h"
//---------------------------------------------------------------------------

namespace geoxl {

class PatchGraph;

/**
	Lets all normals of local reference frames point into the same direction.
	Uses Hoppe's smallest normal difference region growing algorithm on topology graph
*/
class ANIMATIONRECONSTRUCTION_API UnifyNormals : public Persistent {
	GEOXL_CLASS( UnifyNormals )

 private:

 public:
	UnifyNormals();
   
   void assign(const Object* obj, CopyContext *context = NULL);
   
   static void unifyNormals(PatchGraph *pg, const BSROptVariableIndexSet *indices = NULL);
   static void flipNormals(PatchGraph *pg);
   
	virtual ~UnifyNormals();

};

}

#endif