//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "UrshapeCreator.h"
//---------------------------------------------------------------------------
#include "PatchGraph.h"
#include "TrajectorySet.h"
#include "PointSet.h"
#include "PointSet_templCode.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------


void UrshapeCreator::checkCreateAvUrshape(PatchGraph *pg) {
	if (pg->getUrshape() == NULL) {
		averageUrshape(pg);
	}
}

void UrshapeCreator::averageUrshape(PatchGraph *pg) {
	if (pg->getUrshape() == NULL) {
		pg->createAndClearUrshape();
	}
	const card32 numFrames = pg->getTrajectorySet()->getNumFrames();
	const card32 numPatches = pg->getTrajectorySet()->getNumPatches();
	PointSet *ps = pg->getTrajectorySet()->getTrajectories();
	PointSet *urshape = pg->getUrshape();
	pAssert(urshape);
	const AAT posAAT = ps->getAAT("position");
	for (card32 p=0; p<numPatches; p++) {
		Vector3f pos = NULL_VECTOR3F;
		for (card32 f=0; f<numFrames; f++) {
			pos += ps->get<float32, 3>(f,p, posAAT);
		}	
		pos /= numFrames;
		urshape->set<float32, 3>(p, posAAT, pos);
	}
}
