//---------------------------------------------------------------------------
#ifndef BSRFittingH
#define BSRFittingH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
#include "DynamicLinearAlgebra.h"
#include "BSROptPotential.h"
//---------------------------------------------------------------------------

namespace geoxl {

class PatchGraph;
class BSROptContext;

class ANIMATIONRECONSTRUCTION_API BSRFitting {
 private:
	static void fit2ndOrderHeightfToPSPoint(
	   const AAT &POSITION,	const AAT &REF_U,
	   const AAT &REF_N, const AAT &COEFF,
      BSROptContext *context, PointSet *ps, InCorePCTopologyGraph *tg, 
      const card32 frameIndex, const card32 patchIndex);
 public:
	/// Compute the polynomial approximations; result is saved as a channel with each patch
	static void fit2ndOrderHeightf( BSROptContext *context, PatchGraph* pg, const BSROptVariableIndexSet &indices );
	/// (re-)compute reference frames, store result in channel
   static void fitRefFrames( BSROptContext *context, PatchGraph* pg, const BSROptVariableIndexSet &indices );
   /// estimate sample spacing
   static void estSampleSpacing( BSROptContext *context, PatchGraph *pg, const BSROptVariableIndexSet &indices );

	// /// compute 1st order fit to correspondences; result is saved as a channel with each patch
	// static void fit1stOrderCorr( BSROptContext *context, PatchGraph* pg, const BSROptVariableIndexSet &indices );
};

}

#endif