//---------------------------------------------------------------------------
#ifndef HFBFFourierH
#define HFBFFourierH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "HeightFieldBasisFunctionSet.h"
//---------------------------------------------------------------------------

namespace geoxl {

/// Fourier basis functions
/// Attention: must be used on [0..2*PI] x [0..2*PI]
class HFBFFourier : public HeightFieldBasisFunctionSet {
	GEOXL_CLASS( HFBFFourier )

 private:	
	// persistent
	card32 degree;

	inline float32 get1dFunc(card32 index, float32 val);

 public:
	HFBFFourier();
	
	/// create all Fourier basis functions {sin(n*u),cos(n*u)} * {sin(m*v),cos(m*v)}
	/// with n,m <= degree, omitting sin(0)
	/// default value is zero
	void setup(card32 degree);
 
	virtual card32 getNumBasisFunctions();
	virtual float32 evaluate(card32 bfIndex, const Vector2f &uv);
};


}

#endif