//---------------------------------------------------------------------------
#ifndef HeightFieldBasisFunctionSetH
#define HeightFieldBasisFunctionSetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
#include "SparseLinearAlgebra.h"
#include "DynamicLinearAlgebra.h"
//---------------------------------------------------------------------------

namespace geoxl {

/// abstract class representing sets of basis functions
class ANIMATIONRECONSTRUCTION_API HeightFieldBasisFunctionSet : public Persistent {
	GEOXL_ABSTRACT_CLASS( HeightFieldBasisFunctionSet )

 public:
	virtual card32 getNumBasisFunctions() = 0;
	virtual float32 evaluate(card32 bfIndex, const Vector2f &uv) = 0;
};


}

#endif