//---------------------------------------------------------------------------
#ifndef RegularizedPatchFitH
#define RegularizedPatchFitH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PTypes.h"
#include "SparseLinearAlgebra.h"
#include "DynamicLinearAlgebra.h"
#include "LinearAlgebra.h"  
#include "VariablesNaming.h"
//---------------------------------------------------------------------------
#include <string>
#include <vector>
//---------------------------------------------------------------------------

namespace geoxl {
	using namespace std;

class PointSet;
class InCorePCTopologyGraph;
class VariablesNamingScheme;


/*template <typename FloatType, unsigned dim> 
StaticMatrix<FloatType, dim, dim> makeIdentity();

template <typename FloatType, unsigned col0, unsigned col1, unsigned row0, unsigned row1> 
StaticMatrix<FloatType, col0+col1, row0+row1> quadMergeMatrix(
   const StaticMatrix<FloatType, col0, row0> &m00, const StaticMatrix<FloatType, col1, row0> &m10,
   const StaticMatrix<FloatType, col0, row1> &m01, const StaticMatrix<FloatType, col1, row1> &m11
);*/



template <typename FloatType, unsigned channelDim, typename IntType = int32>
class VectorVariableDifferenceMinimzationSystemSetup {
 private:
 public: 
   struct Neighbor {
      card32 index;
      float32 weight;
      StaticMatrix<FloatType, channelDim, channelDim> &coordTransform;
   };

   /// no right hand side because it is zero anyway
   void systemSetupAndAdd(
      const VariablesNamingScheme *naming,
      const VAR_AAT &variableName,
      card32 targetVariableIndex,
      const vector< Neighbor > &neighborhood,
      SparseMatrix<FloatType> &resultMat
   );
      
               
};


/**
	creates a sparse matrix that encodes the regularization constraints (for normals)
	to regularize patch-wise least-squares fitting
	add this matrix to one created by LeastSquaresSystemSetup
*/
template <typename FloatType, typename IntType = int32>
class NormalRegularizationSystemSetup {
 private:
	
 public:
	/// setup linear system for normal deviation regularization
	void systemSetup(const PointSet *patches, const InCorePCTopologyGraph *tg,
						  const VariablesNamingScheme *naming,
						  SparseMatrix<FloatType> &mat, DynamicVector<FloatType> &rhs);
};
	
	
}

#endif