//---------------------------------------------------------------------------
#ifndef GlobalOptimization2H
#define GlobalOptimization2H
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace geoxl {

class PatchGraph;
struct OptimizationRecord2;
class AnimationBSRContext;
class DebugRenderer;
class PointCloudAnimationSequence;


///
///   performs global optimization on a patch graph (and its data points)
///
class ANIMATIONRECONSTRUCTION_API GlobalOptimization2 : public Persistent {
	GEOXL_CLASS( GlobalOptimization2 )
 private:

 public:
	GlobalOptimization2();

	virtual void assign(const Object* obj, CopyContext *context = NULL);

	virtual void optimize( 
		AnimationBSRContext *context,
		PatchGraph* pg, 
	   PointCloudAnimationSequence *data,
		DebugRenderer *debugRenderer,
		OptimizationRecord2 *optRecord
   );

   ~GlobalOptimization2();
};

}

#endif