//---------------------------------------------------------------------------
#ifndef PGOpt2RemoveLowDegreeVerticesH
#define PGOpt2RemoveLowDegreeVerticesH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PTypes.h"
//---------------------------------------------------------------------------

namespace geoxl {

class AnimationBSRContext;
class PatchGraph;
class PointCloudAnimationSequence;

///
///   removes all vertices with low degree from patch graph and topology graph
///
class ANIMATIONRECONSTRUCTION_API PGOpt2RemoveLowDegreeVertices {
 private:
   static card32 processStep(const AnimationBSRContext *context, PatchGraph *pg);
 public:
   static void process(const AnimationBSRContext *context, PatchGraph *pg);
   static void removeUnsupported(const AnimationBSRContext *context, const card32 numDataFrames, PatchGraph *pg, PointCloudAnimationSequence *data);
};

}

#endif