//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PatchGraphResampler2.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "PatchGraphTopologicalResampling.h"
#include "AnimationBSRContext.h"
#include "RecomputeTopology2.h"
//#include "PGOpt2RemoveLowDegreeVertices.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



IMPLEMENT_GEOXL_CLASS( PatchGraphResampler2 ,0) {
	BEGIN_CLASS_INIT( PatchGraphResampler2 );
}

// ----

PatchGraphResampler2::PatchGraphResampler2() {
}

void PatchGraphResampler2::assign(const Object* obj, CopyContext *context) {
	copyObjectProperties(obj, this);
}

PatchGraphResampler2::~PatchGraphResampler2() {
}




void PatchGraphResampler2::resample(AnimationBSRContext *context, PatchGraph *pg) 
{
   pg->getTrajectorySet()->invalidateAllAttachments();

   RecomputeTopology2 recTop;
   recTop.setupStandardFilterConfig(RecomputeTopology2::FILTER_INIT_LENGTH_DEV);
   InCorePCTopologyGraph *newTop = recTop.recomputeTopology(context, pg);
   pg->setTopology(newTop);

   pg->getTrajectorySet()->invalidateAllAttachments();

   PatchGraphTopologicalResampling res;
   PatchGraph *newPG = res.resamplePatches(pg, context->getSamplingSpacing());
   pg->assign(newPG);
   delete newPG;
   
   pg->getTrajectorySet()->invalidateAllAttachments();

   recTop.setupStandardFilterConfig(RecomputeTopology2::FILTER_INIT_LENGTH_DEV);
   newTop = recTop.recomputeTopology(context, pg);
   pg->setTopology(newTop);
   //PGOpt2RemoveLowDegreeVertices::process(context, pg);

   pg->getTrajectorySet()->invalidateAllAttachments();
}
