//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "OptimizationGraph.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "PGOpt2Frame.h"
#include "PGOpt2FramePair.h"
#include "PGOpt2FramePairPair.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



IMPLEMENT_GEOXL_CLASS( OptimizationGraph , 0 )
{
	BEGIN_CLASS_INIT( OptimizationGraph );
	ADD_VAR_ARRAY_PROP( frames, 0, 
		new ObjectClassProperty( "element" , MetaClass::FIRST_VERSION, NULL, 
                               PGOpt2Frame::getClass(), true, NULL )
	)
	ADD_VAR_ARRAY_PROP( edges, 0, 
		new ObjectClassProperty( "element" , MetaClass::FIRST_VERSION, NULL, 
                               PGOpt2FramePair::getClass(), true, NULL )
	)
	ADD_VAR_ARRAY_PROP( interEdgeLinks, 0, 
		new ObjectClassProperty( "element" , MetaClass::FIRST_VERSION, NULL, 
                               PGOpt2FramePairPair::getClass(), true, NULL )
	)
}

OptimizationGraph::OptimizationGraph() {}

void OptimizationGraph::assign(const Object* obj, CopyContext *context)
{
	Persistent::assign(obj,context);
	const OptimizationGraph * o = dynamic_cast<const OptimizationGraph*>(obj);
	pAssert( o != NULL );
	copyObjectProperties(obj, this);
}

void OptimizationGraph::addFrame(PGOpt2Frame *frame) {
   frames.push_back(frame);
}

void OptimizationGraph::addEdge(PGOpt2FramePair *pair) {
   edges.push_back(pair);
}

void OptimizationGraph::addEdgePair(PGOpt2FramePairPair *edgeLink) {
   interEdgeLinks.push_back(edgeLink);
}


OptimizationGraph::~OptimizationGraph() {
   for (unsigned i=0; i<frames.size(); i++) {
      delete frames[i];
   }
   for (unsigned i=0; i<edges.size(); i++) {
      delete edges[i];
   }
   for (unsigned i=0; i<interEdgeLinks.size(); i++) {
      delete interEdgeLinks[i];
   }
}

