//---------------------------------------------------------------------------
#ifndef PGOpt2DebuggingH
#define PGOpt2DebuggingH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------
#include <vector>
//---------------------------------------------------------------------------

namespace geoxl {
   using namespace std;

class InCorePCTopologyGraph;
class PatchGraph;
class AnimationBSRContext;

///
///   helper functionality for debugging
///
class ANIMATIONRECONSTRUCTION_API PGOpt2Debugging {
 public:
   static void computeTopDegHistogram(const InCorePCTopologyGraph *tg, vector<card32> &result);
   static void ouputHistogram(const vector<card32> &h);
   static void outputValidityCheck(const PatchGraph *pg, string name = "pg validity");
   static void searchLongEdges(const AnimationBSRContext *context, const PatchGraph *pg);
   static void outputGraph(const InCorePCTopologyGraph *tg);
   static void outputPoints(const PatchGraph *pg);
};

}

#endif