//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PGOpt2FramePair.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "PointSet.h"
#include "EmbeddedObjectClassProperty.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



IMPLEMENT_GEOXL_CLASS(PGOpt2FramePair, 1) {
	BEGIN_CLASS_INIT(PGOpt2FramePair);
   ADD_CARD32_PROP(optFrameIndex1, 0)
   ADD_CARD32_PROP(optFrameIndex2, 0)
	ADD_VAR_ARRAY_PROP( patchIndices, 0, 
		new Card32ClassProperty( "element" , MetaClass::FIRST_VERSION, NULL )
	)
   ADD_OBJECT_PROP(patchPairsAttribs, 0, PointSet::getClass(), true);
   ADD_FLOAT32_PROP(rigidityWeight, 1)
}


// ----

PGOpt2FramePair::PGOpt2FramePair() {
   optFrameIndex1 = 0;
   optFrameIndex2 = 0;
   patchPairsAttribs = NULL;
   rigidityWeight = 1.0f;
}

void PGOpt2FramePair::setup(
   card32 optFrameIndex1,
   card32 optFrameIndex2,
   const vector<card32> &patchIndices,
   PointSet *patchPairsAttribs)
{
   this->optFrameIndex1 = optFrameIndex1;
   this->optFrameIndex2 = optFrameIndex2;
   this->patchIndices = patchIndices;
   this->patchPairsAttribs = patchPairsAttribs;
}


void PGOpt2FramePair::assign(const Object* obj, CopyContext *context) {
	copyObjectProperties(obj, this);
}

PGOpt2FramePair::~PGOpt2FramePair() {}


