//---------------------------------------------------------------------------
#ifndef PGOpt2FramePairPairH
#define PGOpt2FramePairPairH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
#include "PGOpt2PotentialSelector.h"
//---------------------------------------------------------------------------

namespace geoxl {

///
///   optimization between two pairs of frames
///
class ANIMATIONRECONSTRUCTION_API PGOpt2FramePairPair : public Persistent {
	GEOXL_CLASS( PGOpt2FramePairPair )
 private:
   /// index of first frame pair (index within containing container)
   card32 optFramePairIndex1;
   /// index of second frame pair (index within containing container)
   card32 optFramePairIndex2;
   /// index of patches that should be included in optimization
   vector<card32> patchIndices;

   PGOpt2ThreeFramePotentialSelector pairPairPotentials;

 public:

   PGOpt2FramePairPair();
   PGOpt2FramePairPair(card32 index1, card32 index2, const	 vector<card32> &patchIndices);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

	card32 getOptFramePairIndex1() const {return optFramePairIndex1;}
	void setOptFramePairIndex1(card32 v) {optFramePairIndex1=v;}

	card32 getOptFramePairIndex2() const {return optFramePairIndex2;}
	void setOptFramePairIndex2(card32 v) {optFramePairIndex2=v;}

	vector<card32> getPatchIndices() const {return patchIndices;}
	void setPatchIndices(const vector<card32> &v) {patchIndices=v;}

	PGOpt2ThreeFramePotentialSelector getPairPairPotentials() const {return pairPairPotentials;}
	void setPairPairPotentials(const PGOpt2ThreeFramePotentialSelector &v) {pairPairPotentials=v;}
};

}

#endif