//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PGOpt2FramePairVars.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
// insert your includes here
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



IMPLEMENT_GEOXL_CLASS( PGOpt2FramePairVars ,0) {
	BEGIN_CLASS_INIT( PGOpt2FramePairVars );
}

// ----

PGOpt2FramePairVars::PGOpt2FramePairVars() {
}

void PGOpt2FramePairVars::assign(const Object* obj, CopyContext *context) {
	copyObjectProperties(obj, this);
}

void PGOpt2FramePairVars::clear() {
   for (unsigned i=0; i<pairVars.size(); i++) {
      delete pairVars[i];
   }
   pairVars.clear();
}

void PGOpt2FramePairVars::setup(card32 numFramePairs, card32 numVars, const VertexDescriptor *vd) {
   clear();                                           
   pairVars.resize(numFramePairs);
   for (card32 i=0; i<numFramePairs; i++) {
      PointSet *ps = new PointSet();
      ps->clearAndSetup(1, numVars, vd);
      pairVars[i] = ps;
   }
}

PGOpt2FramePairVars::~PGOpt2FramePairVars() {
   clear();
}



