//---------------------------------------------------------------------------
#ifndef PGOpt2FramePairVarsH
#define PGOpt2FramePairVarsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace geoxl {

///
///   container for variables that describes relationships between frames during optimization
///
class ANIMATIONRECONSTRUCTION_API PGOpt2FramePairVars : public Persistent {
	GEOXL_CLASS( PGOpt2FramePairVars )
 private:
   vector<PointSet*> pairVars;

   void clear();

 public:
	PGOpt2FramePairVars();

	virtual void assign(const Object* obj, CopyContext *context = NULL);

   void setup(card32 numFramePairs, card32 numVars, const VertexDescriptor *vd);
   mpcard getNumFramePairVars() {return pairVars.size();}
   PointSet *getFramePairVars(card32 i) {return pairVars[i];}

   ~PGOpt2FramePairVars();
};

}

#endif