//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PGDataPointIndices.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



IMPLEMENT_GEOXL_CLASS( PGDataPointIndices ,0)
{
	BEGIN_CLASS_INIT( PGDataPointIndices );
}


// ----


PGDataPointIndices::PGDataPointIndices() {
}

void PGDataPointIndices::assign(const Object* obj, CopyContext *context) {
	const PGDataPointIndices *other = dynamic_cast<const PGDataPointIndices*>(obj);
	pAssert(other);
	if (other != NULL) {
		indices = other->indices;
	}
}

void PGDataPointIndices::write(OutputObjectStream *s) const {
	const card32 nt = (card32)indices.size();
	s->write<card32>(nt);
	for (unsigned t=0; t<nt; t++) {
		const card32 np = (card32)indices[t].size();
		s->write<card32>(np);
		for (unsigned p=0; p<np; p++) {
			const card32 ni = (card32)indices[t][p].size();
			s->write<card32>(ni);
			for (unsigned i=0; i<ni; i++) {
				s->write<card32>(indices[t][p][i]);
			}
		}
	}
}

void PGDataPointIndices::read(InputObjectStream *s) {
	indices.clear();
	card32 nt;
	s->read<card32>(nt);
	indices.resize(nt);
	for (unsigned t=0; t<nt; t++) {
		card32 np;
		s->read<card32>(np);
		indices[t].resize(np);
		for (unsigned p=0; p<np; p++) {
			card32 ni;
			s->read<card32>(ni);
			indices[t][p].resize(ni);
			for (unsigned i=0; i<ni; i++) {
				card32 index;
				s->read<card32>(index);
				indices[t][p][i] = index;
			}
		}
	}
}

void PGDataPointIndices::setup(card32 numFrames, card32 numPatches) {
	indices.clear();
	indices.resize(numFrames);
	for (card32 i=0; i<numFrames; i++) {
		indices[i].resize(numPatches);
	}
}
