//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PGMultiResolution.h"
//---------------------------------------------------------------------------
#include "PatchGraph.h"
#include "TrajectorySet.h"
#include "PointSet.h"
#include "PointSet_templCode.h"
#include "InCorePCTopologyGraph.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------

/*

IMPLEMENT_GEOXL_CLASS(PGMultiResolutionLevel , 0)
{
	BEGIN_CLASS_INIT(PGMultiResolutionLevel);
}

IMPLEMENT_GEOXL_CLASS(PGMultiResolution , 0)
{
	BEGIN_CLASS_INIT(PGMultiResolution);
}


// ----


PGMultiResolutionLevel::PGMultiResolutionLevel() {}
PGMultiResolutionLevel::~PGMultiResolutionLevel() {}

void PGMultiResolutionLevel::assign(const Object* obj, CopyContext *context) {
   PGMultiResolutionLevel *other = dynamic_cast<PGMultiResolutionLevel>(obj);
   pAssert(other);
   if (!other) return;
   activeIndicesByFlags = other->activeIndicesByFlags;
   activeIndices = other->activeIndices;
   topology = other->topology;
}

struct PointType {
   card32 index;
   
};

//static void computeNewActiveSetAndMergeTopology(
//   const PatchGraph *pg, PGMultiResolutionLevel *previousLevel,
//   vector<bool> &activeIndicesByFlags,
//   vector<card32> &activeIndices,
//   vector< vector<card32> > &topology)
//{
//   activeIndicesByFlags = previousLevel->activeIndicesByFlags;
//   activeIndices = previousLevel->activeIndices;
//   topology = previousLevel->topology;
//   
//   priority_queue<PointType>
//   
//}

bool PGMultiResolutionLevel::build(const PatchGraph *pg, PGMultiResolutionLevel *previousLevel) {
   if (previousLevel == NULL) {

      /// --- first mr level - this means, just copy original topology
      const PointSet *ps = pg->getTrajectorySet()->getTrajectories();
      const InCorePCTopologyGraph *tg = pg->getTopology();

      const card32 numPatches = ps->getHeight();
      activeIndicesByFlags.resize(numPatches, true);
      activeIndices.resize(numPatches);
      topology.resize(numPatches);
      for (card32 patch=0; patch<numPatches; patch++) {
         activeIndices[patch] = patch;
         const card32 numEdges = tg->getNumAdjacentVertices(patch);
         for (card32 edge=0; edge<numEdges; edge++) {
            topology[patch].push_back(tg->getAdjacentVertex(patch, edge));
         }
      }
      return true;
   } else {

      /// --- lower mr level (less details) - compute relative to previous level
      //computeNewActiveSetAndMergeTopology(pg, previousLevel, activeIndicesByFlags, activeIndices, topology);
      return false; // xxx
   }
}
      


// --


PGMultiResolution::PGMultiResolution() {}

void PGMultiResolution::assign(const Object* obj, CopyContext *context) {
   PGMultiResolution *other = dynamic_cast<PGMultiResolution>(obj);
   pAssert(other);
   if (!other) return;
   levels = other->levels;
}


void PGMultiResolution::build(const PatchGraph *pg, card32 maxNumLevels, card32 minNumPoints) {
   PGMultiResolutionLevel *previousLevel = NULL;
   bool success = false;
   do {
      PGMultiResolutionLevel *newLevel = new PGMultiResolutionLevel();
      bool success = newLevel->build(pg, previousLevel);
      previousLevel = newLevel;
      if (success) {
         levels.push_back(newLevel);
      } else {
         delete newLevel;
         break;
      }
   } while (previousLevel->getNumPoints() > minNumPoints && levels.size() < maxNumLevels);
}


PGMultiResolution::~PGMultiResolution() {
   for (unsigned i=0; i<levels.size(); i++) {
      delete levels[i];
   }
}

*/