//---------------------------------------------------------------------------
#ifndef PGMultiResolutionH
#define PGMultiResolutionH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace geoxl {
/*

class PatchGraph;
class PatchGraphTopologicalResampling;

//
//    A single level in the multi-resolution hiearchy.
//    It stores only indices.
//
class ANIMATIONRECONSTRUCTION_API PGMultiResolutionLevel : public Persistent {
	GEOXL_CLASS( PGMultiResolutionLevel )

   vector<bool> activeIndicesByFlags;
   vector<card32> activeIndices;
   vector< vector<card32> > topology;

 public:
	PGMultiResolutionLevel();
	
	/// build a multiresolution representation that contains half the number of trajectories
	/// previousLevel is the previous multi-resolution level
	/// set to NULL for the first level, which is just a copy of the original topology
	/// returns false if no more points can be removed
	bool build(const PatchGraph *pg, PGMultiResolutionLevel *previousLevel=NULL);

   /// number of patches/points/trajectories (whatever you call them) in the current level
   card32 getNumPoints() const {return activeIndices.size();}
   /// true if the original point of this index is contained in this level, false if it has been removed
   inline bool indexPresent(card32 index) const {return activeIndicesByFlags[index];}
   /// get list of points that are present in the resampled patch graph
   const vector<card32> &getActiveIndices() {return activeIndices;}
   /// get the topology of the resampled point cloud (list of adjacency lists, list i is storing 
   /// the neighborhood of getActiveIndices()[i]
   const vector< vector<card32> > &getTopology() {return topology;}
   
   /// computes a patch graph that contains only a subset of the original patches
   /// given the orignal one that was used for building the multi resolution level
   PatchGraph *createResampledPatchGraph(const PatchGraph *original);

   // assign, read, write does not work (implement if needed)
   virtual void assign(const Object* obj, CopyContext *context = NULL);
   virtual void read(InputObjectStream *s) {pAssert(false);}
   virtual void write(OutputObjectStream *s) {pAssert(false);}

	~PGMultiResolutionLevel();
 friend PatchGraphTopologicalResampling;
};


//
//	This class represents a resampled version of the original patch graph.
//	The representation can for example be used for regularization of deformation potentials
//	or multi-grid solution of the non-linear problems.
//
class ANIMATIONRECONSTRUCTION_API PGMultiResolution : public Persistent {
	GEOXL_CLASS( PGMultiResolution )

 private:
   vector<PGMultiResolutionLevel*> levels;

 public:
	PGMultiResolution();
   
   // assign, read, write does not work (implement if needed)
   virtual void assign(const Object* obj, CopyContext *context = NULL);
   virtual void read(InputObjectStream *s) {pAssert(false);}
   virtual void write(OutputObjectStream *s) {pAssert(false);}

   /// build multi-resolution representation. stop if maximum number of levels or minimum number of points is reached
   void build(const PatchGraph *pg, card32 maxNumLevels = 7, card32 minNumPoints = 100);
   
   /// get number of multi-resolution levels
   card32 getNumLevels() {return levels.size();}
   /// get one level; level zero refers to the original trajectories/topology
   PGMultiResolutionLevel *getLevel(card32 i) {return levels[i];}
   
	~PGMultiResolution();
};

 */
}

#endif