//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PatchTypes.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



const VAD geoxl::POSITION_PATCH_VAD  = mVAD(PATCH_CHANNEL_NAME_POSITION,  3, VAD::DATA_FORMAT_FLOAT32);
const VAD geoxl::NORMAL_PATCH_VAD    = mVAD(PATCH_CHANNEL_NAME_NORMAL,	   3, VAD::DATA_FORMAT_FLOAT32);
const VAD geoxl::TANGENT_U_PATCH_VAD = mVAD(PATCH_CHANNEL_NAME_TANGENT_U,	3, VAD::DATA_FORMAT_FLOAT32);
const VAD geoxl::ROTATION_MATRIX_PATCH_VAD = mVAD(PATCH_CHANNEL_NAME_ROTATION_MATRIX,	4, VAD::DATA_FORMAT_FLOAT32);

VAD geoxl::createHeightfieldCoeffVAD(card32 numCoeff) {
	return mVAD(HEIGHTFIELD_COEFFS_NAME, numCoeff, VAD::DATA_FORMAT_FLOAT32);
}

VAD geoxl::createCorrespondenceCoeffVAD(card32 numCoeff) {
	return mVAD(CORRESPONDENCE_COEFFS_NAME, numCoeff, VAD::DATA_FORMAT_FLOAT32);
}

void CoefficientSet::get(const PointSet *ps, card32 i, AAT aat) {
	const card32 numCoeffs = coeffs.getDim();
	const char *vertex = ps->getDataPointer(i);
	const float32 *vertexf = (const float32*)(vertex + aat.getOffset());
	for (card32 i=0; i<numCoeffs; i++) {
		coeffs[i] = *vertexf;
		vertexf++;
	}
}

void CoefficientSet::set(PointSet *ps, card32 i, AAT aat) {
	const card32 numCoeffs = coeffs.getDim();
	char *vertex = ps->getDataPointer(i);
	float32 *vertexf = (float32*)(vertex + aat.getOffset());
	for (card32 i=0; i<numCoeffs; i++) {
		*vertexf = coeffs[i];
		vertexf++;
	}
}
