//---------------------------------------------------------------------------
#include "stdafx.h"
//---------------------------------------------------------------------------
#include "VariablesNaming.h"
#include "VariablesNaming_templCode.h"
//---------------------------------------------------------------------------
using namespace geoxl;
using namespace std;
//---------------------------------------------------------------------------



mpint VariablesNamingScheme::getIndex(string name) const {
	pAssert(attributes.size() == offsets.size());
	mpint n = attributes.size();
	for (mpint i=0; i<n; i++) {
		if (attributes[i].name == name) {
			return i;
		}
	}
	return -1;
}

void VariablesNamingScheme::addAttrib(VariablesAttributeDescriptor attrib) {
	pAssert(getIndex(attrib.name) == -1);
	attributes.push_back(attrib);
	if (offsets.empty()) {
		offsets.push_back(attrib.numElements);
	} else {
		offsets.push_back(offsets.back() + attrib.numElements);
	}
}

VariablesAAT VariablesNamingScheme::getAAT(string name) const {
	mpint i = getIndex(name);
	if (i == -1) {
		throw ERangeCheck("VariablesNamingScheme::getAAT() - name not found.");
	}
	pAssert((unsigned)i < offsets.size());
	pAssert((unsigned)i < attributes.size());
	VAR_AAT result;
   if (i>0) {
   	result.indexOffset = offsets[i-1];
   } else {
      result.indexOffset = 0;
   }
	result.numElements = attributes[i].numElements;
  	result.overallNumElements = offsets.back();
	return result;
}
