//---------------------------------------------------------------------------
#include "VariablesNaming.h"
//---------------------------------------------------------------------------
using namespace geoxl;
using namespace std;
//---------------------------------------------------------------------------


// -- NamedDynamicVector

template <class FloatType>
NamedDynamicVector<FloatType>::NamedDynamicVector(DynamicVector<FloatType> &init_op) : op(init_op) {}

template <class FloatType>
FloatType &NamedDynamicVector<FloatType>::get(VAR_AAT aat, unsigned varIndex, unsigned streamIndex) {
	return op[aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*streamIndex];
}

template <class FloatType>
const FloatType &NamedDynamicVector<FloatType>::get(VAR_AAT aat, unsigned varIndex, unsigned streamIndex) const {
	return op[aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*streamIndex];
}



// -- NamedSparseVector

template <class FloatType>
NamedSparseVector<FloatType>::NamedSparseVector(SparseVector<FloatType> &init_op) : op(init_op) {}

template <class FloatType>
FloatType &NamedSparseVector<FloatType>::get(VAR_AAT aat, unsigned varIndex, unsigned streamIndex) {
	return op[aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*streamIndex];
}

template <class FloatType>
const FloatType &NamedSparseVector<FloatType>::get(VAR_AAT aat, unsigned varIndex, unsigned streamIndex) const {
	return op[aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*streamIndex];
}



// -- NamedDynamicMatrix

template <class FloatType>
NamedDynamicMatrix<FloatType>::NamedDynamicMatrix(DynamicMatrix<FloatType> &init_op) : op(init_op) {}

template <class FloatType>
DynamicVector<FloatType> &NamedDynamicMatrix<FloatType>::getRow(VAR_AAT aat, unsigned varIndex, unsigned row) {
	return op[aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*row];
}

template <class FloatType>
const DynamicVector<FloatType> &NamedDynamicMatrix<FloatType>::getRow(VAR_AAT aat, unsigned varIndex, unsigned row) const {
	return op[aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*row];
}

template <class FloatType>
FloatType &NamedDynamicMatrix<FloatType>::get(VAR_AAT aat, unsigned varIndex, unsigned row, unsigned column) {
	return op[aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*index]
	         [aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*column];
}

template <class FloatType>
const FloatType &NamedDynamicMatrix<FloatType>::get(VAR_AAT aat, unsigned varIndex, unsigned row, unsigned column) const {
	return op[aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*index]
	         [aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*column];
}



// -- NamedSparseMatrix

template <class FloatType>
NamedSparseMatrix<FloatType>::NamedSparseMatrix(SparseMatrix<FloatType> &init_op) : op(init_op) {}

template <class FloatType>
SparseVector<FloatType> &NamedSparseMatrix<FloatType>::getRow(VAR_AAT aat, unsigned varIndex, unsigned row) {
	return op[aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*row];
}

template <class FloatType>
const SparseVector<FloatType> &NamedSparseMatrix<FloatType>::getRow(VAR_AAT aat, unsigned varIndex, unsigned row) const {
	return op[aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*row];
}

template <class FloatType>
FloatType &NamedSparseMatrix<FloatType>::get(VAR_AAT aat, unsigned varIndex, unsigned row, unsigned column) {
	return op[aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*index]
	         [aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*column];
}

template <class FloatType>
const FloatType &NamedSparseMatrix<FloatType>::get(VAR_AAT aat, unsigned varIndex, unsigned row, unsigned column) const {
	return op[aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*index]
	         [aat.getIndexOffset() + varIndex + aat.getOverallNumElements()*column];
}
