#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "Correspondence.h"
//---------------------------------------------------------------------------
// insert your includes here
//---------------------------------------------------------------------------
using namespace geoxl;

IMPLEMENT_GEOXL_CLASS( Correspondence ,2)
{
	BEGIN_CLASS_INIT( Correspondence );

	ADD_VECTOR3F_PROP( m_Position1, 0 );
	ADD_VECTOR3F_PROP( m_Position2, 0 );
	ADD_CARD32_PROP( m_StartFrame, 0);
	ADD_VECTOR3F_PROP( m_Color, 1 );
	ADD_CARD32_PROP( m_Flags, 2 );
}

Correspondence::Correspondence(void)
{
	m_StartFrame = 0;
	m_Position1 = m_Position2 = makeVector3f(0,0,0);
	m_Color = makeVector3f(1,1,1);
	m_Flags = 0;
}

Correspondence::~Correspondence(void)
{
}

void Correspondence::assign(const Object* obj, CopyContext *context)
{
	//Persistent::assign(obj,context);
	const Correspondence * o = dynamic_cast<const Correspondence*>(obj);
	pAssert( o != NULL );

	m_Position1 = o->m_Position1;
	m_Position2 = o->m_Position2;
	m_StartFrame = o->m_StartFrame;
	m_Color = o->m_Color;
	m_Flags = o->m_Flags;
}