#ifndef CorrespondenceH
#define CorrespondenceH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	holds a single correspondence between two features
*/
class ANIMATIONRECONSTRUCTION_API Correspondence : public Persistent
{
	GEOXL_CLASS( Correspondence )

private:

	Vector3f		m_Position1;
	Vector3f		m_Position2;
	card32		m_StartFrame;
	Vector3f		m_Color;
	card32		m_Flags;

public:
	Correspondence(void);
	~Correspondence(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

	Vector3f getPosition1() const {return m_Position1;}
	void setPosition1(Vector3f v) {m_Position1=v;}

	Vector3f getPosition2() const {return m_Position2;}
	void setPosition2(Vector3f v) {m_Position2=v;}

	card32 getStartFrame() const {return m_StartFrame;}
	void setStartFrame(card32 v) {m_StartFrame=v;}

	Vector3f getColor() const {return m_Color;}
	void setColor(Vector3f v) {m_Color=v;}

	card32 getFlags() const {return m_Flags;}
	void setFlags(card32 v) {m_Flags=v;}

	enum ECorrFlags
	{
		CF_Initial = 0x1,
		CF_Guessed = 0x2
	};


};

}

#endif