#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "CorrespondenceList.h"
//---------------------------------------------------------------------------
#include "StringHelper.h"
//---------------------------------------------------------------------------
using namespace geoxl;

IMPLEMENT_GEOXL_CLASS( CorrespondenceList ,0)
{
	BEGIN_CLASS_INIT( CorrespondenceList );

	ADD_VAR_ARRAY_PROP( Correspondence, 0, new ObjectClassProperty( "", 0, NULL, Correspondence::getClass()));
	SET_NAME( "Correspondences" );

}

CorrespondenceList::CorrespondenceList(void)
{
}

CorrespondenceList::~CorrespondenceList(void)
{
	setNumCorrespondences(0);
}

void CorrespondenceList::assign(const Object* obj, CopyContext *context)
{
	//Persistent::assign(obj,context);
	CorrespondenceList * o = dynamic_cast<CorrespondenceList*>((Object*)obj);
	pAssert( o != NULL );

	setNumCorrespondences(0);
	for( card32 i=0;i<o->getNumCorrespondences();i++ )
		m_Correspondences.push_back( (Correspondence*)o->get(i)->copy() );

}
void CorrespondenceList::setNumCorrespondences(card32 size) 
{
	if( size == m_Correspondences.size() )
		return;

	if( size < m_Correspondences.size() )
	{
		for( card32 i=size;i<m_Correspondences.size();i++ )
			delete m_Correspondences[i];
		m_Correspondences.resize(size);
	}
	else
	{
		while( size > m_Correspondences.size() )
		{
			m_Correspondences.push_back( new Correspondence );
		}
	}
}

void CorrespondenceList::deleteCorrespondence( card32 index ) 
{
	delete m_Correspondences[index];
	m_Correspondences.erase( m_Correspondences.begin() + index );
}

char *CorrespondenceList::getCorrespondence( card32 index ) 
{
	return (char*)&m_Correspondences[index];
}

mpcard CorrespondenceList::getNumCorrespondences() 
{
	return m_Correspondences.size();
}

string CorrespondenceList::getCorrespondenceName(card32 index ) 
{
	return intToStr( index );
}
