#ifndef CorrespondenceListH
#define CorrespondenceListH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------
#include "Correspondence.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	stores a list of correspondences
*/
class ANIMATIONRECONSTRUCTION_API CorrespondenceList : public Persistent
{
	GEOXL_CLASS( CorrespondenceList )

private:

	vector<Correspondence*>		m_Correspondences;

public:
	CorrespondenceList(void);
	~CorrespondenceList(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

   void setNumCorrespondences(card32 size);
   void deleteCorrespondence( card32 index );
   char * getCorrespondence( card32 index );
   mpcard getNumCorrespondences();
   string getCorrespondenceName(card32 index );

	Correspondence * get(card32 i) {return m_Correspondences[i];}

	void setup( const vector<Correspondence*> &clist ) {setNumCorrespondences(0); m_Correspondences = clist;}


};

}

#endif