#ifndef FDAttributeH
#define FDAttributeH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "FeatureDescriptor.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	uses a specified attribute to describe the surface
*/
class ANIMATIONRECONSTRUCTION_API FDAttribute : public FeatureDescriptor
{
	GEOXL_CLASS( FDAttribute )

private:

	string	m_AttributeName;
	card32	m_NumComponents;
	card32	m_FirstComponent;

	void setNumDescriptorDatas(card32 size);
	void deleteDescriptorData( card32 index );
	char * getDescriptorData( card32 index );
	mpcard getNumDescriptorDatas();
	string getDescriptorDataName(card32 index );

public:
	FDAttribute(void);
	~FDAttribute(void);

	virtual void assign(const Object* obj, CopyContext *context = NULL);

	virtual void createDescriptor( const Vector3f &point, float size, PointCloud * pc, TDescriptorContext * context );

	virtual mpcard getNumDescriptorValues() {return m_NumComponents;}

	string getAttributeName() const {return m_AttributeName;}
	void setAttributeName(string v) {m_AttributeName=v;}

	card32 getNumComponents() const {return m_NumComponents;}
	void setNumComponents(card32 v) {m_NumComponents=v;}

	card32 getFirstComponent() const {return m_FirstComponent;}
	void setFirstComponent(card32 v) {m_FirstComponent=v;}
};

}

#endif