#ifndef FDAverageH
#define FDAverageH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "FeatureDescriptor.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	average descriptor using average from an attribute
*/
class ANIMATIONRECONSTRUCTION_API FDAverage : public FeatureDescriptor
{
	GEOXL_CLASS( FDAverage )

private:

	card32	m_NumRings;
	string	m_Attribute;
	card32	m_NumComponents;



	void setNumDescriptorDatas(card32 size);
   void deleteDescriptorData( card32 index );
   char * getDescriptorData( card32 index );
   mpcard getNumDescriptorDatas();
   string getDescriptorDataName(card32 index );


public:
	FDAverage(void);
	~FDAverage(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);
	virtual void createDescriptor( const Vector3f &point, float size, PointCloud * pc, TDescriptorContext * context );
	virtual mpcard getNumDescriptorValues() {return m_NumComponents*m_NumRings;}

	card32 getNumRings() const {return m_NumRings;}
	void setNumRings(card32 v) {m_NumRings=v;}

	string getAttribute() const {return m_Attribute;}
	void setAttribute(string v) {m_Attribute=v;}

	card32 getNumComponents() const {return m_NumComponents;}
	void setNumComponents(card32 v) {m_NumComponents=v;}

};

}

#endif