#ifndef FDClusteredHistogramH
#define FDClusteredHistogramH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "FeatureDescriptor.h"
//---------------------------------------------------------------------------

namespace geoxl
{
class PointCloudAnimationSequence;
class PatchGraph;
/**
	builds circular histograms around a feature (ring histograms). before using this descriptor
	one has to run setupClusters() to build the codebook
*/
class ANIMATIONRECONSTRUCTION_API FDClusteredHistogram : public FeatureDescriptor
{
	GEOXL_CLASS( FDClusteredHistogram )

private:

	card32		m_NumHistograms;
	card32		m_NumBins;
	string		m_Attribute;
	card32		m_NumComponents;

	vector<float> m_Clusters;

	IMPLEMENT_VAR_ARRAY_METHODS_STL( m_DescriptorData );


public:
	FDClusteredHistogram(void);
	~FDClusteredHistogram(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

	virtual void createDescriptor( const Vector3f &point, float size, PointCloud * pc, TDescriptorContext * context );
	virtual mpcard getNumDescriptorValues() {return m_NumHistograms*m_NumBins;}

	void setupClusters( const vector<PatchGraph*> &pgs, const PointCloudAnimationSequence *data );


};

}

#endif