#ifndef FDColorPCAH
#define FDColorPCAH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "FeatureDescriptor.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	uses pca to calculate an elipsoid in colorspace, stores centroid + elipsoid
*/
class ANIMATIONRECONSTRUCTION_API FDColorPCA : public FeatureDescriptor
{
	GEOXL_CLASS( FDColorPCA )

private:

	card32	m_NumRings;

	void setNumDescriptorDatas(card32 size);
	void deleteDescriptorData( card32 index );
	char * getDescriptorData( card32 index );
	mpcard getNumDescriptorDatas();
	string getDescriptorDataName(card32 index );

public:
	FDColorPCA(void);
	~FDColorPCA(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

	virtual void createDescriptor( const Vector3f &point, float size, PointCloud * pc, TDescriptorContext * context );
	virtual mpcard getNumDescriptorValues() {return 3 * m_NumRings;}

};

}

#endif