#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "FDCombined.h"
//---------------------------------------------------------------------------
#include "ObjectListProperty.h"
#include "CopyObjectProperties.h"
//---------------------------------------------------------------------------
using namespace geoxl;

IMPLEMENT_GEOXL_CLASS( FDCombined ,0)
{
	BEGIN_CLASS_INIT( FDCombined );
	ADD_OBJECT_LIST_PROP( Desc, 0, FeatureDescriptor::getClass() );
}

FDCombined::FDCombined(void)
{
}

FDCombined::~FDCombined(void)
{
	deleteDescs( 0, (card32)m_Desc.size() );
}

void FDCombined::assign(const Object* obj, CopyContext *context)
{
	FeatureDescriptor::assign(obj,context);
	const FDCombined * o = dynamic_cast<const FDCombined*>(obj);
	pAssert( o != NULL );

	copyObjectProperties( obj, this );

}
void FDCombined::createDescriptor( const Vector3f &point, float size, PointCloud * pc, TDescriptorContext * context ) 
{
	for( card32 i=0;i<m_Desc.size();i++ )
		m_Desc[i]->createDescriptor( point, size, pc, context );
}

mpcard FDCombined::getNumDescriptorValues() 
{
	mpcard ret = 0;
	for( mpcard i=0;i<m_Desc.size();i++ )
		ret += m_Desc[i]->getNumDescriptorValues();
	return ret;
}

void FDCombined::addDesc( Object * obj ) 
{
	m_Desc.push_back( (FeatureDescriptor*)obj);
}

void FDCombined::deleteDescs( card32 begin, card32 end ) 
{
	for( card32 i=begin;i<end;i++ )
		delete m_Desc[i];
	m_Desc.erase( m_Desc.begin() + begin,m_Desc.begin() + end );
}

Object *FDCombined::getDesc( card32 index ) 
{
	return m_Desc[index];
}

void FDCombined::moveDesc( card32 oldPos, card32 newPos ) 
{
}

mpcard FDCombined::getNumDescs() 
{
	return m_Desc.size();
}

string FDCombined::getDescName(card32 index ) 
{
	return m_Desc[index]->getClass()->getClassName();
}

float FDCombined::compare( const FeatureDescriptor * other ) 
{
	const FDCombined * fdc = dynamic_cast<const FDCombined*>(other);
	float ret = 0;
	for( card32 i=0;i<m_Desc.size();i++ )
		ret += m_Desc[i]->compare( fdc->m_Desc[i] );
	return ret;
}
