#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "FastFeature.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "FeatureDescriptor.h"
#include "CentroidDescriptor.h"
//---------------------------------------------------------------------------
using namespace geoxl;

IMPLEMENT_GEOXL_CLASS( FastFeature ,1)
{
	BEGIN_CLASS_INIT( FastFeature );

	ADD_VECTOR3F_PROP( m_Pos, 0 );
	ADD_VECTOR3F_PROP( m_Normal, 0 );
	ADD_FLOAT32_PROP( m_Radius, 0 );
	ADD_INT32_PROP( m_Level, 0 );
	ADD_BOOLEAN_PROP( m_IsMin,0 );
	ADD_MATRIX3F_PROP( m_TangentFrame, 0 );
	ADD_BOOLEAN_PROP( m_Valid, 0 );
	ADD_FLOAT32_PROP( m_Difference, 0 );
	ADD_FLOAT32_PROP( m_Sigma, 0 );

	ADD_VECTOR3F_PROP( m_Movement, 0);
	ADD_VECTOR3F_PROP( m_SourcePoint, 0 );

	ADD_FLOAT32_PROP( m_Weight,1);

	ADD_OBJECT_PROP( m_Descriptor, 0, FeatureDescriptor::getClass(), true );
}

FastFeature::FastFeature(void)
{
	m_Descriptor = NULL;
	m_CD_Signature = NULL;
}

FastFeature::~FastFeature(void)
{
	delete m_Descriptor;
	delete m_CD_Signature;
}

void FastFeature::assign(const Object* obj, CopyContext *context)
{
	//Persistent::assign(obj,context);
	const FastFeature * o = dynamic_cast<const FastFeature*>(obj);
	pAssert( o != NULL );

	copyObjectProperties( obj, this );
}