#ifndef FastFeatureH
#define FastFeatureH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace geoxl
{
class FeatureDescriptor;
class CentroidSignature;
/**
	simple data class for fast features
*/
class ANIMATIONRECONSTRUCTION_API FastFeature : public Persistent
{
	GEOXL_CLASS( FastFeature )

public:
	FastFeature(void);
	~FastFeature(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);


	Vector3f		m_Pos;
	Vector3f		m_Normal;
	float32		m_Radius;
	int32			m_Level;
	bool			m_IsMin;
	Matrix3f		m_TangentFrame;
	bool			m_Valid;
	float			m_Difference;
	float			m_Sigma;
	float			m_Weight;

	Vector3f		m_Movement;	// stores refinement vector for visualization
	Vector3f		m_SourcePoint;

	vector<Vector3f> m_Samples;	// enviroment samples for local icp
	CentroidSignature	*	m_CD_Signature;

	FeatureDescriptor * m_Descriptor;


};

}

#endif