#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "FeatureAttachment.h"
//---------------------------------------------------------------------------
#include "StringHelper.h"
#include "CopyObjectProperties.h"
#include "ObjectListProperty.h"
//---------------------------------------------------------------------------
using namespace geoxl;

IMPLEMENT_GEOXL_CLASS( FeatureAttachment ,0)
{
	BEGIN_CLASS_INIT( FeatureAttachment );

	ADD_OBJECT_LIST_PROP( _Feature, 0, FastFeature::getClass() );
}

FeatureAttachment::FeatureAttachment(void)
{
}

FeatureAttachment::~FeatureAttachment(void)
{
}

void FeatureAttachment::assign(const Object* obj, CopyContext *context)
{
	AttachedData::assign(obj,context);
	const FeatureAttachment * o = dynamic_cast<const FeatureAttachment*>(obj);
	pAssert( o != NULL );

	copyObjectProperties( obj, this );
}

string FeatureAttachment::get_FeatureName(card32 index ) 
{
	return intToStr(index);
}

void FeatureAttachment::addFeature( FastFeature * f ) 
{
	m_Features.push_back(f);
}

FastFeature *FeatureAttachment::getFeature( card32 i ) 
{
	return m_Features[i];
}

void FeatureAttachment::clearFeatures() 
{
	m_Features.clear();
}

void FeatureAttachment::addFeatureSet( FeatureAttachment * att, const Matrix4f &transf) 
{
	for( card32 i=0;i<att->getNumFeatures();i++ )
	{
		FastFeature * f = (FastFeature*)att->getFeature(i)->copy();
		f->m_Pos = shrink4To3( transf * expand3To4(f->m_Pos));
		f->m_Normal = shrink4To3(transf) * f->m_Normal;
		f->m_SourcePoint = shrink4To3( transf * expand3To4(f->m_SourcePoint));
		f->m_TangentFrame = shrink4To3(transf) * f->m_TangentFrame;
		addFeature(f);
	}
}
