#ifndef FeatureAttachmentH
#define FeatureAttachmentH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
#include "FastFeature.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	container attachment for fast features
*/
class ANIMATIONRECONSTRUCTION_API FeatureAttachment : public AttachedData
{
	GEOXL_CLASS( FeatureAttachment )

private:

	vector<FastFeature*>		m_Features;

public:
	FeatureAttachment(void);
	~FeatureAttachment(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

	// public interface
	/// adds feature, becomes owner of f
	void addFeature( FastFeature * f );

	FastFeature * getFeature( card32 i );
	mpcard getNumFeatures() const {return m_Features.size();}

	void clearFeatures();

	static string attachmentName() {return "FastFeatureAttachment";}

	void addFeatureSet( FeatureAttachment * att, const Matrix4f &transf);

private:

	// intern interface
	void add_Feature( Object * obj ) {m_Features.push_back( (FastFeature*)obj );}
	void delete_Features( card32 begin, card32 end ){
		for( card32 i=begin;i<end;i++ )
			delete m_Features[i];
		m_Features.erase( m_Features.begin() + begin, m_Features.begin() + end);
	}
	Object * get_Feature( card32 index ) {return m_Features[index];}
	void move_Feature( card32 oldPos, card32 newPos ) {}
	mpcard getNum_Features() {return m_Features.size();}
	string get_FeatureName(card32 index );

};

}

#endif