#ifndef FeatureCorrespondencesH
#define FeatureCorrespondencesH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------
#include "Correspondence.h"
//---------------------------------------------------------------------------

namespace geoxl
{

class CorrespondenceList;

/**
	stores correspondences between features from different patch graphs
*/
class ANIMATIONRECONSTRUCTION_API FeatureCorrespondences : public Persistent
{
	GEOXL_CLASS( FeatureCorrespondences )

private:

	vector<CorrespondenceList*>	m_Frames;

	void setNumFrames(card32 size);
   void deleteFrame( card32 index );
   char * getFrame( card32 index );
   string getFrameName(card32 index );


public:
	FeatureCorrespondences(void);
	~FeatureCorrespondences(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);


	struct TFeatureCorrespondence
	{
		card32 frameID;
		Vector3f pos1, pos2;
	};

	mpcard getNumFrames();
	card32 getNumCorrespondenciesInFrame( card32 frameID );
	Correspondence * getCorrespondence( card32 frameID, card32 index );

	void setup( card32 numFrames );
	CorrespondenceList * getFrameCorrespondences( card32 frameID ) {return m_Frames[frameID];}



};

}

#endif