#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "FeatureDescriptor.h"
//---------------------------------------------------------------------------
#include "StringHelper.h"
//---------------------------------------------------------------------------
using namespace geoxl;

IMPLEMENT_GEOXL_CLASS( FeatureDescriptor ,0)
{
	BEGIN_CLASS_INIT( FeatureDescriptor );
}

FeatureDescriptor::FeatureDescriptor(void)
{
}

FeatureDescriptor::~FeatureDescriptor(void)
{
}

void FeatureDescriptor::assign(const Object* obj, CopyContext *context)
{
	const FeatureDescriptor * fd = dynamic_cast<const FeatureDescriptor*>(obj);
	pAssert( fd );
	m_DescriptorData = fd->m_DescriptorData;
}

float FeatureDescriptor::compare( const FeatureDescriptor * other ) 
{
	float ret = 0;
	for( card32 i=0;i<m_DescriptorData.size();i++ )
		ret += pow( m_DescriptorData[i] - (*other)[i], 2.0f );
	return sqrt( ret );
}

void FeatureDescriptor::normalizeDescriptor() 
{
	float l = 0.0f;
	for( card32 i=0;i<m_DescriptorData.size();i++ )
		l += pow( m_DescriptorData[i] ,2.0f );
	if( l < 1e-20f )
		l = 1.0f;
	for( card32 i=0;i<m_DescriptorData.size();i++ )
	{
		m_DescriptorData[i] /= l;
	}

}

void FeatureDescriptor::setupDescriptorData( float * data, card32 numEntries ) 
{
	m_DescriptorData.resize( numEntries );
	for( card32 i=0;i<numEntries;i++ )
		m_DescriptorData[i] = data[i];
}
