#ifndef FeatureDetectorH
#define FeatureDetectorH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------
#include "Feature.h"

namespace geoxl
{

/**
	base class for feature detection
*/
class ANIMATIONRECONSTRUCTION_API FeatureDetector : public Persistent
{
	GEOXL_ABSTRACT_CLASS( FeatureDetector )

private:

public:
	FeatureDetector(void);
	~FeatureDetector(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

	/// detects a set of features for a given point cloud
	virtual FeatureList * detectFeatures( PointCloud * pc, float radius ) = 0;

	virtual vector<FeatureList*> detectFeatures( vector<PointCloud*> pcs, float radius );

};

}

#endif