#ifndef LocalExtremaDetectorH
#define LocalExtremaDetectorH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "FeatureDetector.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	feature detector searching for local maxima/minima 
*/
class ANIMATIONRECONSTRUCTION_API LocalExtremaDetector : public FeatureDetector
{
	GEOXL_CLASS( LocalExtremaDetector )

private:

	string	m_Attribute;	// attribute defining extremas (attribute,componentNumber)
	card32	m_ComponentNumber;	// (attribute,componentNumber)
	float32	m_MinMagnitude;	// reject extremas with lower magnitudes

public:
	LocalExtremaDetector(void);
	~LocalExtremaDetector(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

	virtual FeatureList * detectFeatures( PointCloud * pc, float radius );

	string getAttribute() const {return m_Attribute;}
	void setAttribute(string v) {m_Attribute=v;}

	card32 getComponentNumber() const {return m_ComponentNumber;}
	void setComponentNumber(card32 v) {m_ComponentNumber=v;}

	float32 getMinMagnitude() const {return m_MinMagnitude;}
	void setMinMagnitude(float32 v) {m_MinMagnitude=v;}

};

}

#endif