#ifndef ParametricFeatureDetectorH
#define ParametricFeatureDetectorH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "FeatureDetector.h"
//---------------------------------------------------------------------------

namespace geoxl
{

class LocalParameterization;
class ScatterDataInterpolation;

/**
	base class for parametric feature detection.
	provides automatic sampling, parameterization & scattered data interpolation
	
*/
class ANIMATIONRECONSTRUCTION_API ParametricFeatureDetector : public FeatureDetector
{
	GEOXL_ABSTRACT_CLASS( ParametricFeatureDetector )

private:

	card32	m_ImageSize;	// default size of parametric image
	
	LocalParameterization * m_LocalParameterization;
	ScatterDataInterpolation * m_ScatteredDataInterPolation;


protected:


public:
	ParametricFeatureDetector(void);
	~ParametricFeatureDetector(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

	card32 getImageSize() const {return m_ImageSize;}
	void setImageSize(card32 v) {m_ImageSize=v;}

	//virtual vector<Feature> detectFeatures( PointCloud * pc, float radius );



};

}

#endif