#ifndef PCCPrepareAnimPointCloudH
#define PCCPrepareAnimPointCloudH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace geoxl {

/**
	converts point clouds to unstructured point clouds and filters out points with low intensity or zero position
	used for swiss ranger data
*/
class ANIMATIONRECONSTRUCTION_API PCCPrepareAnimPointCloud : public PCCommand {
	GEOXL_CLASS( PCCPrepareAnimPointCloud )

private:
   float32 minIntensity;
   bool deleteZeroPosPoints;
   bool deleteLowIntensityPoints;

public:
	PCCPrepareAnimPointCloud();

   virtual void execute(Scene *scene);

	~PCCPrepareAnimPointCloud();
};

}

#endif