//---------------------------------------------------------------------------
#ifndef PCCResamplePointCloudH
#define PCCResamplePointCloudH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace geoxl {

class HierarchicalIterator;
class SceneObjectIterator;

/**
	resamples point clouds to fixed sample spacing
	(downsampling only)
*/
class ANIMATIONRECONSTRUCTION_API PCCResamplePointCloud : public PCCommand {
	GEOXL_CLASS( PCCResamplePointCloud )

 private:
	float32 maxSpacing;

	void rekursiveDownsampling(HierarchicalIterator *hit, SceneObjectIterator *it);

 public:
	PCCResamplePointCloud();
	
   virtual void execute(Scene *scene);
};

}

#endif