#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "MMLBFGS.h"
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
using namespace geoxl;


MMLBFGS::MMLBFGS(int N, int forgetit, int forgetit2)
{
	this->N = N;
	x=new double[N];
	g=new double[N];
	m = NULL;
	cnls = cng = cnf = 0;
}

MMLBFGS::~MMLBFGS(void)
{
	delete x;
	delete g;
}

lbfgsfloatval_t lbfgs_evaluteFunctionAndGradient(    void *instance,
												 const lbfgsfloatval_t *x,
												 lbfgsfloatval_t *g,
												 const int n,
												 const lbfgsfloatval_t step )
{
	MMLBFGS * obj = (MMLBFGS*)instance;
	return obj->evaluteFunctionAndGradient(x,g,n,step);
}


void geoxl::MMLBFGS::solve()
{
	lbfgs_parameter_t param;
	lbfgs_parameter_init(&param);
	lbfgsfloatval_t fx;

	lbfgsfloatval_t * optX = new lbfgsfloatval_t[N];
	for( int i=0;i<N;i++)
		optX[i] = x[i];
	
	int  ret = lbfgs(N, optX, &fx, lbfgs_evaluteFunctionAndGradient, NULL, this, &param);
	for( int i=0;i<N;i++)
		x[i] = optX[i];
	delete optX;
	
}

inline lbfgsfloatval_t geoxl::MMLBFGS::evaluteFunctionAndGradient( const lbfgsfloatval_t *x, lbfgsfloatval_t *g, const int n, const lbfgsfloatval_t step )
{
	// set variable
	for( int i=0;i<n;i++ )
		this->x[i] = x[i];
	
	// evaluate and copy gradient to result array
	G();
	for( int i=0;i<n;i++ )
		g[i] = this->g[i];

	// evaluate function and return result
	F();
	return this->f;
}