#ifndef MMLBFGSH
#define MMLBFGSH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "lbfgs.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	lbfgs solver mm solver
*/
class MMLBFGS
{
public:

	int cnls;
	int cnf, cng, cnm;

	double *x;
	double f;
	double *g;
	double *m;

	int N;

	MMLBFGS(int, int forgetit, int forgetit2);
	~MMLBFGS(void);


	void solve();

	virtual void F() = 0;	// f=F(x)
	virtual void G() = 0;	// g=Grad F(x)

	inline lbfgsfloatval_t evaluteFunctionAndGradient(    const lbfgsfloatval_t *x,	lbfgsfloatval_t *g,	const int n,	const lbfgsfloatval_t step );
};

}

#endif