//---------------------------------------------------------------------------
#ifndef ARSequenceEvaluatorH
#define ARSequenceEvaluatorH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace geoxl {

class ARSequence;
class SGListNode;
class ARSettings;
class DeformationEvaluator;

///
///   this abstract class is used to create the final output
///   it interpolates a sequence temporally and spatially
///
class DEFORMATION_API ARSequenceEvaluator : public Persistent {
	GEOXL_ABSTRACT_CLASS( ARSequenceEvaluator )
 public:
	virtual void assign(const Object* obj, CopyContext *context = NULL);
   virtual void evalSeq(
      ARSequence *seq, 
      SGListNode *target, 
      DeformationEvaluator *deformEval,
      ARSettings *settings) = 0;

};

}

#endif