//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "ARConstraints.h"
//---------------------------------------------------------------------------
#include "EmbeddedObjectClassProperty.h"
using namespace geoxl;
//---------------------------------------------------------------------------


IMPLEMENT_GEOXL_CLASS( ARConstraintAnchor , 0 ) {
	BEGIN_CLASS_INIT( ARConstraintAnchor );
	ADD_VECTOR3F_PROP(pos, 0);
	ADD_MAX_PLATFORM_INT_PROP(topologicalAnchor, 0)
}


IMPLEMENT_GEOXL_CLASS( GeneralARConstraint , 0 ) {
	BEGIN_CLASS_INIT( GeneralARConstraint );
	ADD_EMBEDDED_OBJECT_PROP( anchor, 0, ARConstraintAnchor::getClass());
}

IMPLEMENT_GEOXL_ABSTRACT_CLASS( VectorValuedARConstraint , 0 ) {
	BEGIN_CLASS_INIT( VectorValuedARConstraint );
}

IMPLEMENT_GEOXL_ABSTRACT_CLASS( MatrixValuedARConstraint , 0 ) {
	BEGIN_CLASS_INIT( MatrixValuedARConstraint );
}

IMPLEMENT_GEOXL_CLASS( PositionARConstraint, 0) {
	BEGIN_CLASS_INIT( PositionARConstraint );
	ADD_VECTOR3F_PROP(toPoint, 0);
	ADD_MATRIX3F_PROP(covariance, 0);
	ADD_FLOAT32_PROP(time, 0);
}

IMPLEMENT_GEOXL_CLASS( VelocityVectorARConstraint, 0) {
	BEGIN_CLASS_INIT( VelocityVectorARConstraint );
	ADD_FLOAT32_PROP(fromTime, 0);
	ADD_FLOAT32_PROP(toTime, 0);
	ADD_VECTOR3F_PROP(velocity, 0);
	ADD_MATRIX3F_PROP(covariance, 0);
}

IMPLEMENT_GEOXL_CLASS( InstantaneousVelocityARConstraint, 0) {
	BEGIN_CLASS_INIT( InstantaneousVelocityARConstraint );
	ADD_FLOAT32_PROP(time, 0);
	ADD_VECTOR3F_PROP(instVelocity, 0);
}


IMPLEMENT_GEOXL_CLASS( ARHalfSpaceConstraint, 0) {
	BEGIN_CLASS_INIT( ARHalfSpaceConstraint );
	ADD_FLOAT32_PROP(time, 0);
	ADD_VECTOR3F_PROP(halfSpaceFootPoint, 0);
	ADD_VECTOR3F_PROP(halfSpaceNormal, 0);
	ADD_FLOAT32_PROP(penaltyWeight, 0);
}

IMPLEMENT_GEOXL_CLASS( SpatialDerivativeARConstraint, 0) {
	BEGIN_CLASS_INIT( SpatialDerivativeARConstraint );
	ADD_FLOAT32_PROP(time, 0);
	ADD_MATRIX3F_PROP(targetDerivative, 0);
	// covariance
	//((MetaClass*)getClass())->addProperty( new FixedArrayClassProperty( "covariance" , MetaClass::FIRST_VERSION,
	//   (pointer_diff)(&( obj_null_pointer->covariance) - NULL) , new Float32ClassProperty("", 0, NULL, NULL)
 //  	,81, sizeof(float32), 9 ));
}


IMPLEMENT_GEOXL_CLASS( SimpleSpatialDerivativeARConstraint, 0) {
	BEGIN_CLASS_INIT( SimpleSpatialDerivativeARConstraint );
	ADD_FLOAT32_PROP(time, 0);
	ADD_MATRIX3F_PROP(targetDerivative, 0);
   ADD_VECTOR3F_PROP(columnWeights, 0)
}
