#ifndef MMConstraintsOOCH
#define MMConstraintsOOCH

#include "GlobalDefinitions.h"

#include "MMConstraints.h"
#include <vector>
#include <hash_map>
using namespace stdext;
using namespace std;

namespace geoxl {

	class ARSettings;
	class MMDeformations;

	/**
	* Holds for every frame, the cached constraints
	* information. in ooc
	*/
	class DEFORMATION_API MMConstraintsOOC : public  MMConstraints{

	private:
		bool dataOnDisk;
		string fileName;
		vector<ABMatrix3fVec>* dataAfterLoading;
		bool dataReloaded;


		static mpcard constraintsInMem;
		static queue<MMConstraintsOOC*> lruQueue;

		void moveToDisk();
		void reloadFromDisk();
		void checkSwapIn();
		void checkSwapOut();

	public:

		MMConstraintsOOC(const size_t numFrames, const size_t myFrameNum);
		virtual ~MMConstraintsOOC();

		virtual void addPositionConstraint(MMPositionConstraint *c);
		virtual float32 fCorrespondences(MMDeformations * deformations, float32 tempCorrespondenceParam);
		virtual void gCorrespondences(vector<Vector3f> &gradient, MMDeformations * deformations, float32 tempCorrespondenceParam);
		virtual void clearConstraints();

		static bool   useConstraintsOOC;
		static string OOCPathFilename;
		static mpcard maxConstraintsInMem;

	};
}


#endif