//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "MMEdgeContractionSampler.h"
#include "UnstructuredInCorePointCloud.h"
#include "PCCNodesTools.h"
#include "ARSettings.h"
#include "MMNodes.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------

IMPLEMENT_GEOXL_CLASS( MMEdgeContractionSampler , 0 ) {
	BEGIN_CLASS_INIT( MMEdgeContractionSampler );
}

MMNodes* MMEdgeContractionSampler::createNodes(const ARSettings *settings, UnstructuredInCorePointCloud * geometry) {
	const float32 offset = settings->nodalOffset;
	const float32 radius = settings->nodalRadius;	
	
	PCCNodesTools *nd = new PCCNodesTools(offset,radius,1);
//	vector<Vector3f> nodePositions;
	//getNodes(radius, nodePositions);
	UnstructuredInCorePointCloud *uc = nd->edgeContractionSampleMMNodesPointCloud(geometry, offset, radius);
	delete nd;
	//nd->testNodes(uc,incore_urshape,1,radius);
	const float32 newRadius = nd->testNodes(uc,geometry,4,radius);	
	//PointSet * ps = uc->getPointSet();
	//cout << "Total number of nodes: " << ps->getNumEntries() << endl;
	// for now sample some nodes in the [0,1]^3 interval
	//nodes = new MMNodes(uc, newRadius + 0.01);
	MMNodes * nodes;
	if (newRadius>radius) {
		nodes = new MMNodes(uc, newRadius + 0.1);
	}
	else {
		nodes = new MMNodes(uc, radius);
	}
	return nodes;
}