#ifndef MMFurthestPointSamplerH
#define MMFurthestPointSamplerH

#include "GlobalDefinitions.h"
#include "MMSampler.h"

namespace geoxl {

	/**
	  * This is a simple sampler which starts by picking one
	  * geometry point and from then on always picking the one that
	  * is furthest away from the already picked points until every
	  * geometry point is at least covered by one of the picked points.
	  *
	  * This completely ignores topology and does not guarantee that 
	  * every geometry point is covered by at least 4 non-planar nodes 
	  * (necessary for safe inversion).
	  */
	class DEFORMATION_API MMFurthestPointSampler : public MMSampler {
		GEOXL_CLASS( MMFurthestPointSampler )
	
public:

	virtual MMNodes* createNodes(const ARSettings *settings, UnstructuredInCorePointCloud * geometry);
	
};

}
#endif