#ifndef MMHalfSpaceConstraintH
#define MMHalfSpaceConstraintH

#include "GlobalDefinitions.h"
#include "ARConstraints.h"
#include "MMNeighborContainer.h"
#include "MMConstraint.h"

#include <vector>

namespace geoxl {

/**
  * Holds for a constraint anchor point position, the indices of the nodal neighbors,
  * together with the shape functions evaluated at the anchor point.
  * We cache this information for efficient solving.
  */
	class DEFORMATION_API MMHalfSpaceConstraint : public MMConstraint {
	private: 
		const ARHalfSpaceConstraint * constraint;
		//MMNeighborContainer * neighbors;

	public:


		MMHalfSpaceConstraint(const ARHalfSpaceConstraint *c, MMNeighborContainer *n, bool owner) : MMConstraint(n, owner), constraint(c) {
		}

		MMHalfSpaceConstraint(MMHalfSpaceConstraint &copy) : MMConstraint(copy) {
			constraint = (ARHalfSpaceConstraint*)copy.constraint->copy();
		}

		~MMHalfSpaceConstraint() {
			delete constraint; constraint = 0;
		}

		const ARHalfSpaceConstraint * getConstraint() { return constraint; }
	
};


}


#endif