#ifndef MMTopologyH
#define MMTopologyH

#include "GlobalDefinitions.h"


namespace geoxl {

	class AttachedIndexedOctree;
	class PointSetKNNQuery;
	class InCorePCTopologyGraph;
	class PointSet;

	class DEFORMATION_API MMTopology  : public Persistent {
		GEOXL_CLASS( MMTopology )
	private: 
		PointSet * ps;
		AttachedIndexedOctree * octree;
		PointSetKNNQuery * query;
		InCorePCTopologyGraph*	topGraph;
		AAT posAAT;
		
	public:

		MMTopology();
		MMTopology(PointSet *ps, InCorePCTopologyGraph *topGraph);
		~MMTopology();

		MMTopology(MMTopology &copy);

      virtual void write(OutputObjectStream *s) const;
      virtual void read(InputObjectStream *s);

		void getReachableIndices(const card32 index, const Vector3f &pos, const float32 radius, std::set<card32> &result);
		void getReachableIndices(const Vector3f &pos, const float32 radius, std::set<card32> &result);

		bool isNeighbor(const card32 geometryBaseIndex, const card32 nodeBaseIndex, const Vector3f &nodePos, const float32 nodeRadius);

		card32 getClosestBaseIndex(const Vector3f &pos);
		
	
};


}


#endif