#ifndef MeshlessCachedConstraintsH
#define MeshlessCachedConstraintsH

#include "GlobalDefinitions.h"

#include "MeshlessCachedConstraint.h"
#include <vector>

namespace geoxl {

	/**
	  * Holds for every frame, the cached constraints
	  * information.
	  */
	class MeshlessCachedConstraints {

	private:
		vector<MeshlessCachedConstraint*> constraints;

	public:

		MeshlessCachedConstraints();
		~MeshlessCachedConstraints();

		mpcard nbConstraints() {
			return constraints.size();
		}

		MeshlessCachedConstraint* getConstraint(card32 index) {
			return constraints[index];
		}

		void addConstraint(MeshlessCachedConstraint *c) {
			constraints.push_back(c);
		}
	};
}


#endif