#ifndef NeighborInformationH
#define NeighborInformationH

#include "GlobalDefinitions.h"
#include "ObjectStreams.h"

#include <vector>

namespace geoxl {

	class DEFORMATION_API NeighborInformation /*: public Persistent*/ {
		//GEOXL_CLASS( NeighborInformation )
	public:
	   NeighborInformation() {}
		NeighborInformation(card32 i, float32 d, float32 w, const Vector3f &gw) : index(i), distance(d), weight(w), gradientWeight(gw) {}

		card32 index;
		float32 distance;
		float32 weight;
		float32 shapeValue;
		Vector3f gradientShapeValue;
		Vector3f gradientShapeValue2;
		Vector3f gradientWeight;
		
      void write(OutputObjectStream *s) const {
         s->write(index);
         s->write(distance);
         s->write(weight);
         s->write(shapeValue);
         s->write(gradientShapeValue);
		 s->write(gradientShapeValue2);
		 s->write(gradientWeight);
      }
      void read(InputObjectStream *s) {
         s->read(index);
         s->read(distance);
         s->read(weight);
         s->read(shapeValue);
         s->read(gradientShapeValue);
		 s->read(gradientShapeValue2);
		 s->read(gradientWeight);
      }

	};
}

#endif