#ifndef ResamplingH
#define ResamplingH

#include "Persistent.h"
#include "UnstructuredInCorePointCloud.h"
#include "AttachedIndexedOctree.h"
#include "PointCloudProcessingDefinitions.h"
#include "InCorePCTopologyGraph.h"

namespace geoxl
{

/*
 * Up- and down-sampling of point clouds/sets
 */
class DEFORMATION_API Resampling : public Persistent
{	
	GEOXL_CLASS( Resampling )
	private:
		
	public:
		
		// Down-Sample a point set to a certain sampling spacing; return true on success
		static bool downsample( 
			PointSet* ps,
			InCorePCTopologyGraph* topology,
			const float32 samplingSpacing );

		// Up-Sample a point set to a certain sampling spacing; return true on success
		static bool upsample( 
			PointSet* ps, 
			InCorePCTopologyGraph* topology, 
			float32 oldSamplingSpacing );

		// Up-Sampling: insert new point for each topological edge; roughly: samplingSpacing /= 2
		static bool upsample2( 
			PointSet* ps, 
			InCorePCTopologyGraph* topology,
			const float32 oldSamplingSpacing );

};

}

#endif