//---------------------------------------------------------------------------
#ifndef SurfelOptEvaluatorH
#define SurfelOptEvaluatorH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ShapeEvaluator.h"
//---------------------------------------------------------------------------

namespace geoxl {

class SurfelOptimizationContext;
class ARSettings;


///
///   this class evaluates the reconstructions computed with the SurfelOptimizer
///
class DEFORMATION_API SurfelOptEvaluator : public ShapeEvaluator {
	GEOXL_CLASS( SurfelOptEvaluator )
 private:
   SurfelOptimizationContext *context;
   const ARSettings *settings;
   
 public:
	SurfelOptEvaluator();

   /// not used in evaluator
	virtual AROptimizationContext *createOptContext();
	/// bind context and settings
	virtual void setup(AROptimizationContext *context, const ARSettings *settings);
   /// compute reconstruction, return a copy with the result
   virtual PointCloud *evaluate();

   ~SurfelOptEvaluator();
};

}

#endif