//---------------------------------------------------------------------------
#ifndef SurfelOptimizationContextH
#define SurfelOptimizationContextH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ARShapeOptimizationContext.h"
#include "SGESurfelGraph.h"
//---------------------------------------------------------------------------

namespace geoxl {

class ARSettings;

/// 
///
///  TODO: write desription
///
class DEFORMATION_API SurfelOptimizationContext : public ARShapeOptimizationContext 
{
	GEOXL_ABSTRACT_CLASS( SurfelOptimizationContext )

	private:
		PointSet* surfels;
		InCorePCTopologyGraph* topologyGraph;

	public:
		SurfelOptimizationContext();
		~SurfelOptimizationContext();

		/// initializes the shape optimization data structures from a candidate shape
		void initializeFromShape( SceneObject *obj, const ARSettings *params );

		inline PointSet* getSurfels(){ return surfels; }
		inline InCorePCTopologyGraph* getTopologyGraph(){ return topologyGraph; }

   
};

}

#endif