#ifndef DebugAnimationToolsH
#define DebugAnimationToolsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace geoxl
{
class FeatureCorrespondenceSet;
class FeatureSet;
class RenderingTool;

/// Draws a correspondence set (corresponding points live in the given frames)
void DEFORMATION_API drawCorrespondenceSet( FeatureCorrespondenceSet * set, const Matrix4f &frame1, const Matrix4f &frame2);

/// Draws a feature set (feature points are transformed into the given frame)
void DEFORMATION_API drawFeatureSet( FeatureSet * set, const Matrix4f &frame, float size, RenderingTool * rt);


}

#endif