//---------------------------------------------------------------------------
#ifndef SGDeformationConstraintsListH
#define SGDeformationConstraintsListH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "SceneGraphNode.h"
#include "ARConstraints.h"
//---------------------------------------------------------------------------

namespace geoxl {

///   mw - 09/27/2007, reworked for new constraints  11/19/2007
///
///   This SceneGraphNode stores a list of deformation constraint
///
class DEFORMATION_API SGDeformationConstraintsList : public SceneGraphNode {
	GEOXL_CLASS( SGDeformationConstraintsList )
 private:
	vector<GeneralARConstraint*> constraints;
	IMPLEMENT_VAR_ARRAY_METHODS_STL(constraints)

 public:
	SGDeformationConstraintsList();
	
   virtual max_platform_card getNumChildNodes(const SceneGraphState *state) const;
   virtual SceneGraphNode *getChildNode(const SceneGraphState *state, max_platform_card i);
   virtual void removeChildNode(string name);
   virtual bool canAddChildNode();
   virtual bool addChildNode(SceneGraphNode *node);

	/// will take ownership
	void addConstraint(GeneralARConstraint *constr);
	mpcard getNumConstraints();
	const GeneralARConstraint *getConstraint(mpcard index) const;
	GeneralARConstraint *getConstraint(mpcard index);
	void deleteConstraint(mpcard index);

   ~SGDeformationConstraintsList();
};

}

#endif