//---------------------------------------------------------------------------
#ifndef SGDeformationNodeARH
#define SGDeformationNodeARH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "SceneGraphNode.h"
//---------------------------------------------------------------------------

namespace geoxl {

class ARDeformationOptimizationContext;

///
///   this class just stores a ARDeformationOptimizationContext (to be able to directly put it into the scene graph)
///
class DEFORMATION_API SGDeformationNodeAR : public SceneGraphNode {
	GEOXL_CLASS( SGDeformationNodeAR )
 private:
   ARDeformationOptimizationContext *deformation;
   
 public:
	SGDeformationNodeAR();

	ARDeformationOptimizationContext *getDeformation() const {return deformation;}
	/// ownership transferred to this node
	void setDeformation(ARDeformationOptimizationContext *v);
   /// sets deformation to NULL without deleting
	void removeDeformation();

   // --- inherited stuff (trivial behaviour)
   virtual SGStateChanger *getNodeEntryStateChange(const SceneGraphState *state);
   virtual max_platform_card getNumChildNodes(const SceneGraphState *state) const;
   virtual SceneGraphNode *getChildNode(const SceneGraphState *state, max_platform_card i);
   virtual void removeChildNode(string name);
   virtual bool canAddChildNode();
   virtual bool addChildNode(SceneGraphNode *node);

   ~SGDeformationNodeAR();
};

}

#endif