//---------------------------------------------------------------------------
#ifndef SGEDeformationSequenceH
#define SGEDeformationSequenceH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "SceneGraphEntity.h"
//---------------------------------------------------------------------------

namespace geoxl {

///   mw - 09/27/2007
///
///   encapsulates scene graph representation a sequence of deformations of an (ur)shape
///
///   assumptions: (changed! - mw 12/18/07)
///     - path points to a SceneGraphNode
///     - this node and its subgraph encode the deformation sequence _somehow_
class DEFORMATION_API SGEDeformationSequence : public SceneGraphEntity {
	GEOXL_CLASS( SGEDeformationSequence )
 private:

 public:
	SGEDeformationSequence();

	virtual bool check(string &msg) const;

   /// get number of frames in sequence
   virtual mpcard getNumFrames() const;

   ~SGEDeformationSequence();
};

}

#endif