//---------------------------------------------------------------------------
#ifndef SGEPointCloudH
#define SGEPointCloudH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "SGEShape.h"
//---------------------------------------------------------------------------

namespace geoxl {

///
///   scene graph adaptor class for point clouds
///
class DEFORMATION_API SGEPointCloud : public SGEShape {
	GEOXL_CLASS( SGEPointCloud )
 private:
    /// attribute channels the points in th point cloud are expected to have
    VertexDescriptor *pointChannels;

 public:
	SGEPointCloud();
	
	const VertexDescriptor *getPointChannels() const;
   void setPointChannels(VertexDescriptor *cn);

   virtual bool check(string &msg) const;

   /// get point cloud object
   PointCloud *getPointCloud() const;

   ~SGEPointCloud();
};

}

#endif