//---------------------------------------------------------------------------
#ifndef SGERigidDeformationSequenceH
#define SGERigidDeformationSequenceH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "SGEDeformationSequence.h"
#include "LinearAlgebra.h"
//---------------------------------------------------------------------------

namespace geoxl {

class SGTransformationNode;

///
///   scene graph storage for rigid deformation sequences
///
class DEFORMATION_API SGERigidDeformationSequence : public SGEDeformationSequence {
	GEOXL_CLASS( SGERigidDeformationSequence )
 private:

 public:
	SGERigidDeformationSequence();

	virtual bool check(string &msg) const;

   virtual mpcard getNumFrames() const;
   
   virtual SGTransformationNode *getTransformationNode(mpcard frame);
   virtual Matrix4f getTransformation(mpcard frame);
   


   ~SGERigidDeformationSequence();
};

}

#endif