//---------------------------------------------------------------------------
#ifndef SGEShapeH
#define SGEShapeH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "SceneGraphEntity.h"
//---------------------------------------------------------------------------

namespace geoxl {

///   mw - 09/27/2007
///
///   encapsulates scene graph representation of (ur-)shapes
///
///   additional assumptions:
///     - path points to a single SGObjectNode
///     - the scene object stored in this node is not NULL
class DEFORMATION_API SGEShape : public SceneGraphEntity {
	GEOXL_CLASS( SGEShape )
 public:
	SGEShape();

	virtual bool check(string &msg) const;
	/// also includes transformation of SceneObject
	virtual Matrix4f getBaseTransform() const;

	/// get the scene object (i.e. the actual point cloud, mesh, volume or whatever)
	virtual SceneObject *getSceneObject() const;
	/// create an iterator to access the data
   virtual SceneObjectIterator *createIterator(SceneObjectIteratorType type) const;

   ~SGEShape();
};

}

#endif