//---------------------------------------------------------------------------
#ifndef ARInitOneFrameSequenceH
#define ARInitOneFrameSequenceH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace geoxl {

class PointCloud;
class ShapeReconstruction;
class ARSettings;
class ARSequence;


///
///   This class creates animation sequences that contain only one frame
///   (i.e. an urshape and an identity deformation)
///
class DEFORMATION_API ARInitOneFrameSequence : public Persistent {
	GEOXL_CLASS( ARInitOneFrameSequence )
 private:

 public:
	ARInitOneFrameSequence();

	virtual void assign(const Object* obj, CopyContext *context = NULL);

	ARSequence *createSequence(PointCloud *pc, ShapeReconstruction *reconstructor, ARSettings *settings);

   ~ARInitOneFrameSequence();
};

}

#endif