//---------------------------------------------------------------------------
#include "stdafx.h"
//---------------------------------------------------------------------------
#include "ARComputeShapeDistance.h"
//---------------------------------------------------------------------------
#include "ICPConstraints.h"
#include "ARNullConstraintsInterface.h"
#include "ARSettings.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void geoxl::ARComputeShapeDistance::computeShapeDistance( PointCloud *pc1, PointCloud *pc2, ARSettings *settings )
{
   ARNullConstraintsInterface forgetThis;
   ICPConstraints icp;
   icp.setConstraintMode(settings->icpConstraintsMode);
   icp.setDistanceOutliersMode(settings->icpNearFieldCulling?ICP_OUTLIERS_DISTANCE:ICP_OUTLIERS_NONE);
   icp.setOutliersDistanceFactor(settings->icpNearFieldRelativeCutOff);
   icp.setCullNormalOutliers(false);

   icp.clearStatistics();
   icp.buildICPConstraints(settings, &forgetThis, pc1, pc1, pc2, 0);
   debugOutput << "icp.statisticsGetNumOutliers(): " << icp.statisticsGetNumOutliers() << "\n"
               << "icp.statisticsGetSumOfSquaredNormalDistances():" << icp.statisticsGetSumOfSquaredNormalDistances() << "\n";
   icp.clearStatistics();
   icp.buildICPConstraints(settings, &forgetThis, pc2, pc2, pc1, 0);
   debugOutput << "icp.statisticsGetNumOutliers(): " << icp.statisticsGetNumOutliers() << "\n"
      << "icp.statisticsGetSumOfSquaredNormalDistances():" << icp.statisticsGetSumOfSquaredNormalDistances() << "\n";
}