//---------------------------------------------------------------------------
#ifndef ARConstraintsSourceH
#define ARConstraintsSourceH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------

namespace geoxl {

class ARConstraintsInterface;
class ARTimeVariantConstraintsInterface;

///
///   this interface creates constraints from data
///
class DEFORMATION_API ARConstraintsSource {
 public:
   /// creates non-time dependent constraints only (if applicable, otherwise nothing happens)
   virtual void createConstraints(ARConstraintsInterface *receiver) = 0;
   /// creates all the rest (if applicable, otherwise nothing happens)
   virtual void createTimeDependentConstraints(ARTimeVariantConstraintsInterface *receiver) = 0;
   virtual ~ARConstraintsSource() {}
};

}

#endif