//---------------------------------------------------------------------------
#ifndef AREvaluateDeformationH
#define AREvaluateDeformationH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace geoxl {

class PointCloud;
class UnstructuredInCorePointCloud;
class ARDeformationOptimizationContext;
class DeformationEvaluator;
class ARSettings;

///
///   this class evaluates deformations and applies them to geometry
///
class DEFORMATION_API AREvaluateDeformation {
 public:
   static UnstructuredInCorePointCloud *evaluatePC(
      PointCloud *referenceShape, 
      ARDeformationOptimizationContext *deformation, 
      DeformationEvaluator *evaluator,
      float32 time,
      const ARSettings *settings,
		bool writeGradients = false	// write gradient to channel "deform_gradient"
		);

   /// deforms a point cloud "shape" (different to original urshape e.g. high res)
   static UnstructuredInCorePointCloud *evaluatePC(
	   PointCloud *referenceShape, 
	   PointCloud *shape,
	   ARDeformationOptimizationContext *deformation, 
	   DeformationEvaluator *evaluator,
	   float32 time,
	   const ARSettings *settings,
	   bool writeGradients = false	// write gradient to channel "deform_gradient"
	   );
};

}

#endif