//---------------------------------------------------------------------------
#ifndef ARPruneUnsupportedOutliersH
#define ARPruneUnsupportedOutliersH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PTypes.h"
//---------------------------------------------------------------------------
#include <vector>
//---------------------------------------------------------------------------

namespace geoxl {
   using namespace std;

class ARSettings;

///
///   This class provides functionality to throw away points that have only very limited support by actual data points
///
class DEFORMATION_API ARPruneUnsupportedOutliers {
 private:
   const ARSettings *settings;
   card32 numFrames;
   vector<card32> numSupportedFrames;
   // later --- vector<bool> lastFrameSupported;
   //vector<card32> lastFrameNumConsSupp;
   //vector<card32> maxConsecutive;
   
 public:
   static void resetCounters(PointCloud *pc);

   ARPruneUnsupportedOutliers(const ARSettings *settings, card32 numFrames);
   void addNextFrame(PointCloud *pc);
   void getResult(vector<bool> &result);
};

}

#endif