//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "ARSurfaceDeformation.h"
//---------------------------------------------------------------------------
#include "ARDeformationOptimizationContext.h"
#include "ARSettings.h"
#include "ARConstraintsSource.h"
#include "PointCloud.h"
#include "DeformationSolver.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



ARDeformationOptimizationContext *ARSurfaceDeformation::deformOpt(
   PointCloud *shape,
   DeformationSolver *solver,
   ARConstraintsSource *constraints,
   const ARSettings *settings,
   Delegate feedback)
{
   ARDeformationOptimizationContext *result = (ARDeformationOptimizationContext*)solver->createOptContext();
   result->initializeFromShape(shape, makeVector2f(0,0), settings);
   solver->setup(result, settings);
   if (feedback != NULL) {
      solver->clearUserFeedbackCallbacks();
      solver->addUserFeedbackCallback(feedback);
   }
   solver->beginConstraints();
   constraints->createConstraints(solver);
   solver->solve();
   return result;
}
