//---------------------------------------------------------------------------
#ifndef ARUrshapeDeformationOptH
#define ARUrshapeDeformationOptH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "AROptToolWithFeedback.h"
//---------------------------------------------------------------------------
#include <vector>
//---------------------------------------------------------------------------


namespace geoxl {
   using namespace std;

class ARSequence;
class PointCloud;
class DeformationSolver;
class ARSettings;

///
///   optimizes the urshape by deforming it, minimizing the residuals of the matches in the frames
///
class DEFORMATION_API ARUrshapeDeformationOpt : public AROptToolWithFeedback {
 public:
	ARUrshapeDeformationOpt();

	virtual void glDrawFeedback(GLContext *glContext, ARVisualizationSettings *visSettings);	

	PointCloud *optimizeUrshape(
	   /// sequence to be optimized
	   ARSequence *seq, 
	   /// shape optimizer
	   DeformationSolver *deformationSolver,
      /// input data points
      const vector<PointCloud*> &dataPoints,
      /// parameters
	   ARSettings *settings
   );

   ~ARUrshapeDeformationOpt();
};

}

#endif