//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "ARPipelineOptions.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "SeparatorClassProperty.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------


string descrMode(card32 i) {
	if (i == 0) return "mmExtractSurfacesFirst";
	return "mmExtractSurfacesLast";
}

static string descrBailOut(card32 i) {
   if (i==0) return "DEFAULT_PIPELINE";
   if (i==1) return "STOP_AFTER_MERGE";
   return "undefined";
   
}

IMPLEMENT_GEOXL_CLASS( ARPipelineOptions , 12 ) {
	BEGIN_CLASS_INIT( ARPipelineOptions );

   ADD_SEPARATOR("general options")
	ADD_CARD32_PROP_UPDATE_DESCR(mode, 0, NULL, descrMode, 2)
	ADD_BOOLEAN_PROP(deletePartialResults, 0)
	ADD_BOOLEAN_PROP(unused_rigidMode, 2)
	SET_USER_EDIT(false)
	ADD_BOOLEAN_PROP(unused_alignWithConstrData, 4)
	SET_USER_EDIT(false)
	ADD_BOOLEAN_PROP(urshapePropagation, 6)
	ADD_BOOLEAN_PROP(urshapeDeformationOpt, 7)
	ADD_BOOLEAN_PROP(optimizeShapeWhileMerging, 9)
	ADD_BOOLEAN_PROP(mergeInPowersOfTwo, 8)
	ADD_BOOLEAN_PROP(lateTopologyCheck, 10)
	ADD_BOOLEAN_PROP(noTopologyCheck, 11)
   ADD_BOOLEAN_PROP(matchingOnly, 12)

   ADD_SEPARATOR("debugging options")
	ADD_CARD32_PROP(maximumMergeRange, 0)
	ADD_CARD32_PROP_UPDATE_DESCR(bailOut, 3, NULL, descrBailOut, 2)
	ADD_CARD32_PROP(minKeepPartialResultsSize, 5)
	ADD_BOOLEAN_PROP(savePartialResults, 5)
	ADD_STRING_PROP(savePartialResultsPath, 5)
	ADD_BOOLEAN_PROP(recomputeDeformationsInMerge, 9)
}

// ----

ARPipelineOptions::ARPipelineOptions() 
{
	//mode = mmExtractSurfacesLast; // mw, later on 2007-01-07, for debugging the deformation solver
	mode = mmExtractSurfacesFirst;	// pj, 2007-01-10

	deletePartialResults = true;
	minKeepPartialResultsSize = 8;
	urshapeDeformationOpt = false;
	optimizeShapeWhileMerging = true;
	mergeInPowersOfTwo = true;
	lateTopologyCheck = true;
	noTopologyCheck = true; // default: no check
	matchingOnly = false;

	maximumMergeRange = 1000000000;
	bailOut = DEFAULT_PIPELINE;
	unused_alignWithConstrData = false;
	urshapePropagation = true;
	savePartialResults = false;
	savePartialResultsPath = "c:\\temp\\";
	recomputeDeformationsInMerge = true;
}

void ARPipelineOptions::setPresets() {}

void ARPipelineOptions::assign(const Object* obj, CopyContext *context) {
	copyObjectProperties(obj, this);
}

ARPipelineOptions::~ARPipelineOptions() {
}



 