//---------------------------------------------------------------------------
#ifndef PCCBoundaryDetector_H
#define PCCBoundaryDetector_H
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------


namespace geoxl {


/// Detects boundary points and marks then in a channel
class DEFORMATION_API PCCBoundaryDetector : public PCCommand {
	GEOXL_CLASS( PCCBoundaryDetector )
 private:
   card32 numNeighbors;
   float32 sigmaRel;
   float32 quantizeThreshold;

   bool quantize;
   bool boundaryTangents;
   
 public:
	PCCBoundaryDetector();
	virtual void assign(const Object* obj, CopyContext *context = NULL);
   virtual void execute(Scene *scene);
   void detectBoundaries(PointCloud *pc);
	~PCCBoundaryDetector();
};


}

#endif
