#ifndef PCCRemoveSmallPatchesH
#define PCCRemoveSmallPatchesH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	plz comment your class
*/
class DEFORMATION_API PCCRemoveSmallPatches : public PCCommand
{
	GEOXL_CLASS( PCCRemoveSmallPatches )

private:
	string pcName;
	card32 minConnectedPoints;
	card32 top_maxNN;
	float32 top_spacingFactor;

	void mathUnitTest();


public:
	PCCRemoveSmallPatches(void);
	~PCCRemoveSmallPatches(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

	void execute(Scene *scene);
	card32 getMinConnectedPoints(){return minConnectedPoints;};
	card32 getTopMaxNN(){return top_maxNN;};
	float32 getTopSpacingFactor(){return top_spacingFactor;};

	// function used for processing animations
	void execute_ar( Scene *scene, UnstructuredInCorePointCloud *upc );
};

}

#endif