#ifndef CameraParameterAttachmentH
#define CameraParameterAttachmentH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	plz comment your class
*/
class DEFORMATION_API CameraParameterAttachment : public AttachedData
{
	GEOXL_CLASS( CameraParameterAttachment )

private:

	Matrix3f intrinsicMatrix;
	Matrix3f rotationMatrix;
	Vector3f translationVector;
	Matrix4f projectionMatrix;

public:
	CameraParameterAttachment(void);
	CameraParameterAttachment(Matrix3f intrinsicM,Matrix3f rotationM,	Vector3f translationV,Matrix4f projectionM);
	~CameraParameterAttachment(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

	/// default container name
	static string getAttachmentName() {return "CameraParameterAttachment";}

	/// projects a point given in world coordinates onto the image
	Vector2f projectWorldtoImage(const Vector3f xyz);

	/// projects a points given in image coodinates into world coordinates
	Vector3f projectImageToWorld(const Vector3f &uvz);

};

}

#endif
