#ifndef PCCImportDepthAnimationH
#define PCCImportDepthAnimationH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
#include "CameraParameterAttachment.h"
#include "PointCloudImporterReaderMSDepthBMP.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	plz comment your class
*/
class DEFORMATION_API PCCImportDepthAnimation : public PCCommand
{
	GEOXL_CLASS( PCCImportDepthAnimation )

private:
	std::string importPath;
	std::string camCalibFile;
	float32 MinZ , MaxZ ;
	std::string oocSwapFileNamePath;
	card32 firstFrame;
	card32 lastFrame;
	bool  mergePointClouds;

	CalibStruct m_CalibParams[8];
	vector<CameraParameterAttachment*> camParameters;

	bool readCalibrationFile(char *fileName);
	void computeProjectionMatrices();
	float32 DepthLevelToZ( unsigned char d );
	card8 ZToDepthLevel( float32 z );
	float32 projXYZtoUV(double projMatrix[4][4], double x, double y, double z, double *u, double *v);
	void projUVZtoXY(double projMatrix[4][4], double u, double v, double z, double *x, double *y);


public:
	PCCImportDepthAnimation(void);
	~PCCImportDepthAnimation(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

	virtual void execute(Scene *scene);


	static std::string getPointCloudName(card32 time, card32 cam, bool picture);

};

}

#endif