//---------------------------------------------------------------------------
#ifndef AnnSearchH
#define AnnSearchH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PTypes.h"
#include "ANN.h"
//---------------------------------------------------------------------------
namespace geoxl {

/// computes fast approx. nearest Neighbor
class EDITOR_API AnnSearch  {
 private:
   ANNkd_tree*			kdTree;
	card32 numPoints;
	float distanceEpsilon;


 public:
   AnnSearch(float distanceEps = 0.01f);
   ~AnnSearch();

	/// setup search structure
	/// don't delete or move array 'data' while using AnnSearch 
   void buildSearchStructure(card32 number, card32 dimension, ANNpointArray data);
   card32 getNearestNeighbor(ANNpoint) const;
   card32 getNearestNeighborAndDistance(const ANNpoint &searchPoint,float &distance) const;
   void getkNearestNeighbors(const ANNpoint &searchPoint,const card32 &k, float *distances, int32 *indexes) const;
	int getkNearestNeighborsInRadius(const ANNpoint &searchPoint,const card32 &k, const float32 &radius, float *distances, int32 *indexes) const;

	void reset();




private:
	//Helpers:
	ANNidxArray			nnIdx1;	
	ANNdistArray		dists1;

};






}
#endif
