//---------------------------------------------------------------------------
#ifndef CmdObjSpecialDrawH
#define CmdObjSpecialDrawH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "CommandObject.h"
#include "PointCloud.h"
//---------------------------------------------------------------------------

namespace geoxl {


class EDITOR_API CmdObjSpecialDraw : public CommandObject {

 private:
   static MetaClass *CmdObjSpecialDrawMetaClass;
   static Object* newInstance();


 protected:
   Vector3f m_col,m_normal;
   card32 mode;
   int32 flags;


 public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void setup(card32 mode, Vector3f color, Vector3f normal, int32 flags);

   virtual void doAction(Object *context);
   virtual void undoAction(Object *context);
   virtual bool canUndo();

   virtual string getDescription();

};





}

#endif
