#ifndef NormalUnifierH
#define NormalUnifierH

#include "Persistent.h"
#include "PointCloud.h"

namespace geoxl
{
#define NORMAL_ESTIMATOR_FLAG 64

/*
 * Estimate normals in point sets and point clouds
 *
 * Required: 
 * - position  (3f)
 * - flags     (1i)
 * - normal    (3f)  NormalEstimator
*/
class EDITOR_API NormalUnifier : public Persistent
{	
	private:

	public:

		/// Unify all normals in point set
		static void unifyNormals( PointSet* ps, const card32 numKNN );

		/// Unify all normals in point cloud
		static void unifyNormals( PointCloud* pc, const card32 numKNN );

		/// Unify all normals in point set (graph-based [HDD*92])
		static void unifyNormalsHoppe( PointSet* ps, const card32 numKNN );

};

}

#endif