//---------------------------------------------------------------------------
#ifndef PickFromPointSet_H
#define PickFromPointSet_H
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PTypes.h"
//---------------------------------------------------------------------------


namespace geoxl {

class PointSet;
class ViewFrustum;
class Camera;

/// goes through all points of a point set and computes the point with minimum on-screen distance
/// returns distance in pixel and closest index; if ps is empty, an exception is thrown
float32 EDITOR_API computeMinOnScreenDistancePoint(
   int32 x,
   int32 y,
   const PointSet *ps,
   ViewFrustum &vf,
   Camera &cam,
   card32 viewWidth,
   card32 viewHeight,
   mpcard &closestIndex,
   Matrix4f baseTransform = IDENTITY4F,
   string positionChannel = "position");


}

#endif
