//---------------------------------------------------------------------------
#ifndef PointCloudExporterH
#define PointCloudExporterH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include <fstream>
//---------------------------------------------------------------------------
#include "PointCloud.h"
#include "VertexDescriptor.h"
#include "PointCloudIterators.h"
//---------------------------------------------------------------------------

namespace geoxl {


class AttributeWriter {
  private:
    AAT attribToken;
    VAD attribDesc;

  public:
    AttributeWriter(VAD& attribDesc, AAT& attribToken);
    void writeAttrib(std::ofstream& outf, BasicPointCloudIterator* basicIt);
};

class PointCloudExporter {
 private:
   PointCloud* pc;
   std::ofstream* outf;

 public:
   PointCloudExporter(PointCloud* pc, std::ofstream* outf);
   void exportPointCloud();
};

}

//---------------------------------------------------------------------------
#endif
