#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "SceneEditorOptions.h"
//---------------------------------------------------------------------------
#include "FixedArrayClassProperty.h"
#include "ClassTypeClassProperty.h"
#include "ExaminerCameraController.h"
#include "BooleanClassProperty.h"
//---------------------------------------------------------------------------
using namespace geoxl;

IMPLEMENT_GEOXL_CLASS( SceneEditorOptions ,3)
{
	BEGIN_CLASS_INIT( SceneEditorOptions );

	ADD_VECTOR3F_PROP( m_BackGroundColor, 0 );
	ADD_METACLASS_PROP( m_DefaultCameraClass, 0, CameraController::getClass() );

	ADD_BOOLEAN_PROP( m_UseSoftwareVertexBuffers, 1 );
	ADD_BOOLEAN_PROP(m_UseBBSelection,3);

	ADD_INT32_PROP( m_RedrawDelay, 2);

}

SceneEditorOptions::SceneEditorOptions(void)
{
	m_BackGroundColor = makeVector3f( 0.3f,0.1f,0.1f);
	m_DefaultCameraClass = (MetaClass*)ExaminerCameraController::getClass();
	m_UseSoftwareVertexBuffers = false;
	m_UseBBSelection = false;
	m_RedrawDelay = -1;
}

SceneEditorOptions::~SceneEditorOptions(void)
{
}

void SceneEditorOptions::assign(const Object* obj, CopyContext *context)
{
	AttachedData::assign( obj, context );
	const SceneEditorOptions * o = dynamic_cast<const SceneEditorOptions*>(obj);
	pAssert( o != NULL );

	m_BackGroundColor = o->m_BackGroundColor;
	m_DefaultCameraClass = o->m_DefaultCameraClass;
	m_UseSoftwareVertexBuffers = o->m_UseSoftwareVertexBuffers;
	m_RedrawDelay = o->m_RedrawDelay;
	m_UseBBSelection = o->m_UseBBSelection;
}