#ifndef SceneEditorOptionsH
#define SceneEditorOptionsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
//---------------------------------------------------------------------------
#include "LinearAlgebra.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	holds scene editor options ( backgroundcolor, 
*/
class EDITOR_API SceneEditorOptions : public AttachedData
{
	GEOXL_CLASS( SceneEditorOptions )

private:

	
	Vector3f		m_BackGroundColor;
	MetaClass	* m_DefaultCameraClass;
	bool			m_UseSoftwareVertexBuffers;
	bool			m_UseBBSelection;
	int32			m_RedrawDelay;


public:
	SceneEditorOptions(void);
	~SceneEditorOptions(void);


	// -----------------------------
	// properties access
	Vector3f		getBackGroundColor() const { return m_BackGroundColor; }
	void setBackGroundColor( const Vector3f &col ) { m_BackGroundColor = col; }

	MetaClass * getDefaultCameraClass() const {return m_DefaultCameraClass;}
	void setDefaultCameraClass(MetaClass * mc){m_DefaultCameraClass = mc;}

   virtual void assign(const Object* obj, CopyContext *context = NULL);

	bool getUseSoftwareVertexBuffers() const {return m_UseSoftwareVertexBuffers;}
	void setUseSoftwareVertexBuffers(bool v) {m_UseSoftwareVertexBuffers=v;}

	int32 getRedrawDelay() const {return m_RedrawDelay;}
	void setRedrawDelay(int32 v) {m_RedrawDelay=v;}

	bool getUseBBSelection() const {return m_UseBBSelection;}
	void setUseBBSelection(bool v) {m_UseBBSelection=v;}


};

}

#endif