//---------------------------------------------------------------------------
#include "stdafx.h"
 
//---------------------------------------------------------------------------
#include "SceneGraphCmdObjs.h"
//---------------------------------------------------------------------------
#include "SGListNode.h"
#include "ObjectViewsTable.h"
#include "StringClassProperty.h"
#include "NumericalClassProperty.h"
#include "NumericalClassProperty_templCode.h"
#include "ClassTypeClassProperty.h"
#include "Scene.h"
#include "StandardSceneGraphIterator.h"
#include "SGIndexedAndByNameSceneGraphIteratorAdaptor.h"
#include "SGListNode.h"
#include "SceneGraphNode.h"
#include "PointCloudConversionForms.h"
#include "HierarchicalInCorePointCloud.h"
#include "HierarchicalOutOfCorePointCloud.h"
#include "BlockedMultiObjectStream.h"
#include "SGAllocatorList.h"
#include "StringHelper.h"
#include "MultiFileMultiObjectStreamMT.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



using namespace geoxl;

MetaClass* CO_SGAddNode::CO_SGAddNodeMetaClass = NULL;

const MetaClass* CO_SGAddNode::getInstanceClass() const {
   return getClass();
}

Object* CO_SGAddNode::newInstance() {
   return new CO_SGAddNode;
}

const MetaClass* CO_SGAddNode::getClass() {
   if (CO_SGAddNodeMetaClass==NULL) {
      CO_SGAddNodeMetaClass = new MetaClass("CO_SGAddNode", "no description.",
                                  newInstance, sizeof(CO_SGAddNode));
   }
   return CO_SGAddNodeMetaClass;
}

void CO_SGAddNode::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   CO_SGAddNodeMetaClass->copyParentProperties();
   BEGIN_CLASS_INIT(CO_SGAddNode)
   ADD_CARD32_PROP(action ,0)
   ADD_STRING_PROP(target, 0);
	ADD_METACLASS_PROP(newNodeType, 0, SceneGraphNode::getClass())
   ADD_STRING_PROP(undo_newNodeName, 0);
}

void CO_SGAddNode::shutdown() {
   delete CO_SGAddNodeMetaClass;
}


// --


MetaClass* CO_SGDeleteNode::CO_SGDeleteNodeMetaClass = NULL;

const MetaClass* CO_SGDeleteNode::getInstanceClass() const {
   return getClass();
}

Object* CO_SGDeleteNode::newInstance() {
   return new CO_SGDeleteNode;
}

const MetaClass* CO_SGDeleteNode::getClass() {
   if (CO_SGDeleteNodeMetaClass==NULL) {
      CO_SGDeleteNodeMetaClass = new MetaClass("CO_SGDeleteNode", "no description.",
                                  newInstance, sizeof(CO_SGDeleteNode));
   }
   return CO_SGDeleteNodeMetaClass;
}

void CO_SGDeleteNode::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   CO_SGDeleteNodeMetaClass->copyParentProperties();
}

void CO_SGDeleteNode::shutdown() {
   delete CO_SGDeleteNodeMetaClass;
}


// --


MetaClass* CO_SGMoveNode::CO_SGMoveNodeMetaClass = NULL;

const MetaClass* CO_SGMoveNode::getInstanceClass() const {
   return getClass();
}

Object* CO_SGMoveNode::newInstance() {
   return new CO_SGMoveNode;
}

const MetaClass* CO_SGMoveNode::getClass() {
   if (CO_SGMoveNodeMetaClass==NULL) {
      CO_SGMoveNodeMetaClass = new MetaClass("CO_SGMoveNode", "no description.",
                                  newInstance, sizeof(CO_SGMoveNode));
   }
   return CO_SGMoveNodeMetaClass;
}

void CO_SGMoveNode::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   CO_SGMoveNodeMetaClass->copyParentProperties();
   BEGIN_CLASS_INIT(CO_SGMoveNode)
   ADD_STRING_PROP( target, 0 );
   ADD_CARD32_PROP(action ,0)

}

void CO_SGMoveNode::shutdown() {
   delete CO_SGMoveNodeMetaClass;
}


// --


MetaClass* CO_SGMoveSelection::CO_SGMoveSelectionMetaClass = NULL;

const MetaClass* CO_SGMoveSelection::getInstanceClass() const {
   return getClass();
}

Object* CO_SGMoveSelection::newInstance() {
   return new CO_SGMoveSelection;
}

const MetaClass* CO_SGMoveSelection::getClass() {
   if (CO_SGMoveSelectionMetaClass==NULL) {
      CO_SGMoveSelectionMetaClass = new MetaClass("CO_SGMoveSelection", "no description.",
                                  newInstance, sizeof(CO_SGMoveSelection));
   }
   return CO_SGMoveSelectionMetaClass;
}

void CO_SGMoveSelection::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   CO_SGMoveSelectionMetaClass->copyParentProperties();
   BEGIN_CLASS_INIT(CO_SGMoveSelection)
   ADD_STRING_PROP( target, 0 );
   ADD_CARD32_PROP(action ,0)
}

void CO_SGMoveSelection::shutdown() {
   delete CO_SGMoveSelectionMetaClass;
}


// --


MetaClass* CO_SGGroupSelection::CO_SGGroupSelectionMetaClass = NULL;

const MetaClass* CO_SGGroupSelection::getInstanceClass() const {
   return getClass();
}

Object* CO_SGGroupSelection::newInstance() {
   return new CO_SGGroupSelection;
}

const MetaClass* CO_SGGroupSelection::getClass() {
   if (CO_SGGroupSelectionMetaClass==NULL) {
      CO_SGGroupSelectionMetaClass = new MetaClass("CO_SGGroupSelection", "no description.",
                                  newInstance, sizeof(CO_SGGroupSelection));
   }
   return CO_SGGroupSelectionMetaClass;
}

void CO_SGGroupSelection::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   CO_SGGroupSelectionMetaClass->copyParentProperties();
   BEGIN_CLASS_INIT(CO_SGGroupSelection)
   ADD_STRING_PROP( parent, 0 );
}

void CO_SGGroupSelection::shutdown() {
   delete CO_SGGroupSelectionMetaClass;
}


// --


MetaClass* CO_SGUnGroupSelection::CO_SGUnGroupSelectionMetaClass = NULL;

const MetaClass* CO_SGUnGroupSelection::getInstanceClass() const {
   return getClass();
}

Object* CO_SGUnGroupSelection::newInstance() {
   return new CO_SGUnGroupSelection;
}

const MetaClass* CO_SGUnGroupSelection::getClass() {
   if (CO_SGUnGroupSelectionMetaClass==NULL) {
      CO_SGUnGroupSelectionMetaClass = new MetaClass("CO_SGUnGroupSelection", "no description.",
                                  newInstance, sizeof(CO_SGUnGroupSelection));
   }
   return CO_SGUnGroupSelectionMetaClass;
}

void CO_SGUnGroupSelection::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   CO_SGUnGroupSelectionMetaClass->copyParentProperties();
   BEGIN_CLASS_INIT(CO_SGUnGroupSelection)
   ADD_STRING_PROP( target, 0 );
}

void CO_SGUnGroupSelection::shutdown() {
   delete CO_SGUnGroupSelectionMetaClass;
}


// --


MetaClass* CO_SGChangeSelection::CO_SGChangeSelectionMetaClass = NULL;

const MetaClass* CO_SGChangeSelection::getInstanceClass() const {
   return getClass();
}

Object* CO_SGChangeSelection::newInstance() {
   return new CO_SGChangeSelection;
}

const MetaClass* CO_SGChangeSelection::getClass() {
   if (CO_SGChangeSelectionMetaClass==NULL) {
      CO_SGChangeSelectionMetaClass = new MetaClass("CO_SGChangeSelection", "no description.",
                                  newInstance, sizeof(CO_SGChangeSelection));
   }
   return CO_SGChangeSelectionMetaClass;
}

void CO_SGChangeSelection::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   CO_SGChangeSelectionMetaClass->copyParentProperties();
}

void CO_SGChangeSelection::shutdown() {
   delete CO_SGChangeSelectionMetaClass;
}


// --


MetaClass* CmdObjSGChangeDefaultTraversalMode::CmdObjSGChangeDefaultTraversalModeMetaClass = NULL;

const MetaClass* CmdObjSGChangeDefaultTraversalMode::getInstanceClass() const {
   return getClass();
}

Object* CmdObjSGChangeDefaultTraversalMode::newInstance() {
   return new CmdObjSGChangeDefaultTraversalMode;
}

const MetaClass* CmdObjSGChangeDefaultTraversalMode::getClass() {
   if (CmdObjSGChangeDefaultTraversalModeMetaClass==NULL) {
      CmdObjSGChangeDefaultTraversalModeMetaClass = new MetaClass("CmdObjSGChangeDefaultTraversalMode", "no description.",
                                  newInstance, sizeof(CmdObjSGChangeDefaultTraversalMode));
   }
   return CmdObjSGChangeDefaultTraversalModeMetaClass;
}

void CmdObjSGChangeDefaultTraversalMode::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   CmdObjSGChangeDefaultTraversalModeMetaClass->copyParentProperties();
   BEGIN_CLASS_INIT(CmdObjSGChangeDefaultTraversalMode)
   ADD_CARD32_PROP(newMode,0)
   ADD_CARD32_PROP(oldMode,0)
}

void CmdObjSGChangeDefaultTraversalMode::shutdown() {
   delete CmdObjSGChangeDefaultTraversalModeMetaClass;
}



// ----



CO_SGAddNode::CO_SGAddNode(string target, const MetaClass *newNodeType, card32 action) {
   this->action = action;
   this->target = target;
   this->newNodeType = newNodeType;
}

void CO_SGAddNode::doAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); pAssert(scene);

   StandardSceneGraphIterator it;
   it.clearAndSetup(scene->getRootNode(), scene->getRootState(),
                    SGDynamicState::tmAllNodes, 0,0);

   SGIndexedAndByNameSceneGraphIteratorAdaptor byName;
   byName.clearAndSetup(&it);

   bool success = byName.goToName(target);
   if (!success) throw ECommandFailed("CO_SGAddNode::doAction() - target not found.");

   if (action == ADD) {

      SceneGraphNode *node = byName.getNode();
      if (node == NULL) throw ECommandFailed("CO_SGAddNode::doAction() - target not found.");

      if (!node->canAddChildNode()) throw ECommandFailed("CO_SGAddNode::doAction() - target does not accept further child nodes.");
      SceneGraphNode *newnode = (SceneGraphNode*)(newNodeType->newInstance());
      if (!node->addChildNode(newnode)) {
         delete newnode;
         throw ECommandFailed("CO_SGAddNode::doAction() - target currently does not accept the specified type of child node.");
      }

      undo_newNodeName = newnode->getName();

   } else { // action == INSERT

      SceneGraphNode *node = byName.getNode();
      if (node == NULL) throw ECommandFailed("CO_SGAddNode::doAction() - target not found.");
      SceneGraphNode *parent = byName.getParent();

      SceneGraphNode *newnode = (SceneGraphNode*)(newNodeType->newInstance());

      if (!newnode->canAddChildNode()) throw ECommandFailed("CO_SGAddNode::doAction() - the specified type for the new node does not accept child nodes.");

      if (!newnode->addChildNode(node)) {
         delete newnode;
         throw ECommandFailed("CO_SGAddNode::doAction() - the specified type does not accept the selected target node as child node.");
      }

      if (parent != NULL) {
         parent->removeChildNode(node->getName());
         if (!parent->addChildNode(newnode)) {
            parent->addChildNode(node);
            delete newnode;
            throw ECommandFailed("CO_SGAddNode::doAction() - the parent of the selected node does not accept the specified type as child node.");
         }
      } else {
         scene->setRootNode(newnode);
      }

      undo_newNodeName = "";

   }

   ObjectViewsTable::update(scene);
}

void CO_SGAddNode::undoAction(Object *context) {
   if (action != ADD) throw ECannotUndo("CO_SGAddNode::undoAction - undo only supported for ADD operation.");
   Scene *scene = dynamic_cast<Scene*>(context); pAssert(scene);

   StandardSceneGraphIterator it;
   it.clearAndSetup(scene->getRootNode(), scene->getRootState(),
                    SGDynamicState::tmAllNodes, 0,0);

   SGIndexedAndByNameSceneGraphIteratorAdaptor byName;
   byName.clearAndSetup(&it);

   bool success = byName.goToName(target);
   if (!success) throw ECommandFailed("CO_SGAddNode::undoAction() - target not found.");

   SceneGraphNode *node = dynamic_cast<SGListNode*>(byName.getNode());
   if (node == NULL) throw ECommandFailed("CO_SGAddNode::undoAction() - target not found.");

   node->removeChildNode(undo_newNodeName);

   ObjectViewsTable::update(scene);
}

bool CO_SGAddNode::canUndo() {
   if (action == ADD) {
      return true;
   } else {
      return false;
   }
}

string CO_SGAddNode::getDescription() {
   return string("Create new node of type ") + newNodeType->getClassName() + string(" in list node ") + target + string(".");
}


// ----


CO_SGDeleteNode::CO_SGDeleteNode(vector<string> target) {
   this->target = target;
}

void CO_SGDeleteNode::assign(const Object* obj, CopyContext *context) {
   const CO_SGDeleteNode *other = dynamic_cast<const CO_SGDeleteNode*>(obj);
   pAssert(other);
   target = other->target;
   forget(context);
}

void CO_SGDeleteNode::write(OutputObjectStream *s) const {
   card32 n = (card32)target.size();
   s->write(n);
   for (card32 i=0; i<n; i++) {
      s->writeString(target[i]);
   }
}

void CO_SGDeleteNode::read(InputObjectStream *s) {
   card32 n;
   s->read(n);
   target.resize(n);
   for (card32 i=0; i<n; i++) {
      s->readString(target[i]);
   }
}

void CO_SGDeleteNode::doAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); pAssert(scene);
   if (scene == NULL) return;
   size_t n = target.size();
   for (card32 i=0; i<n; i++) {
      StandardSceneGraphIterator it;
      it.clearAndSetup(scene->getRootNode(), scene->getRootState(), SGDynamicState::tmAllNodes);
      SGIndexedAndByNameSceneGraphIteratorAdaptor byName;
      byName.clearAndSetup(&it);
      if (byName.goToName(target[i])) {
         if (byName.getParent() != NULL) {
            byName.getParent()->removeChildNode(byName.getNode()->getName());
         }
      }
   }

}

void CO_SGDeleteNode::undoAction(Object *context) {
   forget(context);
   throw ECannotUndo("CO_SGDeleteNode::undoAction() - undo not supported.");
}

bool CO_SGDeleteNode::canUndo() {
   return false;
}

string CO_SGDeleteNode::getDescription() {
   string result = "Delete nodes:";
   size_t n = target.size();
   for (card32 i=0; i<n; i++) {
      result += string(" ") + target[i];
   }
   return result;
}

// --

CO_SGMoveNode::CO_SGMoveNode(string target, card32 action) {
   this->target = target;
   this->action = action;
}

void CO_SGMoveNode::doAction(Object *context) {
   pAssert(action == 1 || action == 2);
   Scene *scene = dynamic_cast<Scene*>(context); pAssert(scene);
   if (scene == NULL) return;

   StandardSceneGraphIterator it;
   it.clearAndSetup(scene->getRootNode(), scene->getRootState(), SGDynamicState::tmAllNodes);
   SGIndexedAndByNameSceneGraphIteratorAdaptor byName;
   byName.clearAndSetup(&it);

   if (!byName.goToName(target)) return;

   SceneGraphNode *node = byName.getNode();
   SGListNode *parent = dynamic_cast<SGListNode*>(byName.getParent());
   if (node == NULL || parent == NULL) return;

   max_platform_int parentIndex = parent->getChildIndex(node->getName());

   if (parentIndex == -1) return;

   if (action == UP) {
      if (parentIndex <= 0) return;
      parent->swapChildren(parentIndex, parentIndex-1);
   } else {
      pAssert(action == DOWN);
      if (parentIndex+1 >= (max_platform_int)parent->getNumChildNodes(NULL)) return;
      parent->swapChildren(parentIndex, parentIndex+1);
   }
}

void CO_SGMoveNode::undoAction(Object *context) {
   forget(context);
   throw ECannotUndo("CO_SGMoveNode::undoAction() - undo not supported.");
}

bool CO_SGMoveNode::canUndo() {
   return false;
}

string CO_SGMoveNode::getDescription() {
   return string("Move node ") + target + (action == 1?string("one up in parent list."):string("one down in parent list."));
}

// --

CO_SGMoveSelection::CO_SGMoveSelection(string target, card32 action) {
   this->target = target;
   this->action = action;
}

void CO_SGMoveSelection::doAction(Object *context) {
   pAssert(action == 1 || action == 2);
   Scene *scene = dynamic_cast<Scene*>(context); pAssert(scene);
   if (scene == NULL) return;

   StandardSceneGraphIterator it;
   it.clearAndSetup(scene->getRootNode(), scene->getRootState(), SGDynamicState::tmAllNodes);
   SGIndexedAndByNameSceneGraphIteratorAdaptor byName;
   byName.clearAndSetup(&it);

   if (!byName.goToName(target)) return;

   SceneGraphNode *targetNode = byName.getNode();
   if (targetNode == NULL) throw ECommandFailed("CO_SGMoveSelection::doAction() - target not found.");

   set<string> &sel = scene->getRootState()->staticState->selectedNodes;

   set<string>::iterator pos = sel.begin();
   set<string>::iterator end = sel.end();

   while (pos != end) {
      it.clearAndSetup(scene->getRootNode(), scene->getRootState(), SGDynamicState::tmAllNodes);
      byName.clearAndSetup(&it);
      string currentName = *pos;
      if (!byName.goToName(currentName)) {++pos; continue;}
      SceneGraphNode *currentNode = byName.getNode();
      SceneGraphNode *currentNodeParent = byName.getParent();
      if (currentNodeParent == NULL) {++pos; continue;}
      if (SceneGraphNode::nodeReachable(targetNode, currentNode)) {++pos; continue;}

      if (!targetNode->addChildNode(currentNode)) {
         throw ECommandFailed("CO_SGMoveSelection::doAction() - target did not accept (one of) the selected node(s).");
      }
      if (action == MOVE) {
         currentNodeParent->removeChildNode(currentNode->getName());
      }
      ++pos;
   }
}

void CO_SGMoveSelection::undoAction(Object *context) {
   forget(context);
   throw ECannotUndo("CO_SGMoveSelection::undoAction() - undo not supported.");
}

bool CO_SGMoveSelection::canUndo() {
   return false;
}

string CO_SGMoveSelection::getDescription() {
   return string("Move node ") + target + (action == 1?string("one up in parent list."):string("one down in parent list."));
}


// --


CO_SGGroupSelection::CO_SGGroupSelection(string parent, vector<string> children) {
   this->parent = parent;
   this->children = children;
}

void CO_SGGroupSelection::assign(const Object* obj, CopyContext *context) {
   const CO_SGGroupSelection *other = dynamic_cast<const CO_SGGroupSelection*>(obj);
   parent = other->parent;
   children = other->children;
   forget(context);
}

void CO_SGGroupSelection::write(OutputObjectStream *s) const {
   s->writeString(parent);
   mpcard n = children.size();
   s->write(n);
   for (mpcard i=0; i<n; i++) {
      s->writeString(children[i]);
   }
}

void CO_SGGroupSelection::read(InputObjectStream *s) {
   s->readString(parent);
   mpcard n;
   s->read(n);
   children.resize(n);
   for (mpcard i=0; i<n; i++) {
      s->readString(children[i]);
   }
}

void CO_SGGroupSelection::doAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); pAssert(scene);
   StandardSceneGraphIterator it;
   it.clearAndSetup(scene->getRootNode(), scene->getRootState(),
                    SGDynamicState::tmAllNodes, 0,0);
   SGIndexedAndByNameSceneGraphIteratorAdaptor byName;
   byName.clearAndSetup(&it);

   if (byName.goToName(parent)) {
      SGListNode *parent = dynamic_cast<SGListNode*>(byName.getNode());
      if (parent != NULL) {
         SGListNode *newGroup = new SGListNode();
         newGroup->setName("newGroup");
         parent->addNode(newGroup);
         mpcard n = children.size();
         for (mpcard i=0; i<n; i++) {
            string nextChild = children[i];
            mpcard nn = parent->getNumChildNodes(NULL);
            for (mpcard j=0; j<nn; j++) {
               SceneGraphNode *child = parent->getChildNode(NULL, j);
               if (child->getName() == nextChild) {
                  newGroup->addNode(child);
               }
            }
         }
         for (mpcard i=0; i<n; i++) {
            parent->removeChildNode(children[i]);
         }
      }
   }
}

void CO_SGGroupSelection::undoAction(Object *context) {
   forget(context);
   throw ECannotUndo("CO_SGGroupSelection::undoAction() - undo not supported.");
}

bool CO_SGGroupSelection::canUndo() {
   return false;
}

string CO_SGGroupSelection::getDescription() {
   return "group a set of nodes in a list.";
}


// --


CO_SGUnGroupSelection::CO_SGUnGroupSelection(string target) {
   this->target = target;
}

void CO_SGUnGroupSelection::doAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); pAssert(scene);
   StandardSceneGraphIterator it;
   it.clearAndSetup(scene->getRootNode(), scene->getRootState(),
                    SGDynamicState::tmAllNodes, 0,0);
   SGIndexedAndByNameSceneGraphIteratorAdaptor byName;
   byName.clearAndSetup(&it);

   if (byName.goToName(target)) {
      SGListNode *target = dynamic_cast<SGListNode*>(byName.getNode());
      if (target != NULL) {
         SGListNode *parent = dynamic_cast<SGListNode*>(byName.getParent());
         if (parent != NULL) {
            mpcard n = target->getNumChildNodes(NULL);
            for (mpcard i=0; i<n; i++) {
               SceneGraphNode *child = target->getChildNode(NULL, i);
               parent->addNode(child);
            }
            parent->removeChildNode(target->getName());
         }
      }
   }
}

void CO_SGUnGroupSelection::undoAction(Object *context) {
   forget(context);
   throw ECannotUndo("CO_SGGroupSelection::undoAction() - undo not supported.");
}

bool CO_SGUnGroupSelection::canUndo() {
   return false;
}

string CO_SGUnGroupSelection::getDescription() {
   return "ungroup a set of nodes (remove parent list).";
}


// --


CO_SGChangeSelection::CO_SGChangeSelection(set<string> selection) {
   this->selection = selection;
}

void CO_SGChangeSelection::assign(const Object* obj, CopyContext *context) {
   const CO_SGChangeSelection *other = dynamic_cast<const CO_SGChangeSelection*>(obj);
   pAssert(other);
   selection = other->selection;
   prevSelection = other->prevSelection;
   forget(context);
}

void CO_SGChangeSelection::write(OutputObjectStream *s) const {
   card32 n = (card32)selection.size();
   s->write(n);
   set<string>::const_iterator pos = selection.begin();
   set<string>::const_iterator end = selection.end();
   while (pos != end) {
      s->writeString(*pos);
      ++pos;
   }
   n = (card32)prevSelection.size();
   s->write(n);
   pos = prevSelection.begin();
   end = prevSelection.end();
   while (pos != end) {
      s->writeString(*pos);
      ++pos;
   }
}

void CO_SGChangeSelection::read(InputObjectStream *s) {
   selection.clear();
   prevSelection.clear();
   card32 n;
   s->read(n);
   for (card32 i=0; i<n; i++) {
      string name;
      s->readString(name);
      selection.insert(name);
   }
   s->read(n);
   for (card32 i=0; i<n; i++) {
      string name;
      s->readString(name);
      prevSelection.insert(name);
   }
}

void CO_SGChangeSelection::doAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); pAssert(scene);
   prevSelection = scene->getRootState()->staticState->selectedNodes;
   scene->getRootState()->staticState->selectedNodes = selection;
}

void CO_SGChangeSelection::undoAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); pAssert(scene);
   scene->getRootState()->staticState->selectedNodes = prevSelection;
}

bool CO_SGChangeSelection::canUndo() {
   return true;
}

bool CO_SGChangeSelection::mergeCommand(const CommandObject *nextCmd) {
   const CO_SGChangeSelection *other = dynamic_cast<const CO_SGChangeSelection*>(nextCmd);
   if (other != NULL) {
      selection = other->selection;
      return true;
   }
   return false;
}


string CO_SGChangeSelection::getDescription() {
   string result = "Select nodes:";
   if (selection.empty()) {
      result += " (empty selection)";
   } else {
      set<string>::iterator pos = selection.begin();
      set<string>::iterator end = selection.end();
      while (pos != end) {
         result += string(" ") + *pos;
         ++pos;
      }
   }
   return result;
}


MetaClass* CmdObjConvertType::CmdObjConvertTypeMetaClass = NULL;

const MetaClass* CmdObjConvertType::getInstanceClass() const {
   return getClass();
}

Object* CmdObjConvertType::newInstance() {
   return new CmdObjConvertType;
}

const MetaClass* CmdObjConvertType::getClass() {
   if (CmdObjConvertTypeMetaClass==NULL) {
      CmdObjConvertTypeMetaClass = new MetaClass("CmdObjConvertType", "no description.",
                                  newInstance, sizeof(CmdObjConvertType));
   }
   return CmdObjConvertTypeMetaClass;
}

void CmdObjConvertType::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 1);
   CmdObjConvertTypeMetaClass->copyParentProperties();
   BEGIN_CLASS_INIT(CmdObjConvertType)
   ADD_INT32_PROP( action, 0 )
   ADD_BOOLEAN_PROP(delOriginal,0)
   ADD_STRING_PROP(filename_depreciated,0)
   SET_USER_EDIT(false)
   ADD_CARD32_PROP(allocatorIndex, 1)
   ADD_INT32_PROP(blockSize_depreciated,0)
   SET_USER_EDIT(false)
   ADD_INT32_PROP(maxNumNodesInMem,0)
   ADD_INT32_PROP(maxLeafPts,0)
   ADD_INT32_PROP(gridSize,0)
   
}

void CmdObjConvertType::shutdown() {
   delete CmdObjConvertTypeMetaClass;
}

CmdObjConvertType::CmdObjConvertType(int32 action, bool delOriginal, card32 allocatorIndex,
                                     int32 maxNumNodesInMem, int32 maxLeafPts, int32 gridSize)
{
   this->action = action;
   this->delOriginal = delOriginal;
   this->filename_depreciated = "not used anymore";
   this->allocatorIndex = allocatorIndex;
   this->blockSize_depreciated = 42;
   this->maxNumNodesInMem = maxNumNodesInMem;
   this->maxLeafPts = maxLeafPts;
   this->gridSize = gridSize;
}

void CmdObjConvertType::doAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context);
   pAssert(scene);
   SGLegacyPCSceneAdaptor sceneLA(scene);
   const vector<card32> selection = sceneLA.getSelectedPCs();
   const size_t n = selection.size();
   if (n == 0) return;

   if (action == PointCloudConversionWidget::CANCEL) return;
   PointCloud *target;
   const VertexDescriptor *firstVD = sceneLA.getPointCloud(selection[0])->getDescr();
   if (action == PointCloudConversionWidget::HIERARCHICAL) {

      target = new HierarchicalInCorePointCloud();
      ((HierarchicalInCorePointCloud*)target)->clearAndSetup(firstVD);
      MHStandardSettings settings;
      ((HierarchicalInCorePointCloud*)target)->getOctree()->getSettings(settings);
      settings.maxNumObjectsPerLeaf = maxLeafPts;
      settings.multiResGridSize = gridSize;
      ((HierarchicalInCorePointCloud*)target)->getOctree()->setSettings(settings);

   } else if (action == PointCloudConversionWidget::UNSTRUCTURED) {

      target = new UnstructuredInCorePointCloud();
      ((UnstructuredInCorePointCloud*)target)->clearAndSetup(firstVD, 0);

   } else {

      target = new HierarchicalOutOfCorePointCloud();
      if (scene->getRootState()->staticState->allocators->getNumAllocators() <= allocatorIndex) {
			throw ECommandFailed("CmdObjConvertType::doAction() - allocator index out of range (trying to create a HierarchicalOutOfCorePointCloud).");
      }
      MultiObjectStream *multiObj = scene->getRootState()->staticState->allocators->getAllocator(allocatorIndex);
      MHOutOfCorePointSetOctreeBase::NodeAllocator *nAlloc 
			= new MHOutOfCorePointSetOctreeBase::NodeAllocator(MHOutOfCorePointSetOctreeNode::getClass(), multiObj, maxNumNodesInMem);
      // mw - 10/18/07 - moved in constructor - multiObj->addGlobalObjectPointer(nAlloc, 1);

      ((HierarchicalOutOfCorePointCloud*)target)->clearAndSetup(firstVD, nAlloc);
      MHStandardSettings settings;
      ((HierarchicalOutOfCorePointCloud*)target)->getOctree()->getSettings(settings);
      settings.maxNumObjectsPerLeaf = maxLeafPts;
      settings.multiResGridSize = gridSize;
      ((HierarchicalOutOfCorePointCloud*)target)->getOctree()->setSettings(settings);

   }

   for (card32 i=0; i<n; i++) {
      PointCloud *pc = sceneLA.getPointCloud(selection[i]);
      SceneObjectIterator *it = pc->createIterator(SOIT(SOIT::CAP_BASIC_PC));
      BasicPointCloudIterator *bit = dynamic_cast<BasicPointCloudIterator*>(it);

      const bool containsFlags = pc->providesAttribute("flags");
      AAT AAT_FLAGS;
      if (containsFlags) {
         AAT_FLAGS = pc->getAAT("flags");
      }

      if (bit == NULL) {delete it; continue;}

      SceneObjectIterator *target_it = target->createIterator(SOIT(SOIT::CAP_BASIC_PC | SOIT::CAP_DYNAMIC_PC));
      DynamicPointCloudIterator *target_dyn = dynamic_cast<DynamicPointCloudIterator*>(target_it);
      pAssert(target_dyn != NULL);

      char *buffer = new char[firstVD->getSize()];

      while (!bit->atEnd()) {
         if (containsFlags) {
            if ((bit->get1i(AAT_FLAGS) & PF_FLAG_INVALID) == 0) {
               bit->getVertex(buffer);
               target_dyn->add(buffer);
            }
         } else {
            bit->getVertex(buffer);
            target_dyn->add(buffer);
         }
         bit->next();
      }

      delete[] buffer;
      delete it;
      delete target_it;
   }
   if (selection.size() == 1) {
      target->assignSettings(sceneLA.getPointCloud(selection[0]));
   }
   if (delOriginal) {
      sceneLA.deletePointClouds(selection);
   }
   sceneLA.addPointCloud(target);
   ObjectViewsTable::update(scene);
}

void CmdObjConvertType::undoAction(Object *context) {
   pAssert(false);
   forget(context);
}

bool CmdObjConvertType::canUndo() {
   return false;
}

string CmdObjConvertType::getDescription() {
   return "convert point cloud type.";
}

// ----


MetaClass* CmdObjAppendFields::CmdObjAppendFieldsMetaClass = NULL;

const MetaClass* CmdObjAppendFields::getInstanceClass() const {
   return getClass();
}

Object* CmdObjAppendFields::newInstance() {
   return new CmdObjAppendFields;
}

const MetaClass* CmdObjAppendFields::getClass() {
   if (CmdObjAppendFieldsMetaClass==NULL) {
      CmdObjAppendFieldsMetaClass = new MetaClass("CmdObjAppendFields", "no description.",
                                  newInstance, sizeof(CmdObjAppendFields));
   }
   return CmdObjAppendFieldsMetaClass;
}

void CmdObjAppendFields::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   CmdObjAppendFieldsMetaClass->copyParentProperties();
   	BEGIN_CLASS_INIT( CmdObjAppendFields );
	ADD_OBJECT_PROP( newFields, 0, VertexDescriptor::getClass(), true );	
}

void CmdObjAppendFields::shutdown() {
   delete CmdObjAppendFieldsMetaClass;
}

CmdObjAppendFields::CmdObjAppendFields(VertexDescriptor *newFields) {
   this->newFields = newFields;
}

void CmdObjAppendFields::doAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context);
   pAssert(scene);
   SGLegacyPCSceneAdaptor sceneLA(scene);
   const vector<card32> selection = sceneLA.getSelectedPCs();
   const size_t n = selection.size();
   if (n == 0) return;
   for (card32 i=0; i<n; i++) {
      PointCloud *pc = sceneLA.getPointCloud(selection[i]);
		UnstructuredInCorePointCloud * upc = dynamic_cast<UnstructuredInCorePointCloud*>(pc);
		if( upc )
		{
			PointSet * psNew = upc->getPointSet()->appendFields(newFields);
			upc->setPointSet(psNew);
		}
		else
			sceneLA.replacePointCloud(selection[i], pc->appendFields(newFields));
   }
   ObjectViewsTable::update(scene);
}

void CmdObjAppendFields::undoAction(Object *context) {
   pAssert(false);
   forget(context);
}

bool CmdObjAppendFields::canUndo() {
   return false;
}

string CmdObjAppendFields::getDescription() {
   return "Append additional channels to point cloud.";
}


// --



CmdObjSGChangeDefaultTraversalMode::CmdObjSGChangeDefaultTraversalMode(SGStaticState::TraversalModeType mode) {
   newMode = mode;
}

void CmdObjSGChangeDefaultTraversalMode::doAction(Object *context) {
	Scene *scene = dynamic_cast<Scene*>(context); pAssert(scene);
	oldMode = scene->getRootState()->staticState->defaultTraversalMode;
	scene->getRootState()->staticState->defaultTraversalMode = newMode;
}

void CmdObjSGChangeDefaultTraversalMode::undoAction(Object *context) {
	Scene *scene = dynamic_cast<Scene*>(context); pAssert(scene);
	scene->getRootState()->staticState->defaultTraversalMode = oldMode;
}

bool CmdObjSGChangeDefaultTraversalMode::canUndo() {
   return true;
}

string CmdObjSGChangeDefaultTraversalMode::getDescription() {
	string s = "DefaultTraversalMode changed to ";
	switch (newMode) {
		case 0: s += "tmAllNodes"; break;
		case 1: s += "tmRendering"; break;
		default: s += string("unknown(") + intToStr(newMode) + string(")"); break;
	}
   return s;
}

