//---------------------------------------------------------------------------
#include "stdafx.h"
 
//---------------------------------------------------------------------------
#include "SceneInterface.h"
//---------------------------------------------------------------------------
#include "ObjectListProperty.h"
#include "BooleanClassProperty.h"
#include "NumericalClassProperty.h"
#include "NumericalClassProperty_templCode.h"
#include "StringClassProperty.h"
#include "ObjectClassProperty.h"
#include "GEOXLEvent.h"
#include "RGBAImage.h"
#include "StringHelper.h"
#include "SceneEditorWidget.h"

#ifdef GEOXL_GUI
#include <qtGUI/qimage>
#include "CustomCheckBox.h"
#endif

//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace geoxl;
using namespace std;

MetaClass* SceneToolbarElement::SceneToolbarElementMetaClass = NULL;

const MetaClass* SceneToolbarElement::getInstanceClass() const {
   return getClass();
}

const MetaClass* SceneToolbarElement::getClass() {
   if (SceneToolbarElementMetaClass==NULL) {
      SceneToolbarElementMetaClass = new MetaClass("SceneToolbarElement", "no description.",
                                  NULL, sizeof(SceneToolbarElement));
   }
   return SceneToolbarElementMetaClass;
}

void SceneToolbarElement::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 1);
   SceneToolbarElementMetaClass->copyParentProperties();

	BEGIN_CLASS_INIT( SceneToolbarElement );
	ADD_INT32_PROP( m_ShortCut_Key, 1 );
	ADD_INT32_PROP( m_ShortCut_Modifiers, 1 );
}

void SceneToolbarElement::shutdown() {
   delete SceneToolbarElementMetaClass;
}


// ----


MetaClass* SceneToolButton::SceneToolButtonMetaClass = NULL;

const MetaClass* SceneToolButton::getInstanceClass() const {
   return getClass();
}

Object* SceneToolButton::newInstance() {
   return new SceneToolButton;
}

const MetaClass* SceneToolButton::getClass() {
   if (SceneToolButtonMetaClass==NULL) {
      SceneToolButtonMetaClass = new MetaClass("SceneToolButton", "no description.",
                                  newInstance, sizeof(SceneToolButton));
   }
   return SceneToolButtonMetaClass;
}

void SceneToolButton::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 1);
   SceneToolButtonMetaClass->copyParentProperties();
	BEGIN_CLASS_INIT(SceneToolButton)
   ADD_OBJECT_PROP(m_Event,0,GEOXLEvent::getClass(),true)
	ADD_OBJECT_PROP(m_Icon,0,RGBAImage::getClass(),true)
	ADD_STRING_PROP(m_Tooltip,0)
	ADD_STRING_PROP(m_ShortDesc,0)

}

void SceneToolButton::shutdown() {
   delete SceneToolButtonMetaClass;
}

// ----

MetaClass* SceneToolbarCheckBox::SceneToolbarCheckBoxMetaClass = NULL;

const MetaClass* SceneToolbarCheckBox::getInstanceClass() const {
   return getClass();
}

Object* SceneToolbarCheckBox::newInstance() {
   return new SceneToolbarCheckBox;
}

const MetaClass* SceneToolbarCheckBox::getClass() {
   if (SceneToolbarCheckBoxMetaClass==NULL) {
      SceneToolbarCheckBoxMetaClass = new MetaClass("SceneToolbarCheckBox", "no description.",
                                  newInstance, sizeof(SceneToolbarCheckBox));
   }
   return SceneToolbarCheckBoxMetaClass;
}

void SceneToolbarCheckBox::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   SceneToolbarCheckBoxMetaClass->copyParentProperties();
	BEGIN_CLASS_INIT(SceneToolbarCheckBox)
		 ADD_OBJECT_PROP(m_Event,0,GEOXLEvent::getClass(),true)
		 ADD_STRING_PROP(m_Tooltip,0)
		 ADD_STRING_PROP(m_ShortDesc,0)
}

void SceneToolbarCheckBox::shutdown() {
   delete SceneToolbarCheckBoxMetaClass;
}


// ----

MetaClass* ToolbarSplitter::ToolbarSplitterMetaClass = NULL;

const MetaClass* ToolbarSplitter::getInstanceClass() const {
   return getClass();
}

Object* ToolbarSplitter::newInstance() {
   return new ToolbarSplitter;
}

const MetaClass* ToolbarSplitter::getClass() {
   if (ToolbarSplitterMetaClass==NULL) {
      ToolbarSplitterMetaClass = new MetaClass("ToolbarSplitter", "no description.",
                                  newInstance, sizeof(ToolbarSplitter));
   }
   return ToolbarSplitterMetaClass;
}

void ToolbarSplitter::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   ToolbarSplitterMetaClass->copyParentProperties();
}

void ToolbarSplitter::shutdown() {
   delete ToolbarSplitterMetaClass;
}


// ----



MetaClass* SceneToolbar::SceneToolbarMetaClass = NULL;

const MetaClass* SceneToolbar::getInstanceClass() const {
   return getClass();
}

Object* SceneToolbar::newInstance() {
   return new SceneToolbar;
}

const MetaClass* SceneToolbar::getClass() {
   if (SceneToolbarMetaClass==NULL) {
      SceneToolbarMetaClass = new MetaClass("SceneToolbar", "no description.",
                                  newInstance, sizeof(SceneToolbar));
   }
   return SceneToolbarMetaClass;
}

void SceneToolbar::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   SceneToolbarMetaClass->copyParentProperties();

	BEGIN_CLASS_INIT(SceneToolbar);
	ADD_OBJECT_LIST_PROP( Element, 0, SceneToolbarElement::getClass() );
	ADD_STRING_PROP( m_Name , 0 );
}

void SceneToolbar::shutdown() {
   delete SceneToolbarMetaClass;
}


// ----

MetaClass* SceneInterface::SceneInterfaceMetaClass = NULL;

const MetaClass* SceneInterface::getInstanceClass() const {
   return getClass();
}

Object* SceneInterface::newInstance() {
   return new SceneInterface;
}

const MetaClass* SceneInterface::getClass() {
   if (SceneInterfaceMetaClass==NULL) {
      SceneInterfaceMetaClass = new MetaClass("SceneInterface", "no description.",
                                  newInstance, sizeof(SceneInterface));
   }
   return SceneInterfaceMetaClass;
}

void SceneInterface::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   SceneInterfaceMetaClass->copyParentProperties();

	ADD_OBJECT_LIST_PROP( Toolbar, 0, SceneToolbar::getClass() );

}

void SceneInterface::shutdown() {
   delete SceneInterfaceMetaClass;
}


// ----

string SceneToolbarElement::getShortCutDesc()
{
	if( m_ShortCut_Key < 0 )
		return "";

	string ret = "[";
	if( m_ShortCut_Modifiers )
	{
		switch( m_ShortCut_Modifiers )
		{
		case SCM_Ctrl:
			ret += "CTRL + ";
			break;
		case SCM_Alt:
			ret += "ALT + ";
			break;
		case SCM_Shift:
			ret += "Shift + ";
			break;
		}
	}

	if( m_ShortCut_Key >= Qt::Key_A && m_ShortCut_Key <= Qt::Key_Z )
		ret += (m_ShortCut_Key + 'A' - Qt::Key_A);

	if( m_ShortCut_Key >= Qt::Key_0 && m_ShortCut_Key <= Qt::Key_9 )
		ret += (m_ShortCut_Key + '0' - Qt::Key_0);

	if( m_ShortCut_Key == Qt::Key_Space )
		ret += "SPACE";

	ret += "]";

	return ret;
}


SceneToolButton::SceneToolButton()
{
   m_Event = new GEOXLEvent;
   m_Icon = new RGBAImage;
}

SceneToolButton::~SceneToolButton()
{
   delete m_Event;
   delete m_Icon;
}

void SceneToolButton::assign(const Object* obj, CopyContext *context )
{
   SceneToolbarElement::assign( obj, context );
   SceneToolButton * button = (SceneToolButton *)obj;
   delete m_Event;
   m_Event = (GEOXLEvent *)button->m_Event->getInstanceClass()->newInstance();
   m_Event->assign( button->m_Event, context );
   m_Icon->assign( button->m_Icon, context );
   m_Tooltip = button->m_Tooltip;
   m_ShortDesc = button->m_ShortDesc;
}

void SceneToolButton::setup( GEOXLEvent * event, RGBAImage * icon, string tooltip,
   string shortDesc )
{
   delete m_Event;
   delete m_Icon;

   m_Event = event;
   m_Icon = icon;
   m_Tooltip = tooltip;
   m_ShortDesc = shortDesc;
}

string SceneToolButton::getName()
{
   return cutString( m_Tooltip, 10 );
}

SceneToolbarCheckBox::SceneToolbarCheckBox()
{
   m_Event = new GEOXLEvent;
}

SceneToolbarCheckBox::~SceneToolbarCheckBox()
{
   delete m_Event;
}

void SceneToolbarCheckBox::assign(const Object* obj, CopyContext *context)
{
   SceneToolbarElement::assign( obj, context );
   const SceneToolbarCheckBox * cb = dynamic_cast<const SceneToolbarCheckBox*>(obj);
   pAssert( cb != NULL );
   delete m_Event;
   m_Event = (GEOXLEvent *)cb->m_Event->getInstanceClass()->newInstance();
   m_Event->assign( cb->m_Event, context );
}

void SceneToolbarCheckBox::setup( GEOXLEvent * event, string short_desc, string tooltip )
{
   delete m_Event;
   m_Event = event;
   m_ShortDesc = short_desc;
   m_Tooltip = tooltip;
}

string SceneToolbarCheckBox::getName()
{
   return cutString( m_ShortDesc, 10 );
}

SceneToolbar::~SceneToolbar()
{
   for( card32 i=0; i<m_Elements.size(); i++ )
   {
      delete m_Elements[i];
   }
}

void SceneToolbar::assign(const Object* obj, CopyContext *context)
{
   card32 oldVersion = getVersion();
   for( card32 i=0; i<m_Elements.size(); i++ )
   {
      delete m_Elements[i];
   }

   m_Elements.clear();

   const SceneToolbar * tb = dynamic_cast<const SceneToolbar*>(obj);
   pAssert( tb != NULL );
   for( card32 i=0;i<tb->m_Elements.size(); i++ )
   {
      const MetaClass * mc = tb->m_Elements[i]->getInstanceClass();
      SceneToolbarElement * element = (SceneToolbarElement *)mc->newInstance();
      element->assign( tb->m_Elements[i], context );
      m_Elements.push_back( element );
   }

   m_Name = tb->m_Name;
   m_Version = oldVersion + 1;

}

void SceneToolbar::addToolButton( string className, RGBAImage * icon, string tooltip,
   string short_desc )
{
   ModeChangeEvent * event = new ModeChangeEvent;
   event->setModeClassName( className );
   SceneToolButton * button = new SceneToolButton;
   button->setup( event, icon, tooltip, short_desc );
   addElement( button );
}

void SceneToolbar::addToolButton( Object * obj, RGBAImage * icon, string tooltip,
   string short_desc )
{
   SpecifiedModeChangeEvent * event = new SpecifiedModeChangeEvent;
   event->setObject( obj );
   SceneToolButton * button = new SceneToolButton;
   button->setup( event, icon, tooltip, short_desc );
   addElement( button );
}

/*void SceneToolbar::addToolButtonCommand( Command * cmd, RGBAImage * icon, string tooltip,
     string short_desc="" )
{
	CommandObjectEvent * event = new CommandObjectEvent;
	event->setCommandObject
}*/


void SceneToolbar::addElement( Object * obj )
{
   m_Elements.push_back( (SceneToolbarElement*)obj );
   incVersion();
}

void SceneToolbar::deleteElements( card32 begin, card32 end )
{
   pAssert( begin <= end );
   pAssert( end <= m_Elements.size() );
   for( card32 i=begin;i<end;i++ )
      delete m_Elements[i];

   m_Elements.erase( m_Elements.begin() + begin, m_Elements.begin() + end );
   incVersion();
}

Object * SceneToolbar::getElement( card32 index )
{
   pAssert( index < m_Elements.size() );
   return m_Elements[index];
}

void SceneToolbar::moveElement( card32 oldPos, card32 newPos )
{
   pAssert( oldPos < m_Elements.size() );
   pAssert( newPos < m_Elements.size() );

   SceneToolbarElement * element = m_Elements[ oldPos ];
   m_Elements.erase( m_Elements.begin() + oldPos );
   m_Elements.insert( m_Elements.begin() + newPos, element );
   incVersion();
}

mpcard SceneToolbar::getNumElements()
{
   return m_Elements.size();
}

string SceneToolbar::getElementName(card32 index )
{
   pAssert( index < m_Elements.size() );
   return m_Elements[index]->getName();
}

void SceneToolbar::setLastElement_ShortCut( int shortCutKey, int shortCutMod )
{
	pAssert( m_Elements.size() > 0 );
	m_Elements.back()->setShortCut( shortCutKey, shortCutMod );
}

SceneInterface::~SceneInterface()
{
   for( card32 i=0;i<m_Toolbars.size();i++ )
   {
      delete m_Toolbars[i];
   }
}

void SceneInterface::assign(const Object* obj, CopyContext *context)
{
   card32 oldVersion = getVersion();
   AttachedData::assign( obj, context );

   const SceneInterface * si = dynamic_cast<const SceneInterface*>(obj);
   pAssert( obj != NULL );

   for( card32 i=0;i<m_Toolbars.size();i++ )
   {
      delete m_Toolbars[i];
   }
   m_Toolbars.clear();

   for( card32 i=0;i<si->m_Toolbars.size();i++ )
   {
      const MetaClass * mc = si->m_Toolbars[i]->getInstanceClass();
      SceneToolbar * tb = (SceneToolbar *)mc->newInstance();
      tb->assign( si->m_Toolbars[i], context );
      m_Toolbars.push_back( tb );
   }

   m_Version = oldVersion + 1;

}

card32 SceneInterface::getVersion()
{
   card32 ret = 0;
   for( card32 i=0;i<m_Toolbars.size();i++ )
      ret += m_Toolbars[i]->getVersion();

   ret += m_Version;

   return ret;
}

void SceneInterface::addToolbar( Object * obj )
{
   SceneToolbar * tb = dynamic_cast<SceneToolbar*>(obj);
   pAssert( tb != NULL );

   m_Toolbars.push_back( tb );
   incVersion();
}

void SceneInterface::deleteToolbars( card32 begin, card32 end )
{
   pAssert( begin <= end );
   pAssert( end <= m_Toolbars.size() );
   for( card32 i=begin;i<end;i++ )
   {
      m_Version += m_Toolbars[i]->getVersion();
      delete m_Toolbars[i];
   }

   m_Toolbars.erase( m_Toolbars.begin() + begin, m_Toolbars.begin() + end );
   incVersion();
}

Object * SceneInterface::getToolbar( card32 index )
{
   pAssert( index < m_Toolbars.size() );
   return m_Toolbars[index];
}

void SceneInterface::moveToolbar( card32 oldPos, card32 newPos )
{
   pAssert( oldPos < m_Toolbars.size() );
   pAssert( newPos < m_Toolbars.size() );

   SceneToolbar * tb = m_Toolbars[ oldPos ];
   m_Toolbars.erase( m_Toolbars.begin() + oldPos );
   m_Toolbars.insert( m_Toolbars.begin() + newPos, tb );
   incVersion();
}

mpcard SceneInterface::getNumToolbars()
{
   return m_Toolbars.size();
}

string SceneInterface::getToolbarName(card32 index )
{
   pAssert( index < m_Toolbars.size() );

   return m_Toolbars[index]->getName();
}


// ----------- qt implementation ----------------------------
#ifdef GEOXL_GUI

void SceneToolButton::createElement( SceneEditorWidget * w, QToolBar *tb)
{
	QAction * action = tb->addAction( m_ShortDesc.c_str() );
	QImage image( m_Icon->getSizeX(), m_Icon->getSizeY(), QImage::Format_RGB32 );
	QImage alphaImage( m_Icon->getSizeX(), m_Icon->getSizeY(), QImage::Format_RGB32 );
	for( card32 x=0;x<m_Icon->getSizeX();x++ )
	{
		for( card32 y=0;y<m_Icon->getSizeY();y++ )
		{
			Vector4ub col = m_Icon->getPixel(x,y);
			card32 col32 = 0;
			col32 |= (col[0] << 16);
			col32 |= (col[1] << 8);
			col32 |= (col[2] << 0);
			alphaImage.setPixel(x,y, col[3] + (col[3]<<8) + (col[3]<<16) + (col[3]<<24));
			image.setPixel(x,y, col32 );
		}
	}
	QPixmap p = QPixmap::fromImage(image);
	p.setAlphaChannel( QPixmap::fromImage( alphaImage ) );
	action->setIcon(p );
	action->setToolTip( (m_Tooltip + getShortCutDesc()).c_str());
	action->setIconText( m_ShortDesc.c_str() );

	w->addEvent( action, m_Event );
}

void SceneToolButton::keyEvent( SceneEditorWidget * w )
{
	w->processEvent( m_Event );
}

void SceneToolbarCheckBox::createElement( SceneEditorWidget * w, QToolBar * tb)
{
	CustomCheckBox * cb = new CustomCheckBox( m_ShortDesc.c_str(),tb);
	QFont f = cb->font();
	f.setBold(false);
	//f.setPointSize(7);
	cb->setFont(f);
	cb->setCustomData( (char*)m_Event );
	w->connect( cb, SIGNAL(sigStateChanged(bool, char*)), SLOT(sltToolbarCheckBoxHandler( bool, char *)));
	cb->setObjectName( QString("CheckBox") + QString::number( (int)m_Event ) );
	cb->setToolTip( (m_Tooltip + getShortCutDesc()).c_str() );
	tb->addWidget( cb );
}

void SceneToolbarCheckBox::keyEvent( SceneEditorWidget * w )
{
	//w->processEvent( m_Event );
	QCheckBox * cb = w->findChild<QCheckBox*>( QString("CheckBox") + QString::number( (int)m_Event ) );
	cb->toggle();
}

void ToolbarSplitter::createElement( SceneEditorWidget * w, QToolBar *tb)
{
	tb->addSeparator();
}


QToolBar * SceneToolbar::createToolbar( SceneEditorWidget * w)
{
	QToolBar * ret = new QToolBar(m_Name.c_str());
	w->addToolBar(Qt::LeftToolBarArea, ret );
	w->addToolBarVec( ret );
	w->connect( ret, SIGNAL(actionTriggered(QAction*)),SLOT(sltToolbarHandler(QAction*)));
	w->setIconSize( QSize( 32,32 ) );
	w->setToolButtonStyle( Qt::ToolButtonTextUnderIcon );

	for( card32 i=0;i<m_Elements.size();i++ )
	{
		m_Elements[i]->createElement(w,ret);
	}

	return ret;	
}

void SceneToolbar::buildKeyMap( SceneEditorWidget * w  )
{
	for( card32 i=0;i<m_Elements.size();i++ )
	{
		if( m_Elements[i]->getShortCutKey() != -1 )
		{
			int32 key = m_Elements[i]->getShortCutKey();
			w->toolBarShortCuts[ key ].push_back( m_Elements[i] );
		}
	}
}


void SceneInterface::createInterface( SceneEditorWidget * w)
{
	w->clearToolBarsVec();
	w->clearToolBarEvents();
   for( card32 i=0;i<m_Toolbars.size();i++ )
   {
		QToolBar * tb = m_Toolbars[i]->createToolbar( w );
   }
}

void SceneInterface::buildKeyMap(SceneEditorWidget * w )
{
	w->toolBarShortCuts.clear();
	for( card32 i=0;i<m_Toolbars.size();i++ )
   {
		m_Toolbars[i]->buildKeyMap(w);
   }
}

#endif
