//---------------------------------------------------------------------------
#ifndef TestRendererH
#define TestRendererH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Renderer.h"
//---------------------------------------------------------------------------



namespace geoxl {


class EDITOR_API TestRenderer: public Renderer {
 private:
   static MetaClass *TestRendererMetaClass;
   static Object* newInstance();


 public:

   TestRenderer();

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void connect(Scene* scene, GLContext* ctxt);
   virtual void render(card32 viewportWidth, card32 viewportHeight);
   virtual void disconnect(GLContext* ctxt);

 private:
     void drawTestObjekt();
	  void quad(GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2,
		 GLdouble x3, GLdouble y3, GLdouble x4, GLdouble y4);
	  void extrude(GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2);

};


}

#endif
