//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PCCAnimRename.h"
//---------------------------------------------------------------------------
#include "StringClassProperty.h"
#include "NumericalClassProperty.h"
#include "PointCloudTools.h"
#include "SGListNode.h"
#include "StringHelper.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



IMPLEMENT_GEOXL_CLASS(PCCAnimRename, 0)
{
	BEGIN_CLASS_INIT(PCCAnimRename);
	ADD_STRING_PROP(prefix, 0)
	ADD_CARD32_PROP(startIndex, 0)
}

// ----

PCCAnimRename::PCCAnimRename() {
   prefix = "frame";
   startIndex = 0;
}

void PCCAnimRename::execute(Scene *scene) {
   vector<string> selection = scene->getRootState()->staticState->getSelectedNodes();
   if (selection.size() == 0) {
      warning("PCCAnimRename::execute() - nothing selected.");
      return;
   }
   SceneGraphState *myState = scene->getRootState()->createTraversalState();
   myState->staticState->defaultTraversalMode = SGStaticState::tmAllNodes;
   myState->dynamicState->traversalMode = SGDynamicState::tmAllNodes;
   for (card32 i=0; i<selection.size(); i++) {
      SceneGraphNode *node = getSceneGraphNodeByName(scene, selection[i]);
      if (node == NULL) {
         warning("PCCAnimRename::execute() - inconsistency in selection (cannot find node).");
         continue;
      }
      max_platform_card numNodes = node->getNumChildNodes(myState);
      for (max_platform_card n=0; n<numNodes; n++) {
         SceneGraphNode *currentNode = node->getChildNode(myState, n);
         string newName = prefix + intToStr((int)(n + startIndex));
         currentNode->setName(newName);
      }      
   }   
   delete myState;
}

PCCAnimRename::~PCCAnimRename() {}

