//---------------------------------------------------------------------------
#ifndef PCCAnimatedTriangleMeshSamplerH
#define PCCAnimatedTriangleMeshSamplerH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace geoxl {

class SceneObject;

/// Sample an animated triangle mesh to an animated point cloud
class EDITOR_API PCCAnimatedTriangleMeshSampler : public PCCommand {
	private:
		static MetaClass *PCCAnimatedTriangleMeshSamplerMetaClass;
		static Object* newInstance();

		/// Name (incl. path) of source animation node
		string sourceNode;
		/// Name (incl. path) of destination animation node
		string destNode;
		/// Expected number of points in result
		card64 expNumPoints;

	public:
		/// Constructor
		PCCAnimatedTriangleMeshSampler();

		/// Execute command
		virtual void execute(Scene *scene);

		/*** META CLASS MANAGEMENT ***/
		virtual const MetaClass *getInstanceClass() const;
		static const MetaClass *getClass();
		static void init(const MetaClass *parentClass);
		static void shutdown();	
};

}

#endif
 