//---------------------------------------------------------------------------
#ifndef PCCAnimationImporterH
#define PCCAnimationImporterH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PCCImporter.h"
#include "PCCPointCloudCreator.h"
//---------------------------------------------------------------------------

namespace geoxl {


class EDITOR_API PCCAnimationImporter : public PCCImporter {

 private:
   static MetaClass *PCCAnimationImporterMetaClass;
   static Object* newInstance();

	/// adds point cloud creation ability (needed for every frame). not called as command, uses separate method to create point clouds without making an command object.
	PCCPointCloudCreator* m_FramePCCreator;
	/// import to GenericSwapAllOutOfCorePointCloud
	bool m_importAnimationOOC;
	/// GenericSwapAllOutOfCorePointCloud relative path
	bool m_relativePath;
	/// filename of ooc swap file for GenericSwapAllOutOfCorePointCloud
	std::string m_oocSwapFileNamePath;
   /// if this flag is set, the specified path is taken as a directory and all files are imported
	bool m_entireDirectory;

 public:
   PCCAnimationImporter();
   ~PCCAnimationImporter();

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void execute(Scene *scene);

	/// returns m_FramePCCreator
	inline PCCPointCloudCreator* getFramePCCreator() { return m_FramePCCreator; };

	//private access
	bool getImportAnimationOOC() const { return m_importAnimationOOC; }
	void setImportAnimationOOC(bool val) { m_importAnimationOOC = val; }
	bool getRelativePath() const { return m_relativePath; }
	void setRelativePath(bool val) { m_relativePath = val; }
	std::string getOocSwapFileName() const { return m_oocSwapFileNamePath; }
	void setOocSwapFileName(std::string val) { m_oocSwapFileNamePath = val; }
   bool getImportEntireDirectory() const {return m_entireDirectory;}
   void setImportEntireDirectory(bool v) {m_entireDirectory=v;}
};


}

#endif
