//---------------------------------------------------------------------------
#ifndef PCCAutoAlignH
#define PCCAutoAlignH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
#include "Scene.h"
#include "PointCloud.h"
//---------------------------------------------------------------------------

namespace geoxl {


class EDITOR_API PCCAutoAlign : public PCCommand {
 private:
   static MetaClass *PCCAutoAlignMetaClass;
   static Object* newInstance();

   /// Center point clouds
   bool center;
   /// Rescale the point cloud
   bool rescale;
   /// Simply adjust camera settings
   bool adjustCamera;

 public:
   /// Constructor
   PCCAutoAlign();
   /// Execute command
   virtual void execute(Scene *scene);

   /*--- META-CLASS ---*/
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();
};


}

#endif
 