//---------------------------------------------------------------------------
#ifndef PCCComputeFlagsH
#define PCCComputeFlagsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
#include "LinearAlgebra.h"
#include "VertexDescriptor.h"
//---------------------------------------------------------------------------

namespace geoxl {

class ModifyablePointCloudIterator;
class ParametricPointCloudIterator;
class Scene;
class PointCloud;


class EDITOR_API PCCComputeFlags : public PCCommand {
 private:
   static MetaClass *PCCComputeFlagsMetaClass;
   static Object* newInstance();

   float32 referenceValue;
   string channel;
   card32 channelIndex;
   int32 flagsToBeSet;
   bool testOnGreater;

 public:
   PCCComputeFlags();

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void execute(Scene *scene);

};


}

#endif
 