//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PCCConvToSwapAllOOC.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "GenericSwapAllOutOfCorePointCloud.h"
#include "SGObjectNode.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



IMPLEMENT_GEOXL_CLASS( PCCConvToSwapAllOOC , 0 ) {
	BEGIN_CLASS_INIT( PCCConvToSwapAllOOC );
	ADD_STRING_PROP(filenamePrefix, 0)
	ADD_STRING_PROP(filenameSuffix, 0)
	ADD_BOOLEAN_PROP(relativePath, 0)
}

// ----

PCCConvToSwapAllOOC::PCCConvToSwapAllOOC() {
	filenamePrefix = "c:\\temp\\";
	filenameSuffix = "_GSA-swap.object";
}

void PCCConvToSwapAllOOC::assign(const Object* obj, CopyContext *context) {
	copyObjectProperties(obj, this);
}

PCCConvToSwapAllOOC::~PCCConvToSwapAllOOC() {
}




void PCCConvToSwapAllOOC::execute(Scene *scene) 
{
   vector<string> selection = scene->getRootState()->staticState->getSelectedNodes();
   for (unsigned m=0; m<selection.size(); m++) {
      PointCloud *pc = getPointCloud(scene, selection[m]);
      SGObjectNode *node = dynamic_cast<SGObjectNode*>(getSceneGraphNodeByName(scene, selection[m]));
      if (!pc || !node) continue;
      
      if (dynamic_cast<GenericSwapAllOutOfCorePointCloud*>(pc)) {
			warning("selected pc is already of type GenericSwapAllOutOfCorePointCloud - item not converted.");
			continue;
      }
      GenericSwapAllOutOfCorePointCloud *newGSA = new GenericSwapAllOutOfCorePointCloud();
      newGSA->clearAndSetup(pc, filenamePrefix+node->getName()+filenameSuffix, relativePath);
      node->removeSceneObject();
      node->clearAndSetup(newGSA);
	}		
}
