//---------------------------------------------------------------------------
#ifndef PCCDirectoryImporterH
#define PCCDirectoryImporterH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------


namespace geoxl {

class PCCImporter;

///
///  this tool imports all files with certain extension (file ending) from a directory subtree
///
class EDITOR_API PCCDirectoryImporter : public PCCommand {
	GEOXL_CLASS( PCCDirectoryImporter )
private:
   string directory;
   string fileEnding;
   PCCImporter *importer;
   bool ignoreExceptions;
   bool outputFiles;

   void recursiveCollect(string file);

public:
	PCCDirectoryImporter();

   virtual void assign(const Object *obj, CopyContext *context = NULL);
   virtual void execute(Scene *scene);

	~PCCDirectoryImporter();
};

}

#endif