#ifndef PCCImplicitMesherH
#define PCCImplicitMesherH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	creates a triangle mesh for all/selected point clouds.
	defines a implicit function (signed distance) and uses marching cubes for
	triangulation (Hoppe92)
*/
class EDITOR_API PCCImplicitMesher : public PCCommand
{
	GEOXL_CLASS( PCCImplicitMesher )

private:

	void triangulatePointCloud( Scene * scene, string pcName );

	float		m_Sigma;
	card32	m_Resolution;
	float		m_GridSnapTolerance;
	bool		smoothNormals;
	float		smoothNormals_Sigma;

public:
	PCCImplicitMesher(void);
	~PCCImplicitMesher(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

	virtual void execute(Scene *scene);

};

}

#endif