//---------------------------------------------------------------------------
#include "stdafx.h"
//---------------------------------------------------------------------------
#include "PCCPointGenerator.h"
//---------------------------------------------------------------------------
#include "Scene.h"
#include "BoundingBox.h"
#include "BoundingBox_templCode.h"
#include "LinearAlgebra.h"
#include "LinearAlgebra_templCode.h"
#include "PointCloud.h"
#include "PointCloudIterators.h"
#include "NumericalClassProperty.h"
#include "FixedArrayClassProperty.h"
#include "StringClassProperty.h"
#include "PointSet.h"
#include "UnstructuredInCorePointCloud.h"
#include "DebugOutput.h"
#include "VertexDescriptor.h"
#include "Random.h"
#include "PolarCoordinates.h"
#include "PointCloudIterators.h"
#include "BooleanClassProperty.h"
#include "CommandHistory.h"

//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------

static string describeType(card32 q) {
	if ( q == GENERATE_BOX ) {
		return "BOX";
	} else if ( q == GENERATE_SPHERE ) {
		return "SPHERE";
	} else if ( q == GENERATE_PLANE ) {
		return "PLANE";
	} else if ( q == GENERATE_DOWNWARD_SPIRAL ) {
		return "DOWNWARD_SPIRAL";
	} else {
		return "UNDEFINED";
	}
}

IMPLEMENT_GEOXL_CLASS( PCCPointGenerator, 0 )
{
	BEGIN_CLASS_INIT( PCCPointGenerator )
	ADD_CARD32_PROP( numPoints,0 )
	ADD_CARD32_PROP_UPDATE_DESCR( type, 0, NULL, &describeType, 4 )
	ADD_STRING_PROP( pcName, 0 );
}

/** 
 * Create new object, init variables
 */
PCCPointGenerator::PCCPointGenerator()
{
   type = GENERATE_SPHERE;
   numPoints = 2000;
   pcName = "pc1";
}

/**
 * Run command
 */
void PCCPointGenerator::execute( Scene *scene )
{
   CmdObjGeneratePC* newCmd = new CmdObjGeneratePC();
   newCmd->setup( type, numPoints, pcName );
   newCmd->doAction( scene );
   delete newCmd;
}
