//---------------------------------------------------------------------------
#ifndef PCCResamplerH
#define PCCResamplerH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
#include "PointCloud.h"
#include "Scene.h"
//---------------------------------------------------------------------------

namespace geoxl {

/// Downsampling of point clouds
class EDITOR_API PCCResampler : public PCCommand 
{
	GEOXL_CLASS( PCCResampler )
	
	private:
		string source;			// Name of source node; DEPRECATED
		card32 numPoints;		// Number of points to end up with; DEPRECATED
		bool animated;			// Flag for animated data; DEPRECATED
		bool selection;			// ?? DEPRECATED
		float32 spacing;		// Min spacing between points after resampling

		//	PointSet* downSample( PointSet* ps, const card32 numPoints ); // DEPRECATED

	public:
		PCCResampler();
		~PCCResampler();
		void execute( Scene *scene );

      static void resamplePC(PointCloud* pc, float spacing);
      
      float32 getSpacing() const {return spacing;}
      void setSpacing(float32 v) {spacing=v;}

};


}

#endif
