//---------------------------------------------------------------------------
#ifndef PCCTriangleMeshSamplerH
#define PCCTriangleMeshSamplerH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace geoxl {

class SceneObject;


/// this method implements the core functionality
/// source must be a triangle mesh, target must be a (dynamic) point cloud
/// expNumPoints is the approximate number of points to be generated (this is the expected value)
EDITOR_API void sampleMeshRandomly(Scene * scene, string destID, SceneObject *sourceMesh, SceneObject *destPointCloud, card64 numPoints,
                                bool createTangentDiscs, float32 tangentDiscOversampling, bool surfaceNormalSmoothing);


class EDITOR_API PCCTriangleMeshSampler : public PCCommand {
 private:
   static MetaClass *PCCTriangleMeshSamplerMetaClass;
   static Object* newInstance();

   string sourceNode;
   string destNode;
   card64 expNumPoints;
   bool createTangentDiscs;
   float32 tangentDiscOversampling;
	bool surfaceNormalSmoothing;

 public:
   PCCTriangleMeshSampler();

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void execute(Scene *scene);
};

}

#endif
 