// vertex shader
// pointer loeschen
// assertions
// abfragen der AAT providesatribute(...)
// commando und undo redo an editor weiter geben

//---------------------------------------------------------------------------
#include "StdAfx.h"
#include "PCCVolumeGenerator.h"
#include "CopyObjectProperties.h"
#include "RegularVolume_templCode.h"
#include "PointSet_templCode.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------

IMPLEMENT_GEOXL_CLASS( PCCVolumeGenerator , 0 )
{
	BEGIN_CLASS_INIT( PCCVolumeGenerator );
	ADD_STRING_PROP( volumeName, 0 );
	ADD_CARD32_PROP( nVoxelsX,0 );
	ADD_CARD32_PROP( nVoxelsY,0 );
	ADD_CARD32_PROP( nVoxelsZ,0 );
}

PCCVolumeGenerator::PCCVolumeGenerator()
{
	volumeName = "volume1";
	nVoxelsX = nVoxelsY = nVoxelsZ = 100;
	bbLL = makeVector3f(-1.0f,-1.0f,-1.0f);
	bbUR = makeVector3f( 1.0f, 1.0f, 1.0f);
}

void PCCVolumeGenerator::assign(const Object* obj, CopyContext *context)
{
	copyObjectProperties(obj, this);
}

PCCVolumeGenerator::~PCCVolumeGenerator()
{
}

void PCCVolumeGenerator::execute(Scene *scene)
{
	VertexDescriptor vd;
	vd.pushAttrib( mVAD( "position", 3, VAD::DATA_FORMAT_FLOAT32 ) );
	vd.pushAttrib( mVAD( "intensity", 1, VAD::DATA_FORMAT_FLOAT32 ) );
	
	RegularVolume* volume = new RegularVolume();
   BoundingBox3f bb = BoundingBox3f(bbLL,bbUR);

	volume->clearAndSetup(nVoxelsX, nVoxelsY, nVoxelsZ, &vd, bb);
	AAT POSITION  = vd.getToken( "position" );
	AAT INTENSITY = vd.getToken( "intensity" );

	float32 wf,hf,df;
	Vector3f position;
	float32 intensity;
	for (size_t w = 0; w < volume->getWidth(); w++)
	{
		for (size_t h = 0; h < volume->getHeight(); h++)
		{
			for (size_t d = 0; d < volume->getDepth(); d++)
			{
				wf = bbLL[0] + (w * (bbUR[0] - bbLL[0]) / (nVoxelsX-1));
				hf = bbLL[1] + (h * (bbUR[1] - bbLL[1]) / (nVoxelsY-1));
				df = bbLL[2] + (d * (bbUR[2] - bbLL[2]) / (nVoxelsZ-1));
				position = makeVector3f(wf, hf, df);
				//if((abs(wf) < 0.5f) && (abs(hf) < 0.5f) && (abs(df) < 0.5f))// &&
				if((abs((int)(w-volume->getWidth())) > 30)  && (w > 30) && (abs((int)(h-volume->getHeight())) > 20)  && (h > 20) && (abs((int)(d-volume->getDepth())) > 25)  && (d > 25))// &&
					//((abs(wf) > 0.4f) && (abs(hf) > 0.4f) && (abs(df) > 0.4f))	)
//				if((wf == 0.0f) && (hf == 0.0f) && (df == 0.0f))
					intensity = 1.0f;//(0.5f*sin(wf*M_PI*3+0)+0.5f) * (0.5f*sin(hf*M_PI*2+M_PI)+0.5f) * (0.5f*sin(df*M_PI*5+3*M_PI)+0.5f);
				else
					intensity = 0.0f;
				//intensity = (0.5f*sin(wf*M_PI*3+2*M_PI)+0.5f) * (0.5f*sin(hf*M_PI*2+M_PI)+0.5f) * (0.5f*sin(df*M_PI*5+3*M_PI)+0.5f);
				volume->setVoxel((card32)w,(card32)h,(card32)d,POSITION,position);
				volume->setVoxel((card32)w,(card32)h,(card32)d,INTENSITY,intensity);
			}
		}
	}
	
	RegularInCoreVolume* RICvolume = new RegularInCoreVolume();
	RICvolume->setVoxels(volume);
	addSceneObject(scene,RICvolume,volumeName);
}