//---------------------------------------------------------------------------
#ifndef PointCloudImporterReaderBinaryH
#define PointCloudImporterReaderBinaryH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PointCloudImporterReader.h"
//---------------------------------------------------------------------------
#include <stdio.h>
//---------------------------------------------------------------------------

namespace geoxl {

class LargeBinaryFile;

///
///   Universal Importer for Binary Files
///
class EDITOR_API PointCloudImporterReaderBinary : public PointCloudImporterReader {
	GEOXL_CLASS( PointCloudImporterReaderBinary )
 private:
   card32 headerLength;
   VertexDescriptor *vertexDescriptor;

   // --- tmp state
   LargeBinaryFile *f;
   card8 *buffer;
   card32 size;
   card64 fileSize;
   card64 bytesRead;
   AAT posAAT;
   bool checkPos;
   
 public:
	PointCloudImporterReaderBinary();

	virtual void assign(const Object* obj, CopyContext *context = NULL);

   virtual bool beginImport( string filename, bool readTrianglesIfPossible=false );
   virtual const card8* getNextPoint();
	virtual const card8* getNextTriangle();
   virtual void endImport();

   virtual mpcard getWidth();
	virtual mpcard getHeight();

	virtual mpcard getProgressPercentage();

   virtual bool supportsTriangleImport();

   ~PointCloudImporterReaderBinary();
};

}

#endif