#ifndef PointCloudImporterReaderCustomASCIIEditorWidgetH 
#define PointCloudImporterReaderCustomASCIIEditorWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PointCloudImporterReaderCustomASCIIEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace geoxl
{
	using namespace std;

class PointCloudImporterReaderCustomASCII;

class EDITOR_API PointCloudImporterReaderCustomASCIIEditorWidget : public QWidget
{
	Q_OBJECT

private:

	PointCloudImporterReaderCustomASCII	*	m_Object;

	///used to access buttons, etc. from QtDesigner
	Ui_PointCloudImporterReaderCustomASCIIEditorForm ui;

	void setCBCommentMarkers(vector<string>);
	vector<string> getCBCommentMarkers();
	void setCBColumns(vector<card32>);
	vector<card32> getCBColumns();
	bool ColumnIsInColumnList(card32 col, vector<card32> colList);
	void setCBSeparator(string sep);
	bool presetChangedNotByUser;

	ClassEditor *vdEditor;
   QWidget *vdEditorWidget;

public:
	PointCloudImporterReaderCustomASCIIEditorWidget(QWidget * parent = NULL, Qt::WFlags f=0);
	~PointCloudImporterReaderCustomASCIIEditorWidget(void);

	void setup( PointCloudImporterReaderCustomASCII * obj );

	/// update editor content with object data
	void updateEditor();


protected slots:
	void sltCBPresetsCurrentIndexChanged(int);
	void on_SBWidth_valueChanged(int);
	void on_SBHeight_valueChanged(int);
	void on_SBIgnoreFirstLines_valueChanged(int);
	void on_CBCommentMarkers_currentIndexChanged(int);
	void on_BTRemoveLines_clicked();
	void on_CBColumns_currentIndexChanged(int);
	void on_BTRemoveColumns_clicked();
	void sltRadioButtonPressed();
	void on_BTGenerateSampleFile_clicked();
	void sltCBSeparatorCurrentIndexChanged(int);
};

MAKE_CLASS_EDITOR( EDITOR_API , PointCloudImporterReaderCustomASCII )


}

#endif