#ifndef AnimationBarWidgetH
#define AnimationBarWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include <qtGui/qframe.h>
#include <QtCore/QTimer>
#include "PTypes.h"
//---------------------------------------------------------------------------
//this file is generated from the ui file by a custom buildstep, include it here
#include "AnimationBarWidgetForm_ui.h"
//---------------------------------------------------------------------------

namespace geoxl
{

	class SceneEditorWidget;


	class AnimationBarWidget : public QFrame
	{
		Q_OBJECT

	private:
		QTimer* timer;
		int sliderPosBefore;


	public:
		AnimationBarWidget(QWidget *sceneEd);
		~AnimationBarWidget(void);


   private slots:
	void on_frameSlider_valueChanged(int);
	void on_startBox_valueChanged(int);
	void on_endBox_valueChanged(int);
	void on_stepBox_valueChanged(int);
   void on_playButton_clicked();
   void on_stopButton_clicked();
   void on_oneBackButton_clicked();
   void on_oneForwardButton_clicked();
	void on_fpsBox_valueChanged(int);
	void onTimerTick(); 
	void on_traversalModeBox_currentIndexChanged(int);


   signals:
		void frameChanged(int atFrame);
		void traversalModeChanged(SGStaticState::TraversalModeType mode);

	public:
		int getFrameNumber();
		void setFrameNumber(int);
		card32 getStartFrameNumber();
		card32 getEndFrameNumber();
		int32  getAnimStep();
		card32 getFramesCount();
		void updateTraversalModeBox(SGStaticState::TraversalModeType mode);
		void setTime(float32 time);


	protected:
		///used to access buttons, etc. from QtDesigner
		Ui_AnimationBarWidgetForm ui;


	};
}

#endif
