#ifndef CmdObjScriptProgramEditorWidgetH 
#define CmdObjScriptProgramEditorWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "CmdObjScriptProgramEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace geoxl
{
	using namespace std;

class CmdObjScriptProgram;
class ObjectDictionary;

class EDITOR_API CmdObjScriptProgramEditorWidget : public QWidget
{
	Q_OBJECT

private:

	CmdObjScriptProgram	*	cmdScript;

   /// pointer to the script's object dictionary
   ObjectDictionary* dictionary;

	///used to access buttons, etc. from QtDesigner
	Ui_CmdObjScriptProgramEditorForm ui;

	/// class editor of object selected in object list
	ClassEditor* objectEditor;
	/// class editor widget of object selected in object list
	QWidget* objectEditorWidget;
	
	bool updating;

   void updateSelectedItemEditor(Object *obj);

public:
	CmdObjScriptProgramEditorWidget(QWidget * parent = NULL, Qt::WFlags f=0);
	~CmdObjScriptProgramEditorWidget(void);

	void setup( CmdObjScriptProgram * obj );

	/// update editor content with object data
	void updateEditor();

public slots:
   void on_BTEditScript_clicked();
   void on_BTAddMacro_clicked();
   
   void on_BTBottom_clicked();
   void on_BTDown_clicked();
   void on_BTUp_clicked();
   void on_BTTop_clicked();
   void on_BTNew_clicked();
   void on_BTDuplicate_clicked();
   void on_BTDelete_clicked();
   void on_TWCommands_currentCellChanged(int row, int column, int prevRow, int prevColumn);
   void on_TWCommands_cellChanged(int row, int column);

};

MAKE_CLASS_EDITOR( EDITOR_API , CmdObjScriptProgram )


}

#endif