#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "DebugRendererEditorWidget.h"
//---------------------------------------------------------------------------
#include "DebugRenderer.h"
//---------------------------------------------------------------------------
using namespace geoxl;

DebugRendererEditorWidget::DebugRendererEditorWidget(QWidget * parent, Qt::WFlags f)
:QWidget(parent,f)
{
	//call ui.setupUi(this) to set up the layout from QtDesigner
	ui.setupUi(this);
	//Example: easy access to QtDesigner buttons, etc. by ui object
	//QWidget::connect(ui.loadButton,SIGNAL(clicked()),this,SLOT(sltLoadFile()));

}

DebugRendererEditorWidget::~DebugRendererEditorWidget(void)
{
}

void DebugRendererEditorWidget::setup( DebugRenderer * obj )
{
	m_DebugRenderer = obj;
}

void DebugRendererEditorWidget::updateEditor()
{
	ui.listRenderJobs->clear();

	bool selectedJobFound = false;
	unsigned selectedJobIndex = 0;
	for( unsigned i=0;i<m_DebugRenderer->getNumRenderJobs();i++ )
	{
		string rjName = m_DebugRenderer->getRenderJobName(i);
		if( m_SelectedJob == rjName )
		{
			ui.bCurrentJobVisible->setChecked(m_DebugRenderer->getRenderJobActiveFlag(i));
			ui.labelSelectedJob->setText(QString(rjName.c_str()));
			selectedJobIndex = i;
			selectedJobFound = true;
			ui.bCurrentJobVisible->setEnabled(true);
		}
		ui.listRenderJobs->addItem( QString(rjName.c_str()));
	}

	if( !selectedJobFound )
	{
		ui.bCurrentJobVisible->setEnabled(false);
		ui.labelSelectedJob->setText("No job selected");
	}

}

#include "DebugRendererEditorWidget_moc.cpp"
void DebugRendererEditorWidget::on_pbClearAllJobs_clicked() 
{
	m_DebugRenderer->clearDebugData();
}

void DebugRendererEditorWidget::on_pbClearSelectedJob_clicked() 
{
	for( unsigned i=0;i<m_DebugRenderer->getNumRenderJobs();i++ )
	{
		string rjName = m_DebugRenderer->getRenderJobName(i);
		if( m_SelectedJob == rjName )
		{
			m_DebugRenderer->clearDebugData(rjName);
			break;
		}
	}
}

void DebugRendererEditorWidget::on_bCurrentJobVisible_clicked() 
{
	for( unsigned i=0;i<m_DebugRenderer->getNumRenderJobs();i++ )
	{
		string rjName = m_DebugRenderer->getRenderJobName(i);
		if( m_SelectedJob == rjName )
		{
			m_DebugRenderer->setRenderJobActiveFlag(i,ui.bCurrentJobVisible->isChecked());
			break;
		}
	}
}

void DebugRendererEditorWidget::focusInEvent ( QFocusEvent * event ) 
{
	updateEditor();
}

void DebugRendererEditorWidget::enterEvent ( QEvent * event ) 
{
	updateEditor();
}

void DebugRendererEditorWidget::showEvent ( QShowEvent * event ) 
{
	updateEditor();
}

void geoxl::DebugRendererEditorWidget::on_listRenderJobs_itemClicked( QListWidgetItem * item )
{
	m_SelectedJob = item->text().toLatin1().constData();
	updateEditor();
}