//---------------------------------------------------------------------------
#ifndef GeoXLGLWidgetH
#define GeoXLGLWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include <QtOpenGL/qgl.h>
#include "GLContext.h"
//---------------------------------------------------------------------------

namespace geoxl
{

	 class GeoXLGLWidget :
		  public QGLWidget
	 {
		  Q_OBJECT

	 public:
		  GeoXLGLWidget(QWidget * parent = NULL);
		  ~GeoXLGLWidget(void);
	     GLContext *getContext();

		  Scene * scene;

	 protected:
		  void initializeGL();
		  void paintGL();
		  void resizeGL(int width, int height);
		  void mousePressEvent(QMouseEvent *event);
		  void mouseReleaseEvent (QMouseEvent * event);
		  void mouseMoveEvent(QMouseEvent *event);
		  void wheelEvent(QWheelEvent * event);
		  void dragEnterEvent(QDragEnterEvent *event);
		  void dropEvent(QDropEvent *event);

    signals:
		  void sigResize(const QSize);
		  void sigRepaint(void);
		  void sigMouseMove(QMouseEvent *event);
		  void sigMousePress(QMouseEvent *event);
		  void sigMouseRelease(QMouseEvent *event);
		  void sigDropEvent( QMimeData * d, QPoint pos );
		  void sigWheelEvent(QWheelEvent * event);


	public slots:
	 
	 private:

			QPoint	m_dragStartPosition;


	 };


}

#endif