#ifndef MacroScriptEditorWidgetH
#define MacroScriptEditorWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include <qtGui/qmainwindow.h>
#include "PTypes.h"
//---------------------------------------------------------------------------
//this file is generated from the ui file by a custom buildstep, include it here
#include "MacroScriptEditorWidget_ui.h"
//---------------------------------------------------------------------------

namespace geoxl
{

class Scene;
class ObjectDictionary;
class ObjectDictionaryEditor;
class ObjectDictionaryEditorWidget;
class SceneEditorWidget;

class EDITOR_API MacroScriptEditorWidget : public QMainWindow
{
	Q_OBJECT

public:
	MacroScriptEditorWidget(Scene *scene, SceneEditorWidget *editorWidget);
	void update();
	~MacroScriptEditorWidget();

   static bool getScriptRunning();
   static void repaintInScript();

private:
	Scene *scene;
	SceneEditorWidget *editorWidget;
   ObjectDictionary* dictionary;
   ObjectDictionaryEditor* dictionaryEditor;
   ObjectDictionaryEditorWidget* dictionaryEditorWidget;
   static bool scriptRunning;
   static SceneEditorWidget *activeEditorWidget;

private slots:
	void on_action_Load_triggered(bool checked);
	void on_action_Save_triggered(bool checked);
	void on_action_Update_triggered(bool checked);
	void on_BTExecute_clicked();
	void on_BTDebug_clicked();
	void on_BTConvertToScript_clicked();

protected:
	///used to access buttons, etc. from QtDesigner
	Ui_MacroScriptEditorWidget ui;
	
};

 //extern EDITOR_API MacroScriptEditorWidget *macroScriptEditorWidget;

}

#endif
