#ifndef PCICameraManagerEditorWidgetH 
#define PCICameraManagerEditorWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PCICameraManagerEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace geoxl
{
	using namespace std;

class PCICameraManager;
class ClassSelectionDialog;

class EDITOR_API PCICameraManagerEditorWidget : public QWidget
{
	Q_OBJECT

private:

	PCICameraManager	*	m_Object;

	///used to access buttons, etc. from QtDesigner
	Ui_PCICameraManagerEditorForm ui;

	ClassSelectionDialog * m_ClassDlg;
	QWidget			*	m_CameraEditorWidget;
	ClassEditor		*	m_CameraEditor;

public:
	PCICameraManagerEditorWidget(QWidget * parent = NULL, Qt::WFlags f=0);
	~PCICameraManagerEditorWidget(void);

	void setup( PCICameraManager * obj );

	/// update editor content with object data
	void updateEditor();

public slots:

	void on_pbAdd_clicked();
	void on_pbAddPanCam_clicked();
	void on_pbEdit_clicked();
	void on_listCameras_currentTextChanged(const QString &);

};

MAKE_CLASS_EDITOR( EDITOR_API , PCICameraManager )


}

#endif