#ifndef PCIDrawingToolEditorWidgetH 
#define PCIDrawingToolEditorWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PCIDrawingToolEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace geoxl
{
	using namespace std;

class PCIDrawingTool;

class EDITOR_API PCIDrawingToolEditorWidget : public QWidget
{
	Q_OBJECT

private:

	PCIDrawingTool	*	obj;
	Vector3f col;

	///used to access buttons, etc. from QtDesigner
	Ui_PCIDrawingToolEditorForm ui;

	void sendColor();

public:
	PCIDrawingToolEditorWidget(QWidget * parent = NULL, Qt::WFlags f=0);
	~PCIDrawingToolEditorWidget(void);

	void setup( PCIDrawingTool * obj );

	/// update editor content with object data
	void updateEditor();


private slots:
	//auto-connected slot:
	//void on_<widget name>_<signal name>(<signal parameters>);
    void on_redBox_valueChanged(double);
    void on_greenBox_valueChanged(double);
    void on_blueBox_valueChanged(double);
    void on_brushBox_valueChanged(int);
	 void on_surfaceBox_clicked();
	 void on_fadeBox_clicked();
	 void on_fillSelButton_clicked();
	 void on_colorButton_clicked();

	 void on_attributePaintBox_clicked(bool);
	 void on_attNameEdit_textChanged();
	 void on_attrVal_valueChanged(double);
};

MAKE_CLASS_EDITOR( EDITOR_API , PCIDrawingTool )


}

#endif
