#ifndef PCISelectionToolEditorWidgetH 
#define PCISelectionToolEditorWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PCISelectionToolEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace geoxl
{
	using namespace std;

class PCISelectionTool;

class EDITOR_API PCISelectionToolEditorWidget : public QWidget
{
	Q_OBJECT

private:

	PCISelectionTool	*	m_SelTool;

	///used to access buttons, etc. from QtDesigner
	Ui_PCISelectionToolEditorForm ui;

	/// get selection modus and check down the right button
	void updateButtons();

public:
	PCISelectionToolEditorWidget(QWidget * parent = NULL, Qt::WFlags f=0);
	~PCISelectionToolEditorWidget(void);

	void setup( PCISelectionTool * obj );

	/// update editor content with object data
	void updateEditor();

public slots:
	void on_BTSingleCloud_clicked();
	void on_BTSinglePoint_clicked();
	void on_BTBrushCircle_clicked();
	void on_BTBrushQuadratic_clicked();
	void on_SBBrushSize_valueChanged(int);
	void on_CBSurfaceMode_stateChanged(int);
	void on_BTAreaCircle_clicked();
	void on_BTAreaRectangle_clicked();
	void on_BTClearClouds_clicked();
	void on_BTAllClouds_clicked();
	void on_BTClearPoints_clicked();
	void on_BTAllPoints_clicked();
	void on_BTInvertPoints_clicked();
	void on_BTAttribColorSelector_clicked();
	void on_SBAttribColorTolerance_valueChanged(int);
	void on_BTAttribColorExecute_clicked();
	void on_CBDeselect_stateChanged(int);
};

MAKE_CLASS_EDITOR( EDITOR_API , PCISelectionTool )


}

#endif