//---------------------------------------------------------------------------
#ifndef PCImageViewersH
#define PCImageViewersH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include <QtGui/Qwidget.h>
#include <QtGui/QImage.h>
#include "PTypes.h"
//---------------------------------------------------------------------------
//this file is generated from the ui file by a custom buildstep, include it here
#include "PCImageViewerForm_ui.h"
//---------------------------------------------------------------------------


namespace geoxl {

class PointSet;


class EDITOR_API PCImageViewer : public QWidget
{
   
	Q_OBJECT;
   
private:	// User declarations
   const PointSet *pc;
   void rebuildView();
   //Graphics::TBitmap *bmp;
   QImage *bmp;
   card32 imgWidth, imgHeight;
public:		// User declarations
   PCImageViewer(QWidget* parent, const PointSet* pc);


public slots:
	void on_sb_zoom_valueChanged();
   void on_cb_invalid_clicked();
 /*  void CBChannelKeyDown( WORD &Key,
          TShiftState Shift);*/
   void PB_paintAreaPaint();
 /*  void ScrollBox1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);*/
   void on_combo_channel_activated();
   void on_sb_scaling_valueChanged();
   void on_cb_xy_stateChanged();
   void on_cb_invalid_stateChanged();
   void on_cb_3vec_stateChanged();
   void on_cb_offset_stateChanged();
   void on_saveButton_clicked();

protected:
	Ui_PCImageViewerForm ui;
};

}
#endif
