//---------------------------------------------------------------------------
#ifndef PCSceneMaterialBrowserH
#define PCSceneMaterialBrowserH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "SceneClassEditors.h"
//---------------------------------------------------------------------------

namespace geoxl {

class GLContext;
class PCSceneMaterialBrowserWidget;


class EDITOR_API PCSceneMaterialBrowser : public SceneClassEditor {
 private:
   static MetaClass *PCSceneMaterialBrowserMetaClass;
   static Object* newInstance();

   PCSceneMaterialBrowserWidget * matEd;
   GLContext * m_GLContext;

 public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   // -----------------------------
   PCSceneMaterialBrowser();

   //virtual TControl *makeEditor(TComponent *AOwner, Object *obj);
	virtual QWidget * makeEditor( QWidget * parent, Object * obj );
   virtual Object* getObject();
   virtual void apply();
   virtual void update();
   virtual card32 getPreferredWidth();
   virtual card32 getPreferredHeight();

   virtual void setGLContext(GLContext * context) {m_GLContext = context;}
};


}

#endif

