#ifndef SceneEditorOptionsEditorWidgetH 
#define SceneEditorOptionsEditorWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "SceneEditorOptionsEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace geoxl
{
	using namespace std;

class SceneEditorOptions;

class EDITOR_API SceneEditorOptionsEditorWidget : public QWidget
{
	Q_OBJECT

private:

	Vector3f toVec3f( QColor col );
	QColor toColor( Vector3f col );

	SceneEditorOptions	*	m_Object;

	///used to access buttons, etc. from QtDesigner
	Ui_SceneEditorOptionsEditorForm ui;

public:
	SceneEditorOptionsEditorWidget(QWidget * parent = NULL, Qt::WFlags f=0);
	~SceneEditorOptionsEditorWidget(void);

	void setup( SceneEditorOptions * obj );

	/// update editor content with object data
	void updateEditor();

public slots:

	void on_cbDefaultCamera_currentIndexChanged(int index);
	void on_pbSave_clicked();
	void on_pbLoad_clicked();
	void on_pbBGColor_clicked();
	void on_cbUseSoftwareVertexBuffers_clicked();
	void on_cbRedrawMode_currentIndexChanged(int index);
	void on_bUseBoundingBoxSelection_clicked();

};

MAKE_CLASS_EDITOR( EDITOR_API , SceneEditorOptions )


}

#endif