//---------------------------------------------------------------------------
#ifndef SceneGraphEditorH
#define SceneGraphEditorH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "SceneClassEditors.h"
//---------------------------------------------------------------------------

namespace geoxl {

class GLContext;
class SceneGraphEditorWidget;


class EDITOR_API SceneGraphEditor : public SceneClassEditor {
 private:
   static MetaClass *SceneGraphEditorMetaClass;
   static Object* newInstance();

   SceneGraphEditorWidget * sgEd;
	Object *obj;

 public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   // -----------------------------
   SceneGraphEditor();

	virtual QWidget * makeEditor( QWidget * parent, Object * obj );
   virtual Object* getObject();
   virtual void apply();
   virtual void update();
   virtual card32 getPreferredWidth();
   virtual card32 getPreferredHeight();



};


}

#endif
