//---------------------------------------------------------------------------
#ifndef PCIFilterToolH
#define PCIFilterToolH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PCInteractionTool.h"
//---------------------------------------------------------------------------
#include "LinearAlgebra.h"
//---------------------------------------------------------------------------

namespace geoxl {

 
class EDITOR_API PCIFilterTool : public PCInteractionTool {
 private:
   static MetaClass *PCIFilterToolMetaClass;
   static Object* newInstance();

   bool leftMBdown;
   card32 w,h;

   card32 mouseMoveX,mouseMoveY;
   float32 WidthToHeight;


 public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   PCIFilterTool();
   card32 mode,channel;
   float32 size,strength;

   bool use_kNN;
   card32 kNN_numPoints;

   bool use_Heightmap;

   void filterArea(card32 x,card32 y);
   void filterScene();
 //  void averageFilter3f(IteratorAdaptor *it, float32 radius);
  // void  medianFilter3f(IteratorAdaptor *it, float32 radius);

   virtual void mouseDown(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState);
   virtual void mouseMoved(int32 x, int32 y);
   virtual void mouseUp(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState);
   virtual void areaResize(card32 width, card32 height);

   virtual void keyDown(GeneralKey key);
   virtual void keyUp(GeneralKey key);

   virtual void connectScene(Scene *scene, OnSceneChangeCallback *onChange, QWidget *sceneEditorWidget);
   virtual void glDrawTool(GLContext *glContext);
   void drawCircle(float32 x1, float32 y1, float32 r);
};


}

#endif
