#ifndef PCIManualAlignmentH
#define PCIManualAlignmentH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PCInteractionTool.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	align two point clouds manually
*/
class EDITOR_API PCIManualAlignment : public PCInteractionTool
{
	GEOXL_CLASS( PCIManualAlignment )

private:

	vector<Vector3f>		m_PointList1;
	vector<Vector3f>		m_PointList2;

	PointCloud			*	m_PC1;
	PointCloud			*	m_PC2;

public:
	PCIManualAlignment(void);
	~PCIManualAlignment(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

	virtual void keyDown(GeneralKey key) {}
	virtual void keyUp(GeneralKey key) {}

	virtual void mouseDown(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState);
	virtual void mouseMoved(int32 x, int32 y) {}
	virtual void mouseUp(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState) {}
	virtual void areaResize(card32 width, card32 height) {}

	virtual void glDrawTool(GLContext *glContext);

	void clear();
	void align();
	void basePlaneAlignment();


};

}

#endif