#ifndef AttachedDataContainerEditorWidgetH 
#define AttachedDataContainerEditorWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "AttachedDataContainerEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace geoxl
{
	using namespace std;

class AttachedDataContainer;
class ClassSelectionDialog;

class FOUNDATION_API AttachedDataContainerEditorWidget : public QWidget
{
	Q_OBJECT

private:

	void openEditor( Object * obj, const MetaClass * mc );
	
	AttachedDataContainer	*	m_Object;

	///used to access buttons, etc. from QtDesigner
	Ui_AttachedDataContainerEditorForm ui;

	QWidget						*	m_SubObjectWidget;
	ClassSelectionDialog		*	m_ClassSelectionDialog;

public:
	AttachedDataContainerEditorWidget(QWidget * parent = NULL, Qt::WFlags f=0);
	~AttachedDataContainerEditorWidget(void);

	void setup( AttachedDataContainer * obj );

	/// update editor content with object data
	void updateEditor();

public slots:
	
	void on_pbEdit_clicked();
	void on_pbAdd_clicked();
	void on_pbDelete_clicked();
	void on_pbUpdate_clicked();
	void sltItemDoubleClicked ( QTreeWidgetItem * item, int column );
	void sltEditorDestroyed(QObject *obj);

};

MAKE_CLASS_EDITOR( FOUNDATION_API , AttachedDataContainer )


}

#endif