#ifndef DebugWindowsH
#define DebugWindowsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include <QtGui/QWidget.h>
#include "PTypes.h"
//---------------------------------------------------------------------------
//this file is generated from the ui file by a custom buildstep, include it here
#include "DebugWindowsForm_ui.h"
//---------------------------------------------------------------------------

namespace geoxl
{

class EventDisplayerEvent;
class EventViewerWidget;

class FOUNDATION_API DebugWindow :
	public QWidget
{
	Q_OBJECT;

private:

	QTimer *timer;
	QColor stdBackground;
	QColor stdColor;
	EventViewerWidget *eventViewer;
	string textBuffer;

public:
	DebugWindow(QWidget *parent);
	~DebugWindow(void);
   // output
   void operator<<(bool b);
   void operator<<(int i);
   void operator<<(unsigned int i);
   void operator<<(int64 i);
   void operator<<(card64 i);
   void operator<<(long double d);
   void operator<<(std::string s);
   void operator<<(char* s);
   void cr();
   void displayEvent(const MetaClass *eventType /* of type EventDisplayer */, string name, const EventDisplayerEvent *event);
	void flush();
	void warningMessage(string message);
	void errorMessage(string message);
   static const card32 PAGE_CONSOLE = 0;
   static const card32 PAGE_EVENTS = 1;
   static const card32 PAGE_PROTOCOL = 2;
   static const card32 PAGE_ERRORS = 3;
   //static const card32 PAGE_CONSOLE_HIDE_INPUT = 4;
   void showPage(card32 page);

private slots:
	void textTimer();
	
public slots:
	/// button execute clicked
	void sltBTExecClicked();
	/// checkbox log console to file toggled
	void sltCBLogConsoleStateChanged(int);
	/// checkbox log events to file toggled
	void sltCBLogEventsStateChanged(int);

protected:
	Ui_DebugWindowsForm ui;

	void timerEvent(QTimerEvent * e);
	void flushText();

};

extern FOUNDATION_API DebugWindow *debugWindow;

}

#endif
