//---------------------------------------------------------------------------
#ifndef EventCounterDisplayH
#define EventCounterDisplayH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "EventDisplayer.h"
#include "PerformanceGraphWidget.h"
//---------------------------------------------------------------------------
//this file is generated from the ui file by a custom buildstep, include it here
#include "EventCounterDisplayForm_ui.h"
//---------------------------------------------------------------------------

namespace geoxl {

class FOUNDATION_API EventCounterDisplay : public EventDisplayer
{

	private:
		static MetaClass *EventCounterDisplayMetaClass;
		static Object* newInstance();


	protected:
		int32 incrementCounter;
		int32 lastValue;

		///used to access buttons, etc. from QtDesigner
		Ui_EventCounterDisplayForm ui;
		PerformanceGraphWidget* myCounterGraph;

		virtual QWidget *createSpecialWidget(QWidget *parent);


	public:
		virtual const MetaClass *getInstanceClass() const;
		static const MetaClass *getClass();
		static void init(const MetaClass *parentClass);
		static void shutdown();

		EventCounterDisplay();
		~EventCounterDisplay();

		virtual void displayEvent(const EventDisplayerEvent *event, const char *logfile);

		class NewValue : public EventDisplayerEvent {
			public:
				int32 value;
		};

		class NewValueNoStep : public NewValue {};
		class NewValueStepOnChange : public NewValue {};
		class Increment : public EventDisplayerEvent {};
		class Decrement : public EventDisplayerEvent {};
		class Display : public EventDisplayerEvent {};
		class DisplayAndReset : public Display {};

};


}

#endif
