//---------------------------------------------------------------------------
#ifndef EventDisplayerBaseWidgetH
#define EventDisplayerBaseWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Object.h"
#include "PTypes.h"
#include <QtGui/QWidget.h>
//---------------------------------------------------------------------------
//this file is generated from the ui file by a custom buildstep, include it here
#include "EventDisplayerBaseWidgetForm_ui.h"
//---------------------------------------------------------------------------


namespace geoxl {

class FOUNDATION_API EventDisplayerBaseWidget : public QWidget {

	Q_OBJECT

	protected:
		///used to access buttons, etc. from QtDesigner
		Ui_EventDisplayerBaseWidgetForm baseUI;
		QWidget* mySpecialWidget;

	public:
		EventDisplayerBaseWidget(QWidget *parent = NULL);
		~EventDisplayerBaseWidget();

		inline void setName(string n) { baseUI.LabelBaseName->setText(QString(n.c_str())); };
		inline string getName() { return qPrintable(baseUI.LabelBaseName->text()); };

		inline void setValue(string v) { baseUI.LabelBaseValue->setText(QString(v.c_str())); };
		inline string getValue() { return qPrintable(baseUI.LabelBaseValue->text()); };

		inline void setSpecialDisplayWidget(QWidget* w) { 
			mySpecialWidget = w;
			baseUI.FrameSpecialDisplayer->layout()->addWidget(w);
		};
		inline QWidget* getSpecialDisplayWidget() { 
			return mySpecialWidget;
		};

		inline bool isMinimized() { return !baseUI.FrameSpecialDisplayer->isVisible(); };


	public slots:
		void on_TBMinimize_clicked();
		void on_TBClose_clicked();

	signals:
		void sigCloseWidget(string);

};

}


#endif
