//---------------------------------------------------------------------------
#ifndef EventViewerWidgetH
#define EventViewerWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PTypes.h"
//---------------------------------------------------------------------------
#include <QtGui/QWidget.h>
//---------------------------------------------------------------------------
#include "EventViewerWidget_ui.h"
//---------------------------------------------------------------------------

namespace geoxl {

class EventDisplayer;
class EventDisplayerEvent;

class FOUNDATION_API EventViewerWidget : public QWidget {
   Q_OBJECT
 
 private:
	Ui_EventViewerWidget ui;

	struct EventEntry {
      string name;
      EventDisplayer *evDisp;
      QWidget *evWidget;
   };
   vector <EventEntry> eventViewers;
	
	void updateEvLabel();
	
 private slots:
	/// deletes the event displayer identified by name
   void sltDeleteEventDisplayer(string name); 

 public:
	EventViewerWidget(QWidget *parent=0, Qt::WFlags f=0, bool standAlone = true);

   void displayEvent(const MetaClass *eventType /* of type EventDisplayer */, 
                     string name, 
                     const EventDisplayerEvent *event,
                     const char *logFile = NULL);

	~EventViewerWidget();
};

}

#endif