#include "StdAfx.h"
#include "HelpBrowser.h"
#include "Configuration.h"

#ifdef WIN32
#include "shellapi.h"
#endif
//---------------------------------------------------------------------------



using namespace geoxl;


HelpBrowser::HelpBrowser(QWidget* parent)
:QTextBrowser(parent)
{

}

HelpBrowser::~HelpBrowser(void)
{
}

void HelpBrowser::setSource ( const QUrl & name ){
	if (!name.isValid())
		return;

	//catch 
	if (name.scheme() == QLatin1String("http") || name.scheme() == QLatin1String("ftp") || name.scheme() == QLatin1String("mailto")) {


			#if defined(Q_OS_WIN32)
			QT_WA({
				ShellExecute(winId(), 0, (TCHAR*)name.toString().utf16(), 0, 0, SW_SHOWNORMAL);
			} , {
				ShellExecuteA(winId(), 0, name.toString().toLocal8Bit(), 0, 0, SW_SHOWNORMAL);
			});
			return;
			#endif
	}
	QTextBrowser::setSource(name);

}

#include "HelpBrowser_moc.cpp"
