//---------------------------------------------------------------------------
#ifndef InterfaceGlobalsH
#define InterfaceGlobalsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PTypes.h"
//---------------------------------------------------------------------------

class QWidget;

namespace geoxl {

/// this class describes global properties & variables of the user interface
/// such as the main application window (possible extensions: drag&drop, clipboard etc.)
class FOUNDATION_API InterfaceGlobals {
 private:
   static bool onceWin;
   static bool onceApp;
   static QWidget *mainWindow;
   static QApplication *app;
   
 public:
   /// sets the QT main window of the application - must be called only once
   /// the window must exist during the whole lifetime of the application
   static void setMainWindow(QWidget *mainWindow);
   static QWidget *getMainWindow();
   
   /// sets the QT application object of the application - must be called only once
   static void setApplication(QApplication *app);
   static QApplication *getApplication();
};

}


#endif