#ifndef ManualImageFeaturesEditorWidgetH 
#define ManualImageFeaturesEditorWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "ManualImageFeaturesEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace geoxl
{
	using namespace std;

class ManualImageFeatures;

class FOUNDATION_API ManualImageFeaturesEditorWidget : public QWidget
{
	Q_OBJECT

private:

	int m_draggedFeature;
	ManualImageFeatures	*	m_Object;
	///used to access buttons, etc. from QtDesigner
	Ui_ManualImageFeaturesEditorForm ui;
	double zoom;

public:
	ManualImageFeaturesEditorWidget(QWidget * parent = NULL, Qt::WFlags f=0);
	~ManualImageFeaturesEditorWidget(void);

	void setup( ManualImageFeatures * obj );

	/// update editor content with object data
	void updateEditor();
	void redraw();

	void mousePressEvent(QMouseEvent* e);
	void mouseReleaseEvent(QMouseEvent* e);
	void mouseMoveEvent(QMouseEvent* e);

	public slots:
	void on_zoomSB_valueChanged(double val);
	void on_loadImageButton_clicked();


};

MAKE_CLASS_EDITOR( FOUNDATION_API , ManualImageFeatures )


}

#endif