#ifndef MenuWidgetH
#define MenuWidgetH
// -------------------------------------------------------------------
#include "GlobalDefinitions.h"
// -------------------------------------------------------------------
#include <qtGui/qmainwindow.h>
//---------------------------------------------------------------------------
#include <map>
#include <string>
#include <vector>
// -------------------------------------------------------------------

class QMenu;
class QMenuBar;

namespace geoxl 
{
	using namespace std;

class FOUNDATION_API MenuWidget :	public QMainWindow
{
	Q_OBJECT

public:
	MenuWidget(QWidget * parent=NULL, Qt::WFlags f = 0);
	~MenuWidget(void);

	/// adds a menu entry - id holds the menu path seperated by / and has to be unique
	/// example id: "file/new/scene"
	void addMenuEntry( string id, bool checkAble = false );

	/// checks/unchecks menu entry 'id'
	void setMenuEntryChecked( string id, bool checked );
	/// returns checked-state of menu entry
	bool menuEntryChecked( string id );

	/// sets icon 'icon' for menu entry 'id'
	void setMenuEntryIcon( string id, QIcon &icon );


protected:

	virtual void menuItemTriggered( string id );

public slots:
	void sltMenuHandler( QAction * action );

private:

	vector<QString> splitID( string id );

	map<string, QAction * >		m_Actions;	/// stores actions for later access
	map<QAction *, string>		m_ActionsMap;
	map<string, QMenu * >		m_Menu;
	//QMenuBar	*	m_MenuBar;

};

}

#endif