#ifndef ObjectDictionaryEditorWidgetH
#define ObjectDictionaryEditorWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include <qtGui/qlistwidget.h>
#include <qtGui/qicon.h>
#include "ClassEditor.h"
#include <map>
//---------------------------------------------------------------------------

class QMenu;
class QAction;
class QMouseEvent;

namespace geoxl
{
	using namespace std;

class ObjectDictionary;
class ClassSelectionDialog;
class MetaClass;

class FOUNDATION_API ObjectDictionaryEditorWidget : public QListWidget
{
	Q_OBJECT

private:

	void buildMenu( QListWidgetItem * item );
	void loadFile( string filename );
	void saveFile( Object * obj, string filename );
	void addObject( Object * obj, string name );

//	QAction	*	m_EditorsAction;
//	QAction	*	m_MethodsAction;
//	QAction	*	m_ApplicationsAction;
   QAction  *  m_ExecuteScriptAction;
   QAction  *  m_DebugScriptAction;
	QAction	*	m_NewAction;
	QAction	*	m_OpenAction;
	QAction	*	m_NewFolderAction;
	//QAction	*	m_SaveAction;
	QAction  *  m_RenameAction;
	QAction	*	m_SaveAsAction;
	QAction	*	m_DeleteAction;
	QMenu		*	m_ItemMenu;
	QMenu		*	m_EditorsMenu;

	struct TMetaInfo
	{
		MetaClass * mc;
		Object	*	obj;
		string		name;
		bool			isDefault;
	};
	map<QAction*, TMetaInfo >	m_EditorClasses;
	
	ObjectDictionary * m_ObjectDict;
	ClassSelectionDialog	*	m_ClassSelectionDialog;

public:
	ObjectDictionaryEditorWidget(QWidget * parent);
	~ObjectDictionaryEditorWidget(void);

	void setup( ObjectDictionary * obj ) {m_ObjectDict = obj;}
	void updateEditor();
	void load();
	void save();
	Object* getSelectedObject();

public slots:
	void sltMenuHandler( QAction * action );

protected:

	virtual void mousePressEvent( QMouseEvent * e);
	virtual void mouseDoubleClickEvent( QMouseEvent * e );
	virtual void dragEnterEvent( QDragEnterEvent *e);
	virtual void dragMoveEvent( QDragMoveEvent *e);
	virtual void dropEvent( QDropEvent * e);


};

MAKE_CLASS_EDITOR( FOUNDATION_API, ObjectDictionary )


}

#endif