//---------------------------------------------------------------------------
#ifndef OnlineHelpH
#define OnlineHelpH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include <string>
//---------------------------------------------------------------------------

namespace geoxl {
   using namespace std;

class FOUNDATION_API OnlineHelp {
 public:
   /// show online help window, bring to front
   static void show();
   /// display a new topic (html fetched from directory "help")
   /// provide html file name from geoxl\bin\help directory. path will be added automatically.
   /// if the file is not found, the defaultTopic is shown (error page if defaultPage == "")
   static void newTopic(string topic, string defaultTopic = "");
	/// show index of all files
   static void showIndex();
   /// move help window to a new position
   static void position(int x, int y, int width, int height);
   /// hide online help window
   static void hide();
   ///call to shutdown help when closing geoxl	
   static void shutdown();
 private:
   ///create Helpwidget, if it dosen't exist
   static void init();
};

}

#endif
