//---------------------------------------------------------------------------
#include "stdafx.h"
//---------------------------------------------------------------------------
#include "ProgressWindowWidget.h"
//---------------------------------------------------------------------------
#include "UserSettings.h"
#include "Configuration.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------
ProgressWindowWidget *geoxl::progressWindowWidget = NULL;

ProgressWindowWidget::ProgressWindowWidget(QWidget *parent)
:QWidget(parent)
{
	ui.setupUi(this);
	this->setWindowFlags(Qt::Tool);
}

ProgressWindowWidget::~ProgressWindowWidget(void)
{
}

void ProgressWindowWidget::showForm()
{

// changed 08/08/2006 (mh), hopefully works on multi-monitor systems now
//	int sWidth = qApp->desktop()->screen()->width();
//	int sHeight = qApp->desktop()->screen()->height();

	int sWidth = qApp->desktop()->screenGeometry(this).width();
	int sHeight = qApp->desktop()->screenGeometry(this).height();

	int left = sWidth - width() - 50;
	int top = sHeight - height() - 80;

	move(left, top);

// update 04/12/2007: show of ProgressWindow could be enabled/disabled in UserSettings now
	bool doShow = true;
	UserSettings * u = dynamic_cast<UserSettings*>( Configuration->getData( "USER_SETTINGS" ) );
	if( u )
	{
		doShow = u->getShowProgressWindow();
	}
	if (doShow) show();

};

void ProgressWindowWidget::setToolProgress(card32 position)
{
	ui.ToolProgress->setValue(position);
};

void ProgressWindowWidget::setOverallProgress(card32 position)
{
	ui.OverallProgress->setValue(position);
};

void ProgressWindowWidget::setToolProgressAvailable(bool available)
{
	
	ui.ToolProgress->setEnabled(available);

};

void ProgressWindowWidget::setOverallProgressAvailable(bool available)
{
	ui.OverallProgress->setEnabled(available);
};

void ProgressWindowWidget::setToolName(std::string name)
{
	if (!name.empty())
		ui.ToolBox->setTitle(QString((name + " progress: ").c_str()));
	else
		ui.ToolBox->setTitle(QString( "Tool progress: "));

};

void ProgressWindowWidget::setToolMessage(std::string msg)
{
	ui.MessageLabel->setText(QString( msg.c_str())); 
};
void ProgressWindowWidget::drawUpdates()
{
	update();
};
void ProgressWindowWidget::closeForm()
{
	hide();
};

#include "ProgressWindowWidget_moc.cpp"
