#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "RGBACubeMapEditorWidget.h"
#include <QtGui/QFileDialog>
//---------------------------------------------------------------------------
using namespace geoxl;

IMPLEMENT_CLASS_EDITOR( RGBACubeMap )

RGBACubeMapEditorWidget::RGBACubeMapEditorWidget(QWidget * parent, Qt::WFlags f)
:QWidget(parent,f)
{
	//call ui.setupUi(this) to set up the layout from QtDesigner
	ui.setupUi(this);
	//Example: easy access to QtDesigner buttons, etc. by ui object
	QWidget::connect(ui.BTCrossLoad, SIGNAL(clicked()), this, SLOT(sltBTCrossLoadClicked()));
	QWidget::connect(ui.BTAngularLoad, SIGNAL(clicked()), this, SLOT(sltBTAngularLoadClicked()));

}

RGBACubeMapEditorWidget::~RGBACubeMapEditorWidget(void)
{
}

void RGBACubeMapEditorWidget::setup( RGBACubeMap * obj )
{
	m_RGBACubeMap = obj;
}

void RGBACubeMapEditorWidget::updateEditor()
{
   pAssert( m_RGBACubeMap );
   copySideToImageLabel( m_RGBACubeMap->getSide(CubeMap<Vector4ub>::CMS_NEGATIVE_Y), ui.ImageSide1 );
   copySideToImageLabel( m_RGBACubeMap->getSide(CubeMap<Vector4ub>::CMS_POSITIVE_Z), ui.ImageSide2 );
   copySideToImageLabel( m_RGBACubeMap->getSide(CubeMap<Vector4ub>::CMS_POSITIVE_Y), ui.ImageSide3 );
   copySideToImageLabel( m_RGBACubeMap->getSide(CubeMap<Vector4ub>::CMS_NEGATIVE_Z), ui.ImageSide4 );
   copySideToImageLabel( m_RGBACubeMap->getSide(CubeMap<Vector4ub>::CMS_POSITIVE_X), ui.ImageSide5 );
   copySideToImageLabel( m_RGBACubeMap->getSide(CubeMap<Vector4ub>::CMS_NEGATIVE_X), ui.ImageSide6 );
}


// ---------- user functions ----------

void RGBACubeMapEditorWidget::copySideToImageLabel( TemplatedImage<Vector4ub> *rgba_img, QLabel *imageLabel )
{
   if( rgba_img->getSizeX() == 0 )
      return;

   QImage img(QSize(rgba_img->getSizeX(),rgba_img->getSizeY()),QImage::Format_RGB32);
   
   for( card32 y=0;y<rgba_img->getSizeY();y++ )
   {
	   card32 * ptr = (card32 *)img.scanLine(y);  ;
      card32 * srcPtr = (card32 *)rgba_img->getPixels();
      srcPtr += y*rgba_img->getSizeX();
      for( card32 x=0;x<rgba_img->getSizeX();x++ )
      {
         ptr[x] = srcPtr[x];
      }
   }

   imageLabel->setPixmap(QPixmap::fromImage(img));
}


// ---------- slots ----------

void RGBACubeMapEditorWidget::sltBTCrossLoadClicked() {

	QString fname = QFileDialog::getOpenFileName(this,	"Choose a file", "", "Images (*.png *.xpm *.jpg *.bmp);;All Files (*.*)");
	if (!fname.isEmpty()) {
		m_RGBACubeMap->loadFromCrossBMP((char*)qPrintable(fname));
		this->updateEditor();
	}

}

void RGBACubeMapEditorWidget::sltBTAngularLoadClicked() {
 
	QString fname = QFileDialog::getOpenFileName(this, "Choose a file", "", "Images (*.png *.xpm *.jpg *.bmp);;All Files (*.*)");
	if (!fname.isEmpty()) {
		m_RGBACubeMap->loadFromAngularBMP((char*)qPrintable(fname));
		this->updateEditor();
	};

}


#include "RGBACubeMapEditorWidget_moc.cpp"