#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "RGBAImageEditorWidget.h"
#include <QtGui/QFileDialog>
#include <QtGui/QImage>
#include <QtGui/QPixmap>
//---------------------------------------------------------------------------

using namespace geoxl;

IMPLEMENT_CLASS_EDITOR( RGBAImage )


RGBAImageEditorWidget::RGBAImageEditorWidget( QWidget * parent)
:QWidget(parent) // don't forget to call the base constructor with parent !
{
	//call ui.setupUi(this) to set up the layout from QtDesigner
	ui.setupUi(this);

	//easy access to QtDesigner buttons, etc. by ui object
	QWidget::connect(ui.loadButton,SIGNAL(clicked()),this,SLOT(sltLoadFile()));
}


void RGBAImageEditorWidget::setup( RGBAImage * obj )
{
	m_Image=obj;
}


void RGBAImageEditorWidget::updateEditor()
{

   QImage img(QSize(m_Image->getSizeX(),m_Image->getSizeY()),QImage::Format_RGB32);
   
   for( card32 y=0;y<m_Image->getSizeY();y++ )
   {
	   card32 * ptr = (card32 *)img.scanLine(y);  ;
      card32 * srcPtr = (card32 *)m_Image->getPixels();
      srcPtr += y*m_Image->getSizeX();
      for( card32 x=0;x<m_Image->getSizeX();x++ )
      {
         ptr[x] = srcPtr[x];
      }
   }

   ui.label->setPixmap(QPixmap::fromImage(img));
  // this->resize(img.size().width()+150,img.size().height()+150);
}

void RGBAImageEditorWidget::sltLoadFile(){
 QString s = QFileDialog::getOpenFileName(
                    this,
                    "Choose a file",
                    "",
                    "Images (*.png *.xpm *.jpg *.bmp);;All Files (*.*)");
 if (!s.isEmpty()) {
	 m_Image->loadFromFile((char*)qPrintable(s));
	if( ui.normalMapBox->checkState()==Qt::Checked )
		      m_Image->convertToNormalMap();
	this->updateEditor();
 };
 
}


#include "RGBAImageEditorWidget_moc.cpp"
