#ifndef ScriptEngineDebugWidgetH
#define ScriptEngineDebugWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include <qtGui/qwidget.h>
#include <list>
#include "PTypes.h"
//---------------------------------------------------------------------------
//this file is generated from the ui file by a custom buildstep, include it here
#include "ScriptEngineDebugWidget_ui.h"
//---------------------------------------------------------------------------

namespace geoxl
{

class ScriptEngine;
class ScriptDictionaryAdapter;

class FOUNDATION_API ScriptEngineDebugWidget : public QWidget
{
	Q_OBJECT

public:
	ScriptEngineDebugWidget(ScriptEngine* script);
	void update();
	void start();
	void registerScrDicAdapter(ScriptDictionaryAdapter* adapter);
	~ScriptEngineDebugWidget();

private:
	ScriptEngine *script;
   std::vector<int> breakpoints;

private slots:
	void on_LEVarName_returnPressed();
	void on_BTModify_clicked();
	void on_BTObjDetail_clicked();
	void on_BTRun_clicked();
	void on_BTSingleStep_clicked();
	void on_BTBreakpoint_clicked();
	void on_BTEditContinue_clicked();
	void on_BTExit_clicked();
	void on_CBReadOnly_clicked();
	void handleVarTypeToggle(bool b);

protected:
	///used to access buttons, etc. from QtDesigner
	Ui_ScriptEngineDebugWidget ui;
	Object* debugObject;
	
	ScriptDictionaryAdapter* scrDicAdapter;
	
	void updateCodeMarkers(bool scroll);
	
};

 //extern EDITOR_API ScriptEngineDebugWidget *scriptEngineDebugWidget;

}

#endif
