#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "UserSettingsEditorWidget.h"
//---------------------------------------------------------------------------
#include "UserSettings.h"
//---------------------------------------------------------------------------
using namespace geoxl;

IMPLEMENT_CLASS_EDITOR( UserSettings )

UserSettingsEditorWidget::UserSettingsEditorWidget(QWidget * parent, Qt::WFlags f)
:QWidget(parent,f)
{
	//call ui.setupUi(this) to set up the layout from QtDesigner
	ui.setupUi(this);
	//Example: easy access to QtDesigner buttons, etc. by ui object
	//QWidget::connect(ui.loadButton,SIGNAL(clicked()),this,SLOT(sltLoadFile()));

}

UserSettingsEditorWidget::~UserSettingsEditorWidget(void)
{
}

void UserSettingsEditorWidget::setup( UserSettings * obj )
{
	m_Object = obj;
}

void UserSettingsEditorWidget::updateEditor()
{
	ui.cbAskBeforeQuit->setChecked( m_Object->getAskBeforeQuit() );
	ui.cbSortTools->setChecked( m_Object->getSortToolsByName() );
	ui.cbSortCommands->setChecked( m_Object->getSortCommandsByName() );
	ui.cbDisplayDebugEvents->setChecked( m_Object->getDisplayDebugEvents() );
}

void UserSettingsEditorWidget::on_cbAskBeforeQuit_stateChanged(int state)
{
	m_Object->setAskBeforeQuit( state == Qt::Checked );
}

void UserSettingsEditorWidget::on_cbSortTools_stateChanged(int)
{
	m_Object->setSortToolsByName( ui.cbSortTools->checkState() == Qt::Checked );
}

void UserSettingsEditorWidget::on_cbSortCommands_stateChanged(int)
{
	m_Object->setSortCommandsByName( ui.cbSortCommands->checkState() == Qt::Checked );
}

void UserSettingsEditorWidget::on_cbDisplayDebugEvents_stateChanged(int)
{
	m_Object->setDisplayDebugEvents( ui.cbDisplayDebugEvents->checkState() == Qt::Checked );
}

#include "UserSettingsEditorWidget_moc.cpp"