#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "VerticalScrollView.h"
//---------------------------------------------------------------------------
#include "DebugOutput.h"
//---------------------------------------------------------------------------
using namespace geoxl;


VerticalScrollView::VerticalScrollView(QWidget * parent)
{
	m_Content = NULL;
	setHorizontalScrollBarPolicy( Qt::ScrollBarAlwaysOff );
	setWidgetResizable(true);
}

void VerticalScrollView::resizeEvent( QResizeEvent * e ) 
{
	m_Content = viewport()->childAt(1,1);
	if( m_Content == NULL )
		return;

	int content_height = m_Content->height();
	int scrollbarWidth = 20;

	if( content_height+3 > height() )
	{
		m_Content->resize( width() - scrollbarWidth, content_height );
	}
	else
	{
		m_Content->resize( width(), content_height );
	}
	QScrollArea::resizeEvent(e);
}

#include "VerticalScrollView_moc.cpp"