//---------------------------------------------------------------------------
#include "stdafx.h"
//---------------------------------------------------------------------------
#include "LinearAlgebra.h"
#include "LinearAlgebra_templCode.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



const Vector2ub geoxl::NULL_VECTOR2UB = makeVector2ub(0, 0);
const Vector3ub geoxl::NULL_VECTOR3UB = makeVector3ub(0, 0, 0);
const Vector4ub geoxl::NULL_VECTOR4UB = makeVector4ub(0, 0, 0, 0);

const Vector2i geoxl::NULL_VECTOR2I = makeVector2i(0, 0);
const Vector3i geoxl::NULL_VECTOR3I = makeVector3i(0, 0, 0);
const Vector4i geoxl::NULL_VECTOR4I = makeVector4i(0, 0, 0, 0);

const Vector2f geoxl::NULL_VECTOR2F = makeVector2f(0.0, 0.0);
const Vector3f geoxl::NULL_VECTOR3F = makeVector3f(0.0, 0.0, 0.0);
const Vector4f geoxl::NULL_VECTOR4F = makeVector4f(0.0, 0.0, 0.0, 0.0);
const Vector6f geoxl::NULL_VECTOR6F = makeVector6f(0.0, 0.0, 0.0, 0.0, 0.0, 0.0);
const Vector4f geoxl::HOMOGENEOUS_NULL_VECTOR4F = makeVector4f(0.0, 0.0, 0.0, 1.0);

const Vector2d geoxl::NULL_VECTOR2D = makeVector2d(0.0, 0.0);
const Vector3d geoxl::NULL_VECTOR3D = makeVector3d(0.0, 0.0, 0.0);
const Vector4d geoxl::NULL_VECTOR4D = makeVector4d(0.0, 0.0, 0.0, 0.0);
const Vector6d geoxl::NULL_VECTOR6D = makeVector6d(0.0, 0.0, 0.0, 0.0, 0.0, 0.0);

const Vector3f geoxl::XAXIS_VECTOR3F = makeVector3f(1.0, 0.0, 0.0);
const Vector3f geoxl::YAXIS_VECTOR3F = makeVector3f(0.0, 1.0, 0.0);
const Vector3f geoxl::ZAXIS_VECTOR3F = makeVector3f(0.0, 0.0, 1.0);
const Vector4f geoxl::XAXIS_VECTOR4F = makeVector4f(1.0, 0.0, 0.0, 1.0);
const Vector4f geoxl::YAXIS_VECTOR4F = makeVector4f(0.0, 1.0, 0.0, 1.0);
const Vector4f geoxl::ZAXIS_VECTOR4F = makeVector4f(0.0, 0.0, 1.0, 1.0);

const Matrix2f geoxl::IDENTITY2F = makeMatrix2f(1.0, 0.0,
											   0.0, 1.0);
const Matrix3f geoxl::IDENTITY3F = makeMatrix3f(1.0, 0.0, 0.0,
                                              0.0, 1.0, 0.0,
                                              0.0, 0.0, 1.0);
const Matrix4f geoxl::IDENTITY4F = makeMatrix4f(1.0, 0.0, 0.0, 0.0,
                                              0.0, 1.0, 0.0, 0.0,
                                              0.0, 0.0, 1.0, 0.0,
                                              0.0, 0.0, 0.0, 1.0);
const Matrix6f geoxl::IDENTITY6F = makeMatrix6f(1.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                               0.0, 1.0, 0.0, 0.0, 0.0, 0.0,
                                               0.0, 0.0, 1.0, 0.0, 0.0, 0.0,
                                               0.0, 0.0, 0.0, 1.0, 0.0, 0.0,
											   0.0, 0.0, 0.0, 0.0, 1.0, 0.0,
											   0.0, 0.0, 0.0, 0.0, 0.0, 1.0);
const Matrix3d geoxl::IDENTITY3D = makeMatrix3d(1.0, 0.0, 0.0,
                                              0.0, 1.0, 0.0,
                                              0.0, 0.0, 1.0);


