//---------------------------------------------------------------------------
#ifndef NormalConeH
#define NormalConeH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "LinearAlgebra.h"
//---------------------------------------------------------------------------

namespace geoxl {


template <class FloatType, unsigned dim>
class NormalCone {
 private:
   StaticVector<FloatType, dim> normal;
   FloatType angle; // Radian

 public:
   NormalCone() {}
   NormalCone(StaticVector<FloatType, dim> normal, FloatType angle);
   const StaticVector<FloatType, dim> &getNormal() const;
   void setNormal(const StaticVector<FloatType, dim> &normal);
   const FloatType &getAngle() const;
   void setAngle(const FloatType &angle);
};


typedef NormalCone<float32, 3> NormalCone3f;
typedef NormalCone<float64, 3> NormalCone3d;


extern FOUNDATION_API const NormalCone3f NORMAL_CONE_3F_ALL_ANGLES;


}

#endif
 