#ifndef POLYNOMIAL_H
#define POLYNOMIAL_H

namespace geoxl{

/// 1D Polynomial of arbitray degree and dimension
template<class Type, int Degree>
class  Polynomial
{
	private:
		/// Polynomial parameters
		Type param[Degree+1];

	public:
      /// Constructor
      Polynomial();
		/// Evaluate polynomial at position x
		Type eval( Type x );
		/// Debug: init polynomial to specific function
		void init();
		/// Setter: parameters
		inline void setParam( int i, Type p ){ param[i] = p; }
		/// Getter: parameters
		inline Type getParam( int i ){ return param[i]; }


      /// Inverse transformation ( back to world coordinates )
      Matrix3f invTransformation;
      /// Inverse translation ( back to world coordinates )
      Vector3f invTranslation;
      /// Extend of polynomial
      Type dMin, dMax;
};

/**
 * Evaluate polynomial at position ( x,y )
 */
template<class Type, int Degree>
Polynomial<Type,Degree>::Polynomial()
{
   for ( unsigned int n = 0; n < (Degree+1); n++ )
      param[n] = 0;
}

/**
 * Evaluate polynomial at position x
 */
template<class Type, int Degree>
Type Polynomial<Type,Degree>::eval( Type x )
{
	Type result = 0;
	for ( int i = 0; i <= Degree; i++ )
      result = result + param[i] * power( x , i );
	return result;
}

/**
 * Debug: init polynomial to specific function
 */
template<class Type, int Degree>
void Polynomial<Type,Degree>::init()
{
   for ( unsigned int n = 0; n <= Degree; n++ )
      param[i] = 0;
}
		
}

#endif