//---------------------------------------------------------------------------
#ifndef REGRESSION_LINE_H
#define REGRESSION_LINE_H
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Line.h"
#include "PCA.h"
#include "DebugOutput.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/// Container for a plane defined by a normal and one point within the plane.
class FOUNDATION_API RegressionLine : public Line
{
	protected:
		/// Centroid of the given points
		PCA<float32,3> pca;

	public:
		/// Clear all member values
		void clear();
      /// Add point
		void addPoint( Vector3f p );
      /// Compute regression line, return true on success
      bool computeRegressionLine();

};


}

#endif
