//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "CmdObjMemberMethod.h"
//---------------------------------------------------------------------------
#include "ObjectClassProperty.h"
#include "StringClassProperty.h"
#include "ClassMethods.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



IMPLEMENT_GEOXL_CLASS( CmdObjMemberMethod ,0)
{
	BEGIN_CLASS_INIT( CmdObjMemberMethod );
	ADD_OBJECT_PROP(obj, 0, Persistent::getClass(), true)
	ADD_STRING_PROP(methodName, 0)
}


// ----


CmdObjMemberMethod::CmdObjMemberMethod() {
	obj = NULL;
}

void CmdObjMemberMethod::setup(string methodName, const Persistent *obj) {
	this->methodName = methodName;
	delete this->obj;
	this->obj = (Persistent*)(obj->copy());
}

CmdObjMemberMethod::~CmdObjMemberMethod() {
	delete obj;
}					  


void CmdObjMemberMethod::assign(const Object* obj, CopyContext *context) {
	CommandObject::assign(obj,context);
}

void CmdObjMemberMethod::doAction(Object *context) {
	if (obj == NULL) throw ECommandFailed("CmdObjMemberMethod::doAction() - obj is NULL.");
	if (!obj->getInstanceClass()->callNoArgsMethod(obj, methodName)) {
		throw ECommandFailed("CmdObjMemberMethod::doAction() - method name not found");
	}
}

void CmdObjMemberMethod::undoAction(Object *context) {
	throw ECannotUndo("CmdObjMemberMethod::undoAction() - undo is not possible.");
}

bool CmdObjMemberMethod::canUndo() {
	return false;
}

string CmdObjMemberMethod::getDescription() {
	return "";
}
