//---------------------------------------------------------------------------
#ifndef CmdObjMemberMethodH
#define CmdObjMemberMethodH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "CommandObject.h"
//---------------------------------------------------------------------------

namespace geoxl {

/**
	this command object represents the execution of a member function of a persistent class
	the command object stores the method name and the state of the object at the point of execution
	undo is not supported (at least not by this base class)
*/
class FOUNDATION_API CmdObjMemberMethod : public CommandObject {
	GEOXL_CLASS( CmdObjMemberMethod )

 private:
	string methodName;
	Persistent *obj;

 public:
	CmdObjMemberMethod();
	
	virtual void setup(string methodName, const Persistent *obj);

   void assign(const Object* obj, CopyContext *context = NULL);

   virtual void doAction(Object *context);
   virtual void undoAction(Object *context);
   virtual bool canUndo();
   virtual string getDescription();

   inline Persistent* getObject() {return obj;}

	~CmdObjMemberMethod();

};


}

#endif