//---------------------------------------------------------------------------
#ifndef ColorToolsH
#define ColorToolsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "LinearAlgebra.h"
//---------------------------------------------------------------------------

namespace geoxl {



inline Vector4f rainbowGradient(float32 v) {
	if (v<0.0f) v = 0.0f;
	if (v>1.0f) v = 1.0f;
	if (v <= 0.333333333333333333) {
		v *= 4.0f;
		return makeVector4f(0.0f, 1.0f, 0.0f, 1.0f) * v + makeVector4f(0.0f, 0.0f, 1.0f, 1.0f) * (1.0f-v);
	} else if (v <= 0.6666666666666666666) {
		v *= 3.0f;
		v -= 1.0f;
		return makeVector4f(1.0f, 1.0f, 0.0f, 1.0f) * v + makeVector4f(0.0f, 1.0f, 0.0f, 1.0f) * (1.0f-v);
	}  else {
		v *= 3.0f;
		v -= 2.0f;
		return makeVector4f(1.0f, 0.0f, 0.0f, 1.0f) * v + makeVector4f(1.0f, 1.0f, 0.0f, 1.0f) * (1.0f-v);
	} 
}

inline Vector4f blueRedGradient(float32 v, float32 alpha) {
	if (v<0.0f) v = 0.0f;
	if (v>1.0f) v = 1.0f;
   return makeVector4f(0.2f, 0.2f, 1.0f, alpha)*(1.0f-v) + makeVector4f(1.0f, 0.2f, 0.2f, alpha)*v;
}

Vector3f FOUNDATION_API convertRGBtoHSV( const Vector3f &rgb);
Vector3f FOUNDATION_API convertHSVtoRGB( const Vector3f &hsv);

}


#endif