//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "CommandObject.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "ObjectStreams.h"
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



MetaClass* CommandObject::CommandObjectMetaClass = NULL;

const MetaClass* CommandObject::getInstanceClass() const {
   return getClass();
}

const MetaClass* CommandObject::getClass() {
   if (CommandObjectMetaClass==NULL) {
      CommandObjectMetaClass = new MetaClass("CommandObject", "no description.",
                                             NULL, sizeof(CommandObject));
   }
   return CommandObjectMetaClass;
}

void CommandObject::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 1);
   CommandObjectMetaClass->copyParentProperties();
}

void CommandObject::shutdown() {
   delete CommandObjectMetaClass;
}


// ----


void CommandObject::assign(const Object* obj, CopyContext *context) {
   copyObjectProperties(obj, this);
}


