//---------------------------------------------------------------------------
#ifndef EventDisplayerH
#define EventDisplayerH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Object.h"
#include "PTypes.h"
#include "EventDisplayerBaseWidget.h"
//---------------------------------------------------------------------------

namespace geoxl {


class FOUNDATION_API EventDisplayerEvent {
	public:
		virtual ~EventDisplayerEvent() {}
};


class FOUNDATION_API EventDisplayer : public Object {

	private:
		static MetaClass *EventDisplayerMetaClass;

	protected:
		EventDisplayerBaseWidget* baseWidget;
		virtual QWidget *createSpecialWidget(QWidget *parent) = 0;

	public:
		EventDisplayer();

		virtual const MetaClass *getInstanceClass() const;
		static const MetaClass *getClass();
		static void init(const MetaClass *parentClass);
		static void shutdown();

		QWidget *makeWidget(QWidget* Owner, string name);

		/// logfile == NULL if no logging should be performed
		virtual void displayEvent(const EventDisplayerEvent *e, const char *logfile) = 0;
//		virtual int getHeight() {return 50;}

};


}


#endif
