//---------------------------------------------------------------------------
#ifndef ExceptionsH
#define ExceptionsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include <string>
#include <iostream>
//---------------------------------------------------------------------------


namespace geoxl {
   using namespace std;

class FOUNDATION_API PException {
 protected:
   string Msg;
 public:
   PException(const string msg) {
      this->Msg = msg;
      #ifdef DEBUG
      cerr << msg.c_str();
      #endif
   }
   string getMsg() {return Msg;}
   void print() {cerr << Msg.c_str();}
   virtual string getTypeString() {return "PException";}
};

class FOUNDATION_API ERangeCheck : public PException {
 public:
   ERangeCheck(const string msg) : PException(msg) {};
   virtual string getTypeString() {return "ERangeCheck";}
};

class FOUNDATION_API EIOException : public PException {
 public:
   EIOException(const string msg) : PException(msg) {};
   virtual string getTypeString() {return "EIOException";}
};

class FOUNDATION_API EMath : public PException {
 public:
   EMath(const string msg) : PException(msg) {};
   virtual string getTypeString() {return "EMath";}
};

class FOUNDATION_API EInvalidState : public PException {
 public:
   EInvalidState(const string msg) : PException(msg) {};
   virtual string getTypeString() {return "EInvalidState";}
};

class FOUNDATION_API ETypeMismatch : public PException {
 public:
   ETypeMismatch(const string msg) : PException(msg) {};
   virtual string getTypeString() {return "ETypeMismatch";}
};

}

#endif
