//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "ImportTools.h"
//---------------------------------------------------------------------------
#include "MathTools_templCode.h"
#include <fstream>
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------


string geoxl::getExistingNextNumberedFileName( string previousNumberedFilename ) {

	string tmpStr;
	size_t extPos = previousNumberedFilename.find_last_of(".");

	if (extPos == string::npos) {
		tmpStr = previousNumberedFilename;
		extPos = tmpStr.length()-1;
	} else {
		tmpStr = previousNumberedFilename.substr(0, extPos);
		extPos--;
	}
	if (tmpStr.empty()) return "";
	string extStr = previousNumberedFilename.substr(extPos+1, 100);

	//   0  ... 9  numbers
	// = 48 ... 57 ASCII

	bool finished = false;

	// get number of digits
	int digitCount = 0;
	while (!finished) {
		if (!((tmpStr[extPos-digitCount]>=48) && (tmpStr[extPos-digitCount]<=57))) { finished = true; continue; }
		digitCount++;
	}
	if (digitCount==0) return "";
	finished = false;

	while (!finished) {
		if ((tmpStr[extPos] >= 48) && (tmpStr[extPos] <= 56)) {
			// if between 0..8
			tmpStr[extPos]++;
			extPos--;
			finished = true;
		} else if( tmpStr[extPos] == 57 ) {
			// if == 9 set 0 go to next higher digit
			tmpStr[extPos] = 48;
			extPos--;
		}
		else {
			//insert a "1"
			extPos++;
			tmpStr.insert(extPos, 1, '1');
			finished = true;
		}
	}

	tmpStr += extStr;

	if (!geoxl::FileExists(tmpStr.c_str())) {
		// if filename doesn't exist try it with prefixed 0
		tmpStr = tmpStr.insert(extPos, 1, '0');
		if (!geoxl::FileExists(tmpStr.c_str())) {
			return "";
		}
	}

	return tmpStr;
}


/**
 * move to EOL
 */
void geoxl::skipToEOL(ifstream &in) {
   bool cont = true;
   while (!in.eof() && cont) {
      char c;
      in.get(c);
      if (c == 10 || c == 13) {
         cont = false;
      }
   }
}