//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "MemoryManagedAttachment.h"
//---------------------------------------------------------------------------
// xxx #include "GLContext.h"
// xxx #include "GLBuffer.h"
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------


MemoryManagedAttachment::MemoryManagedAttachment()
{
   m_ManagedObject = NULL;
}

MemoryManagedAttachment::~MemoryManagedAttachment()
{
   if (m_ManagedObject != NULL) m_ManagedObject->setOwner(NULL);
   delete m_ManagedObject;    // <- calls onDeleteMMO(...)
}

void MemoryManagedAttachment::setManagedSize( const card32 &size )
{
   if( m_ManagedObject )
      m_ManagedObject->setSize( size );
}

void MemoryManagedAttachment::setupMMA(const string &name, MemoryManager * mm, bool deleteOnUpdate)
{
   setup( name, deleteOnUpdate ? ADF_DELETEONUPDATE:0, NULL );

   m_ManagedObject = new MemoryManagedObject( getManagedSize(), mm );
   m_ManagedObject->setOwner(this);
}

void MemoryManagedAttachment::touched()
{
   if( m_ManagedObject )
      m_ManagedObject->touched();
}


