//---------------------------------------------------------------------------
#ifndef MemoryManagedAttachmentH
#define MemoryManagedAttachmentH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
#include "MemoryManager.h"
//---------------------------------------------------------------------------

namespace geoxl {

class GLVertexBuffer;
class GLContext;
class VertexDescriptor;


class FOUNDATION_API MemoryManagedAttachment : public AttachedData,
   public MMOOwner
{
private:

   MemoryManagedObject  *  m_ManagedObject;

protected:

   virtual card32 getManagedSize() = 0;
   void setManagedSize( const card32 &size);

public:

// MMOOwner - methods
   virtual void onDeleteMMO(MemoryManagedObject*) {m_ManagedObject = NULL; /* avoid infinit recursion */ delete this;}
// -----------

   /// setup attachment & memory managed object
   /// getManagedSize() is used in here!
   virtual void setupMMA( const string &name, MemoryManager * mm, bool deleteOnUpdate=true);

   /// informs MemoryManager that this object is valid
   /// call touched() every time you use this object
   void touched();

   MemoryManagedAttachment();
   virtual ~MemoryManagedAttachment();


};

}

#endif
