//---------------------------------------------------------------------------
#ifndef MemoryMultiObjectStreamH
#define MemoryMultiObjectStreamH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "MultiObjectStream.h"
//---------------------------------------------------------------------------
#include <map>
//---------------------------------------------------------------------------

namespace geoxl {
	using namespace std;

/**
	this is only a debugging class - a multi object stream that stores all objects in main memory
	the lifetime of its objects does not exceed that of the container (there is no serialization)
	main purpose is debugging out-of-core code
*/
class FOUNDATION_API MemoryMultiObjectStream : public MultiObjectStream
{
	GEOXL_CLASS( MemoryMultiObjectStream )

private:
	typedef vector<card8> BinaryContainer;
	typedef pair<ObjectID, BinaryContainer*> EntryType;
	typedef map<ObjectID, BinaryContainer*> MapType;
	typedef MapType::iterator Iterator;

	ObjectID currentID;
	MapType storage;

public:
	MemoryMultiObjectStream();

   virtual void sync();
   virtual ObjectID createObjectEntry();
   virtual void updateObject(ObjectID id, const MultiPartPersistent *obj);
   virtual MultiPartPersistent *getObject(ObjectID id);
   virtual void deleteObject(ObjectID id);
   virtual Status getStatus();

	~MemoryMultiObjectStream(void);
};

}

#endif