#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PanoramicViewFrustum.h"
//---------------------------------------------------------------------------
// insert your includes here
//---------------------------------------------------------------------------
using namespace geoxl;

IMPLEMENT_GEOXL_CLASS( PanoramicViewFrustum ,1)
{
	BEGIN_CLASS_INIT( PanoramicViewFrustum );
	ADD_FLOAT32_PROP( horizontalFieldOfView , 0 );
	ADD_BOOLEAN_PROP( cylindricalCharacteristica , 1 );
}

PanoramicViewFrustum::PanoramicViewFrustum(void)
{
	cylindricalCharacteristica = false;
	horizontalFieldOfView = 360.0f;
}

PanoramicViewFrustum::~PanoramicViewFrustum(void)
{
}


void PanoramicViewFrustum::assign(const Object* obj, CopyContext *context)
{
	ViewFrustum::assign(obj,context);
	const PanoramicViewFrustum * o = dynamic_cast<const PanoramicViewFrustum*>(obj);
	pAssert( o != NULL );

}
void PanoramicViewFrustum::setAll(float32 zNearClip, float32 zFarClip, float32 verticalFieldOfView, BOOLEAN cylindricalCharacteristica, float32 horizontalFieldOfView) 
{
	ViewFrustum::setAll(zNearClip,zFarClip,verticalFieldOfView,1.0f);
	this->horizontalFieldOfView = horizontalFieldOfView;
	this->cylindricalCharacteristica = cylindricalCharacteristica;
}

bool PanoramicViewFrustum::operator==(const PanoramicViewFrustum &vf) const 
{
	return    this->getZNearClip() == vf.getZNearClip()
		&& this->getZFarClip() == vf.getZFarClip()
		&& this->getVerticalFieldOfView() == vf.getVerticalFieldOfView()
		&& this->horizontalFieldOfView == vf.getHorizontalFieldOfView()
		&& this->cylindricalCharacteristica == vf.getcylindricalCharacteristica();
}

