#ifndef PanoramicViewFrustumH
#define PanoramicViewFrustumH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ViewFrustum.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	plz comment your class
*/
class FOUNDATION_API PanoramicViewFrustum : public ViewFrustum
{
	GEOXL_CLASS( PanoramicViewFrustum )

private:
	float32 horizontalFieldOfView;
	BOOLEAN cylindricalCharacteristica;

public:
	PanoramicViewFrustum(void);
	~PanoramicViewFrustum(void);

	virtual void assign(const Object* obj, CopyContext *context = NULL);

	float32 getHorizontalFieldOfView() const {return horizontalFieldOfView;}
	void setHorizontalFieldOfView(float32 angle) {horizontalFieldOfView=angle;}

	card32 getcylindricalCharacteristica() const {return cylindricalCharacteristica;}
	void setcylindricalCharacteristica(BOOLEAN v) {cylindricalCharacteristica=v;}

	virtual void    setAll(float32 zNearClip, float32 zFarClip, float32 verticalFieldOfView, BOOLEAN cylindricalCharacteristica = false, float32 horizontalFieldOfView = 360.0f);


   bool operator==(const PanoramicViewFrustum &vf) const;
   
};

}

#endif