//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "SymbolTables.h"
#include "StringHelper.h"
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

using namespace std;
using namespace geoxl;

bool StringTableHandler::evaluate(const std::string strExpr, std::string& result)
{
  result.clear();
  if (strExpr == "") return false;

  bool inString = false;
  string str, expr;
  for (card32 i = 0; i < strExpr.size(); ++i) {
    if (strExpr[i] == '\"') {  // begin or end of string
      if (inString) {
        result += str;
        str.clear();
      } else {
        expr = trimStr(expr);
        if (expr.size() > 0) {
          string value;
          if (!getValue(expr, value))
            return false;
          result += value;
          expr.clear();
        }
      }
      inString = !inString;
    } else {                      // within string or expression
      if (inString)
        str += strExpr[i];
      else
        expr += strExpr[i];
    }
  }

  if (inString) {
    result += str;
    str.clear();
  } else {
    expr = trimStr(expr);
    if (expr.size() > 0) {
      string value;
      if (!getValue(expr, value))
        return false;
      result += value;
      expr.clear();
    }
  }

  return true;
}

