//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "UserSettings.h"
//---------------------------------------------------------------------------
#include "BooleanClassProperty.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



static string descrStyle(card32 s) {
   switch(s) {
      case 0: return "defaultStyle";
      case 1: return "QMotifStyle";
      case 2: return "QCDEStyle";
      case 3: return "QWindowsStyle";
      case 4: return "QCleanlooksStyle";
      case 5: return "QPlastiqueStyle";
      case 6: return "QWindowsXPStyle";
      default: return "invalid value";
   }
}

IMPLEMENT_GEOXL_CLASS( UserSettings, 4 )
{
	BEGIN_CLASS_INIT( UserSettings );
	ADD_BOOLEAN_PROP( m_AskBeforeQuit, 0 );
	ADD_BOOLEAN_PROP( m_SortToolsByName, 1 );
	ADD_BOOLEAN_PROP( m_SortCommandsByName, 1 );
	ADD_BOOLEAN_PROP( m_displayDebugEvents, 1 );
	ADD_CARD32_PROP_UPDATE_DESCR( interfaceStyle, 2, NULL, descrStyle, 7 );
	ADD_BOOLEAN_PROP( m_showProgressWindow, 3 );
	ADD_BOOLEAN_PROP( m_timeCommands, 4 );
}

UserSettings::UserSettings(void)
{
	m_AskBeforeQuit = false;
	m_SortToolsByName = true;
	m_SortCommandsByName = true;
	m_displayDebugEvents = true;
	interfaceStyle = 4;
	m_showProgressWindow = true;
	m_timeCommands = false;
}

UserSettings::~UserSettings(void)
{
}

void UserSettings::assign(const Object* obj, CopyContext *context)
{
	AttachedData::assign(obj,context);
	const UserSettings * u = dynamic_cast<const UserSettings*>(obj);
	pAssert( u != NULL );

	m_AskBeforeQuit = u->m_AskBeforeQuit;
	m_SortToolsByName = u->m_SortToolsByName;
	m_SortCommandsByName = u->m_SortCommandsByName;
	m_displayDebugEvents = u->m_displayDebugEvents;
	m_showProgressWindow = u->m_showProgressWindow;
	m_timeCommands = u->m_timeCommands;
}