#ifndef UserSettingsH
#define UserSettingsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
//---------------------------------------------------------------------------

namespace geoxl
{

/**
	this class holds customizable system/editor information
*/
class FOUNDATION_API UserSettings : public AttachedData
{
	GEOXL_CLASS( UserSettings )

private:

	bool		m_AskBeforeQuit;
	bool		m_SortToolsByName,
				m_SortCommandsByName;
	bool     m_displayDebugEvents;
	card32   interfaceStyle;
	bool		m_showProgressWindow;
	bool     m_timeCommands;

public:
   enum InterfaceStyleType {defaultStyle, motifStyle, CDEStyle, WindowsStyle, CleanlooksStyle, PlastiqueStyle, WindowsXPStyle};

	UserSettings(void);
	~UserSettings(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);


	void setAskBeforeQuit( bool b ) {m_AskBeforeQuit = b;}
	bool getAskBeforeQuit() const {return m_AskBeforeQuit;}

	void setSortToolsByName( bool b ) {m_SortToolsByName = b;}
	bool getSortToolsByName() const {return m_SortToolsByName;}
	void setSortCommandsByName( bool b ) {m_SortCommandsByName = b;}
	bool getSortCommandsByName() const {return m_SortCommandsByName;}
	void setDisplayDebugEvents( bool b ) {m_displayDebugEvents = b;}
	bool getDisplayDebugEvents() const {return m_displayDebugEvents;}
	void setShowProgressWindow( bool b ) {m_showProgressWindow = b;}
	bool getShowProgressWindow() const {return m_showProgressWindow;}

   InterfaceStyleType getInterfaceStyle() const {return (InterfaceStyleType)interfaceStyle;}
   void setInterfaceStyle(InterfaceStyleType s) {interfaceStyle = (card32)s;}

	bool getTimeCommands() const {return m_timeCommands;}
	void setTimeCommands(bool v) {m_timeCommands=v;}
};

}

#endif