//---------------------------------------------------------------------------
#ifndef CommandObjMacroH
#define CommandObjMacroH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
#include "CommandObject.h"
//---------------------------------------------------------------------------

namespace geoxl {


class CommandObjMacroEditorWidget;

class FOUNDATION_API CommandObjMacro : public Persistent {
  private:
    static MetaClass *CommandObjMacroMetaClass;
    static Object* newInstance();
    vector<CommandObject*> commands;

  public:
    virtual const MetaClass *getInstanceClass() const;
    static const MetaClass *getClass();
    static void init(const MetaClass *parentClass);
    static void shutdown();
    void write(OutputObjectStream *s) const;
    void read(InputObjectStream *s);

    void addCommand(const CommandObject* command);

    ~CommandObjMacro();

    card32 numCommands() const { return (card32)commands.size(); }
    const CommandObject* getCommand(card32 index) const { return commands[index]; };

  friend CommandObjMacroEditorWidget;
};


}

#endif
