//---------------------------------------------------------------------------
#include "stdafx.h"


#include "ScriptDictionaryAdapter.h"
//---------------------------------------------------------------------------



using namespace geoxl;

bool ObjDicSymbolTable::getValue(const std::string name, Object* &value)
{
  pAssertMsg(dictionary != NULL, "Trying to access object symbol table for empty dictionary");
  return dictionary->getObjectSafe(name, value);
}

bool ObjDicSymbolTable::setValue(const std::string name, Object* value)
{
  pAssertMsg(dictionary != NULL, "Trying to access object symbol table for empty dictionary");
  if (value != NULL) {
    // value is not NULL, so add the object to the dictionary
    if (dictionary->nameExists(name)) return false;
    dictionary->addObject(value, name, true);
    return true;
  } else {
    // value is NULL, so delete the object from the dictionary
    return dictionary->deleteObject(name);
  }
}

void ScriptDictionaryAdapter::init(ObjectDictionary* dictionary, ScriptEngine* script)
{
  pAssert(dictionary != NULL);
  objectSymbol.init(dictionary);

  script->getObjectTables()->addTable(&objectSymbol);

  this->script = script;
}

void ScriptDictionaryAdapter::done()
{
  if (script == NULL) return;
  script->getObjectTables()->removeTable(&objectSymbol);
}

