//---------------------------------------------------------------------------
#ifndef ScriptDictionaryAdapterH
#define ScriptDictionaryAdapterH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include <string>
#include "StringHelper.h"
#include "GlobalDefinitions.h"
#include "Object.h"
#include "SymbolTables.h"
#include "ObjectDictionary.h"
#include "ScriptEngine.h"
//---------------------------------------------------------------------------

namespace geoxl {

class FOUNDATION_API ObjDicSymbolTable : public ObjectSymbolTable {
  private:
    ObjectDictionary* dictionary;

  public:
    ObjDicSymbolTable() { dictionary = NULL; };
    void init(ObjectDictionary* dictionary)
      { this->dictionary = dictionary; };
    virtual bool getValue(const std::string name, Object* &value);
    virtual bool setValue(const std::string name, Object* value);
};

class ScriptDictionaryAdapter {
  public:
    ScriptDictionaryAdapter() { script = NULL; }
    void init(ObjectDictionary* dictionary, ScriptEngine* script);
    void done();

  protected:
    ObjDicSymbolTable objectSymbol;

    ScriptEngine* script;
};

}

#endif
