//---------------------------------------------------------------------------
#ifndef BinaryObjectStreamsH
#define BinaryObjectStreamsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ObjectStreams.h"
//---------------------------------------------------------------------------
#include <stdio.h>
//---------------------------------------------------------------------------

namespace geoxl {

class FOUNDATION_API BinaryOutputObjectStream : public OutputObjectStream {
 private:
   FILE *file;     
   string fname;
   card64 classTabPointerPos;

 protected:
   virtual void writeClassTableHeader();
   virtual void writeClassTable();

 public:
   BinaryOutputObjectStream(const char *filename, bool perObjectClassVersion = false, StreamClassTable *classTable = NULL, bool doWriteClassTable = true);
   virtual void writeBuffer(const void* buf, mpcard length);
   virtual string getFileName();
   virtual ~BinaryOutputObjectStream();
};

class FOUNDATION_API BinaryInputObjectStream : public InputObjectStream {
 private:
   FILE *file;
   string fname;

 protected:
   virtual void readClassTable();

 public:
   BinaryInputObjectStream(const char *filename);
   virtual void readBuffer(void* buf, mpcard length);
   virtual string getFileName();
   virtual ~BinaryInputObjectStream();
};

}

#endif
