//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "ClassMethods.h"
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------


ClassMethod::ClassMethod(string name, string description, string icon, bool visible) {
	this->name = name;
   this->description = description;
	this->icon = icon;
	this->visible = visible;
	this->packageAsCmdObjHint = false;
}
string ClassMethod::getDescription() const {
   return description;
}

string ClassMethod::getName() const {
	return name;
}

string ClassMethod::getIcon() const {
	return icon;
}

bool ClassMethod::getVisible() const {
	return visible;
}

void ClassMethod::setVisible(bool v) {
   visible = v;
}


bool ClassMethod::getPackageAsCmdObjHint() const {
   return packageAsCmdObjHint;
}

void ClassMethod::setPackageAsCmdObjHint(bool h) {
   packageAsCmdObjHint = h;
}


// ---

NoArgsClassMethod::NoArgsClassMethod(MethodPointer method, string name, string description, string icon, bool visible) : ClassMethod(name, description, icon, visible) {
   this->method = method;
}

void NoArgsClassMethod::call(Object *obj) const {
   (obj->*method)();
}

ClassMethod *NoArgsClassMethod::copyMethod() const {
   ClassMethod *result = new NoArgsClassMethod(method, getName(), getDescription(), getIcon());
   return result;
}
