//---------------------------------------------------------------------------
#ifndef MultiPartPersistentH
#define MultiPartPersistentH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace geoxl {


/// This class represents objects that objects that are serialized in multiple parts (rather than at once).
/// Typically, they are stored in MultiObjectStreams.
class FOUNDATION_API MultiPartPersistent : public Persistent {
	GEOXL_CLASS(MultiPartPersistent)
 public:
	/// deletes only this part, not any other parts owned / linked by this one
	/// standard behavior implemented here: delete this
	virtual void shallowDelete();
};

}

#endif
