//---------------------------------------------------------------------------
#ifndef PersistentH
#define PersistentH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Object.h"
#include "MetaClass.h"
//---------------------------------------------------------------------------

namespace geoxl {


class OutputObjectStream;
class InputObjectStream;


class FOUNDATION_API Persistent : public Object {
 private:
   static MetaClass *persistentMetaClass;
 public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void write(OutputObjectStream *s) const;
   virtual void read(InputObjectStream *s);
};

// Standard object I/O: read/write all properties declared as stream properties
void FOUNDATION_API writeObjectProperties(OutputObjectStream *s, const Persistent *obj);
void FOUNDATION_API readObjectProperties(InputObjectStream *s, Persistent *obj);


}

#endif
