//---------------------------------------------------------------------------
#ifndef precompFilesFoundationH
#define precompFilesFoundationH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include <vector>
#include <string>
#include <stack>

//---System----
#include "AttachedData.h"
#include "BooleanClassProperty.h"
#include "ClassCreator.h"
#include "ClassEditor.h"
#include "ClassInstanceSet.h"
#include "ClassMethods.h"
#include "ClassProperty.h"
#include "ClassPropertyParameters.h"
#include "ClassPropertyParameters_templCode.h"
#include "ClassTypeClassProperty.h"
#include "CompoundClassProperty.h"
#include "Configuration.h"
#include "CopyObjectProperties.h"
#include "Editor.h"
#include "EmbeddedObjectClassProperty.h"
#include "EmbeddedObjectClassProperty_templCode.h"
#include "FixedArrayClassProperty.h"
#include "LegacyClassNameTranslation.h"
#include "MetaClass.h"
#include "NumericalClassProperty.h"
#include "numericalclassproperty_templcode.h"
#include "Object.h"
#include "ObjectClassProperty.h"
#include "ObjectDictionary.h"
#include "ObjectListBase.h"
#include "ObjectListProperty.h"
#include "ObjectStreams.h"
#include "ObjectViewsTable.h"
#include "PAssert.h"
#include "Persistent.h"
#include "PropertyEditor.h"
#include "PropertyParser.h"
#include "PTypes.h"
#include "SingleClassProperty.h"
#include "StreamClassTable.h"
#include "StringClassProperty.h"
#include "StructClassProperty.h"
#include "values_vs.h"
#include "VariableArrayClassProperty.h"

//---Misc---

#include "CommandHistory.h"
#include "CommandObject.h"
#include "EventDisplayer.h"
#include "Exceptions.h"
#include "GeneralKey.h"
#include "GloballyUniqueID.h"
#include "GlobalMacros.h"
#include "HashTables.h"
#include "HashTables_templCode.h"
#include "ImportTools.h"
#include "KeyboardController.h"
#include "MemoryManager.h"
#include "Modifiers.h"
#include "MouseButtons.h"
#include "StringHelper.h"
#include "Timer.h"
#include "Tools.h"
#include "UserSettings.h"


//---Math---

#include "BoundingBox.h"
#include "BoundingBox_templCode.h"
#include "DynamicLinearAlgebra.h"
#include "dynamiclinearalgebra_templcode.h"
#include "LinearAlgebra.h"
#include "linearalgebra_templcode.h"
#include "MathTools.h"
#include "MathTools_templCode.h"
#include "math_include.h"


//---Interface---

#ifdef GEOXL_GUI

#include "DebugOutput.h"
#include "DebugWindows.h"
#include "EventCounterDisplay.h"
#include "EventDisplayerBaseWidget.h"
#include "ExceptionHandling.h"
#include "FileDialogs.h"
#include "InterfaceGlobals.h"
#include "ProgressWindow.h"
#include "PropertyBrowser.h"
#include "qtHelpers.h"

#endif




#endif