//---------------------------------------------------------------------------
#ifndef KinectCaptureH
#define KinectCaptureH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace openni {
   class Device;
   class VideoStream;
   class VideoFrameRef;
}

namespace geoxl {



///
///   this class represents a kinect device. it captures range images as 2D pointsets (width x height)
///
class GEOXLKINECT_API KinectCapture : public Persistent {
   GEOXL_CLASS(KinectCapture)
 private:
	openni::Device *device;
	openni::VideoStream *depthStream, *colorStream;
   openni::VideoFrameRef *depthFrame;
   openni::VideoFrameRef *colorFrame;
	PointSet *currentFrame;
	float *depthHistogramm;
	static const int MAX_DEPTH_HISTO = 10000;

 public:
   enum ChangeType {NewColor, NewDepth};
 
	KinectCapture();
	
	void startCapture();
	const PointSet *getNextFrame(ChangeType &whatChanged);
	void stopCapture();

   ~KinectCapture();
};


}

#endif