//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PCIKinectCapture.h"
#include "KinectCapture.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



IMPLEMENT_GEOXL_CLASS( PCIKinectCapture, 1 ) {
   BEGIN_CLASS_INIT( PCIKinectCapture );

}

PCIKinectCapture::PCIKinectCapture()
{
   capture = new KinectCapture();
   deviceActive = false;
}

PCIKinectCapture::~PCIKinectCapture()
{
   delete capture;
}


void PCIKinectCapture::startDevice()
{
   capture->startCapture();
   deviceActive = true;
}

void PCIKinectCapture::stopDevice()
{
   deviceActive = false;
   capture->stopCapture();
}

const PointSet *PCIKinectCapture::fetchFrame(KinectCapture::ChangeType &ct)
{
   return capture->getNextFrame(ct);
}
