//---------------------------------------------------------------------------
#ifndef PCIKinectCaptureH
#define PCIKinectCaptureH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PCInteractionTool.h"
#include "KinectCapture.h"
//---------------------------------------------------------------------------

namespace geoxl {

class PCIKinectCaptureEditorWidget;

class GEOXLKINECT_API PCIKinectCapture : public PCInteractionTool
{
	GEOXL_CLASS( PCIKinectCapture )
 private:
   KinectCapture *capture;
   bool deviceActive;
   
 protected:
   void startDevice();
   void stopDevice();
   bool getDeviceActive() {return deviceActive;}
   const PointSet *fetchFrame(KinectCapture::ChangeType &ct);
   
 public:
	PCIKinectCapture();

   virtual void mouseDown(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState) {}
   virtual void mouseMoved(int32 x, int32 y) {}
   virtual void mouseUp(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState) {}
   virtual void areaResize(card32 width, card32 height) {}
   virtual void mouseWheelRotated(int32 rotatedDelta, Modifiers modifiersState) {}

   virtual void keyDown(GeneralKey key) {}
   virtual void keyUp(GeneralKey key) {}

	virtual ~PCIKinectCapture();
   friend PCIKinectCaptureEditorWidget;
};



}

#endif