//---------------------------------------------------------------------------
#ifndef PCIKinectCaptureEditorWidgetH 
#define PCIKinectCaptureEditorWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PCIKinectCaptureEditorWidget_ui.h"
//---------------------------------------------------------------------------

namespace geoxl {

class PCIKinectCapture;
class SGListNode;

class GEOXLKINECT_API PCIKinectCaptureEditorWidget : public QWidget
{
	Q_OBJECT
 private:
	Ui_PCIKinectCaptureEditorWidget ui; 
	PCIKinectCapture *edObj;
	QTimer *timer;
	SGListNode *recList;
	
 public:
	PCIKinectCaptureEditorWidget(QWidget * parent = NULL, Qt::WFlags f=0);
	virtual ~PCIKinectCaptureEditorWidget(void);

	virtual void setup( PCIKinectCapture * obj );

	/// update editor content with object data
	virtual void updateEditor();

 public slots:
   void on_pbStartDev_clicked();
   void on_pbStopDev_clicked();
   void on_pbRec_clicked();
   void on_pbStopRec_clicked();
   void on_timer();
};

MAKE_CLASS_EDITOR( GEOXLKINECT_API , PCIKinectCapture )


}

#endif