//---------------------------------------------------------------------------
#ifndef GLExtensionsH
#define GLExtensionsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "GL/glext.h"

namespace geoxl {

extern GLTOOLS_API bool glExtensionsInitialized;

extern GLTOOLS_API void initGLExtensions();

}

#ifndef GL_EXT_framebuffer_object
#define GL_INVALID_FRAMEBUFFER_OPERATION_EXT 0x0506
#define GL_MAX_RENDERBUFFER_SIZE_EXT      0x84E8
#define GL_FRAMEBUFFER_BINDING_EXT        0x8CA6
#define GL_RENDERBUFFER_BINDING_EXT       0x8CA7
#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT 0x8CD0
#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT 0x8CD1
#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT 0x8CD2
#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT 0x8CD3
#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT 0x8CD4
#define GL_FRAMEBUFFER_COMPLETE_EXT       0x8CD5
#define GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT 0x8CD6
#define GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT 0x8CD7
#define GL_FRAMEBUFFER_INCOMPLETE_DUPLICATE_ATTACHMENT_EXT 0x8CD8
#define GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT 0x8CD9
#define GL_FRAMEBUFFER_INCOMPLETE_FORMATS_EXT 0x8CDA
#define GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT 0x8CDB
#define GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT 0x8CDC
#define GL_FRAMEBUFFER_UNSUPPORTED_EXT    0x8CDD
#define GL_MAX_COLOR_ATTACHMENTS_EXT      0x8CDF
#define GL_COLOR_ATTACHMENT0_EXT          0x8CE0
#define GL_COLOR_ATTACHMENT1_EXT          0x8CE1
#define GL_COLOR_ATTACHMENT2_EXT          0x8CE2
#define GL_COLOR_ATTACHMENT3_EXT          0x8CE3
#define GL_COLOR_ATTACHMENT4_EXT          0x8CE4
#define GL_COLOR_ATTACHMENT5_EXT          0x8CE5
#define GL_COLOR_ATTACHMENT6_EXT          0x8CE6
#define GL_COLOR_ATTACHMENT7_EXT          0x8CE7
#define GL_COLOR_ATTACHMENT8_EXT          0x8CE8
#define GL_COLOR_ATTACHMENT9_EXT          0x8CE9
#define GL_COLOR_ATTACHMENT10_EXT         0x8CEA
#define GL_COLOR_ATTACHMENT11_EXT         0x8CEB
#define GL_COLOR_ATTACHMENT12_EXT         0x8CEC
#define GL_COLOR_ATTACHMENT13_EXT         0x8CED
#define GL_COLOR_ATTACHMENT14_EXT         0x8CEE
#define GL_COLOR_ATTACHMENT15_EXT         0x8CEF
#define GL_DEPTH_ATTACHMENT_EXT           0x8D00
#define GL_STENCIL_ATTACHMENT_EXT         0x8D20
#define GL_FRAMEBUFFER_EXT                0x8D40
#define GL_RENDERBUFFER_EXT               0x8D41
#define GL_RENDERBUFFER_WIDTH_EXT         0x8D42
#define GL_RENDERBUFFER_HEIGHT_EXT        0x8D43
#define GL_RENDERBUFFER_INTERNAL_FORMAT_EXT 0x8D44
#define GL_STENCIL_INDEX1_EXT             0x8D46
#define GL_STENCIL_INDEX4_EXT             0x8D47
#define GL_STENCIL_INDEX8_EXT             0x8D48
#define GL_STENCIL_INDEX16_EXT            0x8D49
#define GL_RENDERBUFFER_RED_SIZE_EXT      0x8D50
#define GL_RENDERBUFFER_GREEN_SIZE_EXT    0x8D51
#define GL_RENDERBUFFER_BLUE_SIZE_EXT     0x8D52
#define GL_RENDERBUFFER_ALPHA_SIZE_EXT    0x8D53
#define GL_RENDERBUFFER_DEPTH_SIZE_EXT    0x8D54
#define GL_RENDERBUFFER_STENCIL_SIZE_EXT  0x8D55
#endif


#ifndef GL_EXT_framebuffer_object
#define GL_EXT_framebuffer_object 1

#define GEOXL_GLAPI extern 
#define GEOXL_APIENTRY APIENTRY

#define GEOXL_GLEXPORT extern

/*GEOXL_GLAPI GLboolean GEOXL_APIENTRY glIsRenderbufferEXT (GLuint);
GEOXL_GLAPI void GEOXL_APIENTRY glBindRenderbufferEXT (GLenum, GLuint);
GEOXL_GLAPI void GEOXL_APIENTRY glDeleteRenderbuffersEXT (GLsizei, const GLuint *);
GEOXL_GLAPI void GEOXL_APIENTRY glGenRenderbuffersEXT (GLsizei, GLuint *);
GEOXL_GLAPI void GEOXL_APIENTRY glRenderbufferStorageEXT (GLenum, GLenum, GLsizei, GLsizei);
GEOXL_GLAPI void GEOXL_APIENTRY glGetRenderbufferParameterivEXT (GLenum, GLenum, GLint *);
GEOXL_GLAPI GLboolean GEOXL_APIENTRY glIsFramebufferEXT (GLuint);
GEOXL_GLAPI void GEOXL_APIENTRY glBindFramebufferEXT (GLenum, GLuint);
GEOXL_GLAPI void GEOXL_APIENTRY glDeleteFramebuffersEXT (GLsizei, const GLuint *);
GEOXL_GLAPI void GEOXL_APIENTRY glGenFramebuffersEXT (GLsizei, GLuint *);
GEOXL_GLAPI GLenum GEOXL_APIENTRY glCheckFramebufferStatusEXT (GLenum);
GEOXL_GLAPI void GEOXL_APIENTRY glFramebufferTexture1DEXT (GLenum, GLenum, GLenum, GLuint, GLint);
GEOXL_GLAPI void GEOXL_APIENTRY glFramebufferTexture2DEXT (GLenum, GLenum, GLenum, GLuint, GLint);
GEOXL_GLAPI void GEOXL_APIENTRY glFramebufferTexture3DEXT (GLenum, GLenum, GLenum, GLuint, GLint, GLint);
GEOXL_GLAPI void GEOXL_APIENTRY glFramebufferRenderbufferEXT (GLenum, GLenum, GLenum, GLuint);
GEOXL_GLAPI void GEOXL_APIENTRY glGetFramebufferAttachmentParameterivEXT (GLenum, GLenum, GLenum, GLint *);
GEOXL_GLAPI void GEOXL_APIENTRY glGenerateMipmapEXT (GLenum);*/

typedef GLboolean (APIENTRYP PFNGLISRENDERBUFFEREXTPROC) (GLuint renderbuffer);
typedef void (APIENTRYP PFNGLBINDRENDERBUFFEREXTPROC) (GLenum target, GLuint renderbuffer);
typedef void (APIENTRYP PFNGLDELETERENDERBUFFERSEXTPROC) (GLsizei n, const GLuint *renderbuffers);
typedef void (APIENTRYP PFNGLGENRENDERBUFFERSEXTPROC) (GLsizei n, GLuint *renderbuffers);
typedef void (APIENTRYP PFNGLRENDERBUFFERSTORAGEEXTPROC) (GLenum target, GLenum internalformat, GLsizei width, GLsizei height);
typedef void (APIENTRYP PFNGLGETRENDERBUFFERPARAMETERIVEXTPROC) (GLenum target, GLenum pname, GLint *params);
typedef GLboolean (APIENTRYP PFNGLISFRAMEBUFFEREXTPROC) (GLuint framebuffer);
typedef void (APIENTRYP PFNGLBINDFRAMEBUFFEREXTPROC) (GLenum target, GLuint framebuffer);
typedef void (APIENTRYP PFNGLDELETEFRAMEBUFFERSEXTPROC) (GLsizei n, const GLuint *framebuffers);
typedef void (APIENTRYP PFNGLGENFRAMEBUFFERSEXTPROC) (GLsizei n, GLuint *framebuffers);
typedef GLenum (APIENTRYP PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC) (GLenum target);
typedef void (APIENTRYP PFNGLFRAMEBUFFERTEXTURE1DEXTPROC) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level);
typedef void (APIENTRYP PFNGLFRAMEBUFFERTEXTURE2DEXTPROC) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level);
typedef void (APIENTRYP PFNGLFRAMEBUFFERTEXTURE3DEXTPROC) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset);
typedef void (APIENTRYP PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC) (GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer);
typedef void (APIENTRYP PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC) (GLenum target, GLenum attachment, GLenum pname, GLint *params);
typedef void (APIENTRYP PFNGLGENERATEMIPMAPEXTPROC) (GLenum target);



GEOXL_GLEXPORT PFNGLISRENDERBUFFEREXTPROC glIsRenderbufferEXT;
GEOXL_GLEXPORT PFNGLBINDRENDERBUFFEREXTPROC glBindRenderbufferEXT;
GEOXL_GLEXPORT PFNGLDELETERENDERBUFFERSEXTPROC glDeleteRenderbuffersEXT;
GEOXL_GLEXPORT PFNGLGENRENDERBUFFERSEXTPROC glGenRenderbuffersEXT;
GEOXL_GLEXPORT PFNGLRENDERBUFFERSTORAGEEXTPROC glRenderbufferStorageEXT ;
GEOXL_GLEXPORT PFNGLGETRENDERBUFFERPARAMETERIVEXTPROC glGetRenderbufferParameterivEXT ;
GEOXL_GLEXPORT PFNGLISFRAMEBUFFEREXTPROC glIsFramebufferEXT ;
GEOXL_GLEXPORT PFNGLBINDFRAMEBUFFEREXTPROC glBindFramebufferEXT ;
GEOXL_GLEXPORT PFNGLDELETEFRAMEBUFFERSEXTPROC glDeleteFramebuffersEXT ;
GEOXL_GLEXPORT PFNGLGENFRAMEBUFFERSEXTPROC glGenFramebuffersEXT ;
GEOXL_GLEXPORT PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC glCheckFramebufferStatusEXT ;
GEOXL_GLEXPORT PFNGLFRAMEBUFFERTEXTURE1DEXTPROC glFramebufferTexture1DEXT ;
GEOXL_GLEXPORT PFNGLFRAMEBUFFERTEXTURE2DEXTPROC glFramebufferTexture2DEXT ;
GEOXL_GLEXPORT PFNGLFRAMEBUFFERTEXTURE3DEXTPROC glFramebufferTexture3DEXT ;
GEOXL_GLEXPORT PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC glFramebufferRenderbufferEXT ;
GEOXL_GLEXPORT PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC glGetFramebufferAttachmentParameterivEXT ;
GEOXL_GLEXPORT PFNGLGENERATEMIPMAPEXTPROC glGenerateMipmapEXT ;


#endif

#endif
