	//---------------------------------------------------------------------------
#ifndef GLObjectH
#define GLObjectH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------
#include <list>
//---------------------------------------------------------------------------

namespace geoxl {
   using namespace std;

class GLContext;


class GLTOOLS_API GLObject
{
public:
   /// every object is attached to a context ( context != NULL !!!!!!)
   GLObject( GLContext * );

   /// removes object from context
   virtual ~GLObject();

   GLContext * getContext() const {return m_Context;}
   GLContext * getRootContext();

   /// object is attached to context -> return true
   /// else -> return false
   bool isCompatible( GLContext * context );
   bool isValid() {return m_Context != NULL;}

protected:

   /// called before deleting root-context
   virtual void onDeleteContext() {}

private:

   /// calls onDeleteContext()
   void callOnDeleteContext();

   GLContext * m_Context;
   list<GLObject *>::iterator m_ContextPosition;

   friend class GLContext;
};

};
#endif
