//---------------------------------------------------------------------------
#ifndef GLEventDisplayerWidgetH
#define GLEventDisplayerWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include <QtGui/QWidget>
#include <QtOpenGL/QGLWidget>
#include <QtOpenGL/qgl.h>
//---------------------------------------------------------------------------
#include "ExaminerCameraController.h"
#include "Camera.h"
//---------------------------------------------------------------------------
#include "GLEventDisplayerWidget_ui.h"
//---------------------------------------------------------------------------

namespace geoxl {

class GLEventObject;
class GLEventConfiguration;
class GLContext;


class GLTOOLS_API GLEventDisplayerWidget : public QWidget {
	Q_OBJECT

 private:
	class MyGLWidget : public QGLWidget {
	 private:
		Camera cam;
		GLContext *glContext;
	 protected:
		virtual void paintGL();
		virtual void mouseMoveEvent(QMouseEvent *event);
		virtual void mousePressEvent(QMouseEvent *event);
		virtual void mouseReleaseEvent(QMouseEvent *event);
		virtual void keyPressEvent(QKeyEvent *event);
		virtual void keyReleaseEvent(QKeyEvent *event);
		virtual void resizeEvent(QResizeEvent *event);
	 public:
		GLEventObject *glEventObject;
		ExaminerCameraController camCtrl;
		MyGLWidget(QWidget *parent = 0);
		~MyGLWidget();
	};

	Ui_GLEventDisplayerWidget ui;
	MyGLWidget *glWidget;	
	int sizeIndex;
	GLEventConfiguration *configPopup;
	
 private slots:
	void on_pbIncreaseSize_clicked();
	void on_pbDecreaseSize_clicked();
	void on_pbConfigure_clicked();
	virtual void changed();

 public:
	GLEventDisplayerWidget(QWidget* parent = 0, Qt::WFlags f = 0);
	virtual void setGLEventObject(GLEventObject *glevo, bool updateDataOnly);
	~GLEventDisplayerWidget();
};
 


}

#endif
