//---------------------------------------------------------------------------
#include "stdafx.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
#include "InitHierarchies.h"
#include "hierarchies.h"
//---------------------------------------------------------------------------
/*
	Please separate between system code and interface code ( editors ), in 
	order to build a non-interface commandline version of geoxl.

File structure:
	includes
		..
		..
	interface includes
		..
		..
	initHierarchies()
	{
		init geoxl classes
		..
		..
		init geoxl class editors
		..
		..
	}
	shutdownHierarchies()
	{
		shutdown geoxl classes
		..
		..
		shutdown geoxl class editors
		..
		..
				
	}
*/

//---------------------------------------------------------------------------
#include "MHAllocators_templCode.h"
#include "MHInCorePointSetOctree.h"
#include "MHOutOfCorePointSetOctree.h"
#include "MHNodeData.h"
#include "MHSettings.h"
#include "HierarchicalInCorePointCloud.h"
#include "HierarchicalOutOfCorePointCloud.h"
#include "MHOutOfCorePointSetOctreeIterator.h"
#include "MHInCorePointSetOctreeIterator.h"
#include "BucketSplitPointsAddingAdaptor.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------


void geoxl::initHierarchies() {
   MHInCorePointSetOctree::init(Persistent::getClass());
   MHOutOfCorePointSetOctree::init(Persistent::getClass());
   MHInCorePointSetOctreeNode::init(Persistent::getClass());
   MHOutOfCorePointSetOctreeNode::init(Persistent::getClass());
   MHOutOfCorePointSetOctreeNode::NodeAllocator::init(Persistent::getClass());
   MHInCorePointSetNodeData::init(Persistent::getClass());
   MHOutOfCorePointSetNodeData::init(Persistent::getClass());
   MHStandardSettings::init(Persistent::getClass());
   HierarchicalInCorePointCloud::init(PointCloud::getClass());
   HierarchicalOutOfCorePointCloud::init(PointCloud::getClass());
   
   BucketSplitPointsAddingAdaptor::init(PointCloudIterator::getClass());
}


void geoxl::shutdownHierarchies() {
   MHInCorePointSetOctree::shutdown();
   MHOutOfCorePointSetOctree::shutdown();
   MHInCorePointSetOctreeNode::shutdown();
   MHOutOfCorePointSetOctreeNode::NodeAllocator::shutdown();
   MHOutOfCorePointSetOctreeNode::shutdown();
   MHInCorePointSetNodeData::shutdown();
   MHOutOfCorePointSetNodeData::shutdown();
   MHStandardSettings::shutdown();
   HierarchicalInCorePointCloud::shutdown();
   HierarchicalOutOfCorePointCloud::shutdown();
   BucketSplitPointsAddingAdaptor::shutdown();
}
