//---------------------------------------------------------------------------
#include "stdafx.h"
 
//---------------------------------------------------------------------------
#include "MHInCorePointSetOctreeIterator.h"
//---------------------------------------------------------------------------
#include "VertexDescriptor.h"
#include "DebugOutput.h"
#include "MHPointSetOctreeIterator_Templ_templCode.h"
#include "MHAllPointsPointSetOctreeIterator_Templ_templCode.h"
#include "MHHierarchy.h"
#include "MHHierarchy_templCode.h"
#include "MHNodeData_templCode.h"
#include "MHAllocators_templCode.h"
#include "MHNodes_templCode.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



MetaClass* MHInCorePointSetOctreeIterator::MHInCorePointSetOctreeIteratorMetaClass = NULL;

const MetaClass* MHInCorePointSetOctreeIterator::getInstanceClass() const {
   return getClass();
}

Object* MHInCorePointSetOctreeIterator::newInstance() {
   return new MHInCorePointSetOctreeIterator;
}

const MetaClass* MHInCorePointSetOctreeIterator::getClass() {
   if (MHInCorePointSetOctreeIteratorMetaClass==NULL) {
      MHInCorePointSetOctreeIteratorMetaClass = new MetaClass("MHInCorePointSetOctreeIterator", "no description.",
                                  newInstance, sizeof(MHInCorePointSetOctreeIterator));
   }
   return MHInCorePointSetOctreeIteratorMetaClass;
}

void MHInCorePointSetOctreeIterator::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   MHInCorePointSetOctreeIteratorMetaClass->copyParentProperties();
}

void MHInCorePointSetOctreeIterator::shutdown() {
   delete MHInCorePointSetOctreeIteratorMetaClass;
}


// --


MetaClass* MHAllPointsInCorePointSetOctreeIterator::MHAllPointsInCorePointSetOctreeIteratorMetaClass = NULL;

const MetaClass* MHAllPointsInCorePointSetOctreeIterator::getInstanceClass() const {
   return getClass();
}

Object* MHAllPointsInCorePointSetOctreeIterator::newInstance() {
   return new MHAllPointsInCorePointSetOctreeIterator;
}

const MetaClass* MHAllPointsInCorePointSetOctreeIterator::getClass() {
   if (MHAllPointsInCorePointSetOctreeIteratorMetaClass==NULL) {
      MHAllPointsInCorePointSetOctreeIteratorMetaClass = new MetaClass("MHAllPointsInCorePointSetOctreeIterator", "no description.",
                                  newInstance, sizeof(MHAllPointsInCorePointSetOctreeIterator));
   }
   return MHAllPointsInCorePointSetOctreeIteratorMetaClass;
}

void MHAllPointsInCorePointSetOctreeIterator::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   MHAllPointsInCorePointSetOctreeIteratorMetaClass->copyParentProperties();
}

void MHAllPointsInCorePointSetOctreeIterator::shutdown() {
   delete MHAllPointsInCorePointSetOctreeIteratorMetaClass;
}


// ----


MHInCorePointSetOctreeIterator::InCoreTemporaryPointsBuffer::InCoreTemporaryPointsBuffer(const VertexDescriptor *descr) {
   ps = new PointSet();
   ps->clearAndSetup(1, 0, descr);
}

void MHInCorePointSetOctreeIterator::InCoreTemporaryPointsBuffer::add(const char *point) {
   if (ps->getNumEntries() < 100000) {
      ps->addPoint(point);
   } else {
      otherPs.push_back(ps);
      ps = new PointSet();
      ps->clearAndSetup(1, 0, otherPs.back()->getDescr());
      ps->addPoint(point);
   }
}

void MHInCorePointSetOctreeIterator::InCoreTemporaryPointsBuffer::getLastModified(PointSet *&ps) {
   ps = this->ps;
}

void MHInCorePointSetOctreeIterator::InCoreTemporaryPointsBuffer::addPointsToHierarchyAndClear(MHInCorePointSetOctree *dest) {
   AAT FLAGS = NULL_AAT;
   if (ps->providesAttribute("flags")) FLAGS = ps->getAAT("flags");
   const AAT POSITION = ps->getAAT("position");

   for (card32 j = 0; j<otherPs.size(); j++) {
      const card32 n2 = otherPs[j]->getNumEntries();
      for (card32 i=0; i<n2; i++) {
         if (FLAGS != NULL_AAT && (((otherPs[j]->get<int32, 1>(i, FLAGS)[0]) & PF_FLAG_INVALID)) != 0) continue;
         MHPointSetPointObject pobj(dest->getDescr(), POSITION, FLAGS, otherPs[j]->getDataPointer(i));
         dest->addObject(pobj);
      }
      delete otherPs[j];
   }
   otherPs.clear();

   const card32 n = ps->getNumEntries();
   for (card32 i=0; i<n; i++) {
      if (FLAGS != NULL_AAT && (((ps->get<int32, 1>(i, FLAGS)[0]) & PF_FLAG_INVALID)) != 0) continue;
      MHPointSetPointObject pobj(dest->getDescr(), POSITION, FLAGS, ps->getDataPointer(i));
      dest->addObject(pobj);
   }
   ps->clear();
}

void MHInCorePointSetOctreeIterator::InCoreTemporaryPointsBuffer::deleteLastModified() {
   card32 h = ps->getHeight();
   pAssert(h >= 1);
   ps->changeHeight(h-1);
}

MHInCorePointSetOctreeIterator::InCoreTemporaryPointsBuffer::~InCoreTemporaryPointsBuffer() {
   pAssert(ps->getNumEntries() == 0);
   delete ps;
}

MHInCorePointSetOctreeIterator::TemporaryPointsBuffer*
   MHInCorePointSetOctreeIterator::createTempBuffer(MHInCorePointSetOctree *hierarchy)
{
   return new InCoreTemporaryPointsBuffer(hierarchy->getDescr());
}


