//---------------------------------------------------------------------------
#ifndef MHInCorePointSetOctreeIteratorH
#define MHInCorePointSetOctreeIteratorH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "MHPointSetOctreeIterator_Templ.h"
#include "MHAllPointsPointSetOctreeIterator_Templ.h"
//---------------------------------------------------------------------------

namespace geoxl {

class HierarchicalInCorePointCloud;


class MHInCorePointSetOctreeIterator
   : public MHPointSetOctreeIterator_Templ<MHInCorePointSetOctree, MHInCorePointSetOctreeNode> {
 private:
   static MetaClass *MHInCorePointSetOctreeIteratorMetaClass;
   static Object* newInstance();

 protected:

   MHInCorePointSetOctreeIterator()
      : MHPointSetOctreeIterator_Templ<MHInCorePointSetOctree, MHInCorePointSetOctreeNode>() {}
   MHInCorePointSetOctreeIterator(MHInCorePointSetOctree *hierarchy)
      : MHPointSetOctreeIterator_Templ<MHInCorePointSetOctree, MHInCorePointSetOctreeNode>(hierarchy) {}

   friend class HierarchicalInCorePointCloud;

   class InCoreTemporaryPointsBuffer : public TemporaryPointsBuffer {
    private:
      PointSet *ps;
      vector<PointSet*> otherPs;
    public:
      InCoreTemporaryPointsBuffer(const VertexDescriptor *descr);
      virtual void add(const char *point);
      virtual void getLastModified(PointSet *&ps);
      virtual void addPointsToHierarchyAndClear(MHInCorePointSetOctree *dest);
      virtual void deleteLastModified();
      virtual ~InCoreTemporaryPointsBuffer();
   };

   virtual TemporaryPointsBuffer *createTempBuffer(MHInCorePointSetOctree *hierarchy);

 public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();
};



class MHAllPointsInCorePointSetOctreeIterator : public
   MHAllPointsPointSetOctreeIterator_Templ<MHInCorePointSetOctree, MHInCorePointSetOctreeNode> {
 private:
   static MetaClass *MHAllPointsInCorePointSetOctreeIteratorMetaClass;
   static Object* newInstance();

 protected:
   MHAllPointsInCorePointSetOctreeIterator()
      : MHAllPointsPointSetOctreeIterator_Templ<MHInCorePointSetOctree, MHInCorePointSetOctreeNode>() {}
   MHAllPointsInCorePointSetOctreeIterator(MHInCorePointSetOctreeIterator *baseIterator)
      : MHAllPointsPointSetOctreeIterator_Templ<MHInCorePointSetOctree, MHInCorePointSetOctreeNode>(baseIterator) {}

   friend class HierarchicalInCorePointCloud;

 public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

};



}


#endif
