//---------------------------------------------------------------------------
#ifndef MHInstancesH
#define MHInstancesH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PTypes.h"
#include "Persistent.h"
//---------------------------------------------------------------------------
#include "MHObjects.h"
#include "MHNodeData.h"
#include "MHNodes.h"
#include "MHHierarchy.h"
#include "MHAllocators.h"
#include "MHSettings.h"
#include "MHMultiRes.h"
//---------------------------------------------------------------------------

namespace geoxl {
   using namespace std;


class HIERARCHIES_API NULL_CLASS {};


//typedef MHPointWAttribObject_TemplBase<float32, 3> MHAttribsPoint3f;
typedef MHIndexedPoint_TemplBase<float32, 3>       MHIndexedPoint3f;


// typedef MHNodeDataObjectVector<MHAttribsPoint3f, float32, 3> MHAttribsVectNodeData3f;
typedef MHNodeDataObjectVector<MHIndexedPoint3f, float32, 3> MHIndexedVectNodeData3f;



template <typename FloatType, int Dimension, typename ObjectType,
          typename NodeType, typename SettingsType, class HierarchyBaseClass>
class HIERARCHIES_API MHPointHierachy_TemplBase : public ModularHierarchy_TemplBase<FloatType, Dimension, ObjectType, NodeType, SettingsType, HierarchyBaseClass> {
 protected:
   VertexDescriptor *descr;

 public:
   MHPointHierachy_TemplBase();
   const VertexDescriptor *getDescr() const;
   VertexDescriptor *getDescr();

   void clearAndSetup(
      typename ModularHierarchy_TemplBase<FloatType, Dimension, ObjectType, NodeType,
                                 SettingsType, HierarchyBaseClass>::NodeAllocator *nAlloc,
      const VertexDescriptor *descr
   );
};


}

#endif



