//---------------------------------------------------------------------------
#ifndef MHInstances_templCodeH
#define MHInstances_templCodeH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "MHInstances.h"
//---------------------------------------------------------------------------
#include "MHObjects_templCode.h"
#include "MHNodeData_templCode.h"
#include "MHNodes_templCode.h"
#include "MHHierarchy_templCode.h"
#include "MHAllocators_templCode.h"
//---------------------------------------------------------------------------

namespace geoxl {
   using namespace std;


template <typename FloatType, int Dimension, typename ObjectType,
          typename NodeType, typename SettingsType, class HierarchyBaseClass>
MHPointHierachy_TemplBase<FloatType, Dimension, ObjectType, NodeType, SettingsType, HierarchyBaseClass>
// --------------------------
::MHPointHierachy_TemplBase()
// --------------------------
{
   descr = NULL;
}



template <typename FloatType, int Dimension, typename ObjectType,
          typename NodeType, typename SettingsType, class HierarchyBaseClass>
const VertexDescriptor *MHPointHierachy_TemplBase<FloatType, Dimension, ObjectType, NodeType, SettingsType, HierarchyBaseClass>
// ---------------
::getDescr() const
// ---------------
{
   return descr;
}


template <typename FloatType, int Dimension, typename ObjectType,
          typename NodeType, typename SettingsType, class HierarchyBaseClass>
VertexDescriptor *MHPointHierachy_TemplBase<FloatType, Dimension, ObjectType, NodeType, SettingsType, HierarchyBaseClass>
// ---------
::getDescr()
// ---------
{
   return descr;
}


template <typename FloatType, int Dimension, typename ObjectType,
          typename NodeType, typename SettingsType, class HierarchyBaseClass>
void MHPointHierachy_TemplBase<FloatType, Dimension, ObjectType, NodeType, SettingsType, HierarchyBaseClass>
// ------------------------------------------------------------------------------------
::clearAndSetup(
   typename ModularHierarchy_TemplBase<FloatType, Dimension, ObjectType, NodeType,
                              SettingsType, HierarchyBaseClass>::NodeAllocator *nAlloc,
   const VertexDescriptor *descr
)
// ------------------------------------------------------------------------------------
{
   ModularHierarchy_TemplBase<FloatType, Dimension, ObjectType, NodeType, SettingsType, HierarchyBaseClass>::
      clearAndSetup(nAlloc);
   this->descr = (VertexDescriptor*)(descr->copy());
}


}

#endif
