//---------------------------------------------------------------------------
#ifndef MHIteratorsH
#define MHIteratorsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PointCloudIterators.h"
#include "BoundingBox.h"
#include "MHSettings.h"
#include "MHInCorePointSetOctree.h"
#include "MHOutOfCorePointSetOctree.h"
//---------------------------------------------------------------------------


namespace geoxl {

/// maximum number of points in add buffer before buffer is flushed (i.e. inserted into hierarchy)
static const card32 MAX_ADD_BUFFER_SIZE = 50 * 1024 * 1024; // max. 50MB
                                                                                   
// ------------------------------ MHIterator ------------------------------



class HIERARCHIES_API MHIterator : public PointCloudIterator
{
 private:
   static MetaClass *MHIteratorMetaClass;

 public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

};







}


#endif
