//---------------------------------------------------------------------------
#ifndef MHSettingsH
#define MHSettingsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------


/*
 |  Expected methods:
 |  class MHSettings {
 |   public:
 |     <currently, any type can be used>
 |  };
*/

namespace geoxl {


class HIERARCHIES_API MHStandardSettings : public Persistent {
 private:
   static MetaClass *MHStandardSettingsMetaClass;
   static Object* newInstance();

 public:
   /// hierarchy termination criterion
   max_platform_card maxNumObjectsPerLeaf;
   /// number of points per bounding box side length for grid stratified multi-res point sets
   card32 multiResGridSize;

   MHStandardSettings();

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();
};


}

#endif
