//---------------------------------------------------------------------------
#ifndef MHUtilities_templCodeH
#define MHUtilities_templCodeH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "MHUtilities.h"
//---------------------------------------------------------------------------
#include "PointSet_templCode.h"
//---------------------------------------------------------------------------


namespace geoxl {

template <typename NodeType>
void HIERARCHIES_API appendFieldsToPointSetNodes(typename NodeType::NodePointer node, const VertexDescriptor *newAttribs) {
   if (node == NULL) return;
   PointSet *psnd = node->nodeData.getPointSet();
   if (psnd != NULL) {
      node->nodeData.appendFields(newAttribs);
   }
   PointSet *psmr = node->multiRes.getPointSet();
   if (psmr != NULL) {
      node->multiRes.appendFields(newAttribs);
   }
   const card32 n = node->getMaxNumChildren();
   for (card32 i=0; i<n; i++) {
      typename NodeType::NodePointer child;
      node->getChild(i, child);
      if (node != NULL) {
         appendFieldsToPointSetNodes<NodeType>(child, newAttribs);
      }
   }
}


}


#endif
