//---------------------------------------------------------------------------
#ifndef PCNearestNeighborIteratorH
#define PCNearestNeighborIteratorH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PointCloudIterators.h"
#include "PointCloud.h"
#include "PointSet.h"
#include "AttachedIndexedOctree.h"
//#include <queue.h>
//---------------------------------------------------------------------------


namespace geoxl {

/*
-------------------
unused old code!
-------------------


struct NeighborPoint {
   public:
   card32 index;
   float32 quaddist;
};

struct PQHierarchyNode {
   public:
//   HierarchicalIterator* hit;
   AIHierarchicalOctreeIterator* hit;
   float32 quaddist;
};

bool operator<(const NeighborPoint& p1, const NeighborPoint& p2){
   return(p1.quaddist>p2.quaddist);
}

bool operator<(const PQHierarchyNode& p1, const PQHierarchyNode& p2){
   return(p1.quaddist>p2.quaddist);
}

class POINTCLOUDS_API PCNearestNeighborIterator:
    public PointCloudIterator,
    public BasicPointCloudIterator,
    public IndexedPointCloudIterator {

 private:
   static MetaClass *PCNearestNeighborIteratorMetaClass;
   static Object* newInstance();

   PointCloud* m_pc;
   PointSet* m_ps;
   HierarchicalIterator* m_startHIt;
   HierarchicalIterator* m_currentHIt;
   Vector3f m_seekPoint;
   std::priority_queue<NeighborPoint> m_neighbors;
   std::priority_queue<PQHierarchyNode> m_pqHierarchy;
   std::priority_queue<PQHierarchyNode> m_pqLeafs;
   card32 m_lastIndex;
   char* m_buffer;
   MemoryManager *m_attachedOctreeMemManager;

   void findNeighbors(void);
   void nextBox();

 public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass, card32 uniqueIdentifier);
   static void shutdown();

   PCNearestNeighborIterator();
   ~PCNearestNeighborIterator();

   bool clearAndSetup(PointCloud*, const Vector3f&, float32 maxDistance, MemoryManager *attachedOctreeMemManager);

   /// go to first point
   virtual void reset();
   /// go to next point
   virtual void next();
   /// true if end-of-set
   virtual bool atEnd();

	// retrieve indices
   virtual card64 getNumPointsInBlock() const; 
   virtual card64 getCurrentPointIndex() const;

   /// get attributes in different formats
   virtual card8     get1ub(const AAT &token) const;
   virtual Vector2ub get2ub(const AAT &token) const;
   virtual Vector3ub get3ub(const AAT &token) const;
   virtual Vector4ub get4ub(const AAT &token) const;

   virtual int32    get1i(const AAT &token) const;
   virtual Vector2i get2i(const AAT &token) const;
   virtual Vector3i get3i(const AAT &token) const;
   virtual Vector4i get4i(const AAT &token) const;

   virtual float32  get1f(const AAT &token) const;
   virtual Vector2f get2f(const AAT &token) const;
   virtual Vector3f get3f(const AAT &token) const;
   virtual Vector4f get4f(const AAT &token) const;

   /// ask VertexDescriptor for buffer size
   virtual void     getVertex(char *buffer) const;

   // --- blockwise access (faster)
   /// step foreward to next data block, false if end-of-set (affects the same position pointer as "next()")
   /// no effect for hierarchal iterators (guaranteed to yield only one block per node)
   virtual bool nextBlock();
   /// access raw data of current data block; call unlock to free;
   /// one data block is guaranteed to easily fit into main memory
   /// for hierarchical iterators: locks current node only
   virtual const PointSet * lockBlockRead();
   /// free locked PointSet again
   virtual void unlock();
};
*/
}

#endif
