//---------------------------------------------------------------------------
#ifndef PointSetToolsH
#define PointSetToolsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PTypes.h"
//---------------------------------------------------------------------------
#include <vector>
//---------------------------------------------------------------------------

namespace geoxl {
   using namespace std;

class PointSet;

///
///   a set of tools to process point sets 
///   (put in an additional file rather than 
///   PointSet.h to avoid frequent recompiling)
///

/// remove all points from the set that do not have a boolean tag of "true" in keep
/// (if keep is smaller than ps->getNumEntries(), false is assumed for all other points)
void POINTCLOUDS_API removePoints(PointSet *ps, const vector<bool> &keep);

}

#endif