//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "StandardChannels.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------

const VAD geoxl::VERTEX_CHANNEL_VAD_POSITION					= mVAD( VERTEX_CHANNEL_NAME_POSITION,				   3, VAD::DATA_FORMAT_FLOAT32 );
const VAD geoxl::VERTEX_CHANNEL_VAD_FLAGS						= mVAD( VERTEX_CHANNEL_NAME_FLAGS,					   1, VAD::DATA_FORMAT_INT32   );
const VAD geoxl::VERTEX_CHANNEL_VAD_NORMAL						= mVAD( VERTEX_CHANNEL_NAME_NORMAL,					   3, VAD::DATA_FORMAT_FLOAT32 );
const VAD geoxl::VERTEX_CHANNEL_VAD_COLOR						= mVAD( VERTEX_CHANNEL_NAME_COLOR,					   3, VAD::DATA_FORMAT_FLOAT32 );
const VAD geoxl::VERTEX_CHANNEL_VAD_INTENSITY					= mVAD( VERTEX_CHANNEL_NAME_INTENSITY,				   1, VAD::DATA_FORMAT_FLOAT32 );
const VAD geoxl::VERTEX_CHANNEL_VAD_TANGENT_U					= mVAD( VERTEX_CHANNEL_NAME_TANGENT_U,				   3, VAD::DATA_FORMAT_FLOAT32 );
const VAD geoxl::VERTEX_CHANNEL_VAD_TANGENT_V					= mVAD( VERTEX_CHANNEL_NAME_TANGENT_V,				   3, VAD::DATA_FORMAT_FLOAT32 );
const VAD geoxl::VERTEX_CHANNEL_VAD_SAMPLESPACING 			= mVAD( VERTEX_CHANNEL_NAME_SAMPLESPACING,		   1, VAD::DATA_FORMAT_FLOAT32 );
const VAD geoxl::VERTEX_CHANNEL_VAD_COVARIANCE 				= mVAD( VERTEX_CHANNEL_NAME_COVARIANCE,			   6, VAD::DATA_FORMAT_FLOAT32 );
const VAD geoxl::VERTEX_CHANNEL_VAD_LOCALMODELUNCERTAINTY  = mVAD( VERTEX_CHANNEL_NAME_LOCALMODELUNCERTAINTY, 1, VAD::DATA_FORMAT_FLOAT32 );
const VAD geoxl::VERTEX_CHANNEL_VAD_REFERENCE_POSITION		= mVAD( VERTEX_CHANNEL_NAME_REFERENCE_POSITION	 , 3, VAD::DATA_FORMAT_FLOAT32 );

const VAD geoxl::TRIANGLE_CHANNEL_VAD_INDEX 					= mVAD( TRIANGLE_CHANNEL_NAME_INDEX,					3, VAD::DATA_FORMAT_INT32   );

const VAD geoxl::TOPGRAPH_CHANNEL_VAD_VINDEX 					= mVAD( TOPGRAPH_CHANNEL_NAME_VINDEX,				   2, VAD::DATA_FORMAT_INT32   );
const VAD geoxl::TOPGRAPH_CHANNEL_VAD_COLOR 	 				= mVAD( TOPGRAPH_CHANNEL_NAME_COLOR,					4, VAD::DATA_FORMAT_FLOAT32 );


static VertexDescriptor make_position_flags_vDescr() {
	VertexDescriptor result;
	result.pushAttrib(mVAD("position", 3, VAD::DATA_FORMAT_FLOAT32));
	return result;
}
static VertexDescriptor make_position_normal_flags_vDescr() {
	VertexDescriptor result;
	result.pushAttrib(mVAD("position", 3, VAD::DATA_FORMAT_FLOAT32));
	result.pushAttrib(mVAD("normal", 3, VAD::DATA_FORMAT_FLOAT32));
	return result;
}
static VertexDescriptor make_position_normal_color_flags_vDescr() {
	VertexDescriptor result;
	result.pushAttrib(mVAD("position", 3, VAD::DATA_FORMAT_FLOAT32));
	result.pushAttrib(mVAD("normal", 3, VAD::DATA_FORMAT_FLOAT32));
	result.pushAttrib(mVAD("color", 3, VAD::DATA_FORMAT_FLOAT32));
	return result;
}
static VertexDescriptor make_index_triDescr() {
	VertexDescriptor result;
	result.pushAttrib(mVAD("index", 3, VAD::DATA_FORMAT_INT32));
	return result;
}
static VertexDescriptor make_vindex_topEdgeDescr() {
	VertexDescriptor result;
	result.pushAttrib(mVAD("vindex", 2, VAD::DATA_FORMAT_INT32));
	return result;
}
static VertexDescriptor make_vindex_color_topEdgeDescr() {
	VertexDescriptor result;
	result.pushAttrib(mVAD("vindex", 2, VAD::DATA_FORMAT_INT32));
	result.pushAttrib(mVAD("color", 4, VAD::DATA_FORMAT_FLOAT32));
	return result;
}


const VertexDescriptor geoxl::POSITION_FLAGS_VDESCR = make_position_flags_vDescr();
const VertexDescriptor geoxl::POSITION_NORMAL_FLAGS_VDESCR = make_position_normal_flags_vDescr();
const VertexDescriptor geoxl::POSITION_NORMAL_COLOR_FLAGS_VDESCR = make_position_normal_color_flags_vDescr();

const VertexDescriptor geoxl::INDEX_TRI_DESCR = make_index_triDescr();

const VertexDescriptor geoxl::VINDEX_TOPEDGE_DESCR = make_vindex_topEdgeDescr();
const VertexDescriptor geoxl::VINDEX_COLOR_TOPEDGE_DESCR = make_vindex_color_topEdgeDescr();
