//---------------------------------------------------------------------------
#ifndef TopologyAttachmentH
#define TopologyAttachmentH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
#include "RenderableObject.h"
//---------------------------------------------------------------------------


namespace geoxl {

class InCorePCTopologyGraph;
class PointCloud;


class POINTCLOUDS_API TopologyAttachment : public AttachedData, public RenderableObject {
	GEOXL_CLASS( TopologyAttachment )
	
 private:
   InCorePCTopologyGraph *topology;
   bool visible;
   float32 colorVisAmplification;
   float32 colorVisOffset;
   bool blending;
   bool displayColor;

 public:
	TopologyAttachment();

   virtual void assign(const Object* obj, CopyContext *context = NULL);

   // default name for attachment      
   static std::string getDefaultName() { return "TopologyAtt"; }
   
	void setTopology(InCorePCTopologyGraph *topology);
	InCorePCTopologyGraph *getTopology() {return topology;}
	/// like setTopology, but does not delete old object
	void swapTopology(InCorePCTopologyGraph *topology);
	
	bool getVisible() const {return visible;}
	void setVisible(bool v) {visible=v;}
	float32 getColorVisAmplification() const {return colorVisAmplification;}
	void setColorVisAmplification(float32 v) {colorVisAmplification=v;}
	float32 getColorVisOffset() const {return colorVisOffset;}
	void setColorVisOffset(float32 v) {colorVisOffset=v;}
	bool getBlending() const {return blending;}
	void setBlending(bool v) {blending=v;}

	virtual void renderGL(SceneObject *obj);
	virtual card32 getSize() const;


	~TopologyAttachment();
};


}

#endif