//---------------------------------------------------------------------------
#ifndef TriangleMeshToolsH
#define TriangleMeshToolsH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
#include "UnstructuredInCoreTriangleMesh.h"
//---------------------------------------------------------------------------

namespace geoxl {

	#define MESH_PARAMETERIZATION_MODE_SPHERE 0
	#define MESH_PARAMETERIZATION_MODE_PLANE 1
	#define MESH_PARAMETERIZATION_MODE_CYLINDER 2

	/// Compute normals for the mesh
	void POINTCLOUDS_API computeTriangleMeshNormals( UnstructuredInCoreTriangleMesh* mesh );
	/// Smooth out normals
	void POINTCLOUDS_API smoothTriangleMeshNormals( UnstructuredInCoreTriangleMesh* mesh, float32 sigma );
	/// Snap close vertices (attention naive implementation O(n^2))
	void POINTCLOUDS_API snapTriangleMeshMesh( UnstructuredInCoreTriangleMesh* mesh, const float32 maxDist );
	/// Parameterize a triangle mesh
	void POINTCLOUDS_API parameterizeTriangleMesh( 
		UnstructuredInCoreTriangleMesh* mesh, 
		const card32 mode, 
		const float32 textureRepeat = 1.0f, 
		bool pcaROT = true, 
		card32 coordIndex0 = 0, 
		card32 coordIndex1 = 1 );

}

#endif
