//---------------------------------------------------------------------------
#ifndef DirectionsMaterialH
#define DirectionsMaterialH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "GLMaterial.h"
//---------------------------------------------------------------------------

namespace geoxl {

///
///   A simple immediate mode material that draws points in point clouds as spheres
///
class RENDERING_API DirectionsMaterial : public GLMaterial {
	GEOXL_CLASS( DirectionsMaterial )
 private:
	string dir1Channel;
	Vector4f dir1Color;
	string dir2Channel;
	Vector4f dir2Color;
	string dir3Channel;
	Vector4f dir3Color;
	string dir4Channel;
	Vector4f dir4Color;
	string positionChannel;
	float32 scaling;
	bool normalizeDir;
	bool alphaBlending;

 public:
	DirectionsMaterial();

   virtual void assign(const Object* obj, CopyContext *context = NULL);

   virtual void draw(Scene *scene, SceneGraphState *state, SceneObject *obj,
      SceneObjectIterator *iter, GLContext *context, MemoryManager * mm = NULL,
      const int32 includeFlags = 0, const int32 excludeFlags = PF_FLAG_INVALID );

	string getdir1Channel() const {return dir1Channel;}
	void setdir1Channel(string v) {dir1Channel=v;}

	Vector4f getdir1Color() const {return dir1Color;}
	void setdir1Color(Vector4f v) {dir1Color=v;}

	string getdir2Channel() const {return dir2Channel;}
	void setdir2Channel(string v) {dir2Channel=v;}

	Vector4f getdir2Color() const {return dir2Color;}
	void setdir2Color(Vector4f v) {dir2Color=v;}

	string getdir3Channel() const {return dir3Channel;}
	void setdir3Channel(string v) {dir3Channel=v;}

	Vector4f getdir3Color() const {return dir3Color;}
	void setdir3Color(Vector4f v) {dir3Color=v;}

	string getdir4Channel() const {return dir4Channel;}
	void setdir4Channel(string v) {dir4Channel=v;}

	Vector4f getdir4Color() const {return dir4Color;}
	void setdir4Color(Vector4f v) {dir4Color=v;}

	string getpositionChannel() const {return positionChannel;}
	void setpositionChannel(string v) {positionChannel=v;}

	float32 getscaling() const {return scaling;}
	void setscaling(float32 v) {scaling=v;}

	bool getnormalize() const {return normalizeDir;}
	void setnormalize(bool v) {normalizeDir=v;}

	bool getalphaBlending() const {return alphaBlending;}
	void setalphaBlending(bool v) {alphaBlending=v;}

   ~DirectionsMaterial();
};

}

#endif