//---------------------------------------------------------------------------
#ifndef GLSimpleVolumeMaterialH
#define GLSimpleVolumeMaterialH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "GLMaterial.h"
#include "AttachedData.h"
//---------------------------------------------------------------------------

namespace geoxl {

class GLVolumeRenderer2DSlices;
class Tex2dVolumeRenderer;


///
///   simple volume renderer material
///
class RENDERING_API GLSimpleVolumeMaterial : public GLMaterial {
	GEOXL_CLASS( GLSimpleVolumeMaterial )
 private:
   GLVolumeRenderer2DSlices *renderer;
   
 public:
	GLSimpleVolumeMaterial();

	virtual void assign(const Object* obj, CopyContext *context = NULL);

   virtual void draw( Scene *scene, SceneGraphState *state, SceneObject *obj,
      SceneObjectIterator *iter, GLContext *context, MemoryManager *mm = NULL,
      const int32 includeFlags = 0, const int32 excludeFlags = PF_FLAG_INVALID );

   ~GLSimpleVolumeMaterial();
};


class TextureStackAttachment : public AttachedData {
   GEOXL_CLASS(TextureStackAttachment)
 public:
   Tex2dVolumeRenderer *texStack;
   float32 minVal;
   float32 maxVal;
   string channel;
};

}

#endif