//---------------------------------------------------------------------------
#ifndef GLVolumeMaterialGeneralH
#define GLVolumeMaterialGeneralH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "GLMaterial.h"
//---------------------------------------------------------------------------

namespace geoxl
{

class RENDERING_API GLVolumeMaterialGeneral : public GLMaterial
{
	GEOXL_CLASS( GLVolumeMaterialGeneral )
 private:
	Shader *         m_VertexShader;
	Shader *         m_PixelShader;
	GLTexture3D *    m_Texture3D;

 public:

   GLVolumeMaterialGeneral();

   virtual ~GLVolumeMaterialGeneral();

   virtual void draw( Scene * scene, SceneGraphState *state, SceneObject * obj,
      SceneObjectIterator *iter, GLContext * context, MemoryManager * mm = NULL,
      const int32 includeFlags = 0, const int32 excludeFlags = PF_FLAG_INVALID ); //???

   virtual void assign(const Object* obj, CopyContext *context=NULL );
};

}

#endif

