#ifndef InterpFunctionTextureAttachmentRGBH
#define InterpFunctionTextureAttachmentRGBH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "MaterialAttachment.h"
//---------------------------------------------------------------------------

namespace geoxl
{
class InterpFunctionTextureAttachment;
class InterpFunctionTextureAttachmentRGBEditorWidget;

/**
	combines three interpolation function into a rgb texture
*/
class RENDERING_API InterpFunctionTextureAttachmentRGB : public TextureAttachment
{
	GEOXL_CLASS( InterpFunctionTextureAttachmentRGB )

private:

	InterpFunctionTextureAttachment * m_Functions[3];
	card32		m_TextureResolution;

	friend		InterpFunctionTextureAttachmentRGBEditorWidget;


public:
	InterpFunctionTextureAttachmentRGB(void);
	~InterpFunctionTextureAttachmentRGB(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

   virtual card32 getTextureType() const  {return TYPE_2D; }
   virtual GLTexture * createGLTexture(GLContext * context);

   vector<card32> createImage( card32 dimX, card32 dimY );

   void setHistogram( const vector<float> &histogram);


};

}

#endif