//---------------------------------------------------------------------------
#ifndef LCHierarchyRendererH
#define LCHierarchyRendererH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Renderer.h"
#include "LCTraversal.h"
//---------------------------------------------------------------------------

namespace geoxl {

class MemoryManager;
class StandardSceneGraphIterator;

extern card32 RENDERING_API GLOBAL_VAR_LCHierarchyRenderer_numNodesRendered;
extern card32 RENDERING_API GLOBAL_VAR_LCHierarchyRenderer_numPointsRendered;


class RENDERING_API LCHierarchyRenderer: public Renderer {
 private:
   static MetaClass *LCHierarchyRendererMetaClass;
   static Object* newInstance();

   LCTraversal *lcTrav;
   MemoryManager *memManager;
   
   void renderRecursive(StandardSceneGraphIterator &sceneIt, card32 viewportWidth, card32 viewportHeight);

 public:

   LCHierarchyRenderer();

   static const int CREATE_NOGLSTATECHANGE = 1;
   LCHierarchyRenderer( int createType );

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void connect(Scene* scene, GLContext* ctxt);
   virtual void render(card32 viewportWidth, card32 viewportHeight);
   virtual void disconnect(GLContext* ctxt);

	virtual void setUseBBSelection(bool b);
	
	~LCHierarchyRenderer();
};


}

#endif
