//---------------------------------------------------------------------------
#include "stdafx.h"
 
//---------------------------------------------------------------------------
#include "MPContainer.h"
//---------------------------------------------------------------------------
#include "MaterialParameter.h"
#include "ObjectListProperty.h"
#include "pAssert.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace std;
using namespace geoxl;
//---------------------------------------------------------------------------



MetaClass* MPContainer::MPContainerMetaClass = NULL;

const MetaClass* MPContainer::getInstanceClass() const {
   return getClass();
}

Object* MPContainer::newInstance() {
   return new MPContainer;
}

const MetaClass* MPContainer::getClass() {
   if (MPContainerMetaClass==NULL) {
      MPContainerMetaClass = new MetaClass("MPContainer", "no description.",
                                  newInstance, sizeof(MPContainer));
   }
   return MPContainerMetaClass;
}

void MPContainer::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   MPContainerMetaClass->copyParentProperties();

	ADD_OBJECT_LIST_PROP( Parm, 0, MaterialParameter::getClass() );

}

void MPContainer::shutdown() {
   delete MPContainerMetaClass;
}


// ----

MPContainer::~MPContainer()
{
   for( card32 i=0;i<m_Parms.size();i++ )
      delete m_Parms[i];
   m_Parms.clear();
}
void MPContainer::assign(const Object* obj, CopyContext *context )
{
   const MPContainer * mpc = dynamic_cast<const MPContainer *>(obj);
   pAssert( mpc != NULL );

   m_Parms.clear();
   for( card32 i=0;i<mpc->m_Parms.size();i++ )
   {
      m_Parms.push_back( (MaterialParameter*)mpc->m_Parms[i]->copy() );
   }

   forget(context);
}


void MPContainer::addParm( Object * obj )
{
   m_Parms.push_back( (MaterialParameter*)obj );
}

void MPContainer::deleteParms(card32 begin, card32 end )
{
   for( card32 i=begin;i<end;i++ )
   {
      delete m_Parms[i];
   }
   m_Parms.erase( m_Parms.begin() + begin, m_Parms.begin() + end );
}

Object * MPContainer::getParm( card32 index )
{
   return m_Parms[index];
}

void MPContainer::moveParm( card32 oldPos, card32 newPos )
{
   if( oldPos != newPos )
   {
      MaterialParameter * p = m_Parms[oldPos];
      m_Parms.erase( m_Parms.begin() + oldPos );
      m_Parms.insert( m_Parms.begin() + newPos, p );
   }
}

string MPContainer::getParmName(card32 index )
{
   return m_Parms[index]->getInstanceClass()->getClassName() + " - " + m_Parms[index]->getName();
}

