//---------------------------------------------------------------------------
#ifndef MPContainerH
#define MPContainerH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
#include "ObjectListBase.h"
//---------------------------------------------------------------------------
#include <vector>
//---------------------------------------------------------------------------

namespace geoxl {
   using namespace std;

class MaterialParameter;


class RENDERING_API MPContainer : public Persistent
{
private:
   static MetaClass *MPContainerMetaClass;
   static Object* newInstance();

public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

/// ObjectList access methods:
   void addParm( Object * obj );
   void deleteParms( card32 begin, card32 end );
   Object * getParm( card32 index );
   void moveParm( card32 oldPos, card32 newPos );
   mpcard getNumParms() {return m_Parms.size(); }
   string getParmName(card32 index );

   virtual void assign(const Object* obj, CopyContext *context=NULL );


private:

   vector<MaterialParameter*>    m_Parms;

public:

   MPContainer() : Persistent()
   {
   }

   virtual ~MPContainer();

};


}

#endif
 