//---------------------------------------------------------------------------
#include "stdafx.h"
 
//---------------------------------------------------------------------------
#include "MaterialParameter.h"
//---------------------------------------------------------------------------
#include "NumericalClassProperty.h"
#include "NumericalClassProperty_templCode.h"
#include "FixedArrayClassProperty.h"
#include "StringClassProperty.h"
#include "BooleanClassProperty.h"
#include "ObjectClassProperty.h"
#include "AttachedData.h"
#include "GLContext.h"
#include "GLShader.h"
#include "GLTexture.h"
#include "GLMaterial.h"
#include "GLShaderMaterial.h"
#include "GLAttachments.h"
#include "Scene.h"
#include "SceneObject.h"
#include "SceneObjectIterator.h"
#include "MaterialAttachment.h"
#include "MemoryManager.h"
#include "MaterialAttachment.h"
#include "RenderTextureAttachment.h"
#ifndef _DEBUG
#include "LinearAlgebra_templCode.h"
#endif
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



MetaClass* MaterialParameter::MaterialParameterMetaClass = NULL;

const MetaClass* MaterialParameter::getInstanceClass() const {
   return getClass();
}

const MetaClass* MaterialParameter::getClass() {
   if (MaterialParameterMetaClass==NULL) {
      MaterialParameterMetaClass = new MetaClass("MaterialParameter", "no description.",
                                  NULL, sizeof(MaterialParameter));
   }
   return MaterialParameterMetaClass;
}

void MaterialParameter::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   MaterialParameterMetaClass->copyParentProperties();
	BEGIN_CLASS_INIT(MaterialParameter)
	ADD_STRING_PROP(m_Name,0)
	ADD_BOOLEAN_PROP(m_UseGlobalFirst,0)
	ADD_BOOLEAN_PROP(m_UseDefault,0)
		
}

void MaterialParameter::shutdown() {
   delete MaterialParameterMetaClass;
}


// ----

MetaClass* MPMatrix4x4::MPMatrix4x4MetaClass = NULL;

const MetaClass* MPMatrix4x4::getInstanceClass() const {
   return getClass();
}

Object* MPMatrix4x4::newInstance() {
   return new MPMatrix4x4;
}

const MetaClass* MPMatrix4x4::getClass() {
   if (MPMatrix4x4MetaClass==NULL) {
      MPMatrix4x4MetaClass = new MetaClass("MPMatrix4x4", "no description.",
                                  newInstance, sizeof(MPMatrix4x4));
   }
   return MPMatrix4x4MetaClass;
}

void MPMatrix4x4::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   MPMatrix4x4MetaClass->copyParentProperties();
	BEGIN_CLASS_INIT(MPMatrix4x4)
	ADD_CARD32_PROP(m_Index,0)
	ADD_FLOAT32_FIXED_ARRAY_PROP(m_DefaultMatrix,0 , 16, 4)
}

void MPMatrix4x4::shutdown() {
   delete MPMatrix4x4MetaClass;
}


// ----



MetaClass* MPVector4::MPVector4MetaClass = NULL;

const MetaClass* MPVector4::getInstanceClass() const {
   return getClass();
}

Object* MPVector4::newInstance() {
   return new MPVector4;
}

const MetaClass* MPVector4::getClass() {
   if (MPVector4MetaClass==NULL) {
      MPVector4MetaClass = new MetaClass("MPVector4", "no description.",
                                  newInstance, sizeof(MPVector4));
   }
   return MPVector4MetaClass;
}

void MPVector4::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   MPVector4MetaClass->copyParentProperties();
	BEGIN_CLASS_INIT(MPVector4)
	ADD_CARD32_PROP(m_Index,0)
	ADD_FLOAT32_FIXED_ARRAY_PROP(m_DefaultVector,0 , 4, 4)
   ADD_BOOLEAN_PROP(m_ClampMin ,0)
	ADD_FLOAT32_FIXED_ARRAY_PROP(m_MinVector ,0 , 4, 4)
   ADD_BOOLEAN_PROP(m_ClampMax ,0)
	ADD_FLOAT32_FIXED_ARRAY_PROP(m_MaxVector ,0 , 4, 4)
}

void MPVector4::shutdown() {
   delete MPVector4MetaClass;
}


// ----

MetaClass* MPTexture::MPTextureMetaClass = NULL;

const MetaClass* MPTexture::getInstanceClass() const {
   return getClass();
}

Object* MPTexture::newInstance() {
   return new MPTexture;
}

const MetaClass* MPTexture::getClass() {
   if (MPTextureMetaClass==NULL) {
      MPTextureMetaClass = new MetaClass("MPTexture", "no description.",
                                  newInstance, sizeof(MPTexture));
   }
   return MPTextureMetaClass;
}

void MPTexture::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 1);
   MPTextureMetaClass->copyParentProperties();
	BEGIN_CLASS_INIT(MPTexture)
	ADD_CARD32_PROP(m_TextureStage,0)
	ADD_STRING_PROP(m_DefaultTextureName,0)
	ADD_OBJECT_PROP(m_DefaultTexture,1, TextureAttachment::getClass(), true );

}

void MPTexture::shutdown() {
   delete MPTextureMetaClass;
}


// ----

MetaClass* MPSingleFloat::MPSingleFloatMetaClass = NULL;

const MetaClass* MPSingleFloat::getInstanceClass() const {
   return getClass();
}

Object* MPSingleFloat::newInstance() {
   return new MPSingleFloat;
}

const MetaClass* MPSingleFloat::getClass() {
   if (MPSingleFloatMetaClass==NULL) {
      MPSingleFloatMetaClass = new MetaClass("MPSingleFloat", "no description.",
                                  newInstance, sizeof(MPSingleFloat));
   }
   return MPSingleFloatMetaClass;
}

void MPSingleFloat::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   MPSingleFloatMetaClass->copyParentProperties();
	BEGIN_CLASS_INIT(MPSingleFloat)
	ADD_FLOAT32_PROP(m_Minimum,0)
	ADD_FLOAT32_PROP(m_Maximum,0)
	ADD_FLOAT32_PROP(m_Interpolator,0)

}

void MPSingleFloat::shutdown() {
   delete MPSingleFloatMetaClass;
}


// ----

AttachedData * MaterialParameter::getData( GLMaterial * mat, Scene * scene, SceneObject * obj,
      SecondaryDataStructureIterator * iter )
{
   if( m_Name.length() == 0 )
      return NULL;

   AttachedData * ret = NULL;
   if( !m_UseGlobalFirst )
   {
      if( iter ) {
			AttachedDataContainer *attachments = iter->lockAttachments();
         ret = attachments->getData( m_Name );
         // todo: not ooc safe!
         iter->unlockAttachments();
      }
      if( ret )
         return ret;

      if( obj )
         ret = obj->getAttachments()->getData( m_Name );
      if( ret )
         return ret;

      if( scene )
         ret = scene->getAttachments()->getData( m_Name );

   }
   else
   {
      if( scene )
         ret = scene->getAttachments()->getData( m_Name );
      if( ret )
         return ret;

      if( obj )
         ret = obj->getAttachments()->getData( m_Name );
      if( ret )
         return ret;

      if( iter ) {
			AttachedDataContainer *attachments = iter->lockAttachments();
         ret = attachments->getData( m_Name );
         // todo: not ooc safe!
         iter->unlockAttachments();
      }
   }

   forget(mat);
   return ret;
}

void MaterialParameter::assign(const Object* obj, CopyContext *context)
{
   MaterialParameter * p = (MaterialParameter*)obj;
   m_Name = p->m_Name;
   m_UseGlobalFirst = p->m_UseGlobalFirst;
   m_UseDefault = p->m_UseDefault;
   forget(context);
}

void MPMatrix4x4::assign(const Object* obj, CopyContext *context )
{
   MaterialParameter::assign( obj, context );

   MPMatrix4x4 * p = (MPMatrix4x4*)obj;
   memcpy( m_DefaultMatrix, p->m_DefaultMatrix, sizeof(float32)*4*4 );
   m_Index = p->m_Index;
}

void MPMatrix4x4::set( GLMaterial * mat, Scene * scene, SceneObject * obj,
      SceneObjectIterator * iter, GLContext * context, MemoryManager * mm )
{
   GLShaderMaterial * shMat = dynamic_cast<GLShaderMaterial*>(mat);
   pAssert( shMat != NULL );

   SecondaryDataStructureIterator * dataIter =
      dynamic_cast<SecondaryDataStructureIterator *>( iter );
   pAssert( dataIter != NULL );

   Matrix4fAttachment * matAttachment = dynamic_cast<Matrix4fAttachment*>( getData( mat, scene, obj, dataIter ) );

   Matrix4f matrix = IDENTITY4F;

   if( matAttachment != NULL )
   {
		matrix = matAttachment->getMatrix();
      shMat->getGLVertexShader(context)->setMatrix4f( getName(), m_Index, &matrix[0][0]);
      shMat->getGLPixelShader(context)->setMatrix4f( getName(), m_Index, &matrix[0][0] );
   }
   else
   {
      if( getUseDefault() )
      {
         shMat->getGLVertexShader(context)->setMatrix4f( getName(), m_Index, m_DefaultMatrix );
         shMat->getGLPixelShader(context)->setMatrix4f( getName(), m_Index, m_DefaultMatrix );
      }
		else
		{
	      shMat->getGLVertexShader(context)->setMatrix4f( getName(), m_Index, &matrix[0][0] );
		   shMat->getGLPixelShader(context)->setMatrix4f( getName(), m_Index, &matrix[0][0] );
		}
	}

   forget(scene);
   forget(obj);
   forget(iter);
   forget(context);
   forget(mm);
}

void MPVector4::assign(const Object* obj, CopyContext *context )
{
   MaterialParameter::assign( obj, context );
   MPVector4 * p = (MPVector4*)obj;
   m_Index = p->m_Index;
   m_ClampMin = p->m_ClampMin;
   m_ClampMax = p->m_ClampMax;
   memcpy( m_DefaultVector, p->m_DefaultVector, sizeof(float32)*4 );
   memcpy( m_MinVector, p->m_MinVector, sizeof(float32)*4 );
   memcpy( m_MaxVector, p->m_MaxVector, sizeof(float32)*4 );

}

void MPVector4::set( GLMaterial * mat, Scene * scene, SceneObject * obj,
      SceneObjectIterator * iter, GLContext * context, MemoryManager * mm )
{
   GLShaderMaterial * shMat = dynamic_cast<GLShaderMaterial*>(mat);
   pAssert( shMat != NULL );

   SecondaryDataStructureIterator * dataIter =
      dynamic_cast<SecondaryDataStructureIterator *>( iter );
   pAssert( dataIter != NULL );

   Vector4fAttachment * vecAttachment = dynamic_cast<Vector4fAttachment*>( getData( mat, scene, obj, dataIter ) );

   ShaderConstant vec( getName(), m_Index, 4 );
   bool setConstant = true;
	Vector4f param;
	card32 numComponentsUsed = 4;

   if( vecAttachment != NULL )
   {
       vec.setData( &vecAttachment->getVector()[0] );
		 param = vecAttachment->getVector();
		 numComponentsUsed = vecAttachment->getNumComponentsUsed();
   }
   else
   {
      if( getUseDefault() )
      {
          vec.setData( m_DefaultVector );
			 param = makeVector4f(m_DefaultVector[0], m_DefaultVector[1],
				 m_DefaultVector[2],m_DefaultVector[3]);
      }
      else
         setConstant = false;
   }

   if( setConstant )
   {
      GLShaderCG *vs,*ps;
		vs = dynamic_cast<GLShaderCG*>(shMat->getGLVertexShader(context));
		ps = dynamic_cast<GLShaderCG*>(shMat->getGLPixelShader(context));

		if( vs != NULL )
			vs->setParameterxf( getName(), numComponentsUsed, &param[0] );
		else
			shMat->getGLVertexShader(context)->setConstant( vec );
   
		if( ps != NULL )
			ps->setParameterxf( getName(), numComponentsUsed, &param[0] );
		else
			shMat->getGLPixelShader(context)->setConstant( vec );

   }
   forget(context);
   forget(mm);
}

MPTexture::~MPTexture()
{
	delete m_DefaultTexture;
}


void MPTexture::assign(const Object* obj, CopyContext *context)
{
   MaterialParameter::assign( obj, context );
   MPTexture * tex = (MPTexture*)obj;
   m_DefaultTextureName = tex->m_DefaultTextureName;
   m_TextureStage = tex->m_TextureStage;
   //m_AttachmentContainer->clear();
	delete m_DefaultTexture;
	m_DefaultTexture = NULL;
	if( tex->m_DefaultTexture )
	{
		m_DefaultTexture = (TextureAttachment*)tex->m_DefaultTexture->copy();
	}
}

void MPTexture::set( GLMaterial * mat, Scene * scene, SceneObject * obj,
      SceneObjectIterator * iter, GLContext * context, MemoryManager * mm )
{
   SecondaryDataStructureIterator * dataIter =
      dynamic_cast<SecondaryDataStructureIterator *>( iter );


	AttachedData * data = getData( mat, scene, obj, dataIter );
	if( (data==NULL) && getUseDefault() )
	{
		data = scene->getAttachments()->getData( m_DefaultTextureName );
	}

	RenderTextureAttachment * rta = dynamic_cast<RenderTextureAttachment*>(data);
   TextureAttachment * texAtt = dynamic_cast<TextureAttachment*>( data );

	if( rta )
	{
		// simple bind render texture
		// no context check done here
		rta->bind( m_TextureStage );
		return;
	}

	if( texAtt == NULL )
	{
       texAtt = m_DefaultTexture;

	}


   if( texAtt )
   {
      //texAtt->update();

      // try to reuse existing gl texture
      string texID = GLTextureAttachment::generateID( context->getRootContext(), "" );
      GLTextureAttachment * glTexAtt = dynamic_cast<GLTextureAttachment*>(
         texAtt->fetchData( texID ) );


      if( glTexAtt )
      {
         // bind existing gl texture
         pAssert( glTexAtt->getTexture() );
         glTexAtt->getTexture()->bind( m_TextureStage );
      }
      else
      {
         // create gl texture & bind it
         glTexAtt = new GLTextureAttachment;

         GLTexture * texture = texAtt->createGLTexture( context );
         glTexAtt->setupTA( texture, "", mm, true );
         texAtt->attachData( glTexAtt );

         texture->bind( m_TextureStage );
      }
   }

}

void MPSingleFloat::set( GLMaterial * mat, Scene * scene, SceneObject * obj,
      SceneObjectIterator * iter, GLContext * context, MemoryManager * mm )
{
   GLShaderMaterial * shMat = dynamic_cast<GLShaderMaterial*>(mat);
   pAssert( shMat != NULL );

   GLShaderCG * vs = dynamic_cast<GLShaderCG*>( shMat->getGLVertexShader(context) );
   GLShaderCG * ps = dynamic_cast<GLShaderCG*>( shMat->getGLPixelShader(context) );

   float value = m_Minimum + m_Interpolator * (m_Maximum - m_Minimum);

   if( vs )
      vs->setParameter1f( getName(), value );
   if( ps )
      ps->setParameter1f( getName(), value );

   forget(scene);
   forget(obj);
   forget(iter);
   forget(mm);
}



