//---------------------------------------------------------------------------
#include "stdafx.h"
 
//---------------------------------------------------------------------------
#include "RGBATextureAttachment.h"
//---------------------------------------------------------------------------
//#include "TextureAttachmentEditorFrames.h"
#include "GLContext.h"
#include "GLTexture.h"
#include "RGBAImage.h"
#include "ObjectClassProperty.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



MetaClass* RGBATextureAttachment::RGBATextureAttachmentMetaClass = NULL;

const MetaClass* RGBATextureAttachment::getInstanceClass() const {
   return getClass();
}

Object* RGBATextureAttachment::newInstance() {
   return new RGBATextureAttachment;
}

const MetaClass* RGBATextureAttachment::getClass() {
   if (RGBATextureAttachmentMetaClass==NULL) {
      RGBATextureAttachmentMetaClass = new MetaClass("RGBATextureAttachment", "no description.",
                                  newInstance, sizeof(RGBATextureAttachment));
   }
   return RGBATextureAttachmentMetaClass;
}

void RGBATextureAttachment::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 1);
   RGBATextureAttachmentMetaClass->copyParentProperties();
   BEGIN_CLASS_INIT(RGBATextureAttachment)
	ADD_OBJECT_PROP(m_Image,0, RGBAImage::getClass(), true )
	ADD_OBJECT_PROP(m_Settings,0, RGBAImage::getClass(), true )
}

void RGBATextureAttachment::shutdown() {
   delete RGBATextureAttachmentMetaClass;
}


// ----


RGBATextureAttachment::RGBATextureAttachment()
{
   m_Image = new RGBAImage;
	m_Image->resize(1,1);
   m_Settings = new GLTextureSettings;
}

RGBATextureAttachment::~RGBATextureAttachment()
{
   delete m_Image;
   delete m_Settings;
}

GLTexture * RGBATextureAttachment::createGLTexture(GLContext * context)
{
   GLTexture2D * ret = new GLTexture2D( context );
   ret->createFromImage( *m_Image, true );
   ret->bind( *m_Settings, 0 );
   return ret;
}

void RGBATextureAttachment::assign(const Object* obj, CopyContext *context)
{
   TextureAttachment::assign( obj, context );
   RGBATextureAttachment * ta =  (RGBATextureAttachment*)obj;
   m_Settings->assign( ta->m_Settings );
   m_Image->assign( ta->m_Image );
}


void RGBATextureAttachment::createFromImage( RGBAImage * image ) 
{
	m_Image->assign( image );
	clearAttachments();
}
