//---------------------------------------------------------------------------
#ifndef TextureAttachmentH
#define TextureAttachmentH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "MaterialAttachment.h"
//---------------------------------------------------------------------------

namespace geoxl {

class RGBAImage;
class GLTextureSettings;


class RENDERING_API RGBATextureAttachment : public TextureAttachment
{
private:
   static MetaClass *RGBATextureAttachmentMetaClass;
   static Object* newInstance();

public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   RGBATextureAttachment();
   virtual ~RGBATextureAttachment();

   virtual card32 getTextureType() const {return TYPE_2D; }
   virtual GLTexture * createGLTexture(GLContext * context);
//   virtual bool needsUpdate() {return false;}

   void createFromImage( RGBAImage * image );
	RGBAImage * getImage() {return m_Image;}
   GLTextureSettings * getSettings() {return m_Settings;}

   virtual void assign(const Object* obj, CopyContext *context);

private:

   RGBAImage * m_Image;
   GLTextureSettings * m_Settings;

// TODO!
//   card32 m_MagFilter;


};

}
#endif
 