#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "RenderTextureAttachment.h"
//---------------------------------------------------------------------------
#include "GLRenderTextureFBO.h"
//---------------------------------------------------------------------------
using namespace geoxl;

IMPLEMENT_GEOXL_CLASS( RenderTextureAttachment ,0)
{
	BEGIN_CLASS_INIT( RenderTextureAttachment );
}

RenderTextureAttachment::RenderTextureAttachment(void)
{
	m_RenderTexture = NULL;
}

RenderTextureAttachment::~RenderTextureAttachment(void)
{
}

void RenderTextureAttachment::assign(const Object* obj, CopyContext *context)
{
	AttachedData::assign(obj,context);
	const RenderTextureAttachment * o = dynamic_cast<const RenderTextureAttachment*>(obj);
	pAssert( o != NULL );

	m_RenderTexture = o->m_RenderTexture;
}

void RenderTextureAttachment::bind(int stage )
{
	if( m_RenderTexture->isBound() )
		m_RenderTexture->unbind();
	m_RenderTexture->bind(stage);
}


void RenderTextureAttachment::unbind() 
{
	m_RenderTexture->unbind();
}
