#ifndef RenderTextureAttachmentH
#define RenderTextureAttachmentH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
//---------------------------------------------------------------------------

namespace geoxl
{

class GLRenderTextureFBO;

/**
	holds a render texture and provides bind()/unbind()
*/
class RENDERING_API RenderTextureAttachment : public AttachedData
{
	GEOXL_CLASS( RenderTextureAttachment )

private:

	GLRenderTextureFBO	*	m_RenderTexture;

public:
	RenderTextureAttachment(void);
	~RenderTextureAttachment(void);

   virtual void assign(const Object* obj, CopyContext *context = NULL);

	void setRenderTexture( GLRenderTextureFBO * rt ) {m_RenderTexture = rt;}

	void bind( int stage = 0);
	void unbind();

};

}

#endif