//---------------------------------------------------------------------------
#ifndef RenderingRoutinesH
#define RenderingRoutinesH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PTypes.h"
//---------------------------------------------------------------------------

namespace geoxl {


class Scene;
class Renderer;
class RGBAImage;
class GLContext;
class GLRenderTextureFBO;


/// render image from render texture
RENDERING_API RGBAImage *createImage(GLRenderTextureFBO *rt, Scene *scene, Renderer *renderer, bool disconnectRenderer = true);

/// render image, creates render texture internally (repeated calls are less efficient due to render texture creation overhead)
RENDERING_API RGBAImage *createImage(GLContext *mainContext, Scene *scene, Renderer *renderer,
                               card32 width, card32 height);


}


#endif
