//---------------------------------------------------------------------------
#ifndef SimpleGLTriMeshMaterialH
#define SimpleGLTriMeshMaterialH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "GLMaterial.h"
//---------------------------------------------------------------------------

namespace geoxl {


class SimpleGLTriMeshMaterial : public GLMaterial {
 private:
   static MetaClass *SimpleGLTriMeshMaterialMetaClass;
   static Object* newInstance();

   bool wireframe;
   bool showNormals;
   float normalLength;
   bool colorizeNormal;
   bool useVertexNormals;
   bool showWireFrameOnly;
   bool showWireFrameOnly_depthTest;
   bool blackWireFrame;
	bool showBorder;
	bool cullBackFace;
	bool intensityPerFace;
	float32 intensityThreshold;

 public:
   SimpleGLTriMeshMaterial();

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void draw( Scene * scene, SceneGraphState *state, SceneObject * cloud,
      SceneObjectIterator *iter, GLContext * context, MemoryManager * mm = NULL,
      const int32 includeFlags = 0, const int32 excludeFlags = PF_FLAG_INVALID );

};


}

#endif
