//---------------------------------------------------------------------------
#ifndef SimplePCMaterialH
#define SimplePCMaterialH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "GLMaterial.h"
//---------------------------------------------------------------------------

namespace geoxl {

class SimplePCMaterial;


class RENDERING_API GLImModePtsRenderObject : public GLRenderObject {
 private:
   static MetaClass *GLImModePtsRenderObjectMetaClass;
   static Object* newInstance();

   PointSet *ps;

 public:
   GLImModePtsRenderObject();
   GLImModePtsRenderObject(PointSet *ps);

   void setPointSet(PointSet *ps);

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual ~GLImModePtsRenderObject();

};



class RENDERING_API SimplePCMaterial : public GLMaterial {
 private:
   static MetaClass *SimplePCMaterialMetaClass;
   static Object* newInstance();

   bool immediateMode;
   bool showColors;
   bool showNormals;
   card32 pointSize;
   bool drawQuads;
   bool drawNormals;
   float normalLength;
   bool drawTangents;

   void intern_drawImmediateMode( GLContext * ctxt, const PointSet * ps, const int32 includeFlags, const int32 excludeFlags );
   void intern_drawNormals( GLContext * ctxt, const PointSet * ps, const int32 includeFlags, const int32 excludeFlags );

 public:
   SimplePCMaterial();
   virtual ~SimplePCMaterial(){};

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void draw( Scene * scene, SceneGraphState *state, SceneObject * cloud,
      SceneObjectIterator *iter, GLContext * context, MemoryManager * mm = NULL,
      const int32 includeFlags = 0, const int32 excludeFlags = PF_FLAG_INVALID );


 friend GLImModePtsRenderObject;
};



}

#endif

