//---------------------------------------------------------------------------
#ifndef TwoPassBlendingRendererH
#define TwoPassBlendingRendererH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Renderer.h"
#include "VariableArrayClassProperty.h"
//---------------------------------------------------------------------------

namespace geoxl {

class LCHierarchyRenderer;
class GLRenderTextureFBO;
class GLContext;
class GLShaderCG;
class GLRenderTextureCache;

class TwoPassBlendingRenderer : public Renderer {
 private:

	 GEOXL_CLASS( TwoPassBlendingRenderer );

   LCHierarchyRenderer *depthPassRenderer;
   LCHierarchyRenderer *imagePassRenderer;

   GLRenderTextureFBO *  m_RenderTarget;
   GLContext      *  m_Context;
   GLShaderCG     *  m_ShaderV,*  m_ShaderF;
   Scene          *  m_Scene;

	GLRenderTextureCache	* m_RTCache;

	bool				m_MultiPassSplattingMode;	// splats into multiple textures
	vector<unsigned> m_AttributeMaterial;
	GLShaderMaterial * m_CombineMaterial;
	GLShaderMaterial * m_DrawTextureMaterial;


	IMPLEMENT_VAR_ARRAY_METHODS_STL( m_AttributeMaterial );

	void renderMultiPass(card32 viewportWidth, card32 viewportHeight);


 public:
   TwoPassBlendingRenderer();

   virtual void connect(Scene* scene, GLContext* ctxt);
   virtual void render(card32 viewportWidth, card32 viewportHeight);
   virtual void disconnect(GLContext* ctxt);

   ~TwoPassBlendingRenderer();
};


}

#endif
