#ifndef InterpFunctionTextureAttachmentEditorWidgetH 
#define InterpFunctionTextureAttachmentEditorWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "InterpFunctionTextureAttachmentEditorForm_ui.h"
#include "BoundingBox.h"
//---------------------------------------------------------------------------

namespace geoxl
{
	using namespace std;

class InterpFunctionTextureAttachment;

class RENDERING_API InterpFunctionTextureAttachmentEditorWidget : public QWidget
{
	Q_OBJECT

private:

	InterpFunctionTextureAttachment	*	m_Object;

	///used to access buttons, etc. from QtDesigner
	Ui_InterpFunctionTextureAttachmentEditorForm ui;

	QPoint	m_LastPos;
	card32	m_SelectedPoint;
	QImage	m_Image;
	BoundingBox2f	m_Zoom;

	Vector2f viewToObject( const QPoint &p) const;
	QPoint objectToView( const Vector2f &p) const;

	enum EMode
	{
		Mode_None,
		Mode_Move
	};

	EMode m_Mode;

public:
	InterpFunctionTextureAttachmentEditorWidget(QWidget * parent = NULL, Qt::WFlags f=0);
	~InterpFunctionTextureAttachmentEditorWidget(void);

	void setup( InterpFunctionTextureAttachment * obj );

	/// update editor content with object data
	void updateEditor();

protected:

	virtual void mouseMoveEvent ( QMouseEvent * event );
	virtual void mousePressEvent ( QMouseEvent * event );
	virtual void mouseReleaseEvent ( QMouseEvent * event );

	virtual void paintEvent ( QPaintEvent * event );
	virtual void resizeEvent ( QResizeEvent * event );

};

MAKE_CLASS_EDITOR( RENDERING_API , InterpFunctionTextureAttachment )


}

#endif