#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "InterpFunctionTextureAttachmentRGBEditorWidget.h"
//---------------------------------------------------------------------------
#include "InterpFunctionTextureAttachmentRGB.h"
#include "InterpFunctionTextureAttachment.h"
#include <qtGui/QPainter>
//---------------------------------------------------------------------------
using namespace geoxl;

IMPLEMENT_CLASS_EDITOR( InterpFunctionTextureAttachmentRGB )

InterpFunctionTextureAttachmentRGBEditorWidget::InterpFunctionTextureAttachmentRGBEditorWidget(QWidget * parent, Qt::WFlags f)
:QWidget(parent,f)
{
	//call ui.setupUi(this) to set up the layout from QtDesigner
	ui.setupUi(this);
	//Example: easy access to QtDesigner buttons, etc. by ui object
	//QWidget::connect(ui.loadButton,SIGNAL(clicked()),this,SLOT(sltLoadFile()));

	for( card32 i=0;i<3;i++ )
	{
		m_Editors[i] = NULL;
	}
	QVBoxLayout* t1=new QVBoxLayout;
	t1->setMargin(0);
	t1->setSpacing(0);
	ui.interpEditorFrame1->setLayout(t1);
	QVBoxLayout* t2=new QVBoxLayout;
	t2->setMargin(3);
	t2->setSpacing(0);
	ui.interpEditorFrame2->setLayout(t2);
	QVBoxLayout* t3=new QVBoxLayout;
	t3->setMargin(3);
	t3->setSpacing(0);
	ui.interpEditorFrame3->setLayout(t3);
}

InterpFunctionTextureAttachmentRGBEditorWidget::~InterpFunctionTextureAttachmentRGBEditorWidget(void)
{
	for( card32 i=0;i<3;i++ )
	{
		delete m_Editors[i];
	}
}

void InterpFunctionTextureAttachmentRGBEditorWidget::setup( InterpFunctionTextureAttachmentRGB * obj )
{
	m_Object = obj;
	QFrame * frames[3];
	frames[0] = ui.interpEditorFrame1;
	frames[1] = ui.interpEditorFrame2;
	frames[2] = ui.interpEditorFrame3;
	for( card32 i=0;i<3;i++ )
	{
		m_Editors[i] = (ClassEditor*)obj->m_Functions[i]->getInstanceClass()->getGUIDescriptor()->getDefaultClassEditor()->newInstance();
		QWidget * tmpWidget = m_Editors[i]->makeEditor(this,obj->m_Functions[i]);
		tmpWidget->setParent(frames[i]);
		frames[i]->layout()->addWidget(tmpWidget);
	}
}

void InterpFunctionTextureAttachmentRGBEditorWidget::updateEditor()
{
}

#include "InterpFunctionTextureAttachmentRGBEditorWidget_moc.cpp"

void InterpFunctionTextureAttachmentRGBEditorWidget::on_pbPreview_clicked() 
{
	QFrame * frame = ui.previewFrame;
	vector<card32> image = m_Object->createImage(frame->width(),frame->height());
	m_PreviewImage = QImage(frame->width(),frame->height(),QImage::Format_RGB32);
	for( card32 x=0;x<(card32)frame->width();x++)
	{
		for( card32 y=0;y<(card32)frame->height();y++)
		{
			card32 col = image[y*frame->width()+x];
			QColor qcol = QColor(col & 0xff,(col>>8) & 0xff,(col >> 16) & 0xff);
			m_PreviewImage.setPixel(x,y,qcol.rgb());
		}

	}
	update();
	m_Object->clearAttachments();
}

void InterpFunctionTextureAttachmentRGBEditorWidget::paintEvent( QPaintEvent * e) 
{
	QPainter painter(this);
	QRect frameRect;
	frameRect.setTopLeft( this->mapFromGlobal(ui.previewFrame->mapToGlobal(QPoint(0,0))) );
	frameRect.setWidth( ui.previewFrame->width());
	frameRect.setHeight( ui.previewFrame->height());
	painter.drawImage( frameRect,m_PreviewImage );
}
