#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "RGBATextureAttachmentEditorWidget.h"
//---------------------------------------------------------------------------
#include "RGBATextureAttachment.h"
#include "RGBAImage.h"
#include "GLTexture.h"
//---------------------------------------------------------------------------
using namespace geoxl;

IMPLEMENT_CLASS_EDITOR( RGBATextureAttachment )

RGBATextureAttachmentEditorWidget::RGBATextureAttachmentEditorWidget(QWidget * parent, Qt::WFlags f)
:QWidget(parent,f)
{
	//call ui.setupUi(this) to set up the layout from QtDesigner
	ui.setupUi(this);
	//Example: easy access to QtDesigner buttons, etc. by ui object
	QWidget::connect(ui.BTUpdate, SIGNAL(clicked()), this, SLOT(sltBTUpdateClicked()));

	// make layout for adding property editors
	QVBoxLayout *layout = new QVBoxLayout;
	layout->setMargin(0);
	layout->setSpacing(0);
	ui.EditorFrame->setLayout(layout);

	QVBoxLayout *layout2 = new QVBoxLayout;
	layout2->setMargin(0);
	layout2->setSpacing(0);
	ui.SettingsFrame->setLayout(layout2);

	// init the rest
   m_TexAtt = NULL;
   m_Editor = NULL;
   m_EditorWidget = NULL;
   m_EditSettings = NULL;
   m_EditSettingsWidget = NULL;
}

RGBATextureAttachmentEditorWidget::~RGBATextureAttachmentEditorWidget(void)
{
	if (m_EditorWidget) ui.EditorFrame->layout()->removeWidget(m_EditorWidget);
   delete m_EditorWidget;
   delete m_Editor;

	if (m_EditSettingsWidget) ui.SettingsFrame->layout()->removeWidget(m_EditSettingsWidget);
   delete m_EditSettingsWidget;
   delete m_EditSettings;
}

void RGBATextureAttachmentEditorWidget::setup( RGBATextureAttachment * obj )
{
	m_TexAtt = obj;

	RGBAImage * image = m_TexAtt->getImage();
	const MetaClass *newEditor = image->getInstanceClass()->getGUIDescriptor()->getDefaultClassEditor();

	if (!newEditor->isAbstract())
	{
		m_Editor = (ClassEditor*)(newEditor->newInstance());
		m_EditorWidget = m_Editor->makeEditor(ui.EditorFrame, image);
		ui.EditorFrame->layout()->addWidget(m_EditorWidget);
		m_EditorWidget->show();
		m_Editor->update();
	}

   GLTextureSettings * settings = m_TexAtt->getSettings();
   const MetaClass *newEditorSettings = settings->getInstanceClass()->getGUIDescriptor()->getDefaultClassEditor();
   if( !newEditorSettings->isAbstract() )
   {
      m_EditSettings = (ClassEditor*)(newEditorSettings->newInstance());
		m_EditSettingsWidget = m_EditSettings->makeEditor(ui.SettingsFrame, settings);
		ui.SettingsFrame->layout()->addWidget(m_EditSettingsWidget);
		m_EditSettingsWidget->show();
      m_EditSettings->update();
   }

}

void RGBATextureAttachmentEditorWidget::updateEditor()
{
}



// ---------- slots ----------

void RGBATextureAttachmentEditorWidget::sltBTUpdateClicked()
{
   if (m_TexAtt) m_TexAtt->clearAttachments();
}



#include "RGBATextureAttachmentEditorWidget_moc.cpp"


