#ifndef ShaderEditorWidgetH 
#define ShaderEditorWidgetH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "ShaderEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace geoxl
{
	using namespace std;

class Shader;
class GLContext;


class RENDERING_API ShaderEditorWidget : public QWidget
{
	Q_OBJECT

private:

	Shader * m_Shader;
    GLContext * m_TestContext;

	///used to access buttons, etc. from QtDesigner
	Ui_ShaderEditorForm ui;

public:
	ShaderEditorWidget(QWidget * parent = NULL, Qt::WFlags f=0);
	~ShaderEditorWidget(void);
	
	string removeChar(const string &dest, char c );
	string replaceChar(const string &dest, char c, const string &replaceStr);

	void setup( Shader * obj );

	/// update editor content with object data
	void updateEditor();
	Shader * getObj();
	void setTestContext( GLContext * context ) {m_TestContext = context;}
	static GLContext	*	m_DefaultGLContext;

	public slots:
		 void sltCompile();
		 void sltSave();
		 void sltLoad();
		 void sltShaderClassChange(int);
       void sltShaderTypeChange(int);
		 void sltEditChange();
		 void sltCursorPosChanged();


};

MAKE_CLASS_EDITOR( RENDERING_API , Shader )


}

#endif