#ifndef LogOutputH
#define LogOutputH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
#include <externalIncludes\opencv\cxcore.h>
#include "LinearAlgebra.h"
#include "DynamicLinearAlgebra.h"
#include "BoundingBox.h"
#include "SparseLinearAlgebra.h"
//---------------------------------------------------------------------------

namespace geoxl
{

class Scene;
class StringAttachment;

/**
	log for important information which is stored in the current scene
*/
class SCENEGRAPH_API LogOutput
{

private:

	Scene *	m_Scene;
	string	m_Trash;

	string & getString();

public:
	LogOutput(void);
	~LogOutput(void);

	void beginLogOutput( Scene * scene );

	LogOutput& operator<<(bool b);
	LogOutput& operator<<(int i);
	LogOutput& operator<<(unsigned int i);
	// this is necessary for 64-bit builds
	LogOutput& operator<<(geoxl::int64 i);
	LogOutput& operator<<(card64 i);
	LogOutput& operator<<(long double d);
	LogOutput& operator<<(float f);
	LogOutput& operator<<(double d);
	LogOutput& operator<<(string s);
	LogOutput& operator<<(char* s);
	LogOutput& operator<<(const Vector2f &v);
	LogOutput& operator<<(const Vector3f &v);
	LogOutput& operator<<(const Vector4f &v);
	LogOutput& operator<<(const Vector6f &v);
	LogOutput& operator<<(const Vector3i &v);
	LogOutput& operator<<(const Matrix4f &m);
	LogOutput& operator<<(const Matrix3f &m);
	LogOutput& operator<<(const BoundingBox3f &m);
	LogOutput& operator<<(const StaticVector<float32,7> &v);
	LogOutput& operator<<(const DynamicVector<float> &m);
	LogOutput& operator<<(const DynamicMatrix<float> &m);
	LogOutput& operator<<(const CvMat &m);
	LogOutput& operator<<(SparseMatrixF &A);

};

extern SCENEGRAPH_API LogOutput logOutput;

}

#endif