//---------------------------------------------------------------------------
#ifndef AllocatorListH
#define AllocatorListH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------
#include <vector>
//---------------------------------------------------------------------------

namespace geoxl {

class MultiObjectStream;

/**
	List of allocators (used by StaticSceneGraphState to provide allocators for out-of-core-nodes)
*/
class SCENEGRAPH_API SGAllocatorList : public Persistent {
	GEOXL_CLASS( SGAllocatorList )

private:
   vector<MultiObjectStream*> allocators;

   void addallocators( Object * obj );
   void deleteallocatorss( card32 begin, card32 end );
   Object * getallocators( card32 index );
   void moveallocators( card32 oldPos, card32 newPos );
   card32 getNumallocatorss();
   string getallocatorsName(card32 index );

public:
   virtual void assign(const Object* obj, CopyContext *context = NULL);
	
	inline card32 getNumAllocators() {return (card32)allocators.size();}
	inline MultiObjectStream* getAllocator(card32 i) {pAssert(i<allocators.size()); return allocators[i];}
	inline void addAllocator(MultiObjectStream *a) {allocators.push_back(a);}
	
	void hackRemoveAllocatorReferences();;
	
	~SGAllocatorList(void);

};

}

#endif