//---------------------------------------------------------------------------
#ifndef SGObjectNodeH
#define SGObjectNodeH
//---------------------------------------------------------------------------
#include "DebugOutput.h"
//---------------------------------------------------------------------------
#include "SceneGraphNode.h"
//---------------------------------------------------------------------------


namespace geoxl {

class SceneObject;


class SCENEGRAPH_API SGObjectNode : public SceneGraphNode {
 private:
   static MetaClass *SGObjectNodeMetaClass;
   static Object* newInstance();

   SceneObject *obj;

 public:
   SGObjectNode(SceneObject *obj = NULL) {this->obj = obj;}

   virtual void clearAndSetup(SceneObject *obj);

   inline SceneObject *getSceneObject() {return obj;}
	/// sets scene object to NULL without deleting it
   virtual void removeSceneObject();

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual SGStateChanger *getNodeEntryStateChange(const SceneGraphState *state);

   virtual max_platform_card getNumChildNodes(const SceneGraphState *state) const;
   virtual SceneGraphNode *getChildNode(const SceneGraphState *state, max_platform_card i);
   virtual void removeChildNode(string name);
   virtual bool canAddChildNode();
   virtual bool addChildNode(SceneGraphNode *node);

   virtual ~SGObjectNode();
};

}

#endif
 