//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "SGSceneObjectFilterAdaptor.h"
//---------------------------------------------------------------------------
#include "SGObjectNode.h"
#include "SceneObject.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



MetaClass* SGSceneObjectFilterAdaptor::SGSceneObjectFilterAdaptorMetaClass = NULL;

const MetaClass* SGSceneObjectFilterAdaptor::getInstanceClass() const {
   return getClass();
}

Object* SGSceneObjectFilterAdaptor::newInstance() {
   return new SGSceneObjectFilterAdaptor;
}

const MetaClass* SGSceneObjectFilterAdaptor::getClass() {
   if (SGSceneObjectFilterAdaptorMetaClass==NULL) {
      SGSceneObjectFilterAdaptorMetaClass = new MetaClass("SGSceneObjectFilterAdaptor", "no description.",
                                  newInstance, sizeof(SGSceneObjectFilterAdaptor));
   }
   return SGSceneObjectFilterAdaptorMetaClass;
}

void SGSceneObjectFilterAdaptor::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   SGSceneObjectFilterAdaptorMetaClass->copyParentProperties();
}

void SGSceneObjectFilterAdaptor::shutdown() {
   delete SGSceneObjectFilterAdaptorMetaClass;
}


// ----


SGSceneObjectFilterAdaptor::SGSceneObjectFilterAdaptor() {
   sceneObjectType = SceneObject::getClass();
}

bool SGSceneObjectFilterAdaptor::processNode(SceneGraphNode *n) {
   SGObjectNode *objNode = dynamic_cast<SGObjectNode*>(n);
   if (objNode == NULL) {
      return false;
   } else {
      SceneObject *sObj = objNode->getSceneObject();
      if (sObj == NULL) {
         return false;
      } else {
         if (sObj->getInstanceClass()->inheritsFrom(sceneObjectType)) {
            return true;
         } else {
            return false;
         }
      }
   }
}


void SGSceneObjectFilterAdaptor::setReportedSceneObjectType(const MetaClass *sceneObjectType) {
   this->sceneObjectType = sceneObjectType;
}

const MetaClass *SGSceneObjectFilterAdaptor::getReportedSceneObjectType() {
   return sceneObjectType;
}
