//---------------------------------------------------------------------------
#ifndef SGSceneObjectFilterAdaptorH
#define SGSceneObjectFilterAdaptorH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "SGNodeTypeFilterAdaptor.h"
//---------------------------------------------------------------------------

namespace geoxl {


/// Filter adaptor that picks SGObjectNodes only, depending on SceneObject type.
class SCENEGRAPH_API SGSceneObjectFilterAdaptor : public SGNodeTypeFilterAdaptor {
 private:
   static MetaClass *SGSceneObjectFilterAdaptorMetaClass;
   static Object* newInstance();

   const MetaClass *sceneObjectType;

 protected:
   virtual bool processNode(SceneGraphNode *n);

 public:
   SGSceneObjectFilterAdaptor();

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   /// set type of scene objects for that the SGObjectNode should be reported - default: SceneObject::getMetaClass()
   void setReportedSceneObjectType(const MetaClass *sceneObjectType);
   /// get type of scene objects for that the SGObjectNode should be reported - default: SceneObject::getMetaClass()
   const MetaClass *getReportedSceneObjectType();
};

}

#endif
