//---------------------------------------------------------------------------
#ifndef SGSetVariable4FNodeH
#define SGSetVariable4FNodeH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "LinearAlgebra.h"
#include "SGStateChangeNode.h"
//---------------------------------------------------------------------------


namespace geoxl {


class SCENEGRAPH_API SGSetVariable4FNode : public SGStateChangeNode {
   GEOXL_CLASS(SGSetVariable4FNode)

 private:
   string variable;
   Vector4f value;


 public:
   SGSetVariable4FNode();

	virtual void assign(const Object* obj, CopyContext *context = NULL);
	Vector4f getValue() const {return value;}
	void setValue(Vector4f v) {value=v;}
	string getVariable() const {return variable;}
	void setVariable(string v) {variable=v;}


   virtual SGStateChanger *getNodeEntryStateChange(const SceneGraphState *state);
};


}

#endif
 