//---------------------------------------------------------------------------
#ifndef SGSimpleAnimationNodeH
#define SGSimpleAnimationNodeH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "SGAnimationNode.h"
//---------------------------------------------------------------------------

namespace geoxl {


/// This node stores simple animations: depending on the current time in the scene graph state,
/// different nodes (possibly subtrees) are activated
class SCENEGRAPH_API SGSimpleAnimationNode : public SGAnimationNode {
 private:
   static MetaClass *SGSimpleAnimationNodeMetaClass;
   static Object* newInstance();

   float32 timePerFrame;

 public:
   SGSimpleAnimationNode();

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual max_platform_card getNumChildNodes(const SceneGraphState *state) const;
   virtual SceneGraphNode *getChildNode(const SceneGraphState *state, max_platform_card i);

   void setTimePerFrame(float32 timePerFrame);
   float32 getTimePerFrame();

};


}

#endif
 