//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "SGStateChangeNode.h"
//---------------------------------------------------------------------------
#include "ObjectClassProperty.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



MetaClass* SGStateChangeNode::SGStateChangeNodeMetaClass = NULL;

const MetaClass* SGStateChangeNode::getInstanceClass() const {
   return getClass();
}

const MetaClass* SGStateChangeNode::getClass() {
   if (SGStateChangeNodeMetaClass==NULL) {
      SGStateChangeNodeMetaClass = new MetaClass("SGStateChangeNode", "no description.",
                                                 NULL, sizeof(SGStateChangeNode));
   }
   return SGStateChangeNodeMetaClass;
}

void SGStateChangeNode::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   SGStateChangeNodeMetaClass->copyParentProperties();
   /*SGStateChangeNodeMetaClass->addProperty(
      new ObjectClassProperty("operand", 1, (ObjectElementPointer)&operand, SceneGraphNode::getClass(), true)
   );*/

	BEGIN_CLASS_INIT(SGStateChangeNode);
	ADD_OBJECT_PROP( operand, 0, SceneGraphNode::getClass(), true )

}

void SGStateChangeNode::shutdown() {
   delete SGStateChangeNodeMetaClass;
}


// ----


SceneGraphNode *SGStateChangeNode::getChildNode(const SceneGraphState *state, max_platform_card i) {
   forget(state);
   pAssert(i==0);
   pAssert(operand != NULL);
   return operand;
}

void SGStateChangeNode::removeChildNode(string name) {
   pAssert(operand != NULL);
   if (operand == NULL) return;
   pAssert(operand->getName() == name);
   if (operand->getName() != name) return;
   setOperand(NULL);
}

bool SGStateChangeNode::canAddChildNode() {
   return operand == NULL;
}

bool SGStateChangeNode::addChildNode(SceneGraphNode *node) {
   if (operand == NULL) {
      setOperand(node);
      return true;
   } else {
      return false;
   }
}


void SGStateChangeNode::setOperand(SceneGraphNode *n) {
   if (operand != n) {
      if (operand != NULL) {
         operand->releaseReference(this);
      }
      operand = n;
      if (n != NULL) {
         n->addReference(this);
      }
   }
}

SGStateChangeNode::~SGStateChangeNode() {
   if (operand != NULL) {
      operand->releaseReference(this);
   }
}

