//---------------------------------------------------------------------------
#ifndef SGStateChangeNodeH
#define SGStateChangeNodeH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "SceneGraphNode.h"
#include "Tools.h"
//---------------------------------------------------------------------------


namespace geoxl {


class SGStateChanger;



/// This scene graph node changes the state for the whole subtree it contains
/// It has at most one descendant node
class SCENEGRAPH_API SGStateChangeNode : public SceneGraphNode {
 private:
   static MetaClass *SGStateChangeNodeMetaClass;
   static Object* newInstance();

   SceneGraphNode *operand;

 public:
   SGStateChangeNode() {operand = NULL;}

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual max_platform_card getNumChildNodes(const SceneGraphState *state) const {forget(state); return operand != NULL ? 1 : 0 ;}
   virtual SceneGraphNode *getChildNode(const SceneGraphState *state, max_platform_card i);
   virtual void removeChildNode(string name);
   virtual bool canAddChildNode();
   virtual bool addChildNode(SceneGraphNode *node);

   inline SceneGraphNode *getOperand() {return operand;}
   void setOperand(SceneGraphNode *n);

   ~SGStateChangeNode();
};


}


#endif
 