//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "SGTimeStateChanger.h"
//---------------------------------------------------------------------------
#include "SceneGraphState.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



IMPLEMENT_GEOXL_CLASS( SGTimeStateChanger , 0 ) {
	BEGIN_CLASS_INIT( SGTimeStateChanger );
}

// ----

SGTimeStateChanger::SGTimeStateChanger() {
	oldTime = 0;
	newTime = 0;
}



void SGTimeStateChanger::setup(float32 newTime) 
{
	this->newTime = newTime;
}

void SGTimeStateChanger::doChange(SceneGraphState *state) 
{
	oldTime = state->dynamicState->time;
	state->dynamicState->time = newTime;
}

void SGTimeStateChanger::undoChange(SceneGraphState *state) 
{
	newTime = state->dynamicState->time;
	state->dynamicState->time = oldTime;
}
