//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "SGTransformationStateChanger.h"
//---------------------------------------------------------------------------
#include "SceneGraphState.h"
#include "FixedArrayClassProperty.h"
#include "BooleanClassProperty.h"
#include "LinearAlgebra_templCode.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



MetaClass* SGTransformationStateChanger::SGTransformationStateChangerMetaClass = NULL;

const MetaClass* SGTransformationStateChanger::getInstanceClass() const {
   return getClass();
}

Object* SGTransformationStateChanger::newInstance() {
   return new SGTransformationStateChanger;
}

const MetaClass* SGTransformationStateChanger::getClass() {
   if (SGTransformationStateChangerMetaClass==NULL) {
      SGTransformationStateChangerMetaClass = new MetaClass("SGTransformationStateChanger", "no description.",
                                  newInstance, sizeof(SGTransformationStateChanger));
   }
   return SGTransformationStateChangerMetaClass;
}

void SGTransformationStateChanger::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   SGTransformationStateChangerMetaClass->copyParentProperties();

   BEGIN_CLASS_INIT(SGTransformationStateChanger)
   ADD_FLOAT32_FIXED_ARRAY_PROP(transformation, 0, 16, 4)
   ADD_FLOAT32_FIXED_ARRAY_PROP(oldTransformation, 0, 16, 4)
   ADD_BOOLEAN_PROP(doChangeHasBeenDone, 0)

}

void SGTransformationStateChanger::shutdown() {
   delete SGTransformationStateChangerMetaClass;
}


// ----


SGTransformationStateChanger::SGTransformationStateChanger(const Matrix4f &t) {
   transformation = t;
   doChangeHasBeenDone = false;
}

void SGTransformationStateChanger::doChange(SceneGraphState *state) {
   pAssert(!doChangeHasBeenDone);
   oldTransformation = state->dynamicState->ctm;
   state->dynamicState->ctm *= transformation;
   doChangeHasBeenDone = true;
}

void SGTransformationStateChanger::undoChange(SceneGraphState *state) {
   pAssert(doChangeHasBeenDone);
   state->dynamicState->ctm = oldTransformation;
   doChangeHasBeenDone = false;
}

