//---------------------------------------------------------------------------
#ifndef SGTransformationStateChangerH
#define SGTransformationStateChangerH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "SGStateChanger.h"
#include "LinearAlgebra.h"
//---------------------------------------------------------------------------

namespace geoxl {


class SCENEGRAPH_API SGTransformationStateChanger : public SGStateChanger {
 private:
   static MetaClass *SGTransformationStateChangerMetaClass;
   static Object* newInstance();

   Matrix4f transformation;
   Matrix4f oldTransformation;
   bool doChangeHasBeenDone;

 public:
   SGTransformationStateChanger(const Matrix4f &t = IDENTITY4F);

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void doChange(SceneGraphState *state);
   virtual void undoChange(SceneGraphState *state);
};


}

#endif
