//---------------------------------------------------------------------------
#include "stdafx.h"
//---------------------------------------------------------------------------
#include "SGVariable4FStateChanger.h"
//---------------------------------------------------------------------------
#include "SceneGraphState.h"
#include "FixedArrayClassProperty.h"
#include "BooleanClassProperty.h"
#include "LinearAlgebra_templCode.h"
#include "CopyObjectProperties.h"
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------

IMPLEMENT_GEOXL_CLASS(SGVariable4FStateChanger, 0)
{
	BEGIN_CLASS_INIT(SGVariable4FStateChanger)
   ADD_STRING_PROP(name, 0)
   ADD_VECTOR4F_PROP(oldValue, 0)
   ADD_BOOLEAN_PROP(variablePresentBefore, 0)
}

//---------------------------------------------------------------------------

SGVariable4FStateChanger::SGVariable4FStateChanger(string name, const Vector4f &value)
{
   this->name = name;
   this->value = value;
   this->oldValue = NULL_VECTOR4F;
   variablePresentBefore = true;
}

void SGVariable4FStateChanger::assign(const Object* obj, CopyContext *context)
{
	copyObjectProperties(obj, this);
}


void SGVariable4FStateChanger::doChange(SceneGraphState *state) {
   variablePresentBefore = state->dynamicState->getStateVariable(name, oldValue);
   state->dynamicState->setStateVariable(name, value);   
}

void SGVariable4FStateChanger::undoChange(SceneGraphState *state) {
   if (variablePresentBefore) {
      state->dynamicState->setStateVariable(name, oldValue);
   } else {
      state->dynamicState->deleteStateVariable(name);
   }
}

