//---------------------------------------------------------------------------
#ifndef SceneGraphTools_H
#define SceneGraphTools_H
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "PTypes.h"
//---------------------------------------------------------------------------
#include <string>
//---------------------------------------------------------------------------


namespace geoxl {
   using namespace std;

// ==== string / path routines

/// for "root/pc1": returns "root/"
SCENEGRAPH_API string extractSGPath(const string &nodeWPath);

/// for "root/pc1": returns "pc1"
SCENEGRAPH_API string extractSGNode(const string &nodeWPath);

/// for "root/pc1": returns ["root", "pc1"]
SCENEGRAPH_API vector<string> parseSGPath(const string &path);

/// for "root/list": returns "root/list/"
SCENEGRAPH_API string endPathWithSlash(const string &str);


// ==== scene graph access

/// returns node for a path string. returns NULL if anything goes wrong.
SCENEGRAPH_API SceneGraphNode *getSceneGraphNode(Scene *scene, string path);

/// returns node for a node with path. returns NULL if anything goes wrong.
SCENEGRAPH_API SceneGraphNode *getSceneGraphNode(Scene *scene, vector<string> pathComponents);

/// adds new scene graph node to the given path. the path must exist (exception if not)
SCENEGRAPH_API void addSceneGraphNode(Scene *scene, string path, SceneGraphNode *addThis);

}

#endif
