//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "VisitSGNodesOnceIterator.h"
//---------------------------------------------------------------------------
#include "SceneGraphNode.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace geoxl;
//---------------------------------------------------------------------------



MetaClass* VisitSGNodesOnceIterator::VisitSGNodesOnceIteratorMetaClass = NULL;

const MetaClass* VisitSGNodesOnceIterator::getInstanceClass() const {
   return getClass();
}

Object* VisitSGNodesOnceIterator::newInstance() {
   return new VisitSGNodesOnceIterator;
}

const MetaClass* VisitSGNodesOnceIterator::getClass() {
   if (VisitSGNodesOnceIteratorMetaClass==NULL) {
      VisitSGNodesOnceIteratorMetaClass = new MetaClass("VisitSGNodesOnceIterator", "no description.",
                                  newInstance, sizeof(VisitSGNodesOnceIterator));
   }
   return VisitSGNodesOnceIteratorMetaClass;
}

void VisitSGNodesOnceIterator::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   VisitSGNodesOnceIteratorMetaClass->copyParentProperties();
}

void VisitSGNodesOnceIterator::shutdown() {
   delete VisitSGNodesOnceIteratorMetaClass;
}


// ----


VisitSGNodesOnceIterator::VisitSGNodesOnceIterator() {
   it = NULL;
}

void VisitSGNodesOnceIterator::clearAndSetup(
   SceneGraphNode *rootNode, const SceneGraphState *rootState,
   SGDynamicState::TraversalModeType traversalMode,
   card32 includeNodeFlags, card32 excludeNodeFlags)
{
   excludeNodeFlags |= SceneGraphNode::FLAG_VISIT;
   it = new StandardSceneGraphIterator();
   it->clearAndSetup(rootNode, rootState, traversalMode, includeNodeFlags, excludeNodeFlags);
}

void VisitSGNodesOnceIterator::next() {
   SceneGraphNode *last = it->getNode();
   it->next();
   last->includeFlags(SceneGraphNode::FLAG_VISIT);
   cleanupList.push_back(last);
}

bool VisitSGNodesOnceIterator::atEnd() {
   return it->atEnd();
}

SceneGraphNode *VisitSGNodesOnceIterator::getNode() {
   return it->getNode();
}

SceneGraphNode *VisitSGNodesOnceIterator::getParent() {
   return it->getParent();
}

SceneGraphState *VisitSGNodesOnceIterator::getState() {
   return it->getState();
}

string VisitSGNodesOnceIterator::getNameWithPath() {
   return it->getNameWithPath();
}


VisitSGNodesOnceIterator::~VisitSGNodesOnceIterator() {
   const max_platform_card n = cleanupList.size();
   for (max_platform_card i=0; i<n; i++) {
      cleanupList[i]->excludeFlags(SceneGraphNode::FLAG_VISIT);
   }
   delete it;
}
