//---------------------------------------------------------------------------
#ifndef VisitSGNodesOnceIteratorH
#define VisitSGNodesOnceIteratorH
//---------------------------------------------------------------------------
#include "GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "StandardSceneGraphIterator.h"
//---------------------------------------------------------------------------

namespace geoxl {

class SCENEGRAPH_API VisitSGNodesOnceIterator : public SceneGraphIterator,
                                         public SGBasicNodesIterator {
 private:
   static MetaClass *VisitSGNodesOnceIteratorMetaClass;
   static Object* newInstance();

   StandardSceneGraphIterator *it;
   vector<SceneGraphNode *> cleanupList;

 public:
   VisitSGNodesOnceIterator();

   void clearAndSetup(SceneGraphNode *rootNode, const SceneGraphState *rootState,
                      SGDynamicState::TraversalModeType traversalMode = SGDynamicState::tmAllNodes,
                      card32 includeNodeFlags = 0,
                      card32 excludeNodeFlags = 0);

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void next();
   virtual bool atEnd();
   virtual SceneGraphNode *getNode();
   virtual SceneGraphNode *getParent();
   virtual SceneGraphState *getState();
   virtual string getNameWithPath();

   virtual ~VisitSGNodesOnceIterator();
};


}


#endif
 